#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


package Common;

use CGI;

use Settings;
use Storage;
use TS;

if ($sqluse == 1) {
	#Required for SQL access
	require ("$path_code/sql.pl");
}


$lt = localtime;

my $cgi = new CGI;

#Random Fix
#$cat=~s/%3E/>/g;
#$cat=~s/%2C/,/g;
#$cat=~s/%3A/:/g;
#$cat=~s/%27/'/g;
#$cat=~s/%21/!/g;
my (%rlinks, %rflags, %aflags, %tflags, $linktext, $checkcat, $linkall, $linktemplate);
my ($loadedlinks) = 0;


# Param: 3
# 1: Category (Validation should already be done)
# 2: Text to check for section links
# 3: Type of text, 0 for a section, 1 for template data

sub sectionLink
{
	my($cat, $text, $type) = @_;
	
	unless ( $loadedlinks ) {
		# load the section links
		# First, if there are no section links, return unaltered string
		unless ( -e "$path_sitedata/$cat.scl" ) { return $text; }
		$loadedlinks = 1; # Only do this once
		open (LINKS, "$path_sitedata/$cat.scl");
		my @slinks = <LINKS>;
		close(LINKS);
		chomp(@slinks);

		# need to load the list of cats, since they won't be loaded for this sub
		open(DCATS, "$path_sitedata/cats.lst");
		my $ucat = <DCATS>;
		close(DCATS);
		
		foreach (@slinks) {
			($linktext, $checkcat, $linkall, $linktemplate) = split(/:/);
			$linktext =~ s/_/ /g;
			if (index($ucat, " $checkcat; ") >= 0) {
				$checkcat =~ s/>/\//g;
				$rlinks{$linktext} = $checkcat;
				$rflags{$linktext} = 0;
				if ( $linkall eq "on" ) {
					$aflags{$linktext} = 1
				} else {
					$aflags{$linktext} = 0
				}
				if ( $linktemplate eq "on" ) {
					$tflags{$linktext} = 1
				} else {
					$tflags{$linktext} = 0
				}
			}
		}
	}

	# Links are loaded so check the text for section links
	foreach $linktext (keys %rlinks) {
		if ( ( ( $tflags{$linktext} ) && ( $type == 1 ) ) || ( ( $aflags{$linktext} ) && ( $type == 0 ) ) ) {
			if ( ( $linktext =~ m/^\[/ ) && ( $linktext =~ /\]$/ ) ) {
				( my $replacetext = $linktext ) =~ s/^\[(.*)\]$/$1/;
				$text =~ s/\[($replacetext)\]/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/gi
			} else {
				$text =~ s/(\s|\(|\'|\’|\")($linktext)(\s|\"|\'|\’|\.|\,|\(|\)|\!|\:|\;)/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>$3/gi;
				$text =~ s/^($linktext)(\s|\"|\'|\’|\.|\,|\(|\)|\!|\:|\;)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>$2/gi;
				$text =~ s/(\s|\(|\'|\’|\")($linktext)$/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>/gi;
			}
		}
	
		if ( ( !$aflags{$linktext} ) && ( $type == 0 ) && ( !$rflags{$linktext} ) ) {
			if ( ( $linktext =~ m/^\[/ ) && ( $linktext =~ /\]$/ ) ) {
				( my $replacetext = $linktext ) =~ s/^\[(.*)\]$/$1/;
				if ( $text =~ s/\[($replacetext)\]/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/i ) {
					$rflags{$linktext} = 1;
				}
			} else {
				if ( ( $text =~ s/(\s|\(|\'|\’|\")($linktext)(\s|\"|\’|\'|\.|\,|\(|\)|\!|\:|\;)/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>$3/i )
					|| ( $text =~ s/^($linktext)(\s|\"|\’|\'|\.|\,|\(|\)|\!|\:|\;)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>$2/i )
					|| ( $text =~ s/(\s|\(|\'|\’|\")($linktext)$/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>/i ) ) {
					$rflags{$linktext} = 1;
				}
			}
		}
	}
	
	return $text;
}


# Establishes if a section is empty or not.
# Params: 1
# Param 1: An array representing the section, in storage-format.
# Returns: 1 - the section is empty.
#          0 - the section has content.

sub isSectionEmpty
{
	my(@tb) = @_;
	
	if ($tb[0]=~/2.0/) {
		if (($tb[2] eq "") || ($tb[2] eq "\n")) {
			return 1;
		}
	} else {
		if (($tb[0] eq "") || ($tb[0] eq "\n")) {
			return 1;
		}
	}
	
	return 0;
}


# Establishes if a category is empty or not.
# Includes:
#  - checker for subcategories.
#  - checker for content.
#  - checker for sections in both reviewed/unreviewed queues.
# Params: 1
# Param 1: the name of the category.
# Returns: 1 if the category is empty, 0 otherwise.

sub isCatEmpty
{
	my ($cat) = @_;
	
	if ($cat eq "") {
		return 0;
	}
	
	open(EL, "$path_sitedata/cats.lst");
	my $cats = <EL>;
	close(EL);
	$cats=~s/(\s)\s/$1/g;
	$cats=~s/\//>/g;
	$cats=~s/\\/>/g;
	
	$cat=~s/\//>/g;
	$cat=~s/\\/>/g;
	
	my $nosubcats = "1";
	if ($cats=~/ $cat>/) {
		$nosubcats++;
	}
	
	my @ttt = ("", "");
	if (open(TF, "$path_sitedata/$cat.reviewed")) {
		@ttt = <TF>;
		close(TF);
	}
	
	$ttt[0]=~s/^$/0/;
	$ttt[1]=~s/^$/0/;
	
	my @tt = ("", "");
	if (open(TF, "$path_sitedata/$cat.unreviewed")) {
		@tt = <TF>;
		close(TF);
	}
	
	$tt[0]=~s/^$/0/;
	$tt[1]=~s/^$/0/;
	
	my $cont = Storage::getData('category', $cat, "html");
	
	$cont=~s/\n//g;
	$cont=~s/\r//g;
	$cont=~s/ //g;
	
	if (($cont eq "") && ($ttt[0] == 0) && ($tt[0] == 0) && ($nosubcats == 1)) {
		return 1;
	}
	
	return 0;
}


# Transforms a month from letters into digits (Jan --> 1, Feb --> 2 etc)
# Params: 1
# Param 1: the month, in letters.
# Returns: the month, in digits.

sub getMonth
{
	my($tomon) = @_;
	
	if (defined $tomon) {
		$tomon=~s/Jan/1/;
		$tomon=~s/Feb/2/;
		$tomon=~s/Mar/3/;
		$tomon=~s/Apr/4/;
		$tomon=~s/May/5/;
		$tomon=~s/Jun/6/;
		$tomon=~s/Jul/7/;
		$tomon=~s/Aug/8/;
		$tomon=~s/Sep/9/;
		$tomon=~s/Oct/10/;
		$tomon=~s/Nov/11/;
		$tomon=~s/Dec/12/;

		$tomon=~s/[\n\r]//g;	
	}
	
	return $tomon;
}


# Checks chars in logging for 'nonos'

sub CheckLChar
{
	my $CheckLCharU = @_;
	   $CheckLCharU=~s/\"/&quot\;/g;
	   $CheckLCharU=~s/\</&lt\;/g;
	   $CheckLCharU=~s/\>/&gt\;/g;
	   $CheckLCharU=~s/\'/&acute\;/g;
}


# Increments the counter of the current category
# Params: 3
# Param 1: the current category
# Param 2: the ID of the counter ("reviewed" or "unreviewed")
# Param 3: the value that should be added to the counter
# Returns: 1 (always)

sub updateCounter
{
	my($cat, $ID, $value) = @_;
	my(@ttt);
	
	open(TF, "$path_sitedata/$cat.$ID");
	@ttt = <TF>;
	close(TF);
	
	if (($ttt[0] eq "") || ($ttt[0] eq "\n")) {
		$ttt[0] = 0;
		$ttt[1] = 0;
	}
	
	$ttt[0] = $ttt[0] + $value;
	$ttt[1] = $ttt[1] + $value;
	
	open(TF, ">$path_sitedata/$cat.$ID");
	print TF $ttt[0] . "\n" . $ttt[1];
	close(TF);
	
	while ($cat=~/>/) {
		$cat=~s/^(.*)>[^>]*$/$1/;
	
		open(TF, "$path_sitedata/$cat.$ID");
		@ttt = <TF>;
		close(TF);
	
		if (($ttt[0] eq "") || ($ttt[0] eq "\n")) {
			$ttt[0] = 0;
			$ttt[1] = 0;
		}
	
		$ttt[0] = $ttt[0] + $value;
	
		open(TF, ">$path_sitedata/$cat.$ID");
		print TF $ttt[0] . "\n" . $ttt[1];
		close(TF);
	}
}


# Makes sure the #!# can not be used in logging query strings.
# Returns 1 (always)

if (defined $ENV{QUERY_STRING}) {
	if ($ENV{QUERY_STRING}=~/%23%21/g) {
		writeHeaderCode();
		print $TS::TS_common_21error;
		writeScriptFooter();
		exit(0);
	}
}


# Generates a combo with the available templates in a given category
# Params: 2
# Param 1: The category in which to display the combo
# Param 2: The name of the select object.
# Returns: 1 (always)

sub writeTemplateCombo
{
	my($tcat, $name, $default) = @_;
	my($cats);
	my($i);
	my(@elim);
	my($HTML);
	
	open(EL, "$path_data/cattype");
	$cats = <EL>;
	close(EL);
	
	$HTML = "<select name=\"$name\">";
	$table = "<option>";
	
	@elim = split(" ; ", $cats);
	if (($tcat=~/^Test/) || ($tcat=~/^Bookmarks/)) {
	} else {
		if ($tcat=~/International>([^>]*)/) {
			$languageID = $1;
			for ($i = "0"; $i <= $#elim; $i++) {
				if ($elim[$i]=~/default/) {
				} else {
					if ($elim[$i]=~/$languageID>(.*)/) {
					} else {
						$elim[$i] = "";
					}
				}
			}
		} else {
			for ($i = "0"; $i <= $#elim; $i++) {
				if ($elim[$i]=~/default/) {
				} else {
					if ($elim[$i]=~/>/) {
						$elim[$i] = "";
					}
				}
			}
		}
	}
	
	for ($i = "0"; $i <= $#elim; $i++) {
		if ($elim[$i]=~/[a-zA-Z0-9]/) {
		} else {
			$elim[$i] = "";
		}
		if ($elim[$i]=~/^default/) {
			$elim[$i] = "";
		}
	}
	
	$cats = join(" ; ", @elim);
	$cats=~s/(\s;\s)+/ ; /g;
	$cats=~s/\s;\s$//g;
	$cats=~s/; +/;/g;
	
	@elim = split(";", $cats);
	@elim = sort {
		if (($a=~/>/) && ($b=~/>/)) {
			$a cmp $b;
		} else {
			if ((!($a=~/>/)) && (!($b=~/>/))) {
				$a cmp $b;
			} else {
				if ($a=~/>/) {
					1;
				} else {
					-1;
				}
			}
		}
	} (@elim);
	
	$cats = join(";", @elim);
	
	$cats=~s/;/$table/g;
	$cats = "$table default". $cats;
	if (defined $default) {
		$cats=~s/\<option\>$default/\<option selected\>$default/;
	}
	
	$HTML = $HTML . "$cats</select>";
	
	return $HTML;
}


# Spell checker code
# Takes a single line and returns an HTML-formatted line with possibly misspelt words in bold, underlined red.

sub spellCheckLine {
	my $spelltext = $_[0];
	my $cat = $_[1];
	# let's pipe this through ispell and highlight any mispelled words
	$cat=~s/>/\//g;
	$cat.='/';
	my $add = "";
	if ($cat=~/^International\/([^\/]*)\//) {
		$cat = $1;
		if ($cat eq "Svenska") {
			$add = "-d svenska ";
		}
		if ($cat eq "Italiano") {
			$add = "-d italian ";
		}
		if ($cat=~/^Esp/) {
			$add = "-d espa~nol ";
		}
	}
	$ENV{PATH} = "";
	# generate a random number for this check so as to reduce the risk of race conditions
	my $randnum = int(rand(10000));
	open(ISPELL, "| /usr/local/bin/ispell $add -a > /tmp/cat-spellcheck-$randnum.txt") || die "Could not open ispell:$!";
	print ISPELL $spelltext;
	close(ISPELL);
	open(ISPELL, "/tmp/cat-spellcheck-$randnum.txt");
	my $firstline = <ISPELL>;
	my $currchar = 0;
	my @chars = split(//, $spelltext);
	my $newline = "";
	
	# Remember the number of < and > in order to prevent spell-checking inside HTML tags
	my $opened = 0;
	my $closed = 0;
	
	my $openedPluser = 0;
	my $closedPluser = 0;
	
	my $txt = "";
	
	while (<ISPELL>) {
		my $outline = $_;
		chomp($outline);
		next if ($outline eq "");
		my ($schar) = split(//, $outline);
		if (($schar eq "*") || ($schar eq "+") || ($schar eq "-")) {
			# good enough, do nothing
		} else {
						# not good enough
			# find out the word and the character position
			if ($schar eq "#") {
				($d, $misword, $offset) = split(/ /, $outline);
				@altwords = ();
			} else {
				($d, $misword, $d, $offset, @altwords) = split(/ /, $outline);
			}
			my $altwords = join(" ", @altwords);
			if ($altwords ne "") {
				$altwords = "$TS::TS_common_spellsuggestions $altwords.";
			} else {
				$altwords = "$TS::TS_common_spellnosuggestions";
			}
			$offset=~s/:$//;
	
			$openedPluser = 0;
			$closedPluser = 0;
			$txt = join("", @chars[$currchar..$offset-1]);
			while ($txt=~/\</g) {
				$openedPluser++;
			}
			while ($txt=~/\>/g) {
				$closedPluser++;
			}
			if ($opened + $openedPluser == $closed + $closedPluser) {
				#Do not spell-check inside HTML tags
				$opened += $openedPluser;
				$closed += $closedPluser;
				# first, copy all the characters from before this offset into the final string
				$newline .= join("", @chars[$currchar..$offset-1]);
				# now copy a star, however many characters of @chars are in $misword, then another star
				$newline .= "<font color=\"#FF0000\"><u><b><span title=\"$altwords\">" . join("", @chars[$offset..$offset+length($misword)-1]) . "</span></b></u></font>";
				# and put currchar up to the right level
				$currchar = $offset+length($misword);
			}
		}
	}
	
	$newline .= join("", @chars[$currchar..$#chars]);
	
	close(ISPELL) || die "Could not close ispell:$!";
	# delete the file afterwards
	unlink("/tmp/cat-spellcheck-$randnum.txt");

	# print "<br><i>$newline</i><br>";
	return $newline;
}


# Deletes a section from a category
# Params: 3
# Param 1: The name of the category from which a section will be deleted.
# Param 2: "" for reviewed queue and "u" for the unreviewed queue.
# Param 3: The ID of the section wanted to be deleted.

sub deleteSection
{
  # $ad = "u" for unreviewed or "" for reviewed
	
	my($cat, $ad, $idtable) = @_;
	
	open(USERS, "$path_sitedata/$cat.$ad" . "sections");
	$users = <USERS>;
	close(USERS);
	
	my $place = "reviewed";
	if ($ad eq "u") {
		$place = "unreviewed";
	}
	
	$users--;
	open(USERS, ">$path_sitedata/$cat.$ad" . "sections");
	print USERS $users;
	close(USERS);
	
	for (my $d = $idtable; $d <= $users; $d++) {
		my $e = $d + 1;
	
		open(IN, "$path_sitedata/$cat.$ad" . "sct$e");
		my @in = <IN>;
		close(IN);
		my $in = join("", @in);
	
		open(OUT, ">$path_sitedata/$cat.$ad" . "sct$d");
		print OUT $in;
		close(OUT);
	}
	
	my $e = $users + 1;
	unlink "$path_sitedata/$cat.$ad" . "sct$e";
}


return 1;
