package Editor;

use base 'Exporter';

our @EXPORT = ('$isEditall', '$isRoot', '$isMeta', '$FullMeta', '$isFullEditall');

use CGI;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;


# Registers the first user in the system
# Params: 0
# Returns: -

sub noUser
{
	if (defined CGI::param('clicked')) {
		if (CGI::param('pass') ne CGI::param('pass2')) {
			print "Error: passwords don\'t match.";
		} else {
			my $user = CGI::param('user');
			if ($user=~/^([a-z0-9]+)$/) {
				$user = $1;
			} else {
				die "Unsafe value for user in Editor.pm";
			}

			Editor::setPassword($user, CGI::param('pass'));
			open(EL, ">$path_data/elist");
			print EL "active: $user ";
			close(EL);

			if (!(-d "$path_data/misc")) {
				mkdir "$path_data/misc";
			}
			if (!(-d "$path_data/logs")) {
			        mkdir("$path_data/logs");
			}
			if (!(-d "$path_data/logs/rootlog")) {
			        mkdir("$path_data/logs/rootlog");
			}

			open(EL, ">$path_data/inlist");
			print EL " ";
			close(EL);

			open(FILE, ">$path_data/misc/$user.eaddr");
			print FILE CGI::param('email');
			close(FILE);
			open(FILE, ">$path_data/root.gf");
			print FILE "root: $user ";
			close(FILE);
			open(FILE, ">$path_data/dirman.gf");
			print FILE "dirman: ";
			close(FILE);
			open(FILE, ">$path_data/dirmod.gf");
			print FILE "dirmod: ";
			close(FILE);

			if (-d "/usr/bin") {
				# This is probably a Linux system which supports pwd
				# Then generate the .htaccess file
				$ENV{'PATH'} = '';
				my $path = `/bin/pwd`;
				$path=~/^(.*)\/[^\/]*\/[^\/]*$/;
				$path = $1;
				open(FILE, ">$path_web/editors/.htaccess");
				print FILE <<END;
AuthName \"Editor Login\"
AuthType Basic
AuthUserFile $path/data/users.upf
AuthGroupFile $path/data/elist
require group active
END
				close(FILE);
			}

			print "Username added. <a href=\".\">Click here</a> to continue.";
		}
	} else {
		print "<p>The user database is empty. Please create below the first account, which will receive admin privs.<p>";
		UI::writeStartForm();
		UI::writeInputItemForm("Username", "text", "user");
		UI::writeInputItemForm("Password", "password", "pass");
		UI::writeInputItemForm("Password (again)", "password", "pass2");
		UI::writeInputItemForm("Email", "text", "email");
		UI::writeHiddenForm("clicked", "1");
		UI::writeEndForm();
	}
	
	UI::writeFooterCode();
	
	exit();
}


# Returns the username of the current user
# Params: 0
# Returns: the username of the current user

sub currentUser
{
	if (Storage::getData("global", "elist")  =~/^[ ]*$/) {
		noUser();
	}
	
	if ($ENV{REMOTE_USER} eq "") {
		return "";
	}
	
	if ($ENV{REMOTE_USER}=~/^([a-z0-9]+)$/) {
		return $1;
	}
	
	print $TS::TS_common_editornotfound;
	UI::writeScriptFooter();
	exit(0);
}


# Returns the email of an editor.
# Params: 1
# Param 1: the username of the editor.
# Returns: the email of the editor.

sub getEmail
{
	my($user) = @_;
	my $ea;

	if (-f "$path_data/misc/$user.eaddr") {
		open(INFILE, "$path_data/misc/$user.eaddr");
		$ea = <INFILE>;
		close(INFILE);
	} else {
		$ea = "";
	}

	return $ea;
}


# Writes the HTML code required to display the editor's name
#  and his email address
# Params: 0
# Returns: 1 (always)

sub writeECode()
{
	my $email = getEmail(currentUser());
	print <<END;
<p>
 <table bgcolor="$UI::box[$UI::currentskin]" cellpadding="4">
  <tr>
   <td align="left">
    <font size="+1">$bold$TS::TS_common_editor: &nbsp;
END

	print currentUser();

	$email = $collectEmails ? "($email)" : "";
	print " $email$unBold</font></td></tr></table></p>";

	return 1;
}


# Halts the execution of the script and displays an error message if the
#  current user is not an editall
# Params: 0
# Returns: 1 (always)

sub restrictedEditall
{
	if ($isEditall ne "1") {
		print $TS::TS_common_noaccess;
		UI::writeScriptFooter();
		exit(0);
	}
   
	return 1;
}


# Halts the execution of the script and displays an error message if
#  the current user is a catmod
# Params: 0
# Returns: 1 (always)

sub restrictedMod
{
	if ($isMeta ne "1") {
		print $TS::TS_common_noaccess;

		UI::writeScriptFooter();
		exit(0);
	}

	my $metaarea;
	if (-f "$path_data/eperm/meta/$ENV{REMOTE_USER}.perm") {
		open(EL, "$path_data/eperm/meta/$ENV{REMOTE_USER}.perm");
		$metaarea = <EL>;
		close(EL);
	}

	if ($isRoot eq "1") {
		$metaarea = "meta";
	}

   	if ($metaarea!~/meta/g) {
		print $TS::TS_common_noaccess;
		UI::writeScriptFooter();
		exit(0);
	}

	return 1;
}


# Halts the execution of the script and displays an error message if the
#  current user is not a meta
# Params: 0
# Returns: 1 (always)

sub restrictedMeta
{
	if ($isMeta ne "1") {
		print $TS::TS_common_noaccess;
		UI::writeScriptFooter();
		exit(0);
	}

	return 1;
}


# Halts the execution of the script and displays an error message if the
#  current user is not a root
# Params: 0
# Returns: 1 (always)

sub restrictedRoot
{
	if ($isRoot ne "1") {
		print $TS::TS_common_noaccess;
		UI::writeScriptFooter();
		exit(0);
	}

	return 1;
}


#The following code sets different vars according to the privs
# of the current user

$noeditall = $cgi->param('noeditall');
if (!(defined $noeditall)) {
	$noeditall = "";
}

if ($noeditall eq "1") {
	$isEditall = "0";
} else {
	$editall = Storage::getData("global", "dirmod.gf");

	if (($editall=~/ $ENV{REMOTE_USER} /) || ($ENV{REMOTE_USER} eq "")) {
		$isEditall = "1";
	} else {
		$isEditall = "0";
	}
}

$nometa = $cgi->param('nometa');
if (!(defined $nometa)) {
	$nometa = "";
}

if ($nometa eq "1") {
	$isMeta = "0";
} else {
	$meta = Storage::getData("global", "dirman.gf");

	if (($meta=~/ $ENV{REMOTE_USER} /) || ($ENV{REMOTE_USER} eq "")) {
		$isMeta = "1";
		my $fileName = "$path_data/eperm/meta/$ENV{REMOTE_USER}.perm";
		if (-f $fileName) {
			open(EL, $fileName);
			$metaarea = <EL>;
			close(EL);
		} else {
			$metaarea = "meta";
		}
		if ($metaarea=~/meta/g)	{
			$FullMeta = 1;
		} else {
			$FullMeta = 0;
		}
	} else {
		$isMeta = "0";
	}
}

$noroot = $cgi->param('noroot');
if (!(defined $noroot)) {
	$noroot = "";
}

$root = Storage::getData("global", "root.gf");

if (($root=~/ $ENV{REMOTE_USER} /)  || ($ENV{REMOTE_USER} eq "")) {
	$isRoot = "1";
	$isEditall = "1";
	$isMeta = "1";
	$FullMeta = "1";
	$isFullEditall = "1";
	$editallArea = "editall";
	$metaarea = "meta";
} else {
	$isRoot = "0";
}

if (!(defined $editallArea)) {
	$editallArea = "";
}
my $file = "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm";
if (-f $file) {
	open(EL, $file);
	if ($isRoot eq "0") {
		$editallArea = <EL>;
	}
	close(EL);
}

if ($isRoot eq "0") {
	$isFullEditall = "0";
}
if ((($editallArea=~/editall/g) || ($editallArea eq "")) && ($isEditall eq "1")) {
	$editallArea = Storage::getData("global", "tlc.lc");
	$isFullEditall = "1";
}

if ($noroot eq "1") {
	$isRoot = "0";
}


# CatMod cat checker
# Checks if a catmod can access them perm

sub catmodPriv
{
	my($cat) = @_;

	my $metaarea = "";
	if (open(EL, "$path_data/eperm/meta/$ENV{REMOTE_USER}.perm")) {
		$metaarea = <EL>;
		close(EL);
	}

	$cat=~s/\//>/g;
	$metaarea=~s/\//>/g;

	if ($isRoot eq "1") {
		$metaarea = "meta";
	}

	$metaarea=~s/\n//g;
	if (($metaarea!~/meta/) && ($cat!~/$metaarea/)) {
		print $TS::TS_common_noaccess;
		writeScriptFooter();
		exit(0);
	}
}


# Validates an editor name and converts him in order to prevent attacks
# Params: 1
# Param 1: the name of the editor
# Returns: the name of the editor, converted after applying security measures

sub validateEditor
{
	my($editor) = @_;

	if ($editor=~/^([a-z0-9]+)$/) {
		$editor = $1;
	} else {
		print $TS::TS_common_editornotfound;
		UI::writeScriptFooter();
		exit(0);
	}
	
	if ($editor=~/ /g) {
		print "$TS::TS_common_editornospaces";
		UI::writeScriptFooter();
		exit(0);
	}

	my $users = Storage::getData("global", "elist");
	$users .= " " . Storage::getData("global", "inlist");

	if (($users !~ / $editor /) || ($editor eq "")) {
		print $TS::TS_common_editornotfound;
		UI::writeScriptFooter();
		exit(0);
	}

	return $editor;
}


# Validates the name of the category, and converts it in order to prevent attacks
# Params: 2
# Param 1: the name of the category
# Param 2: number that tells the script how to look for the category:
#      = 0 - the category must not exist
#      = 1 [default] - the category must exist
#      = 2 - do not check for category existance
# Returns: the name of the category, converted after applying security measures

sub validateCat
{
	my($cat, $mustExist) = @_;

	if (!(defined $cat)) {
		$cat = "";
	}

	if (!(defined $mustExist)) {
		$mustExist = "1";
	}
   
	$cat=~s/^http:\/\/.*?\/(.*)/$1/;
	$cat=~s/^editors\/editcat\.cgi\?cat=(.*)/$1/;

	$cat=~s/: />/g;
	$cat=~s/ /_/g;
	$cat=~s/\//>/g;
	$cat=~s/\\/>/g;

	$cat=~s/>$//;

	if ($cat eq "") {
		UI::showError("", $TS::TS_common_nocatorprivs, "", "");
	}

	if (($cat=~/&/g) || ($cat=~/;/g) || ($cat=~/</g) || ($cat=~/\(/g) || ($cat=~/\)/g) || ($cat=~/%/g) || ($cat=~/"/g) || ($cat=~/#/g) || ($cat=~/\?/g) || ($cat=~/\+/g) || ($cat=~/\`/g) || ($cat=~/\|/g) || ($cat=~/ /g)) {
		UI::showError("", $TS::TS_common_nocatorprivs, "", "");
	}
	
	if ($cat=~/^(.+)$/) {
		$cat = $1;
	} else {
		exit();
	}

	if (!(-d "$path_home/temp")) {
		mkdir "$path_home/temp";
	}
	open(TEXTFILE, ">$path_home/temp/cok.cel");
	print TEXTFILE "$cat";
	close(TEXTFILE);

	open(CH, "$path_home/temp/cok.cel");
	$che = <CH>;
	close(CH);

	if ($che=~/;/g) {
		UI::showError("", $TS::TS_common_nocatorprivs, "", "");
	}

	# Does it exist?
	open(DCATS, "$path_sitedata/cats.lst");
	$ucat = <DCATS>;
	close(DCATS);

	if (index($ucat, " $cat; ") >= 0) {
		#The category exists
		if ($mustExist eq "0") {
			UI::showError("", $TS::TS_common_nocatorprivs, "", "");
		}
	} else {
		# The category doesn't exist
		if ($mustExist eq "1") {
			UI::showError("", $TS::TS_common_nocatorprivs, "", "");
		}
	}
	
	return $cat;
}


# Tests if the user has editing privs in a given category;
#  the execution of the script is halted if the privs are not enough.
# Params: 1
# Param 1: the name of the category
# Returns: the name of the category, converted after applying security measures

sub testPrivs
{
	my($cat) = @_;
	$cat = validateCat($cat);

	my $okay = "0";

	if ($isFullEditall eq "1") {
		$okay = "1";
	}

	# Does the user have editing privs?
	if (!(-d "$path_data/eperm")) {
		mkdir "$path_data/eperm";
	}

	my $ucat = "";
	my $file = "$path_data/eperm/$ENV{REMOTE_USER}.perm";
	if (-f $file) {
		open(DCATS, $file);
		$ucat = <DCATS>;
		close(DCATS);
	}

	my $uct = "";
	my $uct2 = "";
	my $ind = 0;
	my $subcats = 0;

	while ($uct ne $ucat) {
		$uct = $uct . substr($ucat, $ind, 1);
		$uct2 = $uct2 . substr($ucat, $ind, 1);
		if ($uct2 eq " ") {
			$uct2 = "";
		}
		++$ind;
		if (substr($ucat, $ind, 1) eq ";") {
			if ($cat=~/$uct2/) {
				$okay = "1";
				$bookok = "1";
			}
			$uct2 = "";
			$uct = $uct . ";";
			++$ind;
		}
	}

	my $catb = " $cat ";

	if ($catb=~/ Bookmarks/) {
		if ($bookok eq "1") {
		} else {
			$okay = "";
		}

		if ($isMeta eq "1") {
			$okay = "1";
		}
	}

	if ($okay ne "1") {
		UI::writeHeaderCode();
		print $TS::TS_common_nocatorprivs;
		print "<p><a href=\"rncat.cgi?cat=$cat\">$TS::TS_common_applyhere</a>";
		UI::writeScriptFooter();
		exit(0);
	}

	return $cat;
}


# Tests if the user has editing privs in a given category;
#  the execution of the script is halted if the privs are not enough.
# Params: 1
# Param 1: the name of the category
# Returns: the name of the category, converted after applying security measures

sub testCATMVPrivs
{
	my($cat) = @_;
	$cat = validateCat($cat, 2);

	$okay = "0";

	if ($isFullEditall eq "1") {
		$okay = "1";
	}

	#Does the user have editing privs?
	$ucat = "";
	if (open(DCATS, "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm")) {
		$ucat = <DCATS>;
		close(DCATS);

		$ucat=~s/[\r\n]//g;
		$ucat=~s/[ ]*$//;
		if (!($ucat=~/;[ ]*$/)) {
			$ucat = $ucat . ";";
		}
	}

	$uct = "";
	$uct2 = "";
	$ind = 0;
	$subcats = 0;

	while ($uct ne $ucat) {
		$uct = $uct . substr($ucat, $ind, 1);
		$uct2 = $uct2 . substr($ucat, $ind, 1);
		if ($uct2 eq " ") {
			$uct2 = "";
		}
		++$ind;
		if (substr($ucat, $ind, 1) eq ";") {
			if ($cat=~/$uct2/) {
				$okay = "1";
				$bookok = "1";
			}
			$uct2 = "";
			$uct = $uct . ";";
			++$ind;
		}
	}

	$catb = " $cat ";

	if ($catb=~/ Bookmarks/) {
		if ($bookok ne "1") {
			$okay = "";
		}

		if ($isMeta eq "1") {
			$okay = "1";
		}
	}

	return $okay;
}


# Tests if the user has editing privs in a given category;
#  does not halt the script even if the if the privs are not enough.
# Params: 1
# Param 1: the name of the category
# Returns: 1 if the editor has privs, 0 if not.

sub hasPrivs
{
	my($cat) = @_;
	$cat = validateCat($cat);

	$okay = "0";

	if ($isFullEditall eq "1") {
		$okay = "1";
	}

	# Does the user have editing privs?
	open(DCATS, "$path_data/eperm/$ENV{REMOTE_USER}.perm");
	$ucat = <DCATS>;
	close(DCATS);

	$uct = "";
	$uct2 = "";
	$ind = 0;
	$subcats = 0;

	while ($uct ne $ucat) {
		$uct = $uct . substr($ucat, $ind, 1);
		$uct2 = $uct2 . substr($ucat, $ind, 1);
		if ($uct2 eq " ") {
			$uct2 = "";
		}
		++$ind;
		if (substr($ucat, $ind, 1) eq ";") {
			if ($cat=~/$uct2/) {
				$okay = "1";
				$bookok = "1";
			}
			$uct2 = "";
			$uct = $uct . ";";
			++$ind;
		}
	}

	$catb = " $cat ";

	if ($catb=~/ Bookmarks/) {
		if ($bookok ne "1") {
			$okay = "0";
		}

		if ($isMeta eq "1") {
			$okay = "1";
		}
	}

	return $okay;
}


# Set a new password for a given user
# Params: 2
# Param 1: the username
# Param 2: the new password

sub setPassword {
	my($user, $pass) = @_;

	if (!(-f "$path_data/users.upf")) {
		open(FIL, ">$path_data/users.upf");
		close(FIL);
	}
	
	my $crypted = crypt($pass, "VL");

        open(FIL, "$path_data/users.upf");
        my @pwt = <FIL>;
        close(FIL);

	foreach(@pwt) {
		my($username,$password) = split(/:/, $_);
		if ($username eq $user) {
			$_ = '';
		}
	}

	open(FIL, ">$path_data/users.upf");
        print FIL @pwt;
        close(FIL);
	open(FIL, ">>$path_data/users.upf");
	print FIL "$user:$crypted\n";
	close(FIL);
	
	#system("$path_htpasswd -b $path_data/users.upf $user $pass");
}


# Get a specific setting for the current user, for a given ID
# Default: 0.

sub getSetting
{
	my($settingNo) = @_;

	my $user = Editor::currentUser();
	
	if (open(FILE, "$path_data/misc/$user.set")) {
		my $set = <FILE>;
		close(FILE);

		if ($set=~/#$settingNo#([^#]*)#/) {
			return $1;
		}
	}

	return 0;
}


# Set a specific setting for the current user, for a given ID

sub setSetting
{
	my($settingNo, $settingValue) = @_;

	my $cUser = Editor::currentUser();
	
	my $set = "";
	if (open(FILE, "$path_data/misc/$cUser.set")) {
		$set = <FILE>;
		close(FILE);
	}

	if (!($set=~/#$settingNo#([^#]*)#/)) {
		$set .= " #$settingNo#0#";
	}

	$set=~s/#$settingNo#[^#]*#/#$settingNo#$settingValue#/;

	open(FILE, ">$path_data/misc/$cUser.set");
	print FILE $set;
	close(FILE);
}


sub displayBox
{
	my($id, $title, $content) = @_;

	my $link = $0;
	$0=~/\/([^\/\\]*)$/;
	$link = $1;

	if (getSetting($id) == 0) {
		print <<END;
<p>
  <table width="100%" cellspacing="0" border="0">
    <tr bgcolor="$UI::dark[$UI::currentskin]">
      <td>
        <font color="$UI::subheading[$UI::currentskin]">
          $title
        </font>
      </td>
      <td align="right">
        <font color="$UI::subheading[$UI::currentskin]">
          [<a href="$link?modifyValue=$id&newValue=1"><font color="$UI::subheading[$UI::currentskin]">$TS::TS_common_hide</font></a>]
        </font>
      </td>
    </tr>
    <tr bgcolor="$UI::light[$UI::currentskin]">
      <td colspan="2">
        $content
      </td>
    </tr>
  </table>
</p>
END
	} else {
		print <<END;
<p>
  <table width="100%" cellspacing="0" border="0">
    <tr bgcolor="$UI::dark[$UI::currentskin]">
      <td>
        <font color="$UI::subheading[$UI::currentskin]">
          $title
        </font>
      </td>
      <td align="right">
        <font color="$UI::subheading[$UI::currentskin]">
          [<a href="$link?modifyValue=$id&newValue=0"><font color="$UI::subheading[$UI::currentskin]">$TS::TS_common_show</font></a>]
        </font>
      </td>
    </tr>
  </table>
</p>
END
	}

	return 1;
}


if (defined $cgi->param('modifyValue')) {
	setSetting($cgi->param('modifyValue'), $cgi->param('newValue'));
}


return 1;
