package Generate;

use strict;
use CGI;
use Settings;
use PTS;
use Storage;

my ($i, $j, $k, $dnn, $x, $URL, $width, $r, $cs, $HCtable, @tbx, $c, $d);
my ($namecat, $p, $display, $line, $searchcat, $ptcat, $url);
my ($alt, $height, $idt, $leng, $notFound, @tmpl, $tmpcat, $cca);
my ($indexL, $users, @fieldUsed, @used, @used2);
my (%rlinks, %rflags, %aflags, %tflags, $linktext, $checkcat, $linkall, $linktemplate);
my ($loadedlinks) = 0;

my $cgi = new CGI;
my $fullindex = $cgi->param('fullindex');
if (!defined $fullindex) {
	$fullindex = "";
}


# In case static HTMLs are used, the static HTML is updated for a
#  given category.
# Params: 1
# Param 1: the category path which will have the static HTML updated.

sub updatePublicSide
{
	my($cat) = @_;
	my($pcat);
	if ($denyCatCgi eq "1") {
		$pcat = $cat;
		$pcat=~s/>/\//g;
	
		mkdir("$path_web/$pcat", 0777);

		if (open(FIL, ">$path_web/$pcat/index.html")) {
			print(FIL Generate::generateContent($cat));
			close(FIL);
		}
		
		if ($cat=~/^(.*)>/) {
			updatePublicSide($1);
		}
	}
	
	return 1;
}


# Param: 3
# 1: Category (Validation should already be done)
# 2: Text to check for section links
# 3: Type of text, 0 for a section, 1 for template data

sub sectionLink
{
	my($cat, $text, $type) = @_;
	
	unless ( $loadedlinks ) {
		# load the section links
		# First, if there are no section links, return unaltered string
		unless ( -e "$path_sitedata/$cat.scl" ) { return $text; }
		$loadedlinks = 1; # Only do this once
		open (LINKS, "$path_sitedata/$cat.scl");
		my @slinks = <LINKS>;
		close(LINKS);
		chomp(@slinks);
	
		# need to load the list of cats, since they won't be loaded for this sub
		open(DCATS, "$path_sitedata/cats.lst");
		my $ucat = <DCATS>;
		close(DCATS);
	
		foreach (@slinks) {
			($linktext, $checkcat, $linkall, $linktemplate) = split(/:/);
			$linktext =~ s/_/ /g;
			if (index($ucat, " $checkcat; ") >= 0) {
				$checkcat =~ s/>/\//g;
				$rlinks{$linktext} = $checkcat;
				$rflags{$linktext} = 0;
				if ( $linkall eq "on" ) { $aflags{$linktext} = 1 } else { $aflags{$linktext} = 0 }
				if ( $linktemplate eq "on" ) { $tflags{$linktext} = 1 } else { $tflags{$linktext} = 0 }
			}
		}
	}
	
	# Links are loaded so check the text for section links
		# Links are loaded so check the text for section links
	foreach $linktext (keys %rlinks) {
		if ( ( ( $tflags{$linktext} ) && ( $type == 1 ) ) || ( ( $aflags{$linktext} ) && ( $type == 0 ) ) ) {
			if ( ( $linktext =~ m/^\[/ ) && ( $linktext =~ /\]$/ ) ) {
				( my $replacetext = $linktext ) =~ s/^\[(.*)\]$/$1/;
				$text =~ s/\[($replacetext)\]/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/gi
			} else {
				$text =~ s/(\s|\(|\'|\’|\")($linktext)(\s|\"|\'|\’|\.|\,|\(|\)|\!|\:|\;)/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>$3/gi;
				$text =~ s/^($linktext)(\s|\"|\'|\’|\.|\,|\(|\)|\!|\:|\;)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>$2/gi;
				$text =~ s/(\s|\(|\'|\’|\")($linktext)$/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>/gi;
				if ( lc $text eq lc $linktext ) { 
					# This is for the case where the whole of the text is equal to the section link
					$text =~ s/($linktext)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/gi;
				}
			}
		}
	
		if ( ( !$aflags{$linktext} ) && ( $type == 0 ) && ( !$rflags{$linktext} ) ) {
			if ( ( $linktext =~ m/^\[/ ) && ( $linktext =~ /\]$/ ) ) {
				( my $replacetext = $linktext ) =~ s/^\[(.*)\]$/$1/;
				if ( $text =~ s/\[($replacetext)\]/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/i ) {
					$rflags{$linktext} = 1;
				}
			} else {
				if ( ( $text =~ s/(\s|\(|\'|\’|\")($linktext)(\s|\"|\’|\'|\.|\,|\(|\)|\!|\:|\;)/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>$3/i )
					|| ( $text =~ s/^($linktext)(\s|\"|\’|\'|\.|\,|\(|\)|\!|\:|\;)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>$2/i )
					|| ( $text =~ s/(\s|\(|\'|\’|\")($linktext)$/$1<a href=\"$path_on_server\/$rlinks{$linktext}\">$2<\/a>/i ) ) {
					$rflags{$linktext} = 1;
				}
				if ( lc $text eq lc $linktext ) { 
					# This is for the case where the whole of the text is equal to the section link
					$text =~ s/($linktext)/<a href=\"$path_on_server\/$rlinks{$linktext}\">$1<\/a>/gi;
					$rflags{$linktext} = 1;
				}
			}
		}
	}
	
	return $text;
}


sub noHTML
{
	my($content) = @_;
	
	$content=~s/</&lt;/g;
	$content=~s/>/&gt;/g;
	
	return $content;
}


sub safeHTML
{
	my($content) = @_;
	
	$content=~s/<xmp>/&lt;xmp&gt;/g;
	$content=~s/<xml>/&lt;xml&gt;/g;
	$content=~s/<noscript>/&lt;noscript&gt;/g;
	$content=~s/<script>/&lt;script&gt;/g;
	$content=~s/<pre>/&lt;pre&gt;/g;
	$content=~s/<!--/&lt!--/g;
	$content=~s/-->/--&gt;/g;
	
	return $content;
}


sub okayAuto
{
	my($cat) = @_;
	
	my $tpm;
	if (-f "$path_sitedata/$cat.ct") {
		open(TMP, "$path_sitedata/$cat.ct");
		$tpm = <TMP>;
		close(TMP);
	}
	$tpm=~s/[\n\r]+//g;
	
	my @displ;
	if (-f "$path_data/template/$tpm") {
		open(CONTENT, "$path_data/template/$tpm");
		@displ = <CONTENT>;
		close(CONTENT);
	
		if ($displ[0]=~/2.01/) {
			return 0;
		}
	}
	
	return 1;
}


sub generateContent
{
	my($cat) = @_;
	my($HC);
	
	my @cont = split("\n", Storage::getData("category", $cat, "redir"));
	
	open(DCATS, "$path_sitedata/cats.lst");
	my $ucat = <DCATS>;
	close(DCATS);
	
	if (!($ucat=~/ $cat; /)) {
		if ($cont[0]=~/1/) {
			$url = $cont[1];
			$url=~s/>/\//g;
			$HC = "Status: 301 Moved\nLocation: /$url/\n\n";
	
			return $HC;
		}
	}
	
		$HC = <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
END

	my $fPath = "$path_sitedata/items/titles/$cat.tlt";
	my $dtitle = "";
	if (-f $fPath) {
		open(TITLE, $fPath);
		$dtitle = <TITLE>;
		close(TITLE);
	}
	
	$dtitle = noHTML($dtitle);
	
	if ($dtitle ne "") {
		$HC = $HC . "<title>$dtitle - $HD_name</title>\n";
	} else {
		if ($cat ne "") {
			$ptcat = $cat;
			$ptcat =~ s/>/: /g;
			$HC = $HC . "<title>$ptcat - $HD_name</title>\n";
		} else {
			$HC = $HC . "<title>$HD_name</title>\n";
		}
	}
	
	$HC = $HC . <<END;
</head>
<body bgcolor="#ffffff">
<table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="3" width="100%" bgColor="#000000" border="0">
  <tr bgColor="#006699">
    <td vAlign="middle" align="left" width="805" colSpan="2" height="23">
    <font face="Arial, Helvetica, sans-serif" color="#ffffff" size="5">$HD_title</font>
    </td>
  </tr>
  <tr>
    <td align="right" width="50%" bgColor="#cccccc" height="16">
    <p align="left"><font face="Arial, Helvetica, sans-serif" size="2">$HD_description</font></p></td>
    <td width="50%" bgColor="#cccccc" height="16">
    <div align="right">
      <a href="$path_on_server/"><b>
$PTS::TS_common_home</b></a>
END

	#Does it exist?
	open(DCATS, "$path_sitedata/cats.lst");
	$ucat = <DCATS>;
	close(DCATS);
	
	if (index($ucat, " $cat; ") >= 0) {
		my @cat2;
		if (-f "$path_sitedata/$cat.html") {
			open(CAT, "$path_sitedata/$cat.html");
			@cat2 = <CAT>;
			close(CAT);
		}
	
		my @edi = ("");
		if (-f "$path_sitedata/$cat.ed") {
			open(ED, "$path_sitedata/$cat.ed");
			@edi = <ED>;
			close(ED);
		}
	
		my @optsV = split("\n", Storage::getData("category", $cat, "catopt"));
		if ($#optsV < 1) {
			@optsV = ("", "", "", "");
		}
		my $opts = $optsV[0];
		my $fullindexenable = $optsV[3];
		
		if (!defined $opts) {
			$opts = "";
		}
		if (!defined $fullindexenable) {
			$fullindexenable = "";
		}
		
		$opts=~s/\s//g;
	
		my $scat = $cat;
		$scat=~s/>/\//g;
	
		if ($opts ne "off") {
			if ($allowUnreviewed) {
				$HC = $HC . " | <a href=\"$path_on_server/add.cgi?cat=$scat\">$PTS::TS_cat_add</a>";
			}
			$HC = $HC . " | <a href=\"$path_on_server/apply.cgi?cat=$scat\">$PTS::TS_cat_become</a>";
		}
	
		$HC = $HC . "</div> </td> </tr></table>";
	
		my $ct = "";
		my $ct2 = "";
		my $ind = 0;
	
		my $tpm = "";
		if (-f "$path_sitedata/$cat.ct") {
			open(TMP, "$path_sitedata/$cat.ct");
			$tpm = <TMP>;
			close(TMP);
		}
		chomp($tpm);

		my @tem;
		if (-f "$path_sitedata/$cat.tem") {
			open(TEMPD, "$path_sitedata/$cat.tem");
			@tem = <TEMPD>;
			close(TEMPD);
		}
	
		my @displ = ("");
		if (-f "$path_data/template/$tpm") {
			open(CONTENT, "$path_data/template/$tpm");
			@displ = <CONTENT>;
			close(CONTENT);
		}
	
		my $w = "100";
	
		if (($cat=~/>/) || ($cat=~/\//)) {
			if ($cat=~/([^>\/]*)[\/|>]([^>\/;]*)$/) {
				$searchcat = $1 . "/" . $2;
			}
		} else {
			$searchcat = $cat;
		}
	
		if ($allowSearch) {
			$HC = $HC . <<END;
<p><div align="center"><form accept-charset="UTF-8" action="$path_on_server/search.cgi" method="GET">
<input size="30" name="search"> <input type="submit" value="$PTS::TS_cat_search">
    <small><select name="all"><option selected value="yes">$PTS::TS_cat_alldir
<option value="no">$PTS::TS_cat_onlyin $searchcat
</select>
</small>
<input type="hidden" name="cat" value="$cat">
</form></div>
END
		}

		$HC = $HC . "<p><table cellspacing=\"0\" cellpadding=\"3\" align=\"center\" width=\"100%\"><tr>";
	
		if ($tpm ne "") {
			if (($tpm ne "default") && ($displ[0]=~/2.0/)) {
				my $opts = $optsV[2];
				$opts=~s/\s//g;
				if ($opts ne "off") {
					my $w = "80";
					my $tpm_displ = $tpm;
					if ($tpm_displ=~/>(.*)/) {
						$tpm_displ = $1;
					}
					$HC = $HC . "<td valign=\"top\" bgcolor=\"#CCCCCC\" height=\"100%\" width=\"20%\">";
					$HC = $HC . "<table bgcolor=\"#CCCCCC\" cellspacing=\"0\" cellpadding=\"4\" width=\"100%\" align=\"left\">";
					$HC = $HC . "<tr><td valign=\"top\" bgcolor=\"#006699\">";
					$HC = $HC . "<div align=\"center\"><font color=\"white\"><strong>$tpm_displ</strong></font></div></td></tr>";
					$HC = $HC . "<tr><td align=\"center\" height=\"100%\" bgcolor=\"#CCCCCC\" valign=\"top\"><br>";
					my $j = "0";
					for (my $i = "1"; $i <= $#displ; $i = $i + 2) {
						$j++;
						chomp($displ[$i]);
						chomp($displ[$i + 1]);
						$displ[$i]=~s/.$//g;
						chomp($tem[$j]);
						if ($tem[$j] ne "") {
							$displ[$i + 1] =~ s/#name/$tem[$j]/g;
							my $k = $i + 1;
							# Look for section links in the template
							$displ[$k] = sectionLink($cat, $displ[$k], 1);
	
							$HC = $HC . "<p><strong>$displ[$i]:</strong><br>$displ[$k]";
						}
					}
					$HC = $HC . "</td></tr>";
					$HC = $HC . "</table></td>";
				}
			}
		}
	
		$HC = $HC . "<td valign=\"top\" width=\"$w%\"><big><strong><a href=\"$path_on_server/\">Top</a>";
		while ($ct ne $cat) {
			$ct = $ct . substr($cat, $ind, 1);
			$ct2 = $ct2 . substr($cat, $ind, 1);
			++$ind;
			$ct2=~s/_/ /g;
	
			if (substr($cat, $ind, 1) eq ">") {
				my $blr = $ct;
				$blr=~s/>/\//g;
				$HC = $HC . ": <a href=\"$path_on_server/$blr/\">$ct2</a>";
				$ct2 = "";
				$ct = $ct . substr($cat, $ind, 1);
				++$ind;
			}
		}
		$HC = $HC . ": $ct2</strong>";
	
		my @ttt = ("");
		if (-f "$path_sitedata/$cat.reviewed") {
			open(TT, "$path_sitedata/$cat.reviewed");
			@ttt = <TT>;
			close(TT);
		}
	
		my $rd = $ttt[0];
		$rd=~s/[\n\r]//g;
	
		if ($rd eq "") {
			$rd = 0;
		}
	
		$HC = $HC . " ($rd) ";
	
		$HC = $HC . "</big><hr>";
		$leng = $ind;
	
		my $alpha = "0";
	
		while ($ucat =~/ $cat>.;/g) {
			$alpha++;
		}
	
		my $rr = $cat;
		$rr =~s/>/\//g;
	
		if ($alpha >= "5") {
			$HC = $HC . "<center>[ <b>";
			my $subc_list = "";
			while ($ucat =~/ $cat>(.);/g) {
				if ($subc_list ne "") {
					 $subc_list = $subc_list . ";";
				}
				$subc_list = $subc_list . "<a href=\"$path_on_server/$rr/$1/\">$1</a>";
			}
			if (($fullindexenable ne "") && ($fullindexenable ne "\n") && ($fullindex eq "")) {
				$subc_list = $subc_list . ";<a href=\"$path_on_server/$rr/full-index.html\">Complete List</a>";
			}
			my @tempstor = split(";", $subc_list);
			@tempstor = sort @tempstor;
			$subc_list = join(";", @tempstor);
			$subc_list=~s/;/ | /g;
			$HC = $HC . "$subc_list </b>]</center><hr>";
		}
	
		my $subcats = 0;
		my @datas;
	
		my $autocode = "";
	
		my @ntdcats;
	
		if ($alpha >= "5") {
			if (($fullindex ne "") && ($fullindexenable ne "\n") && ($fullindexenable ne "")) {
				while ($ucat=~/ $cat>(.>[^;>]*);/g) {
					my $namesubcat = $1;
					my $uct2 = $1;
					my $backt = $1;
					my $uct = $cat;
					$uct=~s/>/\//g;
					$uct2=~s/_/ /g;
					$uct2=~s/.*>//g;
					$backt=~s/>/\//g;
	
					open(TT, "$path_sitedata/$cat>$namesubcat.reviewed");
					my @ttt = <TT>;
					close(TT);
	
					my $rd = $ttt[0];
					$rd=~s/\n//g;
					$rd=~s/\r//g;
	
					if ($rd eq "") {
						$rd = 0;
					}
	
					$datas[$subcats] = "<li><strong><a href=\"$path_on_server/$uct/$backt/\">$uct2</a></strong> ($rd)<br>";
					$ntdcats[$subcats] = $cat . ">" . $namesubcat;
					$subcats++;
				}
			} else {
				while ($ucat=~/ $cat>(.[^;>]+);/g) {
					my $namesubcat = $1;
					my $uct2 = $1;
					my $backt = $1;
					my $uct = $cat;
					$uct=~s/>/\//g;
					$uct2=~s/_/ /g;
					$uct2=~s/>/: /g;
					$backt=~s/>/\//g;
					open(TT, "$path_sitedata/$cat>$namesubcat.reviewed");
					my @ttt = <TT>;
					close(TT);
	
					$rd = $ttt[0];
					$rd=~s/\n//g;
					$rd=~s/\r//g;
	
					if ($rd eq "") {
						$rd = 0;
					}
	
					$datas[$subcats] = "<li><strong><a href=\"$path_on_server/$uct/$backt/\">$uct2</a></strong> ($rd)<br>";
					$ntdcats[$subcats] = $cat . ">" . $namesubcat;
					$subcats++;
					if (okayAuto($cat . ">" . $namesubcat)) {
						$autocode = $autocode . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=\"#e8e8e8\"><td><strong><a name=\"#$namesubcat\">$namesubcat</a></strong></td></tr><tr><td bgcolor=\"#f0f0f0\">";
						open(CAT, "$path_sitedata/$cat>$namesubcat.html");
						my @dtdata = <CAT>;
						close(CAT);
						for (my $j = "0"; $j <= $#dtdata; $j++) {
							$autocode = $autocode . $dtdata[$j];
						}
						$autocode = $autocode . "<p>[<a href=\"$path_on_server/$uct/$backt/\">more information</a>]</td></tr></table></p>";
					}
				}
			}
		} else {
			while ($ucat=~/ $cat>([^;>]+);/g) {
				my $namesubcat = $1;
				my $uct2 = $1;
				my $backt = $1;
				my $uct = $cat;
				$uct=~s/>/\//g;
				$uct2=~s/_/ /g;
				$uct2=~s/>/: /g;
				$backt=~s/>/\//g;
				
				my @ttt = ("");
				if (-f "$path_sitedata/$cat>$namesubcat.reviewed") {
					open(TT, "$path_sitedata/$cat>$namesubcat.reviewed");
					@ttt = <TT>;
					close(TT);
				}
	
				my $rd = $ttt[0];
				$rd=~s/[\n\r]//g;
	
				if ($rd eq "") {
					$rd = 0;
				}
	
				$datas[$subcats] = "<li><strong><a href=\"$path_on_server/$uct/$backt/\">$uct2</a></strong> ($rd)<br>";
				$ntdcats[$subcats] = $cat . ">" . $namesubcat;
				$subcats++;
				if (okayAuto($cat . ">" . $namesubcat)) {
					$autocode = $autocode . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=\"#e8e8e8\"><td><strong><a name=\"#$namesubcat\">$namesubcat</a></strong></td></tr><tr><td bgcolor=\"#f0f0f0\">";
					open(CAT, "$path_sitedata/$cat>$namesubcat.html");
					my @dtdata = <CAT>;
					close(CAT);
					for (my $j = "0"; $j <= $#dtdata; $j++) {
						$autocode = $autocode . $dtdata[$j];
					}
					$autocode = $autocode . "<p>[<a href=\"$path_on_server/$uct/$backt/\">more information</a>]</td></tr></table></p>";
				}
			}
		}
	
		if (($fullindex ne "") && ($fullindexenable ne "\n") && ($fullindexenable ne "")) {
			while ($ucat=~/ ($cat>.);/g) {
				open(LINKS, "$path_sitedata/$1.symlinks");
				while (<LINKS>) {
					$line = $_;
					chomp($line);
					my($linktitle, $linkcat) = split(/:/, $line);
					my $namesubcat = $linkcat;
					$linkcat=~s/>/\//g;
					$linktitle=~s/_/ /g;
					$datas[$subcats] = "<li><strong><a href=\"$path_on_server/$linkcat\/\">$linktitle</a></strong>\@<br>";
					$ntdcats[$subcats] = $namesubcat;
					$subcats++;
				}
			}
		} elsif (-f "$path_sitedata/$cat.symlinks") {
			open(LINKS, "$path_sitedata/$cat.symlinks");
			while (<LINKS>) {
				$line = $_;
				chomp($line);
				my($linktitle, $linkcat) = split(/:/, $line);
				$linkcat=~s/\//>/g;
				$linkcat=~s/\s+$//g;
				$linkcat=~s/>$//;
				if (index($ucat, " $linkcat; ") >= 0) {
					my $namesubcat = $linkcat;
					$linkcat=~s/>/\//g;
					$linktitle=~s/_/ /g;
					$datas[$subcats] = "<li><strong><a href=\"$path_on_server/$linkcat\/\">$linktitle</a></strong>\@<br>";
					$ntdcats[$subcats] = $namesubcat;
					$subcats++;
				}
			}
		}
	
		my @pricat;
		if (-f "$path_sitedata/$cat.pricat") {
			open(LINKS, "$path_sitedata/$cat.pricat");
			@pricat = <LINKS>;
			close(LINKS);
		}
		
		my $pricat = join("", @pricat);
		$pricat=~s/ /_/g;
		$pricat = " " . $pricat;
	
		my $bckupxxx = $subcats;
	
		for (my $prior = "2"; $prior >= "0"; $prior--) {
			my $subcats = $bckupxxx;
			my @subcat_list = ();
			for (my $i = 0; $i < $subcats; $i++) {
				my $tempx = $datas[$i];
				if ($tempx=~/<a href=\".*?\">(.*?)<\/a>/) {
					$namecat = $1;
				}
	
				$namecat=~s/ /_/g;
	
				if ($pricat=~/\s$namecat.;/) {
					$notFound = "0";
				} else {
					$notFound = "1";
				}
	
				if (($pricat=~/\s$namecat$prior;/) || (($prior eq "0") && ($notFound eq "1"))) {
					push(@subcat_list, $datas[$i]);
				}
			}
	
			@subcat_list = sort {
				($c) = $a=~/<a href=\".*?\">(.*?)<\/a>/;
				($d) = $b=~/<a href=\".*?\">(.*?)<\/a>/;
				$c cmp $d;
			} (@subcat_list);
	
			$subcats = $#subcat_list;
			$subcats++;
	
			if ($subcats >= 1) {
				$HC = $HC . "<table align=\"center\" width=\"100%\"><tr>";
				if ($subcats < 6) {
					$HC = $HC . "<td valign=\"top\" width=\"100%\"><ul>";
					for (my $i = "0"; $i < $subcats; $i++) {
						$HC = $HC . "$subcat_list[$i]\n";
					}
					$HC = $HC . "</ul></td>";
				} else {
					$HC = $HC . "<td valign=\"top\" width=\"50%\"><ul>";
					$x = $subcats / 2;
					$p = 0;
					while ($x >= 1) {
						$p++;
						$x--;
					}
	
					if ($x eq "0.5") {
						$p++;
					}
	
					for (my $i = "0"; $i < $p; $i++) {
						$HC = $HC . "$subcat_list[$i]\n";
					}
	
					$HC = $HC . "</ul></td><td valign=\"top\" width=\"50%\"><ul>";
					for (my $i = $p; $i < $subcats; $i++) {
						$HC = $HC . "$subcat_list[$i]\n";
					}
					$HC = $HC . "</ul></td>";
				}
				$HC = $HC . "</tr></table><hr>";
			}
		}
	
		$HC = $HC . "<br>";
	
		@tem = ();
		if (-f "$path_sitedata/$cat.rel") {
			open(TEMPD, "$path_sitedata/$cat.rel");
			@tem = <TEMPD>;
			close(TEMPD);
	
			if ($tem[0] ne "") {
				$HC = $HC . "<br>\n<div align=\"left\">\n  $PTS::TS_cat_alsosee:<ul>";
				for (my $i = "0"; $i <= $#tem; $i++) {
					my $checkcat = $tem[$i];
					$checkcat=~s/\//>/g;
					$checkcat=~s/\s+$//g;
					$checkcat=~s/>$//;
					if (index($ucat, " $checkcat; ") >= 0) {#*
						$tem[$i]=~s/>/\//g;
						$tem[$i]=~s/\/$//;
						$display = $tem[$i];
						$display=~s/\//: /g;
						$display=~s/_/ /g;
						$HC = $HC . "<li><a href=\"/$tem[$i]/\">$display</a></li>";
					}
				}
				$HC = $HC . "</ul>\n</div>\n";
			}
		}
	
		@tem = ();
		if (-f "$path_sitedata/$cat.altlangs") {
			open(TEMPD, "$path_sitedata/$cat.altlangs");
			@tem = <TEMPD>;
			close(TEMPD);
	
			if ($tem[0] ne "") {
				$HC = $HC . "<p>$PTS::TS_cat_otherlangs:";
				my $f = "0";
				for (my $i = "0"; $i <= $#tem; $i++) {
					my $checkcat = $tem[$i];
					$checkcat=~s/\//>/g;
					$checkcat=~s/\s+$//g;
					$checkcat=~s/>$//;
					if (index($ucat, " $checkcat; ") >= 0) {
						if ($f eq "0") {
							$HC = $HC . "<br>&nbsp; &nbsp; &nbsp; ";
						} else {
							$HC = $HC . "&nbsp; &nbsp; &nbsp; ";
						}
						my $lang = "English";
						$tem[$i]=~s/>/\//g;
						if (($tem[$i]=~/\/$/) || ($tem[$i]=~/\/\s/)) {
						} else {
							$tem[$i] = $tem[$i] . "/";
						}
						if ($tem[$i]=~/International\/([^\>\/]*)/) {
							$lang = $1;
						}
						$HC = $HC . "<a href=\"$path_on_server/$tem[$i]\">$lang</a>";
						$f++;
						if ($f eq "3") {
							$f = "0";
						}
					}
				}
				$HC = $HC . "</p>";
			}
		}
	
		my $ctdr = join("<br>", @cat2);
		$HC = $HC . "$ctdr\n";
	
		if ($tpm ne "") {
			if ($tpm ne "default") {
				$opts = $optsV[2];
				$opts=~s/\s//g;
				if ($opts eq "off") {
					open(TMP, "$path_sitedata/$cat.ct");
					my $tpm = <TMP>;
					close(TMP);
	
					open(TEMPD, "$path_sitedata/$cat.tem");
					my @tem = <TEMPD>;
					close(TEMPD);
	
					chomp($tpm);
	
					open(CONTENT, "$path_data/template/$tpm");
					my @displ = <CONTENT>;
					close(CONTENT);
	
					my $w = "80";
					my $tpm_displ = $tpm;
					if ($tpm_displ=~/>(.*)/) {
						$tpm_displ = $1;
					}
	
					my $llcat = $cat;
					$llcat=~s/.*>([^>]*)/$1/;
					$HC = $HC . "<p><table align=\"center\" cellspacing=\"1\" cellpadding=\"0\" align=\"left\">";
					$HC = $HC . "<tr bgcolor=\"#eeeeee\" align=\"center\"><td colspan=\"2\">";
					$HC = $HC . "<strong>$tpm_displ</strong></td></tr>";
					my $j = "0";
					for (my $i = "1"; $i <= $#displ; $i = $i + 2) {
						$j = $j + 1;
						chomp($displ[$i]);
						chomp($tem[$j]);
						if ($tem[$j] ne "") {
							$displ[$i] =~ s/#name//g;
							$HC = $HC . "<tr bgcolor=\"#f0f0ff\"><td>$displ[$i]</td><td>$tem[$j]</td></tr>";
						}
					}
					$HC = $HC . "</table></p>";
				}
			}
		}
	
		my $auto = "";
		if (-f "$path_sitedata/$cat.autogen") {
			open(LDATA, "$path_sitedata/$cat.autogen");
			$auto = <LDATA>;
			close(LDATA);
		
			if ($auto eq "ON") {
				$HC = $HC . $autocode;
			}
		}
	
		my $tb = 0;
		if (-f "$path_sitedata/$cat.sections") {
			open(TEMPD, "$path_sitedata/$cat.sections");
			$tb = <TEMPD>;
			close(TEMPD);
		}
		for (my $i = 1; $i <= $tb; $i++) {
			push(@used, "");
		}
	
		for (my $i = 1; $i <= $tb; $i++) {
			my @tb;
			if (-f "$path_sitedata/$cat.sct$i") {
				open(TEMPD, "$path_sitedata/$cat.sct$i");
				@tb = <TEMPD>;
				close(TEMPD);
			
			if (($tb[0] ne "") && ($tb[0] ne "\n")) {
				chomp($tb[0]);
				my $indexL = "3";
				if ($tb[0]=~/2.0/) {
					my $nm = $tb[1];
					$nm=~s/[\n\r]+//g;
					@tmpl = ("");
					if (-f "$path_data/template/$nm") {
						open(TEMPL, "$path_data/template/$nm");
						@tmpl = <TEMPL>;
						close(TEMPL);
					}
					if (($tmpl[0]=~/2.01/) && ($used[$i] eq "") && ($tb[2] ne "") && ($tb[2] ne "\n")) {
						my $cs = $#tmpl + 1;
						$fieldUsed[0] = 1;
						$HCtable = "";
						$tb[1]=~s/\n//g;
						$tb[1]=~s/\r//g;
	
						if ($auto eq "ON") {
							for ($j = 0; $j < $bckupxxx; $j++) {
								$tmpcat = $ntdcats[$j];
								open(TEMPD, "$path_sitedata/$tmpcat.tem");
								@tbx = <TEMPD>;
								close(TEMPD);

								open(TMP, "$path_sitedata/$tmpcat.ct");
								$tpm = <TMP>;
								close(TMP);

								chomp($tpm);
	
								if (($tpm eq $tb[1]) && ($used2[$j] eq "")) {
									$used2[$j] = "1";
									$HCtable = $HCtable . "<tr align=\"center\" bgcolor=\"#f0f0ff\">";
									for ($k = 0; $k <= $#tmpl / 2; $k++) {
										$x = $k;
										$cca = "";
										if ($x >= 1) {
											$idt = $x * 2;
											$r = $tmpl[$idt];
											$tbx[$x]=~s/[\n\r]+//g;
											$r=~s/#name/$tbx[$x]/g;
										} else {
											$r = $tmpcat;
											$dnn = $r;
											$dnn=~s/.*>(.*?)/$1/;
											$dnn=~s/_/ /g;
											$r=~s/>/\//g;
											$r = "<a href=\"/$r\">$dnn</a>";
											$cca = " align=left";
										}
										if ($tbx[$x] ne "") {
											$HCtable = $HCtable . "<td$cca>$r</td>";
											$fieldUsed[$k] = 1;
										} else {
											$HCtable = $HCtable . "<td empty##\!##$k##\!##> </td>";
										}
									}
									$HCtable = $HCtable . "</tr>";
								}
							}
						}
	
						for (my $j = 1; $j <= $tb; $j++) {
							if (-f "$path_sitedata/$cat.sct$j") {
							open(TEMPD, "$path_sitedata/$cat.sct$j");
							@tbx = <TEMPD>;
							close(TEMPD);
							$tbx[1]=~s/[\n\r]+//g;
							$tbx[2]=~s/[\n\r]+//g;
							if (($tb[1] eq $tbx[1]) && ($used[$j] eq "")) {
								$used[$j] = "1";
								if ($tbx[2] ne "") {
									$HCtable = $HCtable . "<tr align=\"center\" bgcolor=\"#f0f0ff\">";
									for ($k = 0; $k <= $#tmpl / 2; $k++) {
										$x = $k + 2;
										$cca = "";
										if ($x ne "2") {
											$idt = ($x - 2) * 2;
																				$r = $tmpl[$idt];
										} else {
											$r = "#name";
											$cca = " align=left";
										}
										$tbx[$x]=~s/\n//g;
										$tbx[$x]=~s/\r//g;
										$tbx[$x] = sectionLink($cat, $tbx[$x], 0);
										$r=~s/#name/$tbx[$x]/g;
										if ($tbx[$x] ne "") {
											$HCtable = $HCtable . "<td$cca>$r</td>";
											$fieldUsed[$k] = 1;
										} else {
											$HCtable = $HCtable . "<td empty##\!##$k##\!##> </td>";
										}
									}
									$HCtable = $HCtable . "</tr>";
								}
							}
							}
						}
						$HC = $HC . "<p><table width=\"95%\" align=\"center\"><tr bgcolor=\"#e0f0ff\"><td align=\"center\" colspan=\"$cs\"><strong>$nm Overview</strong></td></tr>";
						$HC = $HC . "<tr align=\"center\"><td bgcolor=\"#e8f8ff\" align=left><strong>Name</strong></td>";
						my $id = 0;
						for (my $k = 1; $k <= $#tmpl; $k += 2) {
							$id++;
							if ((defined $fieldUsed[$id]) && ($fieldUsed[$id] eq 1)) {
								$HC = $HC . "<td bgcolor=\"#e8f8ff\"><strong>$tmpl[$k]</strong></td>";
							} else {
								$HCtable=~s/<td empty##\!##$id##\!##> <\/td>//g;
							}
						}
						$HC = $HC . "</tr>";
						$HCtable=~s/ empty##!##.*?##!##//g;
						$HC = $HC . $HCtable;
						$HC = $HC . "</table>";
					}
				}
			}
			}
		}
	
		if ($auto eq "ON") {
			for (my $i = 0; $j < $bckupxxx; $j++) {
				my $tmpcat = $ntdcats[$j];
				open(TEMPD, "$path_sitedata/$tmpcat.tem");
				my @tb = <TEMPD>;
				close(TEMPD);

				my $tpm = "";
				if (-f "$path_sitedata/$tmpcat.ct") {	
					open(TMP, "$path_sitedata/$tmpcat.ct");
					$tpm = <TMP>;
					close(TMP);
				}
	
				chomp($tpm);
				$tpm=~s/[\n\r]+//g;
	
				chomp($tb[0]);
				my $indexL = "3";
	
				my $nm = $tpm;
				open(TEMPL, "$path_data/template/$nm");
				my @tmpl = <TEMPL>;
				close(TEMPL);
	
				if (($tmpl[0]=~/2.01/) && ($used2[$i] eq "")) {
					$cs = $#tmpl / 2 + 1;
					$HC = $HC . "<p><table width=\"95%\" align=\"center\"><tr bgcolor=\"#e0f0ff\"><td align=\"center\" colspan=$cs><strong>$nm Overview</strong></td></tr>";
					$HC = $HC . "<tr align=\"center\"><td bgcolor=\"#e8f8ff\" align=left><strong>Name</strong></td>";
					for ($k = 1; $k <= $#tmpl; $k += 2) {
						$HC = $HC . "<td bgcolor=\"#e8f8ff\"><strong>$tmpl[$k]</strong></td>";
					}
					$HC = $HC . "</tr>";
	
					for (my $j = 0; $j < $bckupxxx; $j++) {
						$tmpcat = $ntdcats[$j];
						open(TEMPD, "$path_sitedata/$tmpcat.tem");
						my @tbx = <TEMPD>;
						close(TEMPD);
	
						open(TMP, "$path_sitedata/$tmpcat.ct");
						my $tpmx = <TMP>;
						close(TMP);
	
						chomp($tpmx);
						$tpmx=~s/\n//g;
						$tpmx=~s/\r//g;
	
						if (($tpm eq $tpmx) && ($used2[$j] eq "")) {
							$used2[$j] = "1";
							$HC = $HC . "<tr align=\"center\" bgcolor=\"#f0f0ff\">";
							for (my $k = 0; $k <= $#tmpl / 2; $k++) {
								my $x = $k;
								my $cca = "";
								if ($x >= 1) {
									$idt = $x * 2;
									$r = $tmpl[$idt];
									$tbx[$x] =~s/[\n\r]+//g;
									$tbx[$x] = sectionLink($cat, $tbx[$x], 0); # Testing this here
									$r=~s/#name/$tbx[$x]/g;
								} else {
									$r = $tmpcat;
									$dnn = $r;
									$dnn=~s/.*>(.*?)/$1/;
									$dnn=~s/_/ /g;
									$r=~s/>/\//g;
									$r = "<a href=\"/$r\">$dnn</a>";
									$cca = " align=left";
								}
								if ($tbx[$x] ne "") {
									$HC = $HC . "<td$cca>$r</td>";
								} else {
									$HC = $HC . "<td> </td>";
								}
							}
							$HC = $HC . "</tr>";
						}
					}
					$HC = $HC . "</table>";
				}
			}
		}
	
		for (my $i = 1; $i <= $tb; $i++) {
			my @tb;
			if (-f "$path_sitedata/$cat.sct$i") {
				open(TEMPD, "$path_sitedata/$cat.sct$i");
				@tb = <TEMPD>;
				close(TEMPD);
			
				chomp($tb[0]);
				$tb[1]=~s/[\n\r]//g;
				$tb[2]=~s/[\n\r]//g;
				my $indexL = "3";
				if (!defined($used[$i])) {
					$used[$i] = "";
				}
				if (($tb[0]=~/2.0/) && ($used[$i] eq "") && ($tb[2] ne "")) {
					my $nm = $tb[1];
					my @tmpl;
					if (-f "$path_data/template/$nm") {
						open(TEMPL, "$path_data/template/$nm");
						@tmpl = <TEMPL>;
						close(TEMPL);
					}

					$HC = $HC . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=\"#e8e8e8\"><td><strong><a name=\"#$tb[2]\">$tb[2]</a></strong></td></tr><tr><td bgcolor=\"#f0f0f0\">";
					my $k = "2";
					for (my $j = 1; $j <= $#tmpl; $j += 2) {
						$k++;
						$tmpl[$j]=~s/\n//;
						$tmpl[$j]=~s/.$//;
						my $r = $tmpl[$j + 1];
						my $ro = $tb[$k];
						$ro=~s/[\n\r]//g;
						$r=~s/#name/$ro/g;
						$r=~s/[\n\r]//g;
						if ($r ne "") {
							$r = sectionLink($cat, $r, 0);
							$HC = $HC . "<strong>" . $tmpl[$j] . "</strong>: " . $r . "<br>";
						}
					}
					$k++;
					$HC = $HC . "<p>";
					for ($j = $k; $j <= $#tb; $j++) {
						# Check for a section link
						$tb[$j] = sectionLink($cat, $tb[$j], 0);
						$HC = $HC . $tb[$j] . "<br>";
					}
					$HC = $HC . "</p></td></tr></table></p>";
					$HC =~ s/<p><\/p>//g;
				} elsif (($used[$i] eq "") && ($tb[0] ne "") && ($tb[0] ne "\n") && (!($tb[0]=~/2.0/))) {
					$HC = $HC . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=\"#e8e8e8\"><td><strong><a name=\"#$tb[0]\">$tb[0]</a></strong></td></tr><tr><td bgcolor=\"#f0f0f0\">";
					for ($j = 1; $j <= $#tb; $j++) {
						$HC = $HC . $tb[$j] . "<br>";
					}
					$HC = $HC . "</td></tr></table></p>";
				}
			}
		}
	
		$tb = 0;
		if (-f "$path_sitedata/$cat.tables") {
			open(TEMPD, "$path_sitedata/$cat.tables");
			$tb = <TEMPD>;
			close(TEMPD);
		}
	
		for (my $i = "1"; $i <= $tb; $i++) {
			open(TEMPD, "$path_sitedata/$cat.tbl$i");
			my @tb = <TEMPD>;
			close(TEMPD);
			if (($tb[0] ne "") && ($tb[0] ne "\n")) {
				chomp($tb[0]);
				$indexL = "3";
				$HC = $HC . "<p align=\"center\"><b>$tb[0]:</b><br><table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
				for ($j = "1"; $j <= $tb[1]; $j++) {
					$HC = $HC . "<tr align=\"center\">";
					for ($k = "1"; $k <= $tb[2]; $k++) {
						$rr = $tb[$indexL];
						$HC = $HC . "<td>$rr</td>";
						$indexL++;
					}
					$HC = $HC . "</tr>";
				}
				$HC = $HC . "</table></p>";
			}
		}
	
		my @based = split("\n", Storage::getData("category", $cat, "based"));
	
		if ($#based >= 0) {
			$HC = $HC . "<p>Based on:<ol>";
			for ($i = 0; $i <= $#based; $i++) {
				$x = $based[$i];
				$x=~s/(http:\/\/[^\s]*)/<a href="$1">$1<\/a>/g;
				$HC = $HC . "<li>" . $x . "";
			}
			$HC = $HC . "</ol>";
		}
	
		 # Make any leftover section links into "see also"
				my $morelinks = "";
				foreach $linktext (keys %rlinks) {
					unless ( ( $rflags{$linktext} ) || ( $aflags{$linktext} ) ) {
						if ( $morelinks ne "" ) { $morelinks = $morelinks . ", "; }
						$morelinks = $morelinks . "<a href=\"$path_on_server/$rlinks{$linktext}\">$linktext</a>";
					}
				}
	
				if ( $morelinks ne "" ) {
					$HC = $HC . "<p>$PTS::TS_cat_alsosee: $morelinks</p>";
				}
	
		my $path = Storage::getData('category', $cat, 'moz');
	
		if ($path eq "") {
			$path = "1";
		}
	
		if ($path ne "none") {
			my $dt = Storage::getData("global", "mozzies");
			if ($dt=~/>##$path#(.*?)#(.*?)#(.*?)#(.*?)##</) {
				$URL = $1;
				$width = $2;
				$height = $3;
				$alt = $4;
				$HC = $HC . "<p><div align=\"right\"><img src=\"$path_on_server/img/moz/$URL\" width=$width height=$height alt=\"$alt\"></div>";
			}
		}
	
		$HC = $HC . "</td></tr></table>";
	
		my $cp = "";
		$scat = $cat;
		$scat=~s/>/\//g;
	
		if ($edi[0] eq "") {
			$cp = "$PTS::TS_cat_needseditor - <a href=\"$path_on_server/apply.cgi?cat=$scat\">$PTS::TS_cat_applyhere</a>";
	
			if ($opts eq "off") {
				$cp = "";
			}
		} else {
			$cp = "";
			my $inde = 0;
			my $editors = 0;
			push(@edi, "");
			push(@edi, "");
			while (($edi[$inde] ne "") || ($edi[$inde + 1] ne "")) {
				chomp($edi[$inde]);
	
				if ($edi[$inde] ne "") {
					my $addition = "";
					if ($editors > 0) {
						$addition = ", ";
					}
	
					$users = Storage::getData("global", "elist");
					if ($users=~/ $edi[$inde] /) {
						$cp = $cp . $addition . "<a href=\"$path_on_server/profiles/$edi[$inde].html\">$edi[$inde]</a>";
						$editors++;
					} else {
						if ($showExEditors == 1) {
							$cp = $cp . $addition . "$edi[$inde]";
							$editors++;
						}
	
						if ($showExEditors == 2) {
							$cp = $cp . $addition . "<a href=\"$path_on_server/profiles/$edi[$inde].html\">$edi[$inde]</a>";
							$editors++;
						}
							}
							$inde++;
				}
			}
	
			if ($cp eq "") {
				$cp = "$PTS::TS_cat_needseditor - <a href=\"$path_on_server/apply.cgi?cat=$scat\">$PTS::TS_cat_applyhere</a>";
	
				if ($opts eq "off") {
					$cp = "";
				}
			} else {
				if ($editors == 1) {
					$cp = "$PTS::TS_cat_cateditor: " . $cp;
				} else {
					$cp = "$PTS::TS_cat_cateditors: " . $cp;
				}
			}
		}
	
		if (!($cp eq "")) {
			$HC = $HC . "<p><center><table bgcolor=\"#f0f0f0\"><tr><td>$cp</td></tr></table></center>";
		}
	
		$HC = $HC . <<END;
<p>
  <table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="4" width="100%" border="1">
    <tr bgColor="#006699">
      <td width="563" height="2">
      <font face="Arial, Helvetica, sans-serif" color="#ffffff" size="-2">
      Copyright &copy; $HD_name - using the <a href="http://open-site.org/code"><font color=\"#ffffff\">Open Site Code $OS_ver</font></a></font></td>
    </tr>
  </table>
END

		my $rerecat = $cat;
		$rerecat=~s/>/\//g;
	
		#The 4 lines below are commented because we don't want to display the apply.cgi
		# link twice, on every public page, at the bottom.
	
		$HC = $HC . "<p><center>";
		#if ($opts ne "off")
		#{
		#        print "<a href=\"$path_on_server/apply.cgi?cat=$cat\">apply to edit here</a>";
		#}
	
		$HC = $HC . "<a href=\"$path_on_server/editors/editcat.cgi?cat=$rerecat\">$PTS::TS_cat_edit</a>";
		$HC = $HC . "</center>";
	} else {
		$HC = $HC . "</div>    </td>  </tr></table>";
	
		my $ncat = $cat;
		$ncat=~s/>/\//g;
		$ncat=~s/_/ /g;
	
		$HC = $HC . <<END;
<p>$PTS::TS_cat_thecategory <strong>$ncat</strong> $PTS::TS_cat_notfound.</strong></p>
<br />
<br />
<form method="get" action="/search.cgi">
<div align="center">
<center>
<table border="0" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="372" bgcolor="#BBBBBB">
<tr>
<td width="370" align="left"><strong>$PTS::TS_cat_search:</strong></td>
</tr><tr><td width="370" align="left">
<p align="center"><input type="text" name="search" size="40">
<input type="submit" value="$PTS::TS_cat_search"></td>
</tr></table>
</center>
</div>
</form>
<p>
  <table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="4" width="100%" border="1">
    <tr bgColor="#006699">
      <td width="563" height="2">
      <font face="Arial, Helvetica, sans-serif" color="#ffffff" size="-2">
      Copyright &copy; $HD_name - using the <a href="http://open-site.org/code"><font color=\"#ffffff\">Open Site Code $OS_ver</font></a></font></td>
    </tr>
  </table>
END
	}
	$HC = $HC . "</body></html>";
	
	$HC = safeHTML($HC);
	
	return $HC;
}


return 1;
