#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


package Settings;

use base 'Exporter';

our @EXPORT = ('$path_data', '$path_profiles', '$path_edits',
    '$path_web', '$path_code', '$path_temp', '$path_sitedata', '$path_images',
    '$OS_ver', '@param_list');

our $path_home_guessing = "";
our $location;

if (-f "../data/code/Settings.pm") {
	$location = "../data/code/Settings.txt";
	$path_home_guessing = "..";
}
if (-f "../../data/code/Settings.pm") {
	$location = "../../data/code/Settings.txt";
	$path_home_guessing = "../..";
}
if (-f "../../../data/code/Settings.pm") {
	$location = "../../../data/code/Settings.txt";
	$path_home_guessing = "../../..";
}


# The following list represents a definition of the parameters and
#  their default values. Do not modify them here; actual values are
#  stored in the Settings.txt file.

our @param_list = (
	{
		name => 'sqldbname',
		type => 't',
		default => 'open-site'
	},

	{
		name => 'sqlserver',
		type => 't',
		default => 'localhost'
	},

	{
		name => 'sqlusername',
		type => 't',
		default => 'root'
	},

	{
		name => 'sqlpassword',
		type => 't',
		default => ''
	},

	{
		name => 'sqluse',
		type => 'b',
		default => '0'
	},

	{
		name => 'path_home',
		type => 't',
		default => $path_home_guessing
	},

	{
		name => 'path_feedmail',
		type => 't',
		default => '/var/mail'
	},

	{
		name => 'path_htpasswd',
		type => 't',
		default => 'htpasswd',
	},

	{
		name => 'path_sendmail',
		type => 't',
		default => '/usr/local/sbin/sendmail -t > /dev/null'
	},

	{
		name => 'path_on_server',
		type => 't',
		default => ''
	},

	{
		name => 'HD_title',
		type => 't',
		default => 'Open Site'
	},

	{
		name => 'HD_description',
		type => 't',
		default => 'An Open Site Code Powered Project'
	},

	{
		name => 'HD_name',
		type => 't',
		default => 'Open Site'
	},

	{
		name => 'HD_domain',
		type => 't',
		default => ''
	},

	{
		name => 'CAT_access_code',
		type => 't',
		default => ''
	},

	{
		name => 'TO_month',
		type => 't',
		default => 4
	},

	{
		name => 'FTP_IP',
		type => 't',
		default => ''
	},

	{
		name => 'FTP_user',
		type => 't',
		default => ''
	},

	{
		name => 'FTP_password',
		type => 't',
		default => ''
	},

	{
		name => 'YaBB_support',
		type => 't',
		default => 0
	},

	{
		name => 'YaBB_path',
		type => 't',
		default => '/yabb'
	},

	{
		name => 'denyCatCgi',
		type => 'b',
		default => 1
	},

	{
		name => 'validateNewApp',
		type => 'b',
		default => 0
	},

	{
		name => 'showExEditors',
		type => 't',
		default => 0
	},

	{
		name => 'showExEditorsPrivate',
		type => 't',
		default => 1
	},
	
	{
		name => 'allowUnreviewed',
		type => 'b',
		default => 1
	},
	
	{
		name => 'allowSearch',
		type => 'b',
		default => 1
	},
	
	{
		name => 'collectEmails',
		type => 'b',
		default => 1
	},
	
	{
		name => 'allowPolls',
		type => 'b',
		default => 1
	}
);


our %params;
foreach my $item (@param_list) {
	$params{$item->{'name'}} = $item;
}

sub getValue {
	my($param) = @_;

	if (-f $location) {
		open(FIL, $location);
		my @content = <FIL>;
		close(FIL);
		my $content = join("\n", @content);
		$content=~s/\r+//g;
		$content= "\n" . $content . "\n";
		$content=~s/\n+/\n/g;
		if ($content=~/\n$param = \"([^\"]*)\";\n/) {
			return $1;
		}
	}

	return $params{$param}->{'default'};
}

foreach my $item (@param_list) {
	push(@EXPORT, '$' . $item->{'name'});
	eval('our $' . $item->{'name'} . ' = getValue("'
		. $item->{'name'} . '");');
}

if ($path_home=~/^([a-zA-Z0-9\/\.\_\~\-]+)$/) {
	$path_home = $1;
} else {
	exit();
}

our $path_data = $path_home . "/data";
our $path_profiles = $path_home . "/profiles";
our $path_edits = $path_home . "/edits";
our $path_web  = $path_home . "/web";
our $path_code = $path_home . "/data/code";
our $path_temp = $path_home . "/temp";
our $path_sitedata = $path_home . "/sitedata";
our $path_images = $path_home . "/img/";

$YaBB_path = $path_web . $YaBB_path;

our $OS_ver = "0.5.3";

if (!(defined $ENV{REMOTE_USER})) {
	$ENV{REMOTE_USER} = "";
}


return 1;
