#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Settings;
use TS;
use Common;

our($cats);

open(EL, "$path_sitedata/cats.lst");
$cats = <EL>;
close(EL);
$cats=~s/\s\s/\s/g;
$cats=~s/\//>/g;
$cats=~s/\\/>/g;
open(EL, ">$path_sitedata/cats.lst");
print EL $cats;
close(EL);
my(@cats) = split("; ", $cats);
@cats = sort(@cats);

print "Rebuilding...\n\n";

my($catInd, $cat);

foreach $catInd (@cats) {
	my $cat = $catInd;
	$cat=~s/ {1,}//g;
	$cat=~s/;$//g;
	open(TT, ">$path_sitedata/$cat.unreviewed");
	print TT "0\n0\n";
	close(TT);

	open(TT, ">$path_sitedata/$cat.reviewed");
	print TT "0\n0\n";
	close(TT);
}

print "Counters set to 0. Starting to rebuild...\n\n";

for (my $d = 0; $d <= 10000; $d++) {
	print "                ";
}

foreach $catInd (@cats) {
	$cat = $catInd;
	open(USERS, "$path_sitedata/$cat.usections");
	my $users = <USERS>;
	close(USERS);

	my $x = 0;
	my(@r);

	if (($users eq "") || ($users eq "0")) {
	} else {
		for (my $d = 1; $d <= $users; $d++) {
			open(TI, "$path_sitedata/$cat.usct$d");
			@r = <TI>;
			close(TI);
			if (Common::isSectionEmpty(@r)) {
				Common::deleteSection($cat, "u", $d);
				$users--;
				$d--;
			} else {
				$x++;
			}
		};
		open(TT, "$path_sitedata/$cat.unreviewed");
		@r = <TT>;
		close(TT);
		if ($#r == -1) {
			$r[1] = 0;
		}
		Common::updateCounter($cat, "unreviewed", $x - $r[1]);
	}

	open(USERS, "$path_sitedata/$cat.sections");
	my $users = <USERS>;
	close(USERS);

	my $x = 0;
	my(@r);

	if (($users eq "") || ($users eq "0")) {
	} else {
		for (my $d = 1; $d <= $users; $d++) {
			open(TI, "$path_sitedata/$cat.sct$d");
			@r = <TI>;
			close(TI);
			if (Common::isSectionEmpty(@r)) {
				Common::deleteSection($cat, "", $d);
				$users--;
				$d--;
			} else {
				$x++;
			}
		};
		open(TT, "$path_sitedata/$cat.reviewed");
		@r = <TT>;
		close(TT);
		if ($#r == -1) {
			$r[1] = 0;
		}
		Common::updateCounter($cat, "reviewed", $x - $r[1]);
	}
}

print "Done. Counters rebuilt.\n";
