#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use Include;
use Settings;
use PTS;

my $cgi = new CGI;
my $email = $cgi->param('email');
my $cat = $cgi->param('cat');
my $why = $cgi->param('why');
my $act = $cgi->param('action');
my $type = $cgi->param('type');
my $name = $cgi->param('name');
my $val = $cgi->param('val');
my $lt = localtime;

PTS::writeHeader("$PTS::TS_add_title");
print "<p>";

$cat=~s/\//>/g;
$cat=~s/ /_/g;
$cat=~s/\\//g;
$cat=~s/\.\.//g;

open(DCATS, "$path_sitedata/cats.lst");
my $ucat = <DCATS>;
close(DCATS);

open(FOOT, "$path_data/pginfo/footer.html");
my @foot = <FOOT>;
close(FOOT);

if (!($ucat=~/ $cat; /)) {
	print "<p>$PTS::TS_add_validcat</p>\n";
	print "@foot\n";
	die;
}

open(DCATS, "$path_sitedata/$cat.catopt");
my $opts = <DCATS>;
close(DCATS);

if (($opts eq "off") || ($opts eq "off\n")) {
	print $PTS::TS_add_smallercat;
	print "@foot\n";
	die;
}


sub updateCounter {
	my($cat, $ID, $value) = @_;
	my(@ttt);

	open(TF, "$path_sitedata/$cat.$ID");
	@ttt = <TF>;
	close(TF);
	
	if (($ttt[0] eq "") || ($ttt[0] eq "\n")) {
		$ttt[0] = 0;
		$ttt[1] = 0;
	}

	$ttt[0] = $ttt[0] + $value;
	$ttt[1] = $ttt[1] + $value;

	open(TF, ">$path_sitedata/$cat.$ID");
	print TF $ttt[0] . "\n" . $ttt[1];
	close(TF);

	while ($cat=~/>/) {
		$cat=~s/^(.*)>[^>]*$/$1/;

		open(TF, "$path_sitedata/$cat.$ID");
		@ttt = <TF>;
		close(TF);

		if (($ttt[0] eq "") || ($ttt[0] eq "\n")) {
			$ttt[0] = 0;
			$ttt[1] = 0;
		}

		$ttt[0] = $ttt[0] + $value;

		open(TF, ">$path_sitedata/$cat.$ID");
		print TF $ttt[0] . "\n" . $ttt[1];
		close(TF);
	}
}

if ($cgi->param('done') eq "1") {
	open(USERS, "$path_sitedata/$cat.usections");
	my $users = <USERS>;
	close(USERS);

	if ($users eq "") {
		$users = "0";
	}

	open(USERS, ">$path_sitedata/$cat.usections");
	print USERS ++$users;
	close(USERS);

	updateCounter($cat, "unreviewed", 1);

	open(TEMPL, "$path_data/template/$type");
	my @tmpl = <TEMPL>;
	close(TEMPL);

	open(TABLE, ">$path_sitedata/$cat.usct$users");
	print TABLE "2.0\n";

	my $content = $type . "\n";
	$content = $content . $name . "\n";

	for (my $i = 1; $i <= $#tmpl; $i += 2) {
		my $y = "p" . $i;
		my $x = $cgi->param($y);
		$x=~s/\n$//g;
		$x=~s/\r$//g;
		$x=~s/\n$//g;
		$x=~s/\r$//g;
		$content = $content . "$x\n";
	}

	$content = $content . $val;

	print TABLE $content;

	if ($email ne "") {
		print TABLE "\n" . "E-Mail: " . $email;
	}

	close(TABLE);

	print "Done. Thanks.";

	print "@foot\n";
	die;
}

if ($act eq "$PTS::TS_common_submit") {
	my $ip = $ENV{REMOTE_ADDR};

	print <<END;
<p><div align="center">
  <center>
  <table border="0" cellspacing="20" style="border-collapse: collapse" bordercolor="#111111" width="524" id="AutoNumber1" bgcolor="#CCCCCC">
    <tr>
      <td width="520">
      <p align="center"><font size="5">$PTS::TS_add_title</font><br>
      </p>
<form method="POST" action="add.cgi">
END

	my $nicecat = $cat;
	$nicecat=~s/>/\//g;
	$nicecat=~s/_/ /g;
	print "<p><table width=\"90%\"><tr><td width=\"30%\"><strong>$PTS::TS_common_category:</strong></td><td>$nicecat</td></tr>";
	print "<tr><td><strong>$PTS::TS_add_typeofitem:</strong></td><td>$type</td></tr>";
	print "<tr><td><strong>$PTS::TS_add_titlesection:</strong></td><td><input size=\"40\" name=\"name\" type=\"text\" value=\"\">";
	print ("<input type=\"hidden\" name=\"type\" value=\"$type\">");

	$type=~s/\///g;
	$type=~s/\\//g;
	$type=~s/\.\.//g;
	$type=~s/\n//g;

	open(TEMPL, "$path_data/template/$type");
	my @tmpl = <TEMPL>;
	close(TEMPL);

	for (my $d = 1; $d <= $#tmpl; $d = $d + 2) {
		$tmpl[$d]=~s/[\n\r]//g;
		print "<tr><td><strong>$tmpl[$d]:</strong></td><td><input type=\"text\" size=\"40\" name=\"p$d\"></td></tr>";
	}

	print "<tr><td><strong>$PTS::TS_add_content:</strong></td><td><textarea name=\"val\" cols=\"32\" rows=\"10\"></textarea></td></tr>";

	print "<tr><td><p><strong>$PTS::TS_add_youremail:</strong></td><td><input type=\"text\" size=\"40\" name=\"email\"></td></tr></table>";

	print <<END;
<p><input type="submit" value="$PTS::TS_common_submit"></p>
<input type="hidden" name="cat" value="$cat">
<input type="hidden" name="done" value="1">
</form>
<strong><a href=\"./add.cgi?cat=$cat\">$PTS::TS_common_back</a></strong><br>
</td></tr></table>
END
	print "<p>@foot\n";

	exit(0);
}

open(SG, "$path_sitedata/$cat.subguide");
my @g = <SG>;
close(SG);

my $g = join("", @g);

$cat=~s/>/\//g;

print <<END;
<p><div align="center">
  <center>
  <table border="0" cellspacing="20" style="border-collapse: collapse" bordercolor="#111111" width="524" id="AutoNumber1" bgcolor="#CCCCCC">
    <tr>
      <td width="520">
      <p align="center"><font size="5">$PTS::TS_add_title</font><br>
      </p>
<form method="POST" action="add.cgi">
<p><strong>$PTS::TS_common_category:</strong> $cat</p>
END

$g =~s/\n//g;
$g =~s/\r//g;

if ($g ne "") {
	print <<END;
<table width="100%"><tr bgcolor="#99ee99"><td>$PTS::TS_add_submguide</td></tr><tr bgcolor="#bbbbbb"><td>$g</td></tr></table>
END
}

print <<END;
<p><strong>$PTS::TS_add_typeofitem:
END

PTS::writeTemplateCombo($cat, "type");

print <<END;
</strong>
<p><input type="submit" value="$PTS::TS_common_submit" name="action">
<input type="hidden" name="cat" value="$cat"></form>
<p><strong><a href="$path_on_server/$cat">$PTS::TS_common_back</a></strong>
      </td>
    </tr>
  </table>
  </center>
</div>
END

print "<p>@foot\n";
