#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use Include;
use Settings;
use Storage;
use PTS;

my $cgi = new CGI;
my $editor = $cgi->param('uname');
my $email = $cgi->param('email');
my $cat = $cgi->param('cat');
my $pass = $cgi->param('pass');
my $pass2 = $cgi->param('pass2');
my $act = $cgi->param('action');
my $lt = localtime;
my $why = $cgi->param('why');
my $raff = $cgi->param('raff');
my $scont = $cgi->param('scont');
my $confirm = $cgi->param('confirm');

sub exitWithFooter() {
	open(FOOT, "$path_data/pginfo/footer.html");
	my @foot = <FOOT>;
	close(FOOT);

	print "@foot\n";
	exit(0);
}

if (!(-d "$path_data/napps")) {
        mkdir("$path_data/napps");
}
if (!(-d "$path_data/uncapps")) {
        mkdir("$path_data/uncapps");
}
if (!(-d "$path_data/edits")) {
	mkdir("$path_data/edits");
}

$editor = lc($editor);
$cat=~s/\//>/g;

PTS::writeHeader("$PTS::TS_apply_title");

if ($cat eq "") {
	print "<p>$PTS::TS_apply_nocat</p>";
	print "<p><a href=\"/\">$PTS::TS_common_back</a></p>";
	exitWithFooter();
}

open(DCATS, "$path_sitedata/$cat.catopt");
my $opts = <DCATS>;
close(DCATS);

if (($opts eq "off") || ($opts eq "off\n")) {
	print $PTS::TS_apply_smallercat;
	exitWithFooter();
}

open(DCATS, "$path_sitedata/cats.lst");
my $ucat = <DCATS>;
close(DCATS);

if ($ucat!~/ $cat; /) {
	print $PTS::TS_apply_validcat;
	exitWithFooter();
}

if (($confirm eq "") && ($act eq "")) {
	print <<END;
<h3>$PTS::TS_apply_title</h3>
<div align='justify'>
  <p>$PTS::TS_apply_notice
  <p>$PTS::TS_apply_WSaim
  <p>$PTS::TS_apply_WSopportunity
  <p>$PTS::TS_apply_WSselective
  <p>$PTS::TS_apply_WStips
  <ul>
    <li>$PTS::TS_apply_WStip1
    <li>$PTS::TS_apply_WStip2
    <li>$PTS::TS_apply_WStip3
    <li>$PTS::TS_apply_WStip4
    <li>$PTS::TS_apply_WStip5
    <li>$PTS::TS_apply_WStip6
  </ul>
</div>
<form method='POST'>
  <center>
    <input type='submit' name='confirm' value='$PTS::TS_apply_proceed'>
    <input type='hidden' name='cat' value='$cat'>
  </center>
</form>
END
	exitWithFooter();
}

if ($act eq "$PTS::TS_apply_apply") {
	if (!($editor =~ /^[a-zA-Z][a-zA-Z0-9]+$/)) {
		print $PTS::TS_apply_chars;
		exitWithFooter();
	}

	if ($editor eq "") {
		print $PTS::TS_apply_editorname;
		exitWithFooter();
	}

	if (($why eq "") || ($raff eq "") || ($scont eq "")) {
		print $PTS::TS_apply_incomplete;
		exitWithFooter();
	}

	if ($pass ne $pass2) {
		print $PTS::TS_apply_passnomatch;
		exitWithFooter();
	}

	if ($editor eq "") {
		print $PTS::TS_apply_editorname;
		exitWithFooter();
	}

	if ($editor=~/ /g) {
		print "$PTS::TS_apply_spaces<br><b><a href=\"./\">Back</a></b><br>\n";
		exitWithFooter();
	}

	my $users = Storage::getData("global", "elist");

	if ($users=~/ $editor /) {
		print $PTS::TS_apply_userexists;
		exitWithFooter();
	}

	open(USERS, "$path_data/inlist");
	$users = <USERS>;
	close(USERS);
	if ($users=~/ $editor /) {
		print $PTS::TS_apply_uexist;
		exitWithFooter();
	}

	if (length($editor) < 3) {
		print $PTS::TS_apply_toosmall;
		exitWithFooter();
	}

	if ($email eq "") {
		print $PTS::TS_apply_enteremail;
		exitWithFooter();
	}

	if ($pass =~ /\'/) {
	        print $PTS::TS_apply_cip;
		exitWithFooter();
	}

	if ($pass eq "") {
		print $PTS::TS_apply_enterpass;
		exitWithFooter();
	}

	my $ip = $ENV{REMOTE_ADDR};

	$email=~s/\n//g;
	$editor=~s/\n//g;
	$pass=~s/\n//g;

	$lt = localtime;

	open(EL, "$path_home/edits/edit1");
	my $edits = <EL>;
	close(EL);

	my $totaledits = $edits + 1;
	open(LDATA2, ">$path_home/edits/edit1");
	print LDATA2 "$totaledits";
	close(LDATA2);

	$why=~s/\n/ /g;
	$why=~s/\r/ /g;
	$raff=~s/\n/ /g;
	$raff=~s/\r/ /g;
	$scont=~s/\n/ /g;
	$scont=~s/\r/ /g;

	if ($validateNewApp eq "1") {
	        open(SENDMAIL, "| $path_sendmail") || die "Unable to open sendmail";
	        print SENDMAIL "From: $PTS::TS_apply_newappletter3\n";
		print SENDMAIL "To: $email\n";
		print SENDMAIL "Subject: $PTS::TS_apply_newappletter2\n\n";
		print SENDMAIL "$PTS::TS_apply_newappletter1" . " ";
		print SENDMAIL "http://$HD_domain" . "$path_on_server/verifyapp.cgi?code=$totaledits&app=$editor";
	        close(SENDMAIL);
	        open(TEXTFILE, ">$path_data/uncapps/$totaledits.req");
	} else {
		open(TEXTFILE, ">$path_data/napps/$totaledits.req");
	}

	print TEXTFILE "$cat\n";
	print TEXTFILE "$editor\n";
	print TEXTFILE "$email\n";
	print TEXTFILE "$pass\n";
	print TEXTFILE "$ip\n";
	print TEXTFILE "$lt\n";
	print TEXTFILE "$why\n";
	print TEXTFILE "$raff\n";
	print TEXTFILE "$scont\n";
	close(TEXTFILE);
	#end log code

	print "<br>$PTS::TS_apply_sent<br>";

	if ($validateNewApp eq "1") {
		print "<br><br>$PTS::TS_apply_newappnotice<br><br>";
		print "$PTS::TS_apply_newappnotice2<br><br>";
	} else {
		print "<br><br>$PTS::TS_apply_ifaccepted<br><br>";
	}

	print "<strong><a href=\"./\">$PTS::TS_common_back</a></strong><br>\n";
	exitWithFooter();
} 

$cat=~s/>/\//g;
print <<END;
<p><div align="center">
  <center>
  <table border="0" cellspacing="20" style="border-collapse: collapse" bordercolor="#111111" width="524" id="AutoNumber1" bgcolor="#CCCCCC">
    <tr>
      <td width="520">
      <p align="center">
        <font size="5">$PTS::TS_apply_title</font><br>
      </p>
<form method="POST" action="apply.cgi">
<p><strong>$PTS::TS_apply_ifmore <a href="http://open-site.org/editors/rncat.cgi?cat=$cat">$PTS::TS_apply_here</a> $PTS::TS_apply_additionalcats</strong></p>
<p><strong>$PTS::TS_apply_oneaccount</strong></p>
<p><strong>$PTS::TS_common_category:<br>
<input type="text" name="cat" size="40" value="$cat"></strong></p>
<p><strong>$PTS::TS_apply_youremail:<br></strong>
<input type="text" name="email" size="40"><p>$PTS::TS_apply_onlyuse</p>
<strong>$PTS::TS_common_username:</strong><br>
<input type="text" name="uname" size="20"><br>
<br>
<strong>$PTS::TS_apply_pass:</strong><br></b>
<input type="password" name="pass" size="20">
<br><strong>$PTS::TS_apply_passagain:</strong><br></b>
<input type="password" name="pass2" size="20">

<p>$PTS::TS_apply_whygood:<br>
<textarea rows="7" name="why" cols="37"></textarea><br>
<p>$PTS::TS_apply_affiliations:<br>
<textarea rows="7" name="raff" cols="37"></textarea><br>
<p>$PTS::TS_apply_sample_content:<br>
<textarea rows="7" name="scont" cols="37"></textarea><br>
<br><input type="submit" value="$PTS::TS_apply_apply" name="action">
<input type="reset" value="$PTS::TS_apply_reset" name="B1"></p>
      </td>
    </tr>
  </table>
  </center>
</div>
END

exitWithFooter();
