#!/usr/bin/perl -T
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $name = $cgi->param('name');
my $val = $cgi->param('val');
my $type = $cgi->param('type');

if (!(defined $cat)) {
	UI::showError($TS::TS_addsection_title, $TS::TS_common_nocatorprivs);
}

if (!(defined $type)) {
	$type = "";
}

if ($type eq "") {
	$type = "default";
}

if ($type=~/\.\`\|\;\(\)\</) {
	exit();
}

$cat = Editor::testPrivs($cat);

if (defined $submit) {
	open(TEMPL, "$path_data/template/$type");
	my(@tmpl) = <TEMPL>;
	close(TEMPL);

	my $content = "2.0\n";
	$content .= $type . "\n";
	$content .= $name . "\n";

	for (my $i = 1; $i <= ($#tmpl / 2); $i++) {
		my($y) = "p" . $i;
		my($x) = $cgi->param($y);
		chomp($x);
		$content = $content . "$x\n";
	}

	if (Common::isSectionEmpty(split("\n", $content))) {
		UI::writeHeaderCode($TS::TS_addsection_title);
		Editor::writeECode();

		print "<p>$TS::TS_addsection_errornotvalid</p>";
		UI::writeScriptFooter($cat);
		exit(0);
	}

	UI::editRedirect();
	UI::writeHeaderCode($TS::TS_addsection_title);
	Editor::writeECode();

	my $noSections = Storage::getData('category', $cat, 'sections');

	if ($noSections eq "") {
		$noSections = "0";
	}
	
	if ($noSections=~/^([0-9]+)$/) {
		$noSections = $1;
	} else {
		exit();
	}
	
	Storage::setData('category', $cat, 'sections', ++$noSections);
	Common::updateCounter($cat, "reviewed", 1);

	$content = $content . $val;

	open(TABLE, ">$path_sitedata/$cat.sct$noSections");
	print TABLE $content;
	close(TABLE);

	Generate::updatePublicSide($cat);

	print ("<p>$TS::TS_addsection_newcreated</p>");

	Storage::logEdit("edit", "section", $cat, $content);
} else {
	UI::writeHeaderCode($TS::TS_addsection_title);
	Editor::writeECode();

	UI::writeScriptHeader($cat, $TS::TS_addsection_title);

	UI::writeStartForm($cat);
	UI::writeItemForm($TS::TS_common_type, $type);
	UI::writeItemForm($TS::TS_addsection_header, "<input size=\"70\" name=\"name\" type=\"text\" value=\"\">");

	open(TEMPL, "$path_data/template/$type");
	my(@tmpl) = <TEMPL>;
	close(TEMPL);

	my($j) = "0";
	for (my($i) = "1"; $i <= $#tmpl; $i = $i + 2) {
		$j = $j + 1;
		chomp($tmpl[$i]);
		$tmpl[$i]=~s/.$//g;
		my($xx) = $tmpl[$i];
		$xx=~s/<.>//g;
		$xx=~s/<\/.>//g;
		$xx=~s/<br>//g;
		$xx=~s/#name//g;
		UI::writeItemForm($xx, "<input name=\"p$j\" type=\"text\" size=\"70\" value=\"\">");
	}

	UI::writeItemForm($TS::TS_addsection_content, "<textarea name=\"val\" rows=\"10\" cols=\"70\"></textarea>");
	UI::writeHiddenForm("type", $type);
	UI::writeEndForm();
}

UI::writeScriptFooter($cat);
