#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $do = $cgi->param('do');
my $newtempl = $cgi->param('newtempl');
my $cat = $cgi->param('cat');
my($lt) = localtime;

UI::writeHeaderCode($TS::TS_addtemplate_title);
Editor::writeECode();

Editor::restrictedMeta();

if (defined $do) {
	open(EL, ">>$path_data/cattype");
	print EL " ; $newtempl ";
	close(EL);

	#loading head
	my $table = "";
	if (-f "$path_data/pginfo/tble") {
		open(EL, "$path_data/pginfo/tble");
		$table = <EL>;
		close(EL);
	}

	my $editor = Editor::currentUser();
	$editor = Editor::validateEditor($editor);
	
	if (!(-d "$path_data")) {
		mkdir("$path_data");
	}
	if (!(-d "$path_data/logs")) {
		mkdir("$path_data/logs");
	}
	if (!(-d "$path_data/logs/allog")) {
		mkdir("$path_data/logs/allog");
	}
	if (!(-d "$path_data/logs/rootlog")) {
		mkdir("$path_data/logs/rootlog");
	}
	
	open(TEXTFILE, ">>$path_data/logs/allog/$editor.log");
	print TEXTFILE "<i>$lt</i><br>IP: $ENV{REMOTE_ADDR}<br>USER: $ENV{REMOTE_USER};<hr>\n";
	print TEXTFILE "New template created: $newtempl<br>$table\n";
	close(TEXTFILE);

	open(TEXTFILE, ">>$path_data/logs/rootlog/rlog.log");
	print TEXTFILE "<i>$lt</i><br>IP: $ENV{REMOTE_ADDR}<br>USER: $ENV{REMOTE_USER};<hr>\n";
	print TEXTFILE "New template created: $newtempl<br>$table\n";
	close(TEXTFILE);
	#end log code

	print "<p>$TS::TS_addtemplate_created: $newtempl</p>";
}

print "<p>$TS::TS_addtemplate_currently:</p>";

my $tm = Storage::getData("global", "cattype");
$tm=~s/  / /g;
$tm=~s/^? ; //;
my @tm = split(" ; ", $tm);
@tm = sort {
	if (($a=~/>/) && ($b=~/>/)) {
		$a cmp $b;
	} elsif ((!($a=~/>/)) && (!($b=~/>/))) {
		$a cmp $b;
	} elsif ($a=~/>/) {
		1;
	} else {
		-1;
	}
} @tm;

for (my $i = 0; $i <= $#tm; $i++) {
	print "[<a href=\"edittemplate.cgi?newtype=$tm[$i]\">$TS::TS_common_update</a>] $tm[$i]<br>";
}

print <<END;
<p><font size="5">$TS::TS_addtemplate_title</font><br>
<form method="POST" action="addtemplate.cgi">
  <p>$bold $TS::TS_addtemplate_insert: $unBold<br>
  <input type="text" name="newtempl" size="20"></p>
  <p><input type="submit" value="$TS::TS_common_submit" name="do"></p>
</form>
END

UI::writeScriptFooter();
