#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


#Code for adding users

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Forum;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $act = $cgi->param('action');

UI::writeHeaderCode("Add User");
Editor::restrictedRoot();

if ((defined $act) && ($act eq "Add")) {
	my $username = $cgi->param('usn');
	my $password = $cgi->param('pass');
	my $email = $cgi->param('email');
	
	$username=~s/ /_/g;
	if ($username=~/^([a-z0-9]+)$/) {
		$username = $1;
	} else {
		exit();
	}
	
	my $users = Storage::getData("global", "elist");
	if ($users=~/ $username /) {
		print "User already active.";
	} else {
		my $users = Storage::getData("global", "inlist");
		if ($users=~/ $username /) {
			print "User is inactive.";
		} else {
			Editor::setPassword($username, $password);
			Storage::setData("global", "elist",
				Storage::getData("global", "elist") ."$username ");

			open(EL, ">>$path_data/eperm/$username.perm");
			print EL " Test>Bookmarks>$username; ";
			close(EL);

			open(EL, ">$path_sitedata/Test>Bookmarks>$username.html");
			print EL " ";
			close(EL);
			open(EL4, ">>$path_sitedata/cats.lst");
			print EL4 "Test>Bookmarks>$username; ";
			close(EL4);

			# Forum Code
			my @data =<<DATA;
$password
$username
username\@editor.com
$username
username.com
-$username
0
EDITOR

hmm
hmm
Male
Hi
blank.gif
YaBB Admin Land
Home?
1/1/1
1



DATA
			if ($YaBB_support == 1) {
				open(EL, ">$Forum::memberdir/$username.dat");
				print EL "@data";
				close(EL);
				
				open(EL, ">>$Forum::memberdir/memberlist.txt");
				print EL "$username\n";
				close(EL);
			}

			open(TEXTFILE, ">$path_data/misc/$username.eaddr");
			print TEXTFILE "$email\n";
			close(TEXTFILE);

			print "User $username is now added!\n";
			print <<END;
$bold<a href="./">$TS::TS_common_back</a>$unBold<br>\n
END
		}
	}
} else {
	print <<END;
<font size="+2">Add User Tool</font><br>
<i><font size="+1">NOTE:<br>Once a user is added they can <b>NOT</b> be removed from the site with this software. <br> However they can be inactivated.</font></i>
<br>
<hr><form method="post" action="adduser.cgi">
<p><b>Username:</b>
<br><input type="text" name="usn" size="20">
<p><b>Email:</b>
<br><input type="text" name="email" size="40">
<p><b>Password:</b>
<br><input type="text" name="pass" size="20">
<p><input type="submit" value="Add" name="action">
<br></form>
END
}

UI::writeScriptFooter();
