#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my($cgi) = new CGI;
my($cat) = $cgi->param('cat');
my($submit) = $cgi->param('submit');
my($psubmit) = $cgi->param('psubmit');
my($name) = $cgi->param('name');
my($val) = $cgi->param('val');
my($type) = $cgi->param('type');
my($spliter) = $cgi->param('spliter');
my($content);

if ($type eq "") {
	$type = "default";
}

$cat = Editor::testPrivs($cat);

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_addwizard_title);
Editor::writeECode();

UI::writeScriptHeader($cat, $TS::TS_addwizard_title);

if ($psubmit ne "") {
	my($par) = $cgi->param('parant');
	my($dots) = $cgi->param('dots');

	if ($par ne "") {
		$val=~s/\)/ /g;
		$val=~s/\(/ /g;
	}

	if ($dots ne "") {
		$val=~s/\./ /g;
	}

	print <<END;
<form method="post">
  <table width="100%">
    <tr>
      <td bgcolor="#e0f0ff" align="center">
        <strong>$type $TS::TS_common_overview</strong>
      </td>
    </tr>
  </table>
  <table width=100%>
END
	$val=~s/\r//g;
	my(@val) = split("\n", $val);
	my($id) = 0;
	my($bmax) = 0;
	for (my($d) = 0; $d <= $#val; $d++) {
		$id++;
		if ($content ne "") {
			$content = $content . "  " . $val[$d];
		} else {
			$content = $val[$d];
		}
		if ($id == $spliter) {
			print "<tr bgcolor=#f0f0ff>";
			my($lmax) = 0;
			$content=~s/ - /\n/g;
			$content=~s/ : /\n/g;
			$content=~s/ {2,}/\n/g;
			my(@dt) = split("\n", $content);
			for (my($i) = 0; $i <= $#dt; $i++) {
				if ($dt[$i] eq "") {
					$dt[$i] = "-";
				}
				print "<td>$dt[$i]</td>";
				$lmax++;
			}
			print "</tr>";
			$id = 0;
			$content = "";
			if ($lmax > $bmax) {
				$bmax = $lmax;
			}
		}
	}

	print "</table><p>";
	open(TEMPL, "$path_data/template/$type");
	my(@tmpl) = <TEMPL>;
	close(TEMPL);
	for (my($i) = 0; $i <= $bmax - 1; $i++) {
		my($k) = $i + 1;
		print "$TS::TS_addwizard_column $k $TS::TS_addwizard_goesto: <select name=\"p" . $i . "\">";
		print "<option value=\"0\">$TS::TS_addwizard_null";
		print "<option value=\"2\">$TS::TS_common_name";
		for (my($j) = 1; $j <= $#tmpl; $j = $j + 2) {
			$k = ($j - 1) / 2 + 3;
			print "<option value=\"$k\">$tmpl[$j]";
		}
		print "</select><br>";
	}
	$val=~s/`/`0/g;
	$val=~s/\"/`1/g;
	print <<ENDL;
<p>
<input type="hidden" name="cat" value="$cat">
<input type="hidden" name="val" value="$val">
<input type="hidden" name="type" value="$type">
<input type="hidden" name="spliter" value="$spliter">
<input type="submit" name="submit" value="$TS::TS_common_submit"></form>
ENDL
} else {
	if ($submit ne "") {
		$val=~s/`1/\"/g;
		$val=~s/`0/`/g;
		$val=~s/\r//g;
		my(@val) = split("\n", $val);
		my($id) = 0;

		open(TEMPL, "$path_data/template/$type");
		my(@tmpl) = <TEMPL>;
		close(TEMPL);

		for (my($d) = 0; $d <= $#val; $d++) {
			$id++;
			if ($content ne "") {
				$content = $content . "  " . $val[$d];
			} else {
				$content = $val[$d];
			}
			if ($id == $spliter) {
				$content=~s/ - /\n/g;
				$content=~s/ : /\n/g;
				$content=~s/ {2,}/\n/g;
				my(@dt) = split("\n", $content);

				my(@pgf) = {};

				$pgf[1] = $type;

				for (my($q) = "0"; $q <= $#dt; $q++) {
					$pgf[$cgi->param("p" . $q)] = $dt[$q];
				}

				$pgf[0] = "2.0";

				my($ctl) = "";

				my $contenter = "";
				for (my($q) = 0; $q <= $#pgf; $q++) {
					$contenter .= $pgf[$q] . "\n";
					if ($q > 0) {
						$ctl = $ctl . $pgf[$q];
						if ($q < $#pgf) {
							$ctl = $ctl . "\n";
						}
					}
				}

				if (!(Common::isSectionEmpty(split("\n", $contenter)))) {
					open(USERS, "$path_sitedata/$cat.sections");
					my($users) = <USERS>;
					close(USERS);

					if ($users eq "") {
						$users = "0";
					}

					open(USERS, ">$path_sitedata/$cat.sections");
					print USERS ++$users;
					close(USERS);

					Common::updateCounter($cat, "reviewed", 1);

					open(TABLE, ">$path_sitedata/$cat.sct$users");
					print TABLE $contenter;
					close(TABLE);

					Storage::logEdit("add", "section", $cat, $ctl);
				} else {
					print "<p>$TS::TS_addwizard_emptysec";
					UI::writeScriptFooter();
					exit(0);
				}

				$id = 0;
				$content = "";
			}
		}

		Generate::updatePublicSide($cat);

		print $TS::TS_addwizard_done;

		#Redirect
		UI::editRedirect();
	} else {
		UI::writeStartForm($cat);
		UI::writeItemForm($TS::TS_common_type, Common::writeTemplateCombo($cat, "type"));
	
		my($HTML) = "<select name=\"spliter\">";
	        for (my($dd) = 1; $dd < 11; $dd++) {
        	        $HTML = $HTML . "<option value=\"$dd\">$dd ";
                	if ($dd == 1) {
				$HTML = $HTML . $TS::TS_common_row;
			} else {
				$HTML = $HTML . $TS::TS_common_rows;
			}
		}
		$HTML = $HTML . "</select>";

		UI::writeItemForm($TS::TS_addwizard_sectionshave, $HTML);
		UI::writeItemForm($TS::TS_common_content, "<textarea name=\"val\" rows=\"10\" cols=\"80\"></textarea>");
		UI::writeItemForm($TS::TS_addwizard_replace1, "<input type=\"checkbox\" name=\"dots\">");
		UI::writeItemForm($TS::TS_addwizard_replace2, "<input type=\"checkbox\" name=\"parant\">");
		UI::writeEndForm("psubmit");
	}
}

UI::writeScriptFooter($cat);
