#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $errors = $cgi->param('errors');
my $level = $cgi->param('level');
my $cat = $cgi->param('cat');

if (!defined $cat) {
	$cat = "";
}

UI::writeHeaderCode($TS::TS_allcats_currentcats);

our($cats);

sub countSubs
{
	my($catpp) = @_;
	my($no) = "1";
	while ($cats=~/ $catpp>/g) {
		$no++;
	}

	return $no;
}

print <<END;
<p align="center">$bold<form method="get" action="allcats.cgi">
$TS::TS_allcats_restrictto <input type=\"text\" name=\"cat\" size=\"20\"> <input type=\"submit\" name=\"submit\" value="$TS::TS_common_submit"></form>$unBold</p>
<center><p>
END

if (!defined $level) {
	$level = 0;
}

my $olevel = $level;
my($ncat, $pat, $obl);

if ($cat eq "") {
	print "$bold$TS::TS_allcats_allcurrentcats";
	print ":$unBold<br>\n";
	print "</p>";
} else {
	chomp($cat);
	$cat = Editor::validateCat($cat);
	if ($cat ne "") {
		$level++;
	}

	while ($cat=~/>/g) {
		$level++;
	}

	print "$bold$TS::TS_allcats_allcurrentcats:$unBold<br>\n";
	$pat = $cat;
	$pat=~s/(.*)>[^>]*/$1/;
	if (!($cat=~/>/)) {
		$pat = "";
	}
	print "</p>";

	$ncat = UI::getNiceFormat($cat);

	if ($cat ne "") {
		print "<p>$TS::TS_allcats_currently $bold$ncat$unBold <a href=\"allcats.cgi?cat=$pat&level=$obl\">[$TS::TS_allcats_up1level]</a></p>";
	}
}

print "<table><tr bgcolor=\"#d0f0ef\"><td align=\"center\"><strong>$TS::TS_allcats_no</strong></td><td><strong>$TS::TS_common_category</strong></td><td align=\"center\"><strong>$TS::TS_allcats_subcats</strong></td><td align=\"center\"><strong>$TS::TS_allcats_publicpage</strong></td><td align=\"center\"><strong>$TS::TS_allcats_editpage</strong></td><td colspan=\"2\"><strong>$TS::TS_common_sections</strong></td><td>$bold" . "Status$unBold</td></tr>";
open(EL, "$path_sitedata/cats.lst");
$cats = <EL>;
close(EL);
$cats=~s/\s+/ /g;
$cats=~s/\//>/g;
$cats=~s/\\/>/g;
open(EL, ">$path_sitedata/cats.lst");
print EL $cats;
close(EL);
my(@cats) = split("; ", $cats);
@cats = sort(@cats);
my $catBackup = "";
my $number = 1;
my $total = 0;
my $spattern = $cat . ">";
my($cont, $nosubcats, $parentCat, $slev);

if ($spattern eq ">") {
	$spattern = "";
}

my($catInd, $catSec, $catDis);
my $sectTotal = 0;

$spattern=~s/^ //g;
foreach $catInd (@cats) {
	if ($catInd=~/^$spattern/) {
		$total++;
		$catSec = $catInd;
		$catSec=~s/^ //g;

		$slev = 0;
		while ($catSec=~/>/g) {
			$slev++;
		}

		if ($level < $slev) {
			$catInd = "";
		} else {
			$catSec=~s/>/\//g;
			$catSec=~s/^ //g;
			$parentCat = $catInd;
			$parentCat=~s/(.*)>[^>]*/$1/;
			$parentCat=~s/^ //g;
			my $err;

			if ($cats=~/ $parentCat;/) {
				$err = "";
			} else {
				$err = " (<font color=\"red\">$TS::TS_allcats_errornotfound</font>)";
			}

			if ($catSec eq $catBackup) {
				$err = " (<font color=\"red\">$TS::TS_allcats_errorduplicate</font>)";
			}

			$catBackup = $catSec;
			if ((defined $errors) && ($err eq "")) {
				$catInd = "";
			} else {
				$catDis = $catSec;
				$catDis=~s/_/ /g;
				$catSec = $catInd;
				$catSec=~s/^ //g;

				my $status = '<font color="green">Okay</font>';
				my $catSent = $catSec;
				$catSent=~s/\//>/g;
				if (Common::isCatEmpty($catSent)) {
					$status = '<font color="red">Empty</font>';
				}

				my @ttt = ("", "");
				if (open(TF, "$path_sitedata/$catSec.reviewed")) {
					@ttt = <TF>;
					close(TF);
				}

				$ttt[0]=~s/^$/0/;
				$ttt[1]=~s/^$/0/;

				my $nosubcats = 1;
				while ($cats=~/ $catSent>/g) {
					$nosubcats++;
				}

				$catSec=~s/>/\//g;
				$catInd = "<tr bgcolor=\"#e0e0e0\" align=\"center\"><td>$number</td>" . "<td align=\"left\">$catDis <a href=\"allcats.cgi?cat=$catSec&level=$olevel\">[$TS::TS_allcats_restrict]</a></td><td><strong>$nosubcats</strong>$err</td><td><a href=\"/$catSec/\">[$TS::TS_allcats_here]</a></td><td><a href=\"editcat.cgi?cat=$catSec\">[$TS::TS_allcats_here]</a></td><td>$ttt[0]</td><td>$ttt[1]</td><td>$status</td></tr>";
				$sectTotal += $ttt[0];
			}
		}

		if ($catInd ne "") {
			$number++;
		}
	} else {
		$catInd = "";
	}
}

$cats = join("; ", @cats);

$cats=~s/;/<br>\n/g;
$cats=~s/<br>\n //g;

my $status = '<font color="green">Okay</font>';
if (Common::isCatEmpty($cat)) {
	$status = '<font color="red">Empty</font>';
}

$cat=~s/>/\//g;
$cat=~s/\/$//g;
my $pcat = $cat . "/";
print "$cats<tr bgcolor=\"#e0e0e0\"><td align=\"center\">$bold*$unBold</td><td>$TS::TS_allcats_totalarea</td><td align=\"center\"><strong>$total</strong></td><td align=\"center\">[<a href=\"$path_on_server/$pcat\">$TS::TS_allcats_here</a>]</td><td align=\"center\">[<a href=\"$path_on_server/editors/editcat.cgi?cat=$cat\">$TS::TS_allcats_here</a>]</td><td colspan=\"2\" align=\"center\"> $sectTotal </td><td align=\"center\"> $status </td></tr></table>";

$obl = $olevel;
$olevel++;

if ($olevel ne "10001") {
	print "<p>$TS::TS_allcats_depth $olevel";
	my($oplevel) = $olevel + 1;
	print " <a href=\"allcats.cgi?cat=$cat&level=$olevel\">[$TS::TS_allcats_increaseto $oplevel]</a>";
	if ($olevel > 1) {
		$oplevel = $olevel - 2;
		my($opplevel) = $oplevel + 1;
		print " <a href=\"allcats.cgi?cat=$cat&level=$oplevel\">[$TS::TS_allcats_decreaseto $opplevel]</a>";
	}

	print " <a href=\"allcats.cgi?cat=$cat&level=10000\">[$TS::TS_allcats_viewall]</a>";
} else {
	print "<p>$TS::TS_allcats_viewingall";
	print " <a href=\"allcats.cgi?cat=$cat&level=0\">[$TS::TS_allcats_backto1]</a>";
}

$pat = $cat;
$pat=~s/(.*)>[^>]*/$1/;

if (!($cat=~/>/)) {
	$pat = "";
}

print "</p>";

if ($cat ne "") {
	print "<p>$TS::TS_allcats_currently $bold$ncat$unBold <a href=\"allcats.cgi?cat=$pat&level=$obl\">[$TS::TS_allcats_up1level]</a></p>";
}

print "</center>";

UI::writeScriptFooter();
