#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $act = $cgi->param('action');
my $tcat = $cgi->param('tcat');
my $numbers = $cgi->param('numbers');
my $typeset = " default ";
my $ok = "";
my $cat;
my $lt = localtime;

$tcat = Editor::validateCat($tcat);
Editor::testPrivs($tcat);

if (defined $act) {
	my $alphabet = $TS::TS_alphabar_alphabet;
	
	if (!defined $numbers) {
		$numbers = "";
	}
	if ($numbers ne "") {
		$alphabet = $TS::TS_alphabar_alphanum . "," . $alphabet;
	}
	my @alphabar = split(/\,/, $alphabet);
  
	open(EL, "$path_sitedata/cats.lst");
	my $checkdata = <EL>;
	close(EL);
  
	foreach $cat (@alphabar) {
		if ( $checkdata =~ / $tcat>$cat; / ) {
			next; # Do not create a category twice, but continue with next category.
		}
    
		open(EL, ">$path_sitedata/$tcat>$cat.html");
		print EL "$ok ";
		close(EL);
  
  		open(EL4, ">>$path_sitedata/cats.lst");
		print EL4 "$tcat>$cat; ";
		close(EL4);
  
  		open(LDATA, ">$path_sitedata/$tcat>$cat.ct");
		print LDATA "$typeset\n";
		close(LDATA);

		Generate::updatePublicSide($tcat . ">" . $cat);
		Generate::updatePublicSide($tcat);
	}

	UI::writeHeaderCode($TS::TS_alphabar_title);
	Editor::writeECode();

	print <<END;
$TS::TS_alphabar_created<br>\n
END

	my $table;
	if (-f "$path_data/pginfo/tble") {
		open(EL, "$path_data/pginfo/tble");
		$table = <EL>;
		close(EL);
	}

	#head loaded
	open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
	print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## new #!# ##!## category #!# ##!!!## $tcat alphabar - created ##!!!!## \n";
	close(TEXTFILE);
} else {
	UI::writeHeaderCode($TS::TS_alphabar_title);
	Editor::writeECode();

	my $tnice = UI::getNiceFormat($tcat);

	print <<END;
<font size="+2">$TS::TS_alphabar_title</font>
<br>
<hr><form method="post" action="alphabar.cgi">
<p><b>$TS::TS_common_category:</b><br>
<input type="hidden" value="$tnice" name="tcat">
$tnice/ 
<br><br>
<input type="checkbox" name="numbers" value="numbers"> $TS::TS_alphabar_numbers

<p><input type="submit" value="$TS::TS_common_create" name="action"></form>
END
}

UI::writeScriptFooter($tcat);
