#!/usr/bin/perl -w
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Settings;
use Storage;
use UI;
use Editor;
use PTS;

UI::writeHeaderCode();
Editor::restrictedRoot();

my $cgi = new CGI;

if (!(-d "$path_data/uncapps")) {
	mkdir("$path_data/uncapps");
}

chdir("$path_data/uncapps");

$ENV{'PATH'} = '/bin:/usr/bin';
my $output = `grep \@ $path_data/uncapps/*`;

my @output = split('\n', $output);

for(my $id = 0; $id <= $#output; $id++) {
	$output[$id]=~/([0-9]+).req:(.*)$/;
	my $totaledits = $1;
	my $email = $2;
	$email=~s/[\n\r]*//g;
	open(EL, "$path_data/uncapps/$totaledits.req");
	my @REQ = <EL>;
	close(EL);

	#Strip new line from editor name in application data.
	$REQ[1]=~s/\n//g;
	my $editor = $REQ[1];

	print "$totaledits - $email - $editor<br>";
	
	if (defined $cgi->param('send')) {
		open(SENDMAIL, "| $path_sendmail") || die "Unable to open sendmail";
		print SENDMAIL "From: $PTS::TS_apply_newappletter3\n";
		print SENDMAIL "To: $email\n";
		print SENDMAIL "Subject: $PTS::TS_apply_newappletter2\n\n";
		print SENDMAIL "$PTS::TS_apply_newappletter1" . " ";
		print SENDMAIL "http://$HD_domain" . "$path_on_server/verifyapp.cgi?code=$totaledits&app=$editor";
		close(SENDMAIL);
	}
}

UI::writeFooterCode();
