#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $allow_edit = 1;
my $allow_remove = 1;

my $cgi = new CGI;
my $command = $cgi->param('cmd');
my $name = $cgi->param('name');
my $message = $cgi->param('comnt');
my $spriv = $cgi->param('spriv');
my $opinion = $cgi->param('num');
my $edit = $cgi->param('edit');
my $lt = localtime;
my $adder = Editor::currentUser();
my(@metas, $metas, @data, @comments);

my $tr1 = " bgcolor=\"$UI::subheading[$UI::currentskin]\"";
my $tr2 = " bgcolor=\"$UI::box[$UI::currentskin]\"";
my $td_align = " align=\"center\"";
my $t_wid = " width=\"100%\"";

UI::writeHeaderCode($TS::TS_candidates_title);
Editor::writeECode();
Editor::restrictedMod();

if (defined $name) {
	$name = Editor::validateEditor($name);
}

if (!defined $message) {
	$message = "";
}
if (!defined $opinion) {
	$opinion = "";
}
if (!defined $spriv) {
	$spriv = "";
}

print "<p>$bold$TS::TS_candidates_title$unBold</p>";

if (!defined $command) {
	$command = "list";
}

if ($command eq "list") {
	# Display the index with the current nominations

	open(SRC, "$path_data/eperm/cand/cand.lst");
	my(@list) = <SRC>;
	close(SRC);

	shift(@list);
	my $x = 0;
	foreach (@list) {
		$x++;
	}
	print "$TS::TS_candidates_total: <strong>$x</strong><br><br>";
	if ($x) {
		print <<END;
$TS::TS_candidates_clist<br>
<div align="center">
<table border="0"$t_wid>
  <tr$tr1>
    <th width="15%">
      $TS::TS_candidates_ename
    </th>
    <th width="15%">
      $TS::TS_candidates_spriv
    </th>
    <th width="15%">
      $TS::TS_candidates_nomby
    </th>
    <th width="35%">
      $TS::TS_candidates_mecom
    </th>
  </tr>
END
		foreach (@list) {
			my @entry = split(/#!#/, $_);
			my $tempcolor = $UI::box[$UI::currentskin];
			if ($tr2 eq " bgcolor=\"$tempcolor\"") {
				$tr2 = " bgcolor=\"$UI::verylight[$UI::currentskin]\"";
			} else {
				$tr2 = " bgcolor=\"$UI::box[$UI::currentskin]\"";
			}
			$entry[0]=~s/[\n\r]//g;
			if ($entry[0] ne "") {
				my $dis = $entry[3];
				$dis=~s/, $//g;
				print <<END;
  <tr$td_align$tr2>
    <td>
      <a href="candidates.cgi?cmd=view&name=$entry[0]">$entry[0]</a>
    </td>
    <td>
      $entry[1]
    </td>
    <td>
      <a href="$path_on_server/editors/profile.cgi?editor=$entry[2]">$entry[2]</a>
    </td>
    <td>
      $dis
    </td>
  </tr>
END
			}
		}
		print "</table>\n</div>";
	} else {
		print "$TS::TS_candidates_nocands";
	}
	print <<END;
<p>
  <a href="candidates.cgi?cmd=nominate">$TS::TS_candidates_nominate</a>
</p>
END
}

if ($command eq "view") {
	# View the discussion and the votes associated with a specific candidate

	my $total = 0;
	open(SRC, "$path_data/eperm/cand/$name.nfo");
	@data = <SRC>;
	close(SRC);

	print "$TS::TS_candidates_ename: <a href=\"$path_on_server/editors/profile.cgi?editor=$name\">$name</a><br>\n";
	print "$TS::TS_candidates_daten: $data[0]<br>\n";

	@comments = split(/#!#/, $data[1]);

	print <<END;
<div align="center">
  <table border="0"$t_wid>
    <tr$td_align$tr1>
      <th width="15%">
        $TS::TS_candidates_metaname
      </th>
      <th width="5%">
        $TS::TS_candidates_rating
      </th>
      <th width="80%">
        $TS::TS_candidates_comment
      </th>
    </tr>
END

	my $item = 0;
	my $noVotes = 0;
	my %votes;

	foreach (@comments) {
		my($lotime, $meta, $comment, $rating) = split(/#!!#/, $_);
		print "<tr$td_align$tr2>\n";
                my $tempcolor = $UI::box[$UI::currentskin];
		if ($tr2 eq " bgcolor=\"$tempcolor\"")
		{
			$tr2 = " bgcolor=\"$UI::verylight[$UI::currentskin]\"";
		} else {
			$tr2 = " bgcolor=\"$UI::box[$UI::currentskin]\"";
		}
		print "<td><a href=\"$path_on_server/editors/profile.cgi?editor=$meta\">$meta</a></td>";
		if ($rating ne "") {
			print "<td>$rating</td>";
		} else {
			print "<td>-</td>";
		}
		$comment=~s/\|/<br>/g;
		print "<td align=\"left\" valign=\"top\"><img src=\"$path_on_server/posticon.gif\"> <small>item$item - $lotime";
		if (($meta eq Editor::currentUser()) && ($allow_edit == 1)) {
			print " - <a href=\"candidates.cgi?name=$name&cmd=edit&edit=$item\">[edit]</a>";
		}
		print "</small><hr>$comment</td>";
		print "</tr>";

		if ((defined $votes{$meta}) && ($votes{$meta} ne "")) {
			$total -= $votes{$meta};
			$noVotes--;
		}

		if ($rating ne "") {
			$total += $rating;
			$noVotes++;
		}

		$votes{$meta} = $rating;
		$item++;
	}

	my $average = $total / $noVotes;

	my $font;
	my $end_font;
	
	if ($average > 2.5) {
		$font = "<font color=\"#00AA00\">";
		$end_font = "</font>";
	}
	if ($average < 2.5) {
		$font = "<font color=\"#AA0000\">";
		$end_font = "</font>";
	}
	if ($average == 2.5) {
		$font = "<font color=\"#000000\">";
		$end_font = "</font>";
	}
	print "</tr>\n</table>\n</div>\n<p>$TS::TS_candidates_averagerating: $font$average$end_font</p>\n";
	print "<p><a href=\"candidates.cgi?cmd=add&name=$name\">$TS::TS_candidates_addcom</a>\n</p>";
}

if (($command eq "add") || ($command eq "edit")) {
	# Display a form dedicated to the addition of new comments

	if (($command eq "edit") && ($allow_edit != 1)) {
		exit(0);
	}

	my($message, $presel);
	$message = "";

	# If we edit a message, we should display it in the textarea box, so we retrieve it
	if ($command eq "edit") {
		open(SRC, "$path_data/eperm/cand/$name.nfo");
		@data = <SRC>;
		close(SRC);
		@comments = split(/#!#/, $data[1]);
		my($lotime, $meta, $comment, $rating) = split(/#!!#/, $comments[$edit]);
		$message = $comment;
		$presel = $rating;
	}

	UI::writeStartForm();
	UI::writeItemForm("<strong>$TS::TS_candidates_comment</strong>", "<textarea name=\"comnt\" rows=\"5\" cols=\"60\">$message</textarea>");
	UI::writeHiddenForm("name", $name);
	UI::writeHiddenForm("cmd", "insert");
	if ($command eq "add") {
		UI::writeHiddenForm("edit", "add");
	} else {
		UI::writeHiddenForm("edit", $edit);
	}

	my $radio = "";
	for (my $d = 0; $d <= 5; $d++) {
		$radio .= "<input type=\"radio\" name=\"num\" value=\"$d\"";
		if (($command eq "edit") && ($d eq $presel)) {
			$radio .= " checked";
		}
		$radio .= ">$d&nbsp;";
	}

	UI::writeItemForm("<strong>$TS::TS_candidates_rateeditor</strong>", $radio);
	UI::writeEndForm();
}

if (($command eq "insert") && ($message ne "")) {
	# Insert new comments for a given candidate

	open(SRC, "$path_data/eperm/cand/$name.nfo");
	@data = <SRC>;
	close(SRC);
	
	chomp($data[0]);
	chomp($data[1]);

	$message=~s/\&/&amp;/g;
	$message=~s/\|/&#124;/g;
	$message=~s/\n/|/g;
	
	$lt = localtime;

	if ($edit eq "add") {
		# Add a new post at the end

		my $m_com;
		if ($opinion ne "") {
			$m_com = "#!#$lt#!!#$adder#!!#$message#!!#$opinion";
		} else {
			$m_com = "#!#$lt#!!#$adder#!!#$message#!!#-";
		}

		$data[1] = $data[1] . $m_com;
	} else {
		# Edit a post in the middle

		if ($allow_edit != 1) {
			exit(0);
		}

		@comments = split(/#!#/, $data[1]);
		my($lotime, $meta, $comment, $rating) = split(/#!!#/, $comments[$edit]);
		$comment = $message;
		$rating = $opinion;
		if ($rating eq "") {
			$rating = "-";
		}

		if ($meta eq Editor::currentUser()) {
			$comments[$edit] = "$lotime#!!#$meta#!!#$comment#!!#$rating";
		}

		$data[1] = join("#!#", @comments);
	}

	open(SRC, ">$path_data/eperm/cand/$name.nfo");
	print SRC "$data[0]\n$data[1]";
	close(SRC);

	# Modify cand.lst only for new posts, not for edits.
	if ($edit eq "add") {
		open(SRCE, "$path_data/eperm/cand/cand.lst");
		my @cand = <SRCE>;
		close(SRCE);
		
		my @newcandnfo;
		foreach (@cand) {
			my ($ename, $sp, $nomby, $metas) = split(/#!#/, $_);
			if ($ename eq $name) {
				@metas = split(/\, /, $metas);
				push(@metas, $adder);
				
				my $metaList = "";
				foreach my $meta (@metas) {
					$meta=~s/[\n\r]//g;
					if ($meta ne "") {
						$metaList .= "$meta\, ";
					}
				}
				my $insert = "$name#!#$sp#!#$nomby#!#$metaList";
				push(@newcandnfo, $insert);
			} else {
				push(@newcandnfo, $_);
			}
		}

		my $newcand = join("\n", @newcandnfo);
		$newcand=~s/\n{2,}/\n/g;
		open(SRCE, ">$path_data/eperm/cand/cand.lst");
		print SRCE $newcand;
		close(SRCE);
	}

	print "$TS::TS_candidates_commentsadded<br>";
}

if (($command eq "nominate") && ($message ne "") && ($opinion ne "") && ($spriv ne "")) {
	# Process the request to add a new candidate in the list

	$message=~s/\n/ /g;
	$message=~s/\r/ /g;

	if (!(-d "$path_data/eperm")) {
		mkdir("$path_data/eperm");
	}
	if (!(-d "$path_data/eperm/cand")) {
		mkdir("$path_data/eperm/cand");
	}
	open(SRC, "$path_data/eperm/cand/cand.lst");
	my @cand = <SRC>;
	close(SRC);

	my $isAlreadyNominated = 0;
	shift(@cand);
	foreach (@cand) {
		my ($oname, @crud) = split(/#!#/, $_);
		if ($oname eq $name) {
			$isAlreadyNominated = 1;
		}
	}
	if ($isAlreadyNominated) {
		print "$TS::TS_candidates_alreadynomed<br>";
		print "<a href=\"candidates.cgi?cmd=view&name=$name\">$TS::TS_candidates_view</a>";
	} else {
		Editor::validateEditor($name);
		$lt = localtime;
		my $nfo_data;
		if ($opinion ne "") {
			$nfo_data = "$lt#!!#$adder#!!#$message#!!#$opinion";
		} else {
			$nfo_data = "$lt#!!#$adder#!!#$message#!!#-";
		}

		open(SRC, ">$path_data/eperm/cand/$name.nfo");
		print SRC "$lt\n$nfo_data";
		close(SRC);

		my $insert = "$name#!#$spriv#!#$adder#!#$adder";

		open(SRC, ">>$path_data/eperm/cand/cand.lst");
		print SRC "\n$insert";
		close(SRC);
		print "$name $TS::TS_candidates_nominated: $spriv<br>";
	}
}

if (($command eq "nominate") && (($message eq "") || ($opinion eq "") || ($spriv eq ""))) {
	# Displays a form dedicated to the nomination of another candidate

	UI::writeStartForm("", "candidates.cgi");
	UI::writeItemForm("<strong>$TS::TS_candidates_ename</strong>", "<input type=\"text\" name=\"name\">");
	UI::writeItemForm("<strong>$TS::TS_candidates_nomfor</strong>",
		"<input type=\"radio\" name=\"spriv\" value=\"cateditall\">cateditall<br>" .
		"<input type=\"radio\" name=\"spriv\" value=\"editall\">editall<br>" .
		"<input type=\"radio\" name=\"spriv\" value=\"catmod\">catmod<br>" .
		"<input type=\"radio\" name=\"spriv\" value=\"meta\">meta<br>");
	UI::writeItemForm("<strong>$TS::TS_candidates_rateeditor</strong>",
		"<input type=\"radio\" name=\"num\" value=\"0\">0&nbsp;".
		"<input type=\"radio\" name=\"num\" value=\"1\">1&nbsp;".
		"<input type=\"radio\" name=\"num\" value=\"2\">2&nbsp;".
		"<input type=\"radio\" name=\"num\" value=\"3\">3&nbsp;".
		"<input type=\"radio\" name=\"num\" value=\"4\">4&nbsp;".
		"<input type=\"radio\" name=\"num\" value=\"5\">5&nbsp");
	UI::writeItemForm("<strong>$TS::TS_candidates_comment</strong>", "<textarea name=\"comnt\" rows=\"5\" cols=\"60\"></textarea>");
	UI::writeHiddenForm("cmd", "nominate");
	UI::writeEndForm();
}

if (($command eq "remove") && ($name ne "") && ($allow_remove == 1)) {
	my @newcands;
	my $deldata;
	
	open(SRC, "$path_data/eperm/cand/cand.lst");
	my @cands = <SRC>;
	close(SRC);

	shift(@cands);
	foreach (@cands) {
		my ($ename, @crud) = split(/#!#/, $_);
		if ($ename ne $name) {
			push(@newcands, $_);
		} else {
			$deldata = $_;
			print "$TS::TS_candidates_candelete<br>";
		}
	}

	open(SRC, ">$path_data/eperm/cand/cand.lst");
	foreach (@newcands) {
		chomp($_);
		if ($_ ne "") {
			print SRC "\n$_";
		}
	}
	close(SRC);

	unlink("$path_data/eperm/cand/$name.nfo");
	open(SRC, ">>$path_home/deldata/cand/cand.lst");
	print SRC "$deldata\n";
	close(SRC);
}


if ($command ne "list") {
	print <<END;
<p>
  <a href="candidates.cgi?cmd=list">$TS::TS_candidates_returntolist</a>
</p>
END
}

UI::writeScriptFooter();
