#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Logs;
use Settings;
use TS;
use UI;

my($cgi) = new CGI;
my($cat) = $cgi->param('cat');

if ($cat eq "") {
	UI::writeHeaderCode($TS::TS_catlogs_title);
	Editor::writeECode();

	UI::writeScriptHeader("", $TS::TS_catlogs_title, $TS::TS_catlogs_info);
	print <<END;
<form method="GET" action="catlogs.cgi">
  <p><input type="text" name="cat" size="39"><br>
  <input type="submit" value="$TS::TS_common_submit"></p>
</form>
END
} else {
	$cat = Editor::validateCat($cat);

	UI::writeHeaderCode($TS::TS_catlogs_title);
	Editor::writeECode();

	UI::writeScriptHeader($cat, $TS::TS_catlogs_title, $TS::TS_catlogs_info);

	print "<table><tr bgcolor=\"#eeeeee\"><td>$TS::TS_common_editor</td><td>$TS::TS_common_time</td><td>$TS::TS_catlogs_action</td><td>$TS::TS_catlogs_object</td><td>$TS::TS_catlogs_details</td></tr>";

	open(META, "$path_data/logs/rootlog/comeditlog.log");
	my(@rlog2) = <META>;
	close(META);
	@rlog2 = grep { / $cat / } @rlog2;
	for (my($d) = 0; $d <= $#rlog2; $d++) {
		my($rlog) = $rlog2[$d];
		if ($rlog=~/##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# {1,}##!## (.*?) {1,}#!# ##!!!## (.*?) (.*?) ##!!!!##/) {
			my($editor) = $1;
			my($time) = $2;
			my($action) = $3;
			my($what) = $4;
			my($edit) = $6;
			$edit =~s/ - //g;
			$edit =~s/- //g;
			if ($edit=~/^[0-9]*$/) {
				$edit = "<a href=\"viewedit.cgi?num=$edit\">[$TS::TS_catlogs_view]</a>";
			}

			print "<tr bgcolor=\"#f8f8f8\"><td><a href=\"$path_on_server/editors/profile.cgi?editor=$editor\">$editor</a></td><td>$time</td><td>$action</td><td>$what</td><td>$edit</td></tr>";
		}
	}

	print "</table>";
}

UI::writeScriptFooter();
