#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

UI::writeHeaderCode($TS::TS_catmvlog_title);
Editor::writeECode();

UI::writeScriptHeader("", $TS::TS_catmvlog_title, $TS::TS_catmvlog_info);

my $name = $cgi->param('name');

open(LOG, "$path_data/logs/rootlog/catmv.log");
my(@CONTENT) = <LOG>;
close(LOG);

my $start = $cgi->param('start');
if ($start eq "") {
	$start = 1;
}

my $size = $cgi->param('size');
if ($size eq "") {
	if ($name eq "") {
		$size = 100;
	} else {
		$size = $#CONTENT + 1;
	}
}
my $osize = $size;

if ($start > $#CONTENT + 1) {
	$start = $#CONTENT;
}
if ($start < 1) {
	$start = 1;
}

if ($start + $size - 1 > $#CONTENT + 1) {
	$size = $#CONTENT + 2 - $start;
}

my $end = $start + $size - 1;
my $total = $#CONTENT + 1;

if ($name eq "") {
	print "<p>$TS::TS_common_displaying $start $TS::TS_common_to $end... ($TS::TS_common_fromatotal $total)<br>";
	if ($start != 1) {
		print "<a href=\"catmvlog.cgi?name=$name&start=";
		print 1;
		print "\">[$TS::TS_common_start]</a> ";
        }
	if ($start >= $osize) {
		print "<a href=\"catmvlog.cgi?name=$name&start=";
		print $start - $osize;
		print "\">[$TS::TS_common_prev]</a> ";
	}
	if ($end < $#CONTENT) {
		print "<a href=\"catmvlog.cgi?name=$name&start=";
		print $start + $osize;
		print "\">[$TS::TS_common_next]</a> ";
	}
	my $endEntry = $total;
	if ($endEntry == 0) {
		$endEntry = 1;
	}
	while ($endEntry - 1!= int($endEntry / $osize) * $osize) {
		$endEntry--;
	}
	if ($start != $endEntry) {
		print "<a href=\"catmvlog.cgi?name=$name&start=";
		print $endEntry;
		print "\">[$TS::TS_common_end]</a> ";
	}
	if (!(($start == 1) && ($end == $total))) {
		print "<a href=\"catmvlog.cgi?name=$name&start=1&size=$total\">[$TS::TS_common_all]</a>";
	}
	print "</p>";
} else {
	print "<p>Displaying entries made by editor $name... (from a total of $total) [<a href=\"catmvlog.cgi\">cancel editor restriction</a>]</p>";
	$start = 1;
	my($content) = $#CONTENT;
}

print <<END;
<table width="100%">
  <tr align="center" bgcolor="#eeeeee">
    <td width="20%">$bold $TS::TS_common_time $unBold</td>
    <td width="1%">$bold $TS::TS_common_editor $unBold</td>
    <td>$bold $TS::TS_common_category $unBold</td>
  </tr>
END

for (my $d = $#CONTENT - $start + 1; $d >= $#CONTENT - $end + 1; $d--) {
	if ($CONTENT[$d]=~/## (.*?) ## (.*?) ## (.*?) ## (.*?) ##/) {
		my $time = $1;
		my $editor = $2;
		my $from = $3;
		my $to = $4;

		$from = UI::getNiceFormat($from);
		my $nto = $to;
		$nto =~s/>/\//g;
		$to = UI::getNiceFormat($to);

		if (($name eq "") || ($name eq $editor)) {
			$editor = "<a href=\"catmvlog.cgi?name=$editor\">$editor</a> [<a href=\"profile.cgi?editor=$editor\">$TS::TS_common_profile</a>]";
			print "<tr><td rowspan=\"2\">$time</td><td rowspan=\"2\">$editor</td><td>$from ==></td></tr><tr><td><a href=\"/$nto/\">$to</a></td></tr>\n";
		}
	}
}

close(LOG);

print("</table>");

UI::writeScriptFooter();
