#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $do = $cgi->param('do');
my $typeset = $cgi->param('newtype');

$cat = Editor::testPrivs($cat);

if ($do ne "") {
        UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_cattype_title);
Editor::writeECode();

if ($do ne "") {
	open(LDATA, ">$path_sitedata/$cat.ct");
	print LDATA "$typeset\n";
	close(LDATA);

	Storage::logEdit("edit", "cattype", $cat, $typeset);

	Generate::updatePublicSide($cat);
}

open(CAT, "$path_sitedata/$cat.html");
my(@cat2) = <CAT>;
close(CAT);

open(ED, "$path_sitedata/$cat.ed");
my(@edi) = <ED>;
close(ED);

open(CT, "$path_sitedata/$cat.ct");
my($typ) = <CT>;
close(CT);

if ($typ eq "") {
	$typ = "default";
}

$typ=~s/\n//g;
$typ=~s/\r//g;

UI::writeScriptHeader($cat, $TS::TS_cattype_title, $TS::TS_cattype_info);

UI::writeStartForm($cat);
UI::writeItemForm($TS::TS_cattype_currenttype, Common::writeTemplateCombo($cat, "newtype", $typ));
UI::writeEndForm("do");

UI::writeScriptFooter($cat);
