#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $cmd = $cgi->param('cmd');

my $catnoteoff = $cgi->param('catnoteoff');
my $autogen = $cgi->param('autogen');
my $templates = $cgi->param('templates');
my $complete = $cgi->param('complete');

$cat = Editor::validateCat($cat);

if ($cmd ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_chcatopt_title);
Editor::writeECode();

UI::writeScriptHeader($cat, $TS::TS_chcatopt_title);

#Load Catopts File
open(DCATS, "$path_sitedata/$cat.catopt");
my @opts = <DCATS>;
close(DCATS);

my($cnchecked, $autogenchecked, $templateschecked, $completechecked);

#Check if it is already checked
if ($opts[0] eq "off\n") {
	$cnchecked = " checked";
}

if ($opts[1] eq "off\n") {
	$autogenchecked = " checked";
}

#Include for compatibility issues
open(LDATA, "$path_sitedata/$cat.autogen");
my $readst = <LDATA>;
close(LDATA);

if ($readst eq "ON") {
	$autogenchecked = " checked";
}

if ($opts[2] eq "off\n") {
	$templateschecked = " checked";
}

if ($opts[3] eq "off\n") {
	$completechecked = " checked";
}

if ($cmd ne "") {
	if (($catnoteoff eq "off") && ($isMeta == 1)) {
		$opts[0] = "off";
	} elsif ($isMeta == 1) {
		$opts[0] = "";
	}
   
	if ($autogen eq "off") {
		$opts[1] = "off";
	} else {
		$opts[1] = "";
	}
   
	if ($templates eq "off") {
		$opts[2] = "off";
	} else {
		$opts[2] = "";
	}
   
	if ($complete eq "off") {
		$opts[3] = "off";
	} else {
		$opts[3] = "";
	}
   
	open(TEXTFILE, ">$path_sitedata/$cat.catopt");
	print TEXTFILE $opts[0] . "\n";
	print TEXTFILE $opts[1] . "\n";
	print TEXTFILE $opts[2] . "\n";
	print TEXTFILE $opts[3] . "\n";
	close(TEXTFILE);

	#Include the second value in another file, for compatibility issues
	open(LDATA, ">$path_sitedata/$cat.autogen");
	if ($opts[1] eq "off") {
		print LDATA "ON"
	} else {
		print LDATA "OFF";
	}
	close(LDATA);

	Generate::updatePublicSide($cat);
	Storage::logEdit("edit", "catopt", $cat, "$opts[0]\n$opts[1]\n$opts[2]\n$opts[3]\n");

	print $TS::TS_chcatopt_chsav;
}

if ($cmd eq "") {
	print <<END;
<form method="POST" action="chcatopt.cgi">
  <input type="hidden" value="$cat" name="cat">
END

	if ($isMeta == 1) {
		print <<END;
  <p>$TS::TS_chcatopt_cheno -
  <input type="checkbox" name="catnoteoff" value="off"$cnchecked></p>
END
	}

	print <<END;
  <p>$TS::TS_chcatopt_ascg -
  <input type="checkbox" name="autogen" value="off"$autogenchecked></p>
  <p>$TS::TS_chcatopt_notem -
  <input type="checkbox" name="templates" value="off"$templateschecked></p>
  <p>$TS::TS_chcatopt_compl - 
  <input type="checkbox" name="complete" value="off"$completechecked></p>
  <p><input type="submit" value="$TS::TS_common_submit" name="cmd"></p>
</form>
END
}

UI::writeScriptFooter($cat);
