#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $action = $cgi->param('action');
my $editall = $cgi->param('editall');
my $meta = $cgi->param('meta');
my $root = $cgi->param('root');

UI::writeHeaderCode("Change Current Privileges");

# check for 'real' root permissions...

open(ROOT, "$path_data/root.gf");
my $rootPrivs = <ROOT>;
close(ROOT);

my($isRealRoot);

if (($rootPrivs=~/ $ENV{REMOTE_USER} /) || ($rootPrivs=~/ ~$ENV{REMOTE_USER} /) || ($ENV{REMOTE_USER} eq "")) {
	$isRealRoot = "1";
} else {
	$isRealRoot = "0";
}

if ($isRealRoot eq "0") {
	print $TS::TS_common_noaccess;
	UI::writeScriptFooter();
	exit(0);
}

# reminder: root = root.gf
#           meta = dirman.gf
#        editall = dirmod.gf

if ($action ne "submit") {
	my $editallPrivs = "";
	my $metaPrivs = "";
	my $rootPrivs = "";

	open(EDITALL, "$path_data/dirmod.gf");
	if (<EDITALL>=~/^| $ENV{REMOTE_USER} |$/) { $editallPrivs = " checked"; }
	close(EDITALL);

	open(META, "$path_data/dirman.gf");
	if (<META>=~/^| $ENV{REMOTE_USER} |$/) { $metaPrivs = " checked"; }
	close(META);

	open(ROOT, "$path_data/root.gf");
	if (<ROOT>=~/^| $ENV{REMOTE_USER} |$/) { $rootPrivs = " checked"; }
	close(ROOT);

	print <<HTML_QUOTE;
<h2>Change Current Privileges</h2>
<p>This form will let you change the privileges that CGIs will see that you have. This is
intended as an easier solution than adding ?noeditall=1, etc to the URLs. It works by
adding a tilde character (~) before your name in dirmod.gf, dirman.gf or root.gf. This
causes CGIs to think that you are not in that privilege, while still allowing CGIs related
to this one to see that you really *are* a root. :)</p>
<form action="chprivs.cgi" method="get">
<input type="hidden" name="action" value="submit">
<table>
<tr><td>Editall:</td><td><input type="checkbox" name="editall" value="1"$editallPrivs></td></tr>
<tr><td>Meta:</td><td><input type="checkbox" name="meta" value="1"$metaPrivs></td></tr>
<tr><td>Root:</td><td><input type="checkbox" name="root" value="1"$rootPrivs></td></tr>
<tr><td colspan="2"><input type="submit" value="$TS::TS_common_submit"></td></tr>
</table>
</form>
HTML_QUOTE
} else {
	# first, remove ourselves from the .gf files
	open(EDITALL, "$path_data/dirmod.gf");
	my $editallPrivs = <EDITALL>;
	close(EDITALL);

	open(META, "$path_data/dirman.gf");
	my $metaPrivs = <META>;
	close(META);

	open(ROOT, "$path_data/root.gf");
	my $rootPrivs = <ROOT>;
	close(ROOT);

	#$metaPrivs=~s/ ~?$ENV{REMOTE_USER} / /;
	#$rootPrivs=~s/ ~?$ENV{REMOTE_USER} / /;

	# now, stick our name back on the end with a prefix.

	if ($editall eq "1") {
		if (!($editallPrivs=~/^| $ENV{REMOTE_USER} |$/)) {
			$editallPrivs .= " $ENV{REMOTE_USER}";
		}
	} else {
		$editallPrivs=~s/(^| )($ENV{REMOTE_USER})( |$)/$1$3/;
		$editallPrivs=~s/  +/ /g;
	}

	if ($meta eq "1") {
		if (!($metaPrivs=~/^| $ENV{REMOTE_USER} |$/)) {
			$metaPrivs .= " $ENV{REMOTE_USER}";
		}
	} else {
		$metaPrivs=~s/(^| )($ENV{REMOTE_USER})( |$)/$1$3/;
		$metaPrivs=~s/  +/ /g;
	}

	if ($root eq "1") {
		$rootPrivs=~s/ ~($ENV{REMOTE_USER}) / $1 /;
	} else {
		$rootPrivs=~s/ ($ENV{REMOTE_USER}) / ~$1 /;
	}

	# finally, write these values back. (note: Not writing to the real files yet)
	open(EDITALL, ">$path_data/dirmod.gf");
	print EDITALL $editallPrivs;
	close(EDITALL);

	open(META, ">$path_data/dirman.gf");
	print META $metaPrivs;
	close(META);

	open(ROOT, ">$path_data/root.gf");
	print ROOT $rootPrivs;
	close(ROOT);

	print "<p>Your permissions have been changed.</p>";
}

UI::writeScriptFooter();
