#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $line = $cgi->param('line');

UI::writeHeaderCode("Edit Top Level Categories");
Editor::writeECode();
Editor::restrictedRoot();

if ($line eq "") {
	my $comments = Storage::getData("global", "tlc.lc");
	print <<END;
<title>Change Top Level Categories</title>
<b>Top Level Category List</b><br>
Choose the categories that editalls may create/rename/delete categories in.
<br>
<form method="POST" action="./ctlc.cgi">
<input type="text" name="line" value="$comments" size="40"></p>
<input type=submit value="Change"></form><br>
END
}

if ($line ne "") {
	Storage::setData("global", "tlc.lc", "$line\n");
	print "Top level category list changed.<br>";
END
}

UI::writeScriptFooter();
