#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $tcat = $cgi->param('tcat');
my $lt = localtime;

UI::writeHeaderCode($TS::TS_delcat_title);
Editor::writeECode();
Editor::restrictedEditall();

if ($act ne "") {
	$cat = Editor::validateCat($cat, 2);
	$tcat = Editor::validateCat($tcat);
	Editor::validateCat($tcat . ">" . $cat);

	if (!(Common::isCatEmpty($cat))) {
		UI::showError("", "$TS::TS_common_notempty", $cat, "");
	}

	move("$path_sitedata/$tcat>$cat.html", "$path_home/deldata/$tcat>$cat.html");
	move("$path_sitedata/$tcat>$cat.ed", "$path_home/deldata/$tcat>$cat.ed");

	open(EL, "$path_sitedata/cats.lst");
	my $lou2 = <EL>;
	$lou2=~s/ $tcat>$cat; / /g;
	close(EL);

	open(EL2, ">$path_sitedata/cats.lst");
	print EL2 "$lou2";
	close(EL2);

	Generate::updatePublicSide($cat);
	print "$TS::TS_delcat_done<br>";

	#log code

	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);

	open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
	print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## edit #!# ##!## delete #!# ##!!!## $tcat>$cat - deleted ##!!!!## \n";
	close(TEXTFILE);

	#end log code
}
else
{
	#Top Cat Parse
	open(EL, "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm");
	my $dmlst= <EL>;
	close(EL);
	if ($dmlst=~/editall/g) {
		$dmlst = Storage::getData("global", "tlc.lc");
	}

	my $sep = "</option><option>";
	$dmlst=~s/; /$sep/g;

	print <<END;
<font size="+2">$TS::TS_delcat_title</font>
<br>
<hr><form method="POST" action="delcat.cgi">
<p><b>$TS::TS_common_category:</b><br>
<select name="tcat">
<option>
$dmlst
</select>
<input type="text" name="cat" size="40">
<p><input type="submit" value="$TS::TS_common_submit" name="action">
<br></form>
END
}

UI::writeScriptFooter();
