#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************



use strict;
use CGI;

use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $action = $cgi->param('action');
my $cat = $cgi->param('cat');
my $link = $cgi->param('link');
my $confirm = $cgi->param('confirm');

$cat = Editor::validateCat($cat);

my($pointsto, @output);

if ($confirm ne "") {
        UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_delsymlink_deletelink);
Editor::writeECode();

if ($link ne "") {
   if ($confirm eq "yes") {
      # The editor confirmed that he wants the @link deleted

      open(LINKS, "$path_sitedata/$cat.symlinks");
      my $found = 0;
      while (<LINKS>) {
         my $line = $_;
         chomp($line);
         my ($linktitle, $linkpath) = split(/:/, $line);
         if ($linktitle ne $link) {
            push(@output, "$line\n");
         } else {
            $found = 1;

	    open(PRIC, "$path_sitedata/$cat.pricat");
	    my @data = <PRIC>;
	    close(PRIC);

	    for (my $xr = 0; $xr <= $#data; $xr++) {
	    	if ($data[$xr]=~/$linktitle(.);/) {
			$data[$xr] = "";
		}
            }
	    
	    my $data = join("", @data);

	    open(PRIC, ">$path_sitedata/$cat.pricat");
	    print PRIC $data;
	    close(PRIC);

	    my(@outputtwo);

            open(LINKSTO, "$path_sitedata/$linkpath.symlinksto");
            while (<LINKSTO>) {
               my $linetwo = $_;
               chomp($linetwo);
               my($linkedby) = split(/:/, $linetwo);
               if ($linkedby ne $cat) {
                  push(@outputtwo, "$linetwo\n");
               }
            }
            close(LINKSTO);
            open(LINKSTO, ">$path_sitedata/$linkpath.symlinksto");
            print LINKSTO @outputtwo;
            close(LINKSTO);

            open(EL, "$path_data/pginfo/tble");
            my $table = <EL>;
            close(EL);
			
	    Storage::logEdit("delete", "symlink", $cat, "$linktitle\n$linkpath");
         }
      }
      close(LINKS);
      open(LINKS, ">$path_sitedata/$cat.symlinks");
      print LINKS @output;
      close(LINKS);

      Generate::updatePublicSide($cat);

      if ($found eq "0") {
         print "$TS::TS_delsymlink_notfound\n";
      } else {
         print "$TS::TS_delsymlink_deleted\n";
      }
   } else {
      open(LINKS, "$path_sitedata/$cat.symlinks");
      my $found = 0;
      while (<LINKS>) {
         my $line = $_;
         chomp($line);
         my ($linktitle, $linkpath) = split(/:/, $line);
         if ($linktitle eq $link) {
            $pointsto = $linkpath;
            $found = 1;
         }
      }
      close(LINKS);

      if ($found eq "1") {
         $link = Generate::noHTML($link);
         print <<END;
<h2>$TS::TS_delsymlink_deletelink</h2>
<p>$TS::TS_delsymlink_areyousure</p>
<table>
<tr><td>$TS::TS_delsymlink_fromcategory</td><td>$cat</td></tr>
<tr><td>$TS::TS_delsymlink_titleoflink</td><td>$link</td></tr>
<tr><td>$TS::TS_delsymlink_pointsto</td><td>$pointsto</td></tr>
</table>
<form action="delsymlink.cgi" method="POST">
<input type="hidden" name="confirm" value="yes">
<input type="hidden" name="cat" value="$cat">
<input type="hidden" name="link" value="$link">
<p><input type="submit" value="$TS::TS_delsymlink_confirm"></p>
</form>
END
      } else {
         print "$TS::TS_delsymlink_notfound\n";
      }
   }
} else {
   print "$TS::TS_delsymlink_pleasegivelink\n";
}

UI::writeScriptFooter($cat);
