#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

sub writeTable
{
	my($cats) = @_;
	$cats=~s/[^:]*:[\s]*([a-z].*)/$1/g;
	print <<END;
<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="276"><tr><td width="600">
END
	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);
	$cats=~s/([^\s\<\>]*)/<a href="\/editors\/profile.cgi?editor=$1">$1<\/a>/g;
	$cats=~s/<\/a> /<\/a>$table/g;
	print "$cats";
	print "</table>";

	return 1;
}

sub displayMode
{
	my($okayMode, $ID, $text) = @_;
	if ($okayMode eq $ID) {
		print "<li><strong>$text</strong> - $TS::TS_dirmods_selected</li>";
	} else {
		print "<li><a href=\"dirmods.cgi?mode=$ID\">$text</a></li>";
	}
}

my $mode = $cgi->param('mode');

if ($mode eq "") {
	$mode = "3";
}

UI::writeHeaderCode($TS::TS_dirmods_title);

print "<h2>$TS::TS_dirmods_title</h2>";
print "<a href=\"/edoc/editalls.html\">$TS::TS_dirmods_publist</a><hr>";

if ($mode eq "3") {
	print <<END;
<table cellSpacing="2" cellPadding="2" border="1">
<tbody>
<tr>
<td align="middle"><strong>editor</strong></td>
<td><b>root</b></TD>
<td><b>editall</b></TD>
<td><b>meta</b></TD>
<td align="middle"><strong>last login</strong></td></tr>
END

	opendir(DIR,"$path_data/misc");
	my @edits = readdir(DIR);
        closedir(DIR);

	@edits = sort { lc($a) cmp lc($b) } @edits;

	my $users = Storage::getData("global", "elist");

	chomp(@edits);
	foreach (@edits) {
		$_=~s/.eaddr//g;

		if ($users=~/ $_ /) {
			open(FILE, "$path_data/dirmod.gf");
			my $editalllist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/dirman.gf");
			my $metalist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/root.gf");
			my $rootlist = <FILE>;
			close(FILE);

			my $onmeta = "";
			my $onroot = "";
			my $oneditall = "";
			my $editor = $_;
			my $onlist = 0;
			my $cat = "";

			if ($editalllist=~/ $_ /g) {
				$onlist = 1;
				$oneditall =  "editall";
				open(LDATA, "$path_data/eperm/editall/$_.perm");
				$cat = <LDATA>;
				close(LDATA);
				if ($cat=~/editall/) {
					$cat = "editall";
				} else {
					$cat = "cateditall";
				}
			}

			if ($metalist=~/ $_ /g) {	
				$onlist = 1;
				open(LDATA, "$path_data/eperm/meta/$_.perm");
				my $mcat = <LDATA>;
				close(LDATA);
				if ($mcat=~/meta/) {
					$onmeta = "meta";
				} else {
					$onmeta = "catmod";
				}        
			}

			if ($rootlist=~/ $_ /g) {
				$onlist = 1;
				$onroot = "root";
			}

			if ($onlist eq "1") {
				open(LDATA, "$path_data/logs/$editor.ll");
				my $ll = <LDATA>;
				close(LDATA);
				$cat=~s/;/<br>/g;
			        print <<END;
<tr>
<td><a href="profile.cgi?editor=$_">$_</a></td>
<td>$onroot&nbsp;</td>
<td>$cat&nbsp;</td>
<td>$onmeta&nbsp;</td>
<td>$ll</td></tr>
END
			        $onmeta = "";
			        $onroot = "";
			        $oneditall = "";
			}

			#$ook = "<a href=\"../../profile.cgi?editor=$_\">$_</a>";
			#$rlog=~s/ $_ /$ook/g;
		}
	};

	print <<END;
</tbody></table>
END
}

if ($mode eq "2") {
	print "<br><b>(Cat)Editalls:<br></b>\n";
	open(EL, "$path_data/dirmod.gf");
	my $cats = <EL>;
	close(EL);
	$cats=~s/ ~(.*?) / $1 /;
	writeTable($cats);

	print "<br><b>Metas:<br></b>\n";
	open(EL, "$path_data/dirman.gf");
	my $cats = <EL>;
	close(EL);
	$cats=~s/ ~(.*?) / $1 /;
	writeTable($cats);

	print "<br><b>Roots:<br></b>\n";
	open(EL, "$path_data/root.gf");
	my $cats = <EL>;
	close(EL);
	$cats=~s/ ~(.*?) / $1 /;
	writeTable($cats);
}

if ($mode eq "1") {
	open(EDEDITALL, "$path_data/dirmod.gf");
	my $ed_editall = <EDEDITALL>;
	close(EDEDITALL);
	$ed_editall=~s/dirmod/<strong>(Cat)Editalls<\/strong>/;
	$ed_editall = <p> . $ed_editall . "</p>";
	$ed_editall=~s/ ~(.*?) / $1 /;
	print $ed_editall;

	open(EDMETA, "$path_data/dirman.gf");
	my $ed_meta = <EDMETA>;
	close(EDMETA);
	$ed_meta=~s/dirman/<strong>Metas<\/strong>/;
	$ed_meta = <p> . $ed_meta . "</p>";
	$ed_meta=~s/ ~(.*?) / $1 /;
	print $ed_meta;

	open(EDROOT, "$path_data/root.gf");
	my $ed_root = <EDROOT>;
	close(EDROOT);
	$ed_root=~s/root/<strong>Roots<\/strong>/;
	$ed_root = <p> . $ed_root . "</p>";
	$ed_root=~s/ ~(.*?) / $1 /;
	print $ed_root;
}

print "<p>$TS::TS_dirmods_skinselected:<ol>";

displayMode($mode, 1, $TS::TS_dirmods_skintextonly);
displayMode($mode, 2, $TS::TS_dirmods_skinpermission);
displayMode($mode, 3, $TS::TS_dirmods_skinalphabetical);

print "</ol></p>";

UI::writeScriptFooter();
