#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use Include;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $name = $cgi->param('name');
my $val = $cgi->param('val');

$cat = Editor::testPrivs($cat);

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode("$TS::TS_eddesc_epc");
Editor::writeECode();

if ($submit ne "") {
	Storage::setData('category', $cat, 'html', $val);
	Storage::logEdit("edit", "page", $cat, $val);

	Generate::updatePublicSide($cat);
	print ("$TS::TS_eddesc_phbm");
} else {
	my $cont = Storage::getData('category', $cat, 'html');

	UI::writeScriptHeader($cat, $TS::TS_eddesc_epc, $TS::TS_eddesc_info);

	UI::writeStartForm($cat);
	UI::writeItemForm($TS::TS_eddesc_content, "<textarea name=\"val\" rows=\"10\" cols=\"70\">$cont</textarea>");
	UI::writeEndForm();
}

UI::writeScriptFooter($cat);
