#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use TS;

my $cgi = new CGI;

my $editor = $cgi->param('editor');

UI::writeHeaderCode($TS::TS_ededitor_title);
Editor::writeECode();

Editor::validateEditor($editor);

if ($isMeta eq "1") {
	print <<END;
<ul>
  <li><a href="./rmcat.cgi?name=$editor">
$TS::TS_ededitor_revoke</a>
  </li>
  <li><a href="./gcat.cgi?editor=$editor">
$TS::TS_ededitor_grant</a>
  </li>
  <li><a href="./warn.cgi?editor=$editor">
$TS::TS_ededitor_warn</a>
  </li>
  <li><a href="./rmuser.cgi?editor=$editor">$TS::TS_ededitor_removeeditor</a>
  </li>
  <li><a href="./reactuser.cgi?editor=$editor">$TS::TS_ededitor_reinstate</a>
  </li>

</ul>
END
}

if ($isRoot eq "1") {
	print <<END;
<ul>
  <li><a href="rnote.cgi?usn=$editor">$TS::TS_ededitor_addnote</a>
  </li>
  <li><a href="grant.cgi?usn=$editor">$TS::TS_ededitor_grantpriv</a>
  </li>
  <li><a href="revoke.cgi?usn=$editor">$TS::TS_ededitor_revokepriv</a>
  </li>
  <li><a href="editarea.cgi?priv=editall&editor=$editor">$TS::TS_ededitor_editeditall</a>
  </li>
  <li><a href="editarea.cgi?priv=meta&editor=$editor">$TS::TS_ededitor_editmeta</a>
  </li>
</ul>
END
}

print "<p><b><a href=\"./logs.cgi?name=$editor&what=4\">$TS::TS_common_back</a></b></p>";

UI::writeScriptFooter();
