#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use CGI;
use File::Copy;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;

my($cgi) = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $lt = localtime;

$cat = Editor::testPrivs($cat);

# Checks to see if an editor is listed in a category.
open(ED, "$path_sitedata/$cat.ed");
$edincat = <ED>;
close(ED);
$EdList = 0;

if ($edincat ne "") {
	$EdList = 1;
} else {
	$EdList = 0;
}

if ($EdList eq "1") {
	UI::showError("", $TS::TS_edelcat_listededitors, "", "");
}

if (!(Common::isCatEmpty($cat))) {
	UI::showError("", "$TS::TS_common_notempty", $cat, "");
}

if ($act eq "$TS::TS_edelcat_delete") {
	move("$path_sitedata/$cat.html", "$path_home/deldata/$cat.html");
	move("$path_sitedata/$cat.ed", "$path_home/deldata/$cat.ed");
   
	move("$path_sitedata/$cat.pricat", "$path_home/deldata/$cat.pricat");
	move("$path_sitedata/$cat.catopt", "$path_home/deldata/$cat.catopt");

	open(EL, "$path_sitedata/cats.lst");
	$lou2 = <EL>;
	$lou2=~s/ $cat; / /g;
	close(EL);	

	open(EL2, ">$path_sitedata/cats.lst");
	print EL2 "$lou2";
	close(EL2);

	$parentCat = $cat;

	if ($parentCat=~/(.*)>(.*?)/) {
		$parentCat = $1;
		Generate::updatePublicSide($parentCat);
	}

	$bckup = $cat;
	$cat = $parentCat;
	#UI::editRedirect();
	$cat = $bckup;

	UI::writeHeaderCode("$TS::TS_edelcat_deletecat");
	Editor::writeECode();

	print "$TS::TS_edelcat_catdeleted <br>";

	open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
	print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## delete #!# ##!## category  #!# ##!!!## $cat - deleted ##!!!!## \n";
	close(TEXTFILE);
} else {
	UI::writeHeaderCode("$TS::TS_edelcat_deletecat");
	Editor::writeECode();

	open(EL, "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm");
	our $dmlst= <EL>;
	close(EL);

	if ($dmlst=~/editall/g) {
		$dmlst = Storage::getData("global", "tlc.lc");
	}

	$sep = "</option><option>";
	$dmlst=~s/; /$sep/g;

	UI::writeScriptHeader($cat, $TS::TS_edelcat_deletecat . " $cat\?", "");
	UI::writeStartForm($cat, "edelcat.cgi");
	UI::writeEndForm("action", $TS::TS_edelcat_delete);
}

$parentCat = $cat;

if ($act eq "$TS::TS_edelcat_delete") {
	if ($parentCat=~/(.*)>(.*?)/) {
		$parentCat = $1;
	}
}

UI::writeScriptFooter($parentCat);
