#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $editor = $cgi->param('editor');
my $do = $cgi->param('do');
my $data = $cgi->param('data');
my $priv = $cgi->param('priv');
my $lt = localtime;

if (!(defined $priv)) {
	$priv = "";
}

if (($priv ne "editall") && ($priv ne "meta")) {
	UI::showError("Edit Access Area", "The specified priv is invalid.");
}

UI::writeHeaderCode("$editor - Edit Access Area");
Editor::writeECode();
Editor::restrictedRoot();

if ($editor ne "") {
	my $file = ($priv eq "editall") ? "dirmod.gf" : "dirman.gf";
	my $users = Storage::getData("global", $file);

	if ($users!~/ $editor /) {
		print "The selected user is not $priv.";
		UI::writeScriptFooter();
		exit(0);
	}
}

#Submit code
if ($do ne "") {
	open(LDATA, ">$path_data/eperm/$priv/$editor.perm");
	print LDATA "$data\n";
	close(LDATA);
}

if ($editor ne "") {
	my $users = Storage::getData("global", "elist");

	if ($users=~/ $editor /) {
		open(CATL, "$path_data/eperm/$priv/$editor.perm");
		my $cat4 = <CATL>;
		close(CATL);

		print <<END;
<form method="post" action="editarea.cgi">
Type $priv for full $priv access or the category name for restricted access.<br>
<input type="text" name="data" value="$cat4" size="40">
<br><p><input type="radio" name="editor" value="$editor" checked>$editor</p>
<input type="submit" value="Update" name="do">
<input type="hidden" name="priv" value="$priv"></form>
END
	} else {
		print "Editor not found.";
	}
} else {
	print <<END;
<b><h1>Edit Access Area</h1><p>Choose an editor:</b><br>
<form method="get" action="editarea.cgi">
<b>Editor:</b>
<br><input type="text" name="editor" value="$editor" size="20">
<input type="submit" value="Ok">
<input type="hidden" name="priv" value="$priv"></form>
END
} 

UI::writeScriptFooter();
