#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Logs;
use Settings;
use Storage;
use TS;
use UI;

my($cgi) = new CGI;

my $cat = $cgi->param('cat');
my $data = $cgi->param('data');
my $spellcheck = $cgi->param('spell');

open(DCATS, "$path_sitedata/cats.lst");
my $ucat = <DCATS>;
close(DCATS);

my $r = Storage::getData("editor", $ENV{REMOTE_USER}, "spell");

if ($r=~/1/) {
	$spellcheck = "1";
}


# Generates the charter
# Params: 1
# Param 1: the category.
# Returns: 1 (always)

sub writeCharter
{
	my ($cat) = @_;
	print <<END;
<table border="1" cellspacing="1" style="border-collapse: collapse" bordercolor="$UI::dark[$UI::currentskin]" width="100%" id="AutoNumber1" bgcolor="$UI::lightest[$UI::currentskin]">
<tr><td>
$bold $TS::TS_common_charter $unBold
</td></tr>
<tr><td>
END

	my $charter = Storage::getData('category', $cat, "charter");
	$charter =~ s/\n/<br>/g;
	$charter = UI::safeHTML($charter);

	print <<END;
$charter
</td></tr></table>
<hr>
END
	return 1;
}


sub listCatWithLinks
{
	my($cat) = @_;

	print "<a href=\"../\">Top</a>";
	my $ct = "";
	my $ct2 = "";
	my $ind = 0;
	my $ct22;

	while (($ct ne $cat) && ($ind < 200)) {
		$ct = $ct . substr($cat, $ind, 1);
		$ct2 = $ct2 . substr($cat, $ind, 1);
		++$ind;
		if ((substr($cat, $ind, 1) eq ">") || (substr($cat, $ind, 1) eq "/")) {
			my $rr = $ct;
			$rr=~s/>/\//g;
			$ct22 = $ct2;
			$ct22=~s/_/ /g;
			print ": <a href=\"../$rr/\">$ct22</a>";
			$ct2 = "";
			$ct = $ct . substr($cat, $ind, 1);
			++$ind;
		}
	}
	$ct=~s/>/\//g;
	$ct22 = $ct2;
	$ct22=~s/_/ /g;
	print ": <a href=\"../$ct/\">$ct22</a>";

	return 1;
}

sub titleAndHTMLEdit
{
	my($cat) = @_;

	my $titled = "";
	if (open(INFILE, "$path_sitedata/items/titles/$cat.tlt")) {
		$titled = <INFILE>;
		close(INFILE);
	}

	$titled = UI::noHTML($titled);

	my $ncat = $cat;
	$ncat=~s/>/\//g;

	print <<END;
<hr>
<p>$bold [<a href="./edtitle.cgi?cat=$ncat">$TS::TS_editcat_edit</a>] - $TS::TS_editcat_title: $titled $unBold
END
	open(CATL, "$path_sitedata/$cat.html");
	my @cat4 = <CATL>;
	close(CATL);
	print "<p><b>[<a href=\"./eddesc.cgi?cat=$ncat\">$TS::TS_editcat_edit</a>] - $TS::TS_editcat_eddesc</b></p>";

	my($spelltext);

	# Spellcheck code
	if ((defined $spellcheck) && ($spellcheck)) {
		my @catcontent = @cat4;
		foreach $spelltext (@catcontent) {
			$spelltext = UI::safeHTML($spelltext);
			print Common::spellCheckLine($spelltext, $ncat) . "<br>";
		}
	} else {
		my $cttl4 = join("<br>", @cat4);
		$cttl4 = UI::safeHTML($cttl4);
		print "$cttl4";
	}
	print "<hr>";

	my $path = Storage::getData('category', $cat, "moz");

	if ($path eq "") {
		$path = 1;
	}


	my @dt = ("");
	if (open(CONF, "$path_data/mozzies")) {
		@dt = <CONF>;
		close(CONF);
	}
	my $dt = join ("", @dt);
	if ($dt=~/>##$path#(.*?)#(.*?)#(.*?)#(.*?)##</) {
		my $URL = $1;
		my $width = $2;
		my $height = $3;
		my $alt = $4;
		print "<img src=\"$path_on_server/img/moz/$URL\" height=\"$height\" width=\"$width\" alt=\"$alt\"><br>";
	}

	print "<p><b><a href=\"editmoz.cgi?cat=$ncat\">$TS::TS_editcat_changefooterimage</a></b><hr>";
	my $cat4 = join("", @cat4);
	print <<END;
<br>
END
};

sub editorMenu
{
	my($cat) = @_;

	my $ty = "";
	if (open(CT, "$path_sitedata/$cat.ct")) {
		$ty = <CT>;
		close(CT);
	}

	if ($ty eq "") {
		$ty = "default";
	}

	my $ncat = $cat;
	$ncat=~s/>/\//g;

	print "<ol><strong>";
	print "<li><form action=\"addsection.cgi\" method=\"get\"><input type=\"hidden\" name=\"cat\" value=\"$cat\"><a href=\"addsection.cgi?cat=$ncat\">$TS::TS_editcat_newsection</a> ";

	open(EL, "$path_data/cattype");
	my $cats= <EL>;
	close(EL);

	print Common::writeTemplateCombo($cat, "type");

	print "<input type=\"submit\" value=\"$TS::TS_common_submit\"></form></li>";

	print "<li><a href=\"addwizard.cgi?cat=$ncat\">$TS::TS_editcat_addwizard</a><br /></li>";
	print "<li><a href=\"cattype.cgi?cat=$ncat\">$TS::TS_editcat_changetemplate</a> ($TS::TS_editcat_currenttype $ty)<br></li>";
	print "<li><a href=\"template.cgi?cat=$ncat\">$TS::TS_editcat_edittemplate</a><br /></li>";
	print "<li><a href=\"charter.cgi?cat=$ncat\">$TS::TS_editcat_charter</a>";
	print "<li><a href=\"subguide.cgi?cat=$ncat\">$TS::TS_editcat_edsub</a>";
	print "<li><a href=\"catlogs.cgi?cat=$ncat\">$TS::TS_editcat_catlogs</a>";
	print "<li><a href=\"enewcat.cgi?tcat=$ncat\">$TS::TS_common_newcat</a><br /></li>";
	print "<li><a href=\"alphabar.cgi?tcat=$ncat\">$TS::TS_editcat_alphabar</a><br /></li>";

	if ($cat=~/>/) {
		#Be sure that top level categories don't have links for catmv and delete

		print "<li><a href=\"edelcat.cgi?cat=$ncat\">$TS::TS_common_delcat</a><br /></li>";
		if (Editor::testCATMVPrivs($cat) == 1) {
			print "<li><a href=\"catmv.cgi?cat=$ncat\">$TS::TS_common_movecat</a><br /></li>";
		}
	}

	if ($allowUnreviewed) {
		my @r = (0, 0);
		if (open(TT, "$path_sitedata/$cat.unreviewed")) {
			@r = <TT>;
			close(TT);
		}
		$r = $r[1];

		if ($r eq "") {
			$r = "0";
		}

		print "<li><a href=\"review.cgi?cat=$ncat\">$TS::TS_editcat_review</a> (<font color=\"green\">$r $TS::TS_common_unreviewed</font>)<br /></li>";
	}
	
	print "<li><a href=\"chcatopt.cgi?cat=$ncat\">$TS::TS_common_catopt</a><br /></li>";
	print "<li><a href=\"pricat.cgi?cat=$ncat\">$TS::TS_editcat_setpriority</a><br /></li>";
	print "<li><a href=\"basedon.cgi?cat=$ncat\">$TS::TS_editcat_basedon</a><br /></li>";
	print "<li><a href=\"../sectionchart.cgi?cat=$ncat\">$TS::TS_editcat_sectionchart</a><br /></li>";
	if ($ncat=~/International\/[^\/]*$/) {
		print "<li><a href=\"translate.cgi?cat=$ncat\">$TS::TS_editcat_editlangstrings</a><br /></li>";
	}
	print "<li>$TS::TS_editcat_publicpage ";

	listCatWithLinks($cat);

	print "<br><br></li></strong></ol>";
	return 1;
}

sub listTables
{
	my($cat) = @_;

	my $nucat = $cat;
	$nucat=~s/>/\//g;

	my $HC = "";

	my $tb = 0;
	if (open(TEMPD, "$path_sitedata/$cat.sections")) {
		$tb = <TEMPD>;
		close(TEMPD);
	}

	if (($tb ne "") && ($tb ne "\n") && ($tb != 0)) {
		print "<p><a href=\"powereditsection.cgi?cat=$nucat\">$TS::TS_editcat_poweredit</a></p>";
	}

	my $ncat = $cat;
	$ncat=~s/>/\//g;

	my(@used, $line);

	for (my $i = 1; $i <= $tb; $i++) {
		$used[$i] = "";
	}
	for (my $i = 1; $i <= $tb; $i++) {
		my @tb = ("", "", "");
		if (open(TEMPD, "$path_sitedata/$cat.sct$i")) {
			@tb = <TEMPD>;
			close(TEMPD);
			$tb[0]=~s/[\n\r]//g;
			$tb[2]=~s/[\n\r]//g;
		}
		if (($tb[0]=~/2.0/) && ($tb[2] ne "")) {
			my $nm = $tb[1];
			my @tmpl = ("2.0");
			if (open(TEMPL, "$path_data/template/$nm")) {
				@tmpl = <TEMPL>;
				close(TEMPL);
			}
			if (($tmpl[0]=~/2.01/) && ($used[$i] eq "")) {
				my $cs = $#tmpl + 1;
				$HC = $HC . "<table width=\"95%\" align=\"center\"><tr bgcolor=\"#e0f0ff\"><td align=\"center\" colspan=\"$cs\"><strong>$nm Overview</strong></td></tr>";
				$HC = $HC . "<tr bgcolor=#e8f8ff><td></td><td><strong>Name</strong></td>";
				for (my $k = 1; $k <= $#tmpl; $k += 2) {
					$HC = $HC . "<td><strong>$tmpl[$k]</strong></td>";
				}
				$HC = $HC . "</tr>";
				$tb[1]=~s/[\n\r]//g;
				for (my $j = 1; $j <= $tb; $j++) {
					if (open(TEMPD, "$path_sitedata/$cat.sct$j")) {
						my @tbx = <TEMPD>;
						close(TEMPD);
						$tbx[1]=~s/[\n\r]//g;
						$tbx[2]=~s/[\n\r]//g;
						if (($tb[1] eq $tbx[1]) && ($used[$j] eq "")) {
							$used[$j] = "1";
							if ($tbx[2] ne "") {
								$HC = $HC . "<tr bgcolor=#f0f0ff><td align=center><strong>[<a href=\"editsection.cgi?cat=$ncat&idtable=$j\">$TS::TS_editcat_edit</a>]</strong></td>";
								for (my $k = 0; $k <= $#tmpl / 2; $k++) {
									my $x = $k + 2;
									$tbx[$x] = Common::sectionLink($cat, $tbx[$x], 0);
									$HC = $HC . "<td>$tbx[$x]</td>";
								}
								$HC = $HC . "</tr>";
							}
						}
					}
				}
				$HC = $HC . "</table>";
			}
		}
	}

	my($k);

	for (my $i = 1; $i <= $tb; $i++) {
		my @tb = ("", "", "");
		if (open(TEMPD, "$path_sitedata/$cat.sct$i")) {
			@tb = <TEMPD>;
			close(TEMPD);
			chomp($tb[0]);
		}

		if (($tb[0]=~/2.0/) && ($used[$i] eq "") && ($tb[2] ne "") && ($tb[2] ne "\n")) {
			my $nm = $tb[1];
			my @tmpl;
			if (open(TEMPL, "$path_data/template/$nm")) {
				@tmpl = <TEMPL>;
				close(TEMPL);
			}

			$HC = $HC . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=\"#aaaaff\"><td><strong><a name=\"#$tb[2]\">$tb[2]</a> - <a href=\"editsection.cgi?cat=$ncat&idtable=$i\">$TS::TS_editcat_editthissection</a></strong></td></tr><tr><td bgcolor=#ddeeff>";
			$k = 2;
			for (my $j = 1; $j <= $#tmpl; $j += 2) {
				$k++;
				$tmpl[$j]=~s/\n//;
				$tmpl[$j]=~s/.$//;

				$tb[$k] = Common::sectionLink($cat, $tb[$k], 0);

				$HC = $HC . "<strong>" . $tmpl[$j] . "</strong>: " . $tb[$k] . "<br>";
			}
			$k++;
			$HC = $HC . "<p>";
			for (my $j = $k; $j <= $#tb; $j++) {
				$tb[$j] = Common::sectionLink($cat, $tb[$j], 0);

				if ((defined $spellcheck) && ($spellcheck)) {
					my @sectcontent = split(/\n/, $tb[$j]);
					foreach $line (@sectcontent) {
						$HC = $HC . Common::spellCheckLine($line, $cat) . "<br>";
					}
				} else {
					$HC = $HC . $tb[$j] . "<br>";
				}
			}
			$HC = $HC . "</p></td></tr></table></p>";
			$HC =~ s/<p><\/p>//g;
		} else {
			if (($used[$i] eq "") && ($tb[0] ne "") && ($tb[0] ne "\n") && (!($tb[0]=~/2.0/))) {
				$HC = $HC . "<p><table width=\"95%\" align=\"center\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\"><tr bgcolor=#aaaaff><td><strong><a name=\"#$tb[0]\">$tb[0]</a> - <a href=\"editsection.cgi?cat=$ncat&idtable=$i\">$TS::TS_editcat_editthissection</a></strong></td></tr><tr><td bgcolor=#ddeeff>";
				for (my $j = 1; $j <= $#tb; $j++) {
					$HC = $HC . $tb[$j] . "<br>";
				}
				$HC = $HC . "</td></tr></table></p>";
			}
		}
	}

	$HC = UI::safeHTML($HC);
	print $HC;

	if (open(TEMPD, "$path_sitedata/$cat.tables")) {
		my $noTables = <TEMPD>;
		close(TEMPD);

		for (my $i = 1; $i <= $noTables; $i++) {
			open(TEMPD, "$path_sitedata/$cat.tbl$i");
			my @tb = <TEMPD>;
			close(TEMPD);
			$tb[0]=~s/[\n\r]//g;
			if ($tb[0] ne "") {
				chomp($tb[0]);
				my $indexL = 3;
				print <<END;
    <p align="center">
      <b>
        $tb[0]: - <a href="edittable.cgi?cat=$cat&idtable=$i">$TS::TS_editcat_edittable $i</a>
      </b>
      <br>
      <table width="100%" border="1" cellspacing="0" cellpadding="0">
END
				for (my $j = 1; $j <= $tb[1]; $j++) {
					print "<tr align=\"center\">";
					for (my $k = 1; $k <= $tb[2]; $k++) {
						my $rr = $tb[$indexL];
						print "<td>$rr</td>";
						$indexL++;
					}
					print "</tr>";
				}
				print "</table></p>";
			}
		}
	}

	return 1;
}

sub listEditors
{
	my $cat = $_[0];
	my @edi = split("\n", Storage::getData("category", $cat, "ed"));

	print <<END;
<p><div align="right">
  <table bgColor="$UI::box[$UI::currentskin]" border="1">
    <tr>
      <td align="middle">$bold $TS::TS_editcat_editors $unBold</td>
    </tr>
    <tr>
      <td>
END
	my $d = 0;
	push(@edi, "");
	push(@edi, "");
	while ($edi[$d] ne "") {
		my $ltime = $TS::TS_editcat_removed;
		my $ed = $edi[$d];
		chomp($ed);

		my $users = Storage::getData("global", "elist");

		if ($users=~/ $ed /) {
			$ltime = "";
			if (open(EL, "$path_data/logs/$ed.ll")) {
				$ltime = <EL>;
				close(EL);
			}
			if ($ltime eq "") {
				$ltime = $TS::TS_editcat_llunknown;
			}

			$ed = "<a href=\"profile.cgi?editor=$ed\">$ed</a>";
		} else {
			if (($showExEditorsPrivate == 2) || (($showExEditorsPrivate == 3) && ($isMeta eq "1"))) {
				$ed = "<a href=\"profile.cgi?editor=$ed\">$ed</a>";
			}
		}
		print "$ed - $ltime<br>";

		$d++;
	}
	print <<END;
</td>
    </tr>
  </table>
</div>
END
	return 1;
}

sub submitAndLogCode
{
	my($cat) = @_;
	my $cgi = new CGI;
	my $do = $cgi->param('do');
	my $dtitle = $cgi->param('stitle');
	my $lt = localtime;

	#Submit code
	if (defined $do) {
		$cat = Editor::testPrivs($cat);

		open(LDATA, ">$path_sitedata/$cat.html");
		print LDATA "$data";
		close(LDATA);

		open(LDATA2, ">$path_sitedata/items/titles/$cat.tlt");
		print LDATA2 "$dtitle";
		close(LDATA2);

		open(EL, "$path_home/edits/edit1");
		my $edits = <EL>;
		close(EL);
		#head loaded
			
		my $totaledits = $edits + 1;
		open(LDATA2, ">$path_home/edits/edit1");
		print LDATA2 "$totaledits+1";
		close(LDATA2);

		open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
		print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## edit #!# ##!## modify #!# ##!!!## $cat - $totaledits ##!!!!## \n";
		close(TEXTFILE);

		open(TEXTFILE, ">$path_home/edits/$totaledits.log");
		print TEXTFILE "$ENV{REMOTE_USER}\n";
		print TEXTFILE "$ENV{REMOTE_ADDR}\n";
		print TEXTFILE "$lt\n";
		print TEXTFILE "$cat\n";
		print TEXTFILE "$dtitle\n";
		print TEXTFILE "$data";
		close(TEXTFILE);
		#end log code
	}
}

sub noPrivsOrWrongCat
{
	print "<br><b>$TS::TS_editcat_youcaneditin<br></b>\n";
	open(EL, "$path_data/eperm/$ENV{REMOTE_USER}.perm");
	my $ucat= <EL>;
	close(EL);
	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);
	print "<ul>";
	my $uct = " ";
	my $uct2 = "";
	my $ind = 1;
	my $subcats = 0;

	while ($uct ne $ucat) {
		$uct = $uct . substr($ucat, $ind, 1);
		$uct2 = $uct2 . substr($ucat, $ind, 1);
		if ($uct2 eq " ")
		{
			$uct2 = "";
		}
		++$ind;
		if (substr($ucat, $ind, 1) eq ";")
		{
			print "<li><a href=\"./editcat.cgi?cat=$uct2\">$uct2</a><br>";
			$uct2 = "";
			$uct = $uct . substr($ucat, $ind, 1);
			++$ind;
		}
	}
	print "</ul>";

	print <<END;
<br>
<a href="./allcats.cgi">$TS::TS_common_allcats</a><br>\n
<hr width=\"100%\">
<b>$TS::TS_editcat_chooseacategory</b><br>
<form method="get" action="editcat.cgi">
</b>$TS::TS_editcat_category</b>
<br><input type="text" name="cat" value="$cat" size="40">
<input type="submit" value="$TS::TS_editcat_ok">
END
}

sub headerAndSubcats
{
	my($cat) = @_;
	my $HC;

	my $p;
	my $x;

	my @ttt = ("");
	if (open(TT, "$path_sitedata/$cat.reviewed")) {
		@ttt = <TT>;
		close(TT);
	}

	my $rd = $ttt[0];
	$rd=~s/[\n\r]//g;

	if ($rd eq "") {
		$rd = 0;
	}

	@ttt = ("");
	if (open(TT, "$path_sitedata/$cat.unreviewed")) {
		@ttt = <TT>;
		close(TT);
	}

	my $re = $ttt[0];
	$re=~s/[\n\r]//g;

	if ($re eq "") {
		$re = 0;
	}

	writeCharter($cat);

	print "<big><a href=\"index.cgi\"><strong>$TS::TS_editcat_editormain</a>";
	my $ct = "";
	my $ct2 = "";
	my $ind = 0;
	while (($ct ne $cat) && ($ind < 200)) {
		$ct = $ct . substr($cat, $ind, 1);
		$ct2 = $ct2 . substr($cat, $ind, 1);
		++$ind;
		if ((substr($cat, $ind, 1) eq ">") || (substr($cat, $ind, 1) eq "/")) {
			my $tmpstrct = $ct;
			$tmpstrct=~s/>/\//g;
			my $ct22 = $ct2;
			$ct22=~s/_/ /g;
			print ": <a href=\"./editcat.cgi?cat=$tmpstrct\">$ct22</a>";
			$ct2 = "";
			$ct = $ct . substr($cat, $ind, 1);
			++$ind;
		}
	}
	my $ct22 = $ct2;
	$ct22=~s/_/ /g;
	print ": $ct22 ($rd";
	if ($allowUnreviewed) {
		print ", <font color=\"green\">$re</font>";
	}
	print ")</strong></big><br><br>";
	
	my $leng = $ind;

	my $alpha = "0";
	while ($ucat =~/ $cat>.;/g) {
		$alpha++;
	}

	my $rr = $cat;
	$rr =~s/>/\//g;

	my($subc_list);

	if ($alpha >= 5) {
		$HC = $HC . "<center>[ <b>";
		$subc_list = "";
		while ($ucat =~/ $cat>(.);/g)
		{
			if ($subc_list ne "")
			{
				$subc_list = $subc_list . ";";
			}
			$subc_list = $subc_list . "<a href=\"editcat.cgi?cat=$rr/$1\">$1</a>";
		}
		my @tempstor = split(";", $subc_list);
		@tempstor = sort @tempstor;
		$subc_list = join(";", @tempstor);
		$subc_list=~s/;/ | /g;
		$HC = $HC . "$subc_list </b>]</center><hr>";
	}

	my $subcats = 0;
	my @datas;

	if ($alpha >= 5) {
		while ($ucat=~/ $cat>(.[^;>]+);/g) {
			my $namesubcat = $1;
			my $uct2 = $1;
			my $backt = $1;
			my $tmp = $1;
			my $uct = $cat;
			$uct=~s/>/\//g;
			$uct2=~s/_/ /g;
			$uct2=~s/>/: /g;
			$backt=~s/>/\//g;
			
			my @ttt = ("");
			if (open(TT, "$path_sitedata/$cat>$tmp.reviewed")) {
				@ttt = <TT>;
				close(TT);
			}

			my $rd = $ttt[0];
			$rd=~s/[\n\r]//g;

			if ($rd eq "") {
				$rd = 0;
			}

			@ttt = ("");
			if (open(TT, "$path_sitedata/$cat>$tmp.unreviewed")) {
				@ttt = <TT>;
				close(TT);
			}

			my $re = $ttt[0];
			$re=~s/[\n\r]//g;

			if ($re eq "") {
				$re = 0;
			}

			$re = ", <font color=\"green\">$re</font>";
			if (!$allowUnreviewed) {
				$re = "";
			}

			$datas[$subcats] = "<li><strong><a href=\"editcat.cgi?cat=$uct/$backt\">$uct2</a> ($rd$re)</strong><br>";
			$subcats++;
		}
	} else {
		while ($ucat=~/ $cat>([^;>]+);/g) {
			my $namesubcat = $1;
			my $uct2 = $1;
			my $backt = $1;
			my $tmp = $1;
			my $uct = $cat;
			$uct=~s/>/\//g;
			$uct2=~s/_/ /g;
			$uct2=~s/>/: /g;
			$backt=~s/>/\//g;

			my @ttt = (0);
			if (open(TT, "$path_sitedata/$cat>$tmp.reviewed")) {
				@ttt = <TT>;
				close(TT);
			}

			my $rd = $ttt[0];
			$rd=~s/[\n\r]//g;

			if ($rd eq "") {
				$rd = 0;
			}

			@ttt = (0);
			if (open(TT, "$path_sitedata/$cat>$tmp.unreviewed")) {
				@ttt = <TT>;
				close(TT);
			}

			my $re = $ttt[0];
			$re=~s/[\n\r]//g;

			if ($re eq "") {
				$re = 0;
			}

			$re = ", <font color=\"green\">$re</font>";
			if (!$allowUnreviewed) {
				$re = "";
			}

			$datas[$subcats] = "<li><strong><a href=\"editcat.cgi?cat=$uct/$backt\">$uct2</a> ($rd$re)</strong><br>";
			$subcats++;
		}
	}

	my($line, $heylook, $didheylook);
	$didheylook = "";

	if (open(LINKS, "$path_sitedata/$cat.symlinks")) {
		while (<LINKS>) {
			$line = $_;
			chomp($line);
			my ($linktitle, $linkcat) = split(/:/, $line);
			$linkcat=~s/\//>/g;
			$linkcat=~s/\s+$//g;
			$linkcat=~s/>$//;

			# If the link is not valid, mark it using $heylook
			#  and explain the marker in $didheylook

			if (index($ucat, " $linkcat; ") >= 0) { #*
			      $heylook = "";
			} else {
			      $heylook = "<font color=\"red\">!--&gt;</font>";
			      $didheylook = "<font color=\"red\"><strong>!--&gt;</font> $TS::TS_editcat_heylook</strong>";
			}

			my $linktitledisp = $linktitle;
			$linktitledisp=~s/_/ /g;
			my $tempvar = $linkcat;
			$tempvar=~s/>/\//g;

			my @tttl = (0);
			if (open(TTL, "$path_sitedata/$linkcat.unreviewed")) {
				@tttl = <TTL>;
				close(TTL);
			}

			my $rl = $tttl[0];
			$rl=~s/[\n\r]//g;

			if ($rl eq "") {
				$rl = 0;
			}

			open(TTL, "$path_sitedata/$linkcat.reviewed");
			@tttl = <TTL>;
			close(TTL);

			my $rdl = $tttl[0];
			$rdl=~s/[\n\r]//g;

			if ($rdl eq "") {
				$rdl = 0;
			}

			$tempvar = UI::noHTML($tempvar);
			$linktitledisp = UI::noHTML($linktitledisp);

			# $heylook was added before the link here. If the cat link to doesn't exist
			# the $heylook variable will contain a group of symbols to call attention to it.
			# If the cat exists, $heylook will be blank.

			$datas[$subcats] = "<li><strong>$heylook<a href=\"editcat.cgi?cat=$tempvar\">$linktitledisp</a></strong>\@ <b>($rdl, <font color=green>$rl</font>)</b> <small>[<a href=\"delsymlink.cgi?cat=$cat&link=$linktitle\">$TS::TS_editcat_deletelink</a>]</small>";
			$subcats++;
		}
		close(LINKS);
	}

	my $pricat = "";
	if (open(LINKS, "$path_sitedata/$cat.pricat")) {
		my @pricat = <LINKS>;
		close(LINKS);
		$pricat = join("", @pricat);
	}
	$pricat=~s/ /_/g;
	$pricat = " " . $pricat;

	my $bckupxxx = $subcats;
	my $namecat;
	my $tempx;
	my $notFound;

	for (my $prior = 2; $prior >= 0; $prior--) {
		my @subcat_list = ();
		$subcats = $bckupxxx;
		for (my $i = 0; $i < $subcats; $i++) {
			$tempx = $datas[$i];
			if ($tempx=~/<a href=\".*?\">(.*?)<\/a>/) {
				$namecat = $1;
			}

			$namecat=~s/ /_/g;

			if ($pricat=~/\s$namecat.;/) {
				$notFound = "0";
			} else {
				$notFound = "1";
			}

			if (($pricat=~/\s$namecat$prior;/) || (($prior eq "0") && ($notFound eq "1"))) {
				push(@subcat_list, $datas[$i]);
			}
		}

		my($c, $d);

		@subcat_list = sort {
			($c) = $a=~/<a href=\".*?\">(.*?)<\/a>/;
			($d) = $b=~/<a href=\".*?\">(.*?)<\/a>/;
			$c cmp $d;
		} (@subcat_list);

		$subcats = $#subcat_list;
		$subcats++;

		if ($subcats >= 1) {
			$HC = $HC . "<table align=\"center\" width=\"100%\"><tr>";
			if ($subcats < 6) {
				$HC = $HC . "<td valign=\"top\" width=\"100%\"><ul>";
				for (my $i = 0; $i < $subcats; $i++) {
					$HC = $HC . "$subcat_list[$i]\n";
				}
				$HC = $HC . "</ul></td>";
			} else {
				$HC = $HC . "<td valign=\"top\" width=\"50%\"><ul>";
				$x = $subcats / 2;
				$p = 0;
				while ($x >= 1)	{
					$p++;
					$x--;
				}

				if ($x eq "0.5") {
					$p++;
				}

				for (my $i = 0; $i < $p; $i++) {
					$HC = $HC . "$subcat_list[$i]\n";
				}
				$HC = $HC . "</ul></td><td valign=\"top\" width=\"50%\"><ul>";
				for (my $i = $p; $i < $subcats; $i++) {
					$HC = $HC . "$subcat_list[$i]\n";
				}
				$HC = $HC . "</ul></td>";
			}
			$HC = $HC . "</tr></table><hr>";
		}
	}

	# Added $didheylook, which will contain explain the $heylook symbols if they were
        # used. If there was no broken links, this will be blank.
	$HC = $HC . "$didheylook<br>";

	print $HC;

	$HC = "";

	my $ncat = $cat;
	$ncat=~s/>/\//g;

	print "<p>$bold<a href=\"mksymlink.cgi?cat=$ncat\">$TS::TS_editcat_addnewlink</a>$unBold";
}

sub sectionlinks
{
	my($cat) = @_;

	my($line, $heylook, $didheylook, $checkcat, $cattext, $display, $linktext);
	my($linkall, $linktemplate);
	my($didlinkall) = "";
	my($didlinktemplate) = "";

	$didheylook = "";

	my $ncat = $cat;
	$ncat=~s/>/\//g;
	print "<p><strong><a href=\"mksectionlink.cgi?cat=$ncat\">$TS::TS_editcat_addsectionlink</a></strong>";

	my @slinks = ();
	if (open(LINKS, "$path_sitedata/$cat.scl")) {
		@slinks = <LINKS>;
		close(LINKS);
		chomp(@slinks);
	}
	for (my $i = 0; $i <= $#slinks; $i++) {
		($cattext, $checkcat, $linkall, $linktemplate ) = split(/:/, $slinks[$i]);

		if ( $linkall eq "on" ) {
			$linkall = "(A)";
			$didlinkall = "(A) $TS::TS_editcat_linksall<br>";
		} else {
			$linkall = "";
		}
		if ( $linktemplate eq "on" ) {
			$linktemplate = "(T)";
			$didlinktemplate = "(T) $TS::TS_editcat_linkstemplate<br>";
		} else {
			$linktemplate = "";
		}

		$display = $checkcat;
		$checkcat=~s/\//>/g;
		$checkcat=~s/\s+$//g;
		$checkcat=~s/>$//;
		if (index($ucat, " $checkcat; ") >= 0) {
			$heylook = "";
		} else {
			$heylook = "<font color=\"red\">!--&gt;</font>";
			$didheylook = "<font color=\"red\"><strong>!--&gt;</font> $TS::TS_editcat_heylook</strong>";
		}

		$linktext = $cattext;
		$cattext =~ s/_/ /g;
		$cattext = UI::noHTML($cattext);
		print <<END;
<li>
  <strong>$heylook$cattext: <a href="editcat.cgi?cat=$display">$display</a> $linkall $linktemplate</strong>
  <small>[<a href="delsectionlink.cgi?cat=$cat&link=$linktext">$TS::TS_editcat_deletelink</a>]</small>
</li><br>
END
	}
	print "$didlinkall$didlinktemplate$didheylook</p>";
}

sub related
{
	my($cat) = @_;

	my($line, $heylook, $didheylook, $checkcat);
	$didheylook = "";
  
	my $ncat = $cat;
	$ncat=~s/>/\//g;
	print "<p><strong><a href=\"related.cgi?cat=$ncat\">$TS::TS_editcat_related</a></strong>";
	if (open(REL, "$path_sitedata/$cat.rel")) {
		my @rel = <REL>;
		close(REL);
		for (my $i = "0"; $i <= $#rel; $i++) {
			$checkcat = $rel[$i];
			$checkcat=~s/\//>/g;
			$checkcat=~s/\s+$//g;
			$checkcat=~s/>$//;
			if (index($ucat, " $checkcat; ") >= 0) {
				$heylook = "";
			} else {
				$heylook = "<font color=\"red\">!--&gt;</font>";
				$didheylook = "<font color=\"red\"><strong>!--&gt;</font> $TS::TS_editcat_heylook</strong>";
			}

			my $display = $rel[$i];
			$display=~s/>/\//g;
			print "<li>$TS::TS_editcat_opensitecategory <strong>$heylook<a href=\"editcat.cgi?cat=$display\">$display</a></strong></li><br>";
		}
	}
	print "$didheylook</p>";
}

sub altlang
{
	my($cat) = @_;

	my $ncat = $cat;
	$ncat=~s/>/\//g;
	print "<p><strong><a href=\"altlang.cgi?cat=$ncat\">$TS::TS_editcat_editaltlangs</a></strong>";

	my $HC = "";
	
	my @tem = ("");
	if (open(TEMPD, "$path_sitedata/$cat.altlangs")) {
		@tem = <TEMPD>;
		close(TEMPD);
	}

	my($heylook, $didheylook);
	$didheylook = "";

	if ($tem[0] ne "") {
		my $f = "0";
		for (my $i = "0"; $i <= $#tem; $i++) {
			my $checkcat = $tem[$i];
			$checkcat=~s/\//>/g;
			$checkcat=~s/\s+$//g;
			$checkcat=~s/>$//;
			if (index($ucat, " $checkcat; ") >= 0) {
				$heylook = "";
			} else {
				$heylook = "<font color=\"red\">!--&gt;</font>";
				$didheylook = "<p><font color=\"red\"><strong>!--&gt;</font> $TS::TS_editcat_heylook</strong>";
			}

			if ($f eq "0") {
				$HC = $HC . "<br>&nbsp; &nbsp; &nbsp; ";
			} else {
				$HC = $HC . "&nbsp; &nbsp; &nbsp; ";
			}
			my $lang = "English";
			$tem[$i]=~s/>/\//g;
			if (($tem[$i]=~/\/$/) || ($tem[$i]=~/\/\s/)) {
			} else {
				$tem[$i] = $tem[$i] . "/";
			}
			if ($tem[$i]=~/International\/([^\>\/]*)/) {
				$lang = $1;
			}
			$HC = $HC . "$heylook<a href=\"$path_on_server/$tem[$i]\">$lang</a>";
			$f++;
			if ($f eq "3") {
				$f = "0";
			}
		}
	}
	print "$HC$didheylook</p>";
}

$cat = Editor::testPrivs($cat);

UI::writeHeaderCode();
Editor::writeECode();

editorMenu($cat);
print "<hr>";
headerAndSubcats($cat);
submitAndLogCode($cat);
sectionlinks($cat);
related($cat);
altlang($cat);
titleAndHTMLEdit($cat);
listTables($cat);
listEditors($cat);

UI::writeFooterCode();
