#!/usr/bin/perl

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

UI::writeHeaderCode();
Editor::writeECode();
Editor::restrictedRoot();

my @forumDef = split("\n", Storage::getData("global", "forums"));

my $id = $cgi->param('id');

if ($id ne "") {
	my $new = $cgi->param('new');
	my $delete = $cgi->param('delete');
	my $editgroup = $cgi->param('editgroup');
	my $name = $cgi->param('name');
	my $url = $cgi->param('url');
	my $access = $cgi->param('access');
	my $action = $cgi->param('action');

	if ($new ne "") {
		Storage::setData("global", "forums", Storage::getData(
			"global", "forums") . "$id $new\n");
	}
	if ($delete ne "") {
		my $content = "";
		for (my $d = 0; $d <= $#forumDef; $d++) {
			if (!($forumDef[$d] =~ /^$id $delete$/)) {
				$content .= $forumDef[$d] . "\n";
			}
		}
		Storage::setData("global", "forums", $content);
	}
	if ($editgroup ne "") {
		my $line = "$name $url $access\n";
		if ($action eq "delete") {
			$line = "";
			$forumDef[0]--;
		}
		my $content = "";
		for (my $d = 0; $d <= $#forumDef; $d++) {
			if ($d != $id) {
				$content .= $forumDef[$d] . "\n";
			} else {
				$content .= $line;
			}
		}
		Storage::setData("global", "forums", $content);
	}
	if ($action eq "delete") {
		print "$TS::TS_editforum_deleted";
		print "<p><a href=\"editforum.cgi\">$TS::TS_editforum_back</a></p>";
		UI::writeScriptFooter();
		exit();
	}

	@forumDef = split("\n", Storage::getData("global", "forums"));
	$forumDef[$id] =~ /^([^ ]*) ([^ ]*) (.*)$/;
	print <<END;
<p>$TS::TS_editforum_properties</p>
<form action="editforum.cgi" method="post">
<input type="hidden" name="editgroup" value="1">
<input type="hidden" name="id" value="$id">
<table>
<tr bgcolor="#e0e0e0"><th>Field</th><th>Value</th></tr>
<tr bgcolor="#f0f0f0"><td>$TS::TS_common_title:</td><td><input type="text" name="name" value="$1" size="40"></td></tr>
<tr bgcolor="#f0f0f0"><td>URL:</td><td><input type="text" name="url" value="$2" size="40"></td></tr>
<tr bgcolor="#f0f0f0"><td>Access:</td><td>$3<input type="hidden" name="access" value="$3"></td></tr>
<tr bgcolor="#f0f0f0"><td>$TS::TS_common_action:</td>
<td><input type="radio" name="action" value="update" checked>$TS::TS_common_update
<input type="radio" name="action" value="delete">$TS::TS_common_delete</td></tr>
<tr bgcolor="#f0f0f0"><td colspan="2" align="center">
<input type="submit" name="submit" value="$TS::TS_common_submit"></td></tr>
</table></form></p>

<p>$TS::TS_editforum_components</p>
<form action="editforum.cgi" method="post">
<input type="hidden" name="id" value="$id">
<table>
<tr bgcolor="#e0e0e0"><th>$TS::TS_common_title</th><th>$TS::TS_common_action</th></tr>
END
	for (my $d = $forumDef[0] + 1; $d <= $#forumDef; $d++) {
		$forumDef[$d] =~ /^([^ ]*) (.*)$/;
		if ($1 == $id) {
			print <<END;
<tr bgcolor="#f0f0f0"><td>$2</td>
<td>[ <a href="editforum.cgi?id=$id&delete=$2">$TS::TS_common_delete</a> ]</td></tr>
END
		}
	}
	print <<END;
<tr bgcolor="#f0f0f0"><td><input type="text" name="new"></td>
<td><input type="submit" name="submit" value="$TS::TS_common_create"></td></tr>
</table>
<p><a href="editforum.cgi">$TS::TS_editforum_back</a></p>
END
} else {
	my $name = $cgi->param('name');
	my $url = $cgi->param('url');
	my $access = $cgi->param('access');
	my $line;

	if ($name ne "") {
		$line = "$name $url $access\n";
		my $newDef = ++$forumDef[0] . "\n";
		for (my $d = 1; $d < $forumDef[0]; $d++) {
			$newDef .= $forumDef[$d] . "\n";
		}
		$newDef .= $line;
		for (my $d = $forumDef[0]; $d <= $#forumDef; $d++) {
			$newDef .= $forumDef[$d] . "\n";
		}
		Storage::setData("global", "forums", $newDef);
		@forumDef = split("\n", Storage::getData("global", "forums"));
	}

	print "<p>$TS::TS_editforum_following</p>";

	print <<END;
<form action="editforum.cgi" method="post">
<table><tr bgcolor="#e0e0e0"><th>$TS::TS_common_action</th>
<th>$TS::TS_common_title</th><th>URL</th><th>Access</th></tr>
END

	for (my $d = 1; $d <= $forumDef[0]; $d++) {
		$forumDef[$d] =~ /^([^ ]*) ([^ ]*) (.*)$/;

		print <<END;
<tr bgcolor="#f0f0f0"><td>
[<a href="editforum.cgi?id=$d"><strong>$TS::TS_common_view</strong></a>]<td>$1</td><td>$2</td><td>$3</td></tr>
END
	}

	print <<END;
<tr><td><input type="submit" name="add" value="$TS::TS_common_create"></td><td>
<input type="text" name="name" value=""></td>
<td><input type="text" name="url" value=""></td>
<td><select name="access">
<option>isEditor</option>
<option>isEditall</option>
<option>isCatmod</option>
<option>isMeta</option>
<option>isRoot</option>
</td></tr></table>
</form>
END
}

UI::writeScriptFooter();
