#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $moz = $cgi->param('moz');

$cat = Editor::testPrivs($cat);

if ($submit ne "") {
	Storage::setData('category', $cat, 'moz', $moz);
	Storage::logEdit("edit", "footer image", $cat, $moz);
	Generate::updatePublicSide($cat);

	UI::editRedirect();
	UI::writeHeaderCode($TS::TS_editmoz_title);
	Editor::writeECode();
	print $TS::TS_common_changesdone;
} else {
	UI::writeHeaderCode($TS::TS_editmoz_title);
	Editor::writeECode();

	my $val = Storage::getData('category', $cat, 'moz');

	UI::writeScriptHeader($cat, $TS::TS_editmoz_title, $TS::TS_editmoz_info);

	print ("<p><form method=\"post\">");

	open(CONF, "$path_data/mozzies");
	my @cf = <CONF>;
	close(CONF);
	print "<table border=\"1\" align=\"center\" width=\"80%\"><tr>";
	my $d = "0";
	my($id, $URL, $width, $height, $alt);
	for (my $i = "0"; $i <= $#cf; $i++) {
		if ($cf[$i]=~/>##(.*)#(.*?)#(.*?)#(.*?)#(.*?)##</) {
			$id = $1;
			$URL = $2;
			$width = $3;
			$height = $4;
			$alt = $5;
		}
      
		print <<END;
<td><center><img src="$path_on_server/img/moz/$URL" width="$width" height="$height" alt="[$alt]"><br>$bold $alt $unBold<br><input type="radio" valign = "bottom" name="moz" value="$id"></center></td>
END
		$d++;
		if (($d eq "3") && ($i < $#cf)) {
			$d = "0";
			print "</tr><tr>";
		}
	}

	print <<END;
  <tr>
    <td>$bold<center><input type="radio" valign="bottom" name="moz" value="none"> $TS::TS_editmoz_none</center>$unBold</td>
  </tr>
</table>
<input type="hidden" value="$cat" name="cat"><input type="submit" name="submit" value="$TS::TS_common_submit">
</form>
END
}

UI::writeScriptFooter($cat);
