#!/usr/bin/perl -w
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $clicked = $cgi->param('clicked');

UI::writeHeaderCode("Edit Params");
Editor::writeECode();
Editor::restrictedRoot();

UI::writeScriptHeader("", "Edit Parameters", "This page allows the modification of parameters for this code installation.");

if (defined($clicked)) {
	my $location = $path_code . "/Settings.txt";
	open(FIL, ">$location");
	foreach my $item (@param_list) {
		my $name = $item->{'name'};
		if ($cgi->param("radio$name") eq "custom") {
			print FIL "$name = \"" . $cgi->param("value$name") . "\";\n";
		}
	}
	close(FIL);
	print "<p>Changes done.</p>";
	UI::writeScriptFooter();
	exit();
}

sub getValue {
	my $param = $_[0];
	my $location = $path_code . "/Settings.txt";

	if (-f $location) {
		open(FIL, $location);
		my @content = <FIL>;
		close(FIL);
		my $content = join("\n", @content);
		$content=~s/\r+//g;
		$content= "\n" . $content . "\n";
		$content=~s/\n+/\n/g;
		if ($content=~/\n$param = \"([^\"]*)\";\n/) {
			return $1;
		}
	}

	return "-1";
}

print <<END;
<form method="post" action="editparams.cgi">
  <table width="100%" cellspacing="2" cellpadding="3">
END
	
my $color = "#ffeeff";
foreach my $item (@param_list) {
	my $name = $item->{'name'};
	my $default = $item->{'default'};
	my $type = $item->{'type'};
	my $value = getValue($item->{'name'});
	
	my $checked_default = "";
	my $checked_custom = "";
	my $customField;
	
	if ($value eq "-1") {
		$value = "";
		$checked_default = "checked";
	} else {
		$checked_custom = "checked";
	}
	
	$color = ($color eq '#ddeeff') ? '#eef0ff' : '#ddeeff';
	
	if ($type eq "t") {
		$customField = "<input name=\"value$name\" type=\"text\" value=\"$value\" size=\"40\">";
	} elsif ($type eq "b") {
		if ($default == 0) {
			$customField = "<input name=\"value$name\" type=\"hidden\" value=\"1\">Yes";
		} else {
			$customField = "<input name=\"value$name\" type=\"hidden\" value=\"0\">No";
		}
	}
	if ($type eq "b") {
		$default = ($default == "1") ? "Yes" : "No";
	}

	print <<END;
    <tr bgcolor="$color">
      <td rowspan="2" width="1%">
        <strong>$name</strong>
      </td>
      <td>
        <input type="radio" name="radio$name" value="default" $checked_default>
        default: <u>$default</u>
      </td>
    </tr>
    <tr bgcolor="$color">
      <td>
        <input type="radio" name="radio$name" value="custom" $checked_custom>
        custom: $customField
      </td>
    </tr>
END
}

print <<END;
    <tr align="center">
      <td colspan="2">
        <input type="submit" value="$TS::TS_common_submit">
      </td>
    </tr>
  </table>
  <input type=\"hidden\" name=\"clicked\" value=\"1\">
</form>
END

UI::writeScriptFooter(); 
