#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $last = $cgi->param('last');
my $command = $cgi->param('command');
my $reset = $cgi->param('reset');

UI::writeHeaderCode($TS::TS_editrootlog_title);

my($qcmd, $rlog, @rlog2, $editor, $action, $what, $cat, $edit, $time, $ncat);

if ( ($command ne "") || ($reset ne "") ) {
	# This meta only routine will reset the edit log to the number entered.
	Editor::restrictedMeta();
	my $edits = 0;
	if (open(EL, "$path_home/edits/edit1")) {
		$edits = <EL>;
		close(EL);
		$edits=~s/[\n\r]//g;
	} else {
		# This needs to be translated
		print "Could not open edit file to read last edit ID.<br>";
		UI::writeScriptFooter();
		exit;
	}
	
	if ($reset eq "")	{
		# This needs to be translated 
		print <<END;
		Currently the value of the last edit file is $edits<br>
		To set this to a different value, enter the value here. Be sure the 
		value is greater than the value of the last edit in the log, or past
		edits will be overwritten.
END
		UI::writeStartForm("", "editrootlog.cgi");
	  UI::writeInputItemForm("Reset value", "text", "reset");
	  UI::writeEndForm();
		UI::writeScriptFooter();
		exit;
	} else {
		open(EL, ">$path_home/edits/edit1");
		print EL "$reset";
		close(EL);
		print "The last edit ID value has been reset.";
		UI::writeScriptFooter();
		exit;
	}
}
	
if ($qcmd ne "") {
	print "<br><H2><b>$TS::TS_editrootlog_title<br></H2></b>\n";
	#Request Log
	print <<END;
Log cleared.<br>
END
} else {
	if ($last eq "") {
		$last = 100;
	}

	print "<br><h2><b>$TS::TS_editrootlog_title ($TS::TS_editrootlog_last $last)<br></h2></b>\n";

	UI::writeStartForm("", "editrootlog.cgi");
	UI::writeInputItemForm($TS::TS_editrootlog_last, "text", "last");
	UI::writeEndForm();

	my @rlog;
	open(INFILE, "$path_data/logs/rootlog/comeditlog.log");
	while (<INFILE>) {
		push @rlog, $_;
		if ($#rlog == $last) {
			shift @rlog;
		}
	}
	close(INFILE);
	
	$rlog = join("", @rlog);

	print "<table><tr bgcolor=\"#eeeeee\"><td>Editor</td><td>Time</td><td>Category</td><td>Action</td><td>Object</td><td>Details</td></tr>";

	@rlog2 = split("\n", $rlog);
	for (my $d = 0; $d <= $#rlog2; $d++) {
		$rlog = $rlog2[$d];
		if ($rlog=~/##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# {1,}##!## (.*?) {1,}#!# ##!!!## (.*?) (.*?) ##!!!!##/) {
			$editor = $1;
			$time = $2;
			$action = $3;
			$what = $4;
			$cat = $5;
			$edit = $6;
                        if ($cat eq "Uploaded") {
                                $cat = "img/$editor/$edit";
                        }
		
			#workaround for buggy previous logging, don't remove it without fixing the log entries
			if ($cat=~/^'(.*)'$/) {
				$cat = $1;
			}

			$ncat = UI::getNiceFormat($cat);
			$cat=~s/>/\//g;
			$edit =~s/ - //g;
			$edit =~s/- //g;
			$edit =~s/unreviewed//g;
			if ($edit=~/^[0-9]*$/) {
				$edit = "<a href=\"viewedit.cgi?num=$edit\">[view]</a>";
			}

			print "<tr bgcolor=\"#f8f8f8\"><td><a href=\"/editors/profile.cgi?editor=$editor\">$editor</a></td><td>$time</td><td><a href=\"/$cat\">$ncat</a></td><td>$action</td><td>$what</td><td>$edit</td></tr>";
		}
	}

	print "</table>";

	print <<END;
<br></form>
END
}

UI::writeScriptFooter();
