#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $idtable = $cgi->param('idtable');
my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $name = $cgi->param('name');
my $val = $cgi->param('val');
my $type = $cgi->param('type');
my $omit = $cgi->param('omit');
my $movetocat = $cgi->param('movetocat');

my($ad, $users, @tmpl, $cntl, $i, $x, $y, @cont, $ncat, $j, $xx, $k, $t, $mt, $privs, $action, $annotate, $fromplace, $toplace);

$type=~s/\n//g;
$type=~s/\r//g;

$cat = Editor::testPrivs($cat);

if ( !$movetocat ){ 
       $movetocat = $cat 
} else {
       $movetocat = Editor::validateCat($movetocat);
}

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_editsection_title);
Editor::writeECode();

if ($cgi->param('unreviewed') eq "1") {
	$ad = "u";
} else {
	$ad = "";
}

$users = Storage::getData('category', $cat, "$ad" . "sections");

if (($idtable < "1") || ($idtable > $users)) {
	print "$TS::TS_editsection_invalid";
} else {
	UI::writeScriptHeader($cat, $TS::TS_editsection_title, $TS::TS_editsection_editno . " $idtable");

	print ("<p>");

	if ($submit ne "") {
		if ($omit eq "yes") {
			open(TABLE, "$path_sitedata/$cat.$ad" . "sct$idtable");
			my @cntl = <TABLE>;
			close(TABLE);
			$cntl = join("", @cntl);

			Common::deleteSection($cat, $ad, $idtable);
			my $place = "reviewed";
			if ($ad eq "u") {
				Storage::logEdit("delete", "section", "$cat - unreviewed", $cntl);
				$place = "unreviewed";
			} else {
				Storage::logEdit("delete", "section", $cat, $cntl);
			}

			Common::updateCounter($cat, $place, -1);
		} else {
			open(TEMPL, "$path_data/template/$type");
			@tmpl = <TEMPL>;
			close(TEMPL);

			$cntl = "2.0\n";
			$cntl .= $type . "\n";
			$cntl .= $name . "\n";

			for ($i = "1"; $i <= ($#tmpl / 2); $i++) {
				$y = "p" . $i;
				$x = $cgi->param($y);
				chomp($x);
				$cntl = $cntl . "$x\n";
			}

			$cntl = $cntl . $val;

			if (!(Common::isSectionEmpty(split("\n", $cntl)))) {
				open(TABLE, ">$path_sitedata/$cat.$ad" . "sct$idtable");
				print TABLE $cntl;
				close(TABLE);

			# Test for change of published status, and category.
		        $privs = Editor::hasPrivs($movetocat);
		        $mt = $ad;
		        $action = "edit";
		        
		        if ( $omit eq "swap" ) {
		          if ( $ad eq "u" ) {
		            $mt = "";
		            $action = "publish";
		          } else {
		            $mt = "u";
		            $action = "unreview";
		          }
		        }
        
		        if ( $movetocat ne $cat ) {
		          if ( !$privs ) {
		            $mt = "u";
		          }
          
		          if ( $mt eq "u" ) {
		            $action = "move/unreview";
		          } else {
		            if ( $ad eq "u" ) {
		              $action = "move/publish";
		            } else {
		              $action = "move";
		            }
 		         }
          
		          if ( $ad eq "u" ) { $fromplace = "unreviewed" } else {$fromplace = "reviewed" }
		          if ( $mt eq "u" ) { $toplace = "unreviewed" } else { $toplace = "reviewed" }
		          $annotate = "Moved from $cat - $fromplace to $movetocat - $toplace<hr>";
		          $cntl = $annotate . $cntl;
		          $annotate = "$movetocat - $toplace";
		          $annotate = $movetocat if ( $mt eq "" );
		          Storage::logEdit("$action", "section", "$annotate", $cntl);
			} else {
		          if ( $ad eq "u" ) { $fromplace = "unreviewed" } else { $fromplace = "reviewed" }
		          if ( $mt eq "u" ) { $toplace = "unreviewed" } else { $toplace = "reviewed" }
		        }
        
		        if ( $action eq "edit" ) {          
		          if ($ad eq "u") {
		            Storage::logEdit("edit", "section", "$cat - unreviewed", $cntl);
		          } else {
		            Storage::logEdit("edit", "section", $cat, $cntl);
		          }
		        } else {
		          my ( $f1, $f2, $newid );
		          $f1 = "$path_sitedata/$cat.$ad" . "sct$idtable";
		          # Since we are moving this section, we need a new id.
		          if ( $mt eq "u" ) {
		            open(USERS, "$path_sitedata/$movetocat.usections");
		            $newid = <USERS>;
		            close(USERS);
          
		            if ($newid eq "") {
		              $newid = "0";
		            }
          
		            open(USERS, ">$path_sitedata/$movetocat.usections");
		            print USERS ++$newid;
		            close(USERS);
		          } else {
		            $newid = Storage::getData('category', $movetocat, "sections");
		            if ($newid eq "") {
		              $newid = "0";
		            }
          
		            Storage::setData('category', $movetocat, "sections", ++$newid);
		          }
          
 		         $f2 = "$path_sitedata/$movetocat.$mt" . "sct$newid";
          
		          # First, adjust counters
		          Common::updateCounter($cat, $fromplace, -1);
		          Common::updateCounter($movetocat, $toplace, 1);
          
  		        # Next, move section
		          move($f1, $f2);
		          # Now, to fix the empty spot it was moved from, using deleteSection
		          # It should work even though the secton was moved.
		          Common::deleteSection($cat, $ad, $idtable);
		          # Last, log edit
		          $annotate = "$cat - $fromplace";
		          $annotate = $cat if ( $ad eq "" );
		          Storage::logEdit("$action", "section", "$annotate", $cntl);
		        }

			} else {
				print "$TS::TS_editsection_errorsection";
				UI::writeScriptFooter($cat);
				exit(0);
			}
		}

		Generate::updatePublicSide($cat);
		if ( $movetocat ne $cat ) {
			Generate::updatePublicSide($movetocat);
		}

		print $TS::TS_common_changesdone;

		#Redirect
		UI::editRedirect();
	} else {
		open(TABLE, "$path_sitedata/$cat.$ad" . "sct$idtable");
		@cont = <TABLE>;
		close(TABLE);

		if ($cont[0]=~/2.0/) {
			$type = $cont[1];
			$name = $cont[2];
		} else {
			$type = "default";
			$name = $cont[0];
			$val = "";
			for ($i = "1"; $i <= $#cont; $i++) {
				$val = $val . $cont[$i];
			}
		}
		$type=~s/\n//g;
		$type=~s/\r//g;

		open(TEMPL, "$path_data/template/$type");
		@tmpl = <TEMPL>;
		close(TEMPL);

		$ncat=$cat;
		$ncat=~s/>/\//g;
		$ncat=~s/_/ /g;

		print ("<form method=\"post\"><input type=\"hidden\" name=\"idtable\" value=\"$idtable\">");
		print ("<input type=\"hidden\" name=\"unreviewed\" value=\"" . $cgi->param('unreviewed') . "\">");

		$name=~s/\"/&quot;/g;

		print ("<table><tr><td>$TS::TS_common_type:</td><td>$type</td></tr><tr><td>$TS::TS_common_title:</td><td><input size=\"70\" name=\"name\" type=\"text\" value=\"$name\"></td></tr>");

		if ($cont[0]=~/2.0/) {
			$j = "0";
			for ($i = "1"; $i <= $#tmpl; $i = $i + 2) {
				$j = $j + 1;
				chomp($tmpl[$i]);
				$tmpl[$i]=~s/.$//g;
				$xx = $tmpl[$i];
				$xx=~s/<.>//g;
				$xx=~s/<\/.>//g;
				$xx=~s/<br>//g;
				$xx=~s/#name//g;
				$k = $j + 2;
				print "<tr><td>$xx:</td><td><input name=\"p$j\" type=\"text\" size=\"70\" value=\"$cont[$k]\"></td></tr>";
			}
			$val = "";
			for ($t = $j + 3; $t <= $#cont; $t++) {
				$val = $val . $cont[$t];
			}
		}

		my $actionLabel;
		if ($cgi->param('unreviewed') eq "1") {
			$actionLabel = $TS::TS_common_publish;
		} else {
			$actionLabel = $TS::TS_common_unreview;
		}
		
		print <<END;
  <tr>
    <td>$TS::TS_common_content:</td>
    <td><textarea name="val" rows="10" cols="70">$val</textarea></td>
  </tr>
  
  <tr>
    <td>$TS::TS_common_action:</td>
    <td>
      <input type="radio" name="omit" value="no" checked>$TS::TS_common_update &nbsp; 
      <input type="radio" name="omit" value="swap">$actionLabel &nbsp;
      <input type="radio" name="omit" value="yes">$TS::TS_common_delete
    </td>
  </tr>

  <tr>
    <td>$TS::TS_common_movetocat:</td>
    <td><input type="text" name="movetocat" size="70" value="$cat"></td>
  </tr>

  <tr>
    <td>
      <input type="hidden" name="cat" value="$cat">
      <input type="submit" name="submit" value="$TS::TS_common_submit">
    </td>
  </tr>
</table>
<input type="hidden" name="type" value="$type">
</form>
END
	}

	print ("</p>");
	UI::writeEditLink($cat);
	UI::writeBackLink();
}

UI::writeFooterCode();
