#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use CGI;
use strict;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $idtable = $cgi->param('idtable');
my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $name = $cgi->param('name');
my $rows = $cgi->param('rows');
my $cols = $cgi->param('cols');
my $val = $cgi->param('val');
my $lt = localtime;

$cat = Editor::testPrivs($cat);

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_edittable_title);
Editor::writeECode();

open(EL, "$path_data/pginfo/tble");
my $table= <EL>;
close(EL);
#head loaded

open(USERS, "$path_sitedata/$cat.tables");
my $users = <USERS>;
close(USERS);

if (($idtable < "1") || ($idtable > $users))
{
	print $TS::TS_edittable_invalidnumber;
}
else
{
   print ("<p>");

   if ($submit ne "") {
      open(USERS, "$path_sitedata/$cat.tables");
      $users = <USERS>;
      close(USERS);
      if ($users eq "") {
         $users = "0";
      }

      open(TABLE, ">$path_sitedata/$cat.tbl$idtable");
      print TABLE $name . "\n";
      print TABLE $rows . "\n";
      print TABLE $cols . "\n";
      print TABLE $val;
      close(TABLE);

      print ($TS::TS_edittable_done);
      open(EL, "$path_data/pginfo/tble");
      $table = <EL>;
      close(EL);

      Generate::updatePublicSide($cat);

			Storage::logEdit("edit","table",$cat,"$name<hr>$rows<hr>$cols<hr>$val");
	
	#Redirect
	UI::editRedirect();
   } else {
      open(TABLE, "$path_sitedata/$cat.tbl$idtable");
      my @cont = <TABLE>;
      close(TABLE);
      my $name = $cont[0];
      my $rows = $cont[1];
      my $cols = $cont[2];
      my $val = "";
      for (my $i = "3"; $i <= $#cont; $i++) {
         $val = $val . $cont[$i];
      }

      print "<p>$TS::TS_edittable_editingno $idtable</p>";
      print ("<form method=\"post\"><input type=\"hidden\" name=\"idtable\" value=\"$idtable\">");
      print ("<table><tr><td>$TS::TS_edittable_name:</td><td><input size=\"70\" name=\"name\" type=\"text\" value=\"$name\"></td></tr>");
      print ("<tr><td>$TS::TS_edittable_rows:</td><td><input size=\"70\" name=\"rows\" type=\"text\" value=\"$rows\"></td></tr>");
      print ("<tr><td>$TS::TS_edittable_cols:</td><td><input size=\"70\" name=\"cols\" type=\"text\" value=\"$cols\"></td></tr>");
      print ("<tr><td>$TS::TS_edittable_values:</td><td><textarea name=\"val\" rows=\"10\" cols=\"70\">$val</textarea></td></tr>");
      print ("<tr><td><input type=\"hidden\" value=\"$cat\" name=\"cat\"><input type=\"submit\" name=\"submit\" value=\"$TS::TS_common_submit\"></td></tr>");
      print ("</table>");
      print ("</form>");
   }
   print ("</p>");
}

UI::writeScriptFooter($cat);
