#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $do = $cgi->param('do');
my $newtype = $cgi->param('newtype');
my @newtempl = $cgi->param('newtempl');
my $cat = $cgi->param('cat');
my $omit = $cgi->param('omit');
my $lt = localtime;

my $name = $newtype;

Editor::restrictedMeta();

if ($name eq "") {
	$name = "default";
}

if (!(-d "$path_data/template")) {
	mkdir("$path_data/template");
}

if ($do ne "") {
	my $value = "2.0\n";
	if ($cgi->param('group') eq "1") {
		$value = "2.01\n";
	}
	unshift	@newtempl, $value;
	if ($omit eq "no") {
		open(EL, ">$path_data/template/$name");
		print EL join("", @newtempl);
		close(EL);
	} else {
		open(EL, ">$path_data/template/$name");
		close(EL);

		open(EL, "$path_data/cattype");
		my $tr = <EL>;
		close(EL);

		$tr =~s/ ; $name//;

		open(EL, ">$path_data/cattype");
		print EL $tr;
		close(EL);
	}

	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);
	#head loaded

	open(TEXTFILE, ">>$path_data/logs/allog/$ENV{REMOTE_USER}.log");
	print TEXTFILE "<i>$lt</i><br>IP: $ENV{REMOTE_ADDR}<br>USER: $ENV{REMOTE_USER};<hr>\n";
	print TEXTFILE "The structure of template $name has been modified.<br>@newtempl<br>$table\n";
	close(TEXTFILE);

	open(TEXTFILE, ">>$path_data/logs/rootlog/rlog.log");
	print TEXTFILE "<i>$lt</i><br>IP: $ENV{REMOTE_ADDR}<br>USER: $ENV{REMOTE_USER};<hr>\n";
	print TEXTFILE "The structure of template $name has been modified.<br>@newtempl<br>$table\n";
	close(TEXTFILE);

	open(TEXTFILE, "$path_data/misc/$ENV{REMOTE_USER}.qedit");
	my $chkqedit = <TEXTFILE>;
	close(TEXTFILE);
	if ($chkqedit eq "on") {
		print "Status: 302 Moved\n";
		print "Location: ./addtemplate.cgi\n\n";
	}
}

UI::writeHeaderCode($TS::TS_edittemplate_title);
Editor::writeECode();

open(EL, "$path_data/template/$name");
my @rd = <EL>;
close(EL);

my $group = shift @rd;
my $rd = join("", @rd);

my $groupChecked = "";
if ($group=~/2.01/) {
	$groupChecked = "checked";
}

UI::writeScriptHeader("", "$TS::TS_edittemplate_title - $name", 'Here you can modify the fields for a template. Each field takes two rows. On the first row the name of the field must be placed. On the second row, the way in which the value of the field will be displayed must be introduced; HTML can be used; #name will be replaced with the actual value of the field.');

UI::writeStartForm("", "edittemplate.cgi");
UI::writeItemForm("Template Definition", "<textarea name=\"newtempl\" rows=\"10\" cols=\"80\">$rd</textarea>");
UI::writeCheckboxForm("group", "1", "Sections of this type are displayed together as rows in a table.", $groupChecked);
UI::writeItemForm($TS::TS_common_action, "<input type=\"radio\" name=\"omit\" value=\"no\" checked>$TS::TS_common_update &nbsp; <input type=\"radio\" name=\"omit\" value=\"yes\">$TS::TS_common_delete</td></tr>");
UI::writeHiddenForm("newtype", $name);
UI::writeEndForm("do");

print "<a href=\"addtemplate.cgi\">$TS::TS_common_back</a>";

UI::writeScriptFooter();
