#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my($cgi) = new CGI;

UI::writeHeaderCode($TS::TS_edmozlist_title);
Editor::writeECode();
Editor::restrictedMeta();

open(MOZ, "$path_data/mozzies");
my @cont = <MOZ>;
close(MOZ);

my($command) = $cgi->param('command');

if ($command eq "") {
	UI::writeScriptHeader("", $TS::TS_edmozlist_title, $TS::TS_edmozlist_desc);

	print "<a href=\"edmozlist.cgi?command=add\">$bold $TS::TS_edmozlist_newimage $unBold</a>";

	open(MOZZIES, "$path_data/mozzies");
	my @content = <MOZZIES>;
	close(MOZZIES);

	print <<END;
<p><table cellpadding="6" width="100%"><tr align="center" bgcolor="#ccddbb">
<td>$bold $TS::TS_edmozlist_action $unBold</td>
<td>$bold $TS::TS_edmozlist_image $unBold</td>
<td>$bold $TS::TS_edmozlist_width $unBold</td>
<td>$bold $TS::TS_edmozlist_height $unBold</td>
<td>$bold $TS::TS_edmozlist_description $unBold</td></tr>
END

	my($number, $name, $height, $width, $description);

	for (my $id = 0; $id <= $#content; $id++) {
		$content[$id] =~ />##([^#]*)#([^#]*)#([^#]*)#([^#]*)#([^#]*)##</;
		print <<END;
<tr align="center" bgcolor="#ddeecc">
<td>$bold
<a href="edmozlist.cgi?command=edit&number=$1">$TS::TS_edmozlist_edit</a><br>
END
	if ($1 != 1) {
		print <<END;
<a href="edmozlist.cgi?command=delete&number=$1">$TS::TS_edmozlist_delete</a>
END
	}

	print <<END;
 $unBold</td>
<td><img src="$path_on_server/img/moz/$2" title="$5" width="$3" height="$4"></td>
<td>$bold $3 $unBold</td>
<td>$bold $4 $unBold</td>
<td>$bold $5 $unBold</td>
</tr>
END
	}

	print "</table>";
}

if ($command eq "delete") {
	print $TS::TS_edmozlist_suredelete;
	my $ID;
	my $image;
	my $height;
	my $width;
	my $description;

	for (my $x = 0; $x <= $#cont; $x++) {
		$cont[$x] =~ />##([^#]*)#([^#]*)#([^#]*)#([^#]*)#([^#]*)##</;
		if ($1 == $cgi->param('number')) {
			$ID = $1;
			$image = $2;
			$width = $3;
			$height = $4;
			$description = $5;
		}
	}

	UI::writeStartForm("", "edmozlist.cgi");
	UI::writeItemForm($TS::TS_edmozlist_image, "<img height=\"$height\" width=\"$width\" src=\"$path_on_server/img/moz/$image\">");
	UI::writeItemForm($TS::TS_edmozlist_height, $height);
	UI::writeItemForm($TS::TS_edmozlist_width, $width);
	UI::writeItemForm($TS::TS_edmozlist_description, $description);
	UI::writeHiddenForm("number", $cgi->param('number'));
	UI::writeHiddenForm("command", "delete2");
	UI::writeEndForm();
}

if ($command eq "add") {
	print <<END;
$TS::TS_edmozlist_newimage
<form method="post" action="edmozlist.cgi" enctype="multipart/form-data">
<table>
END
	UI::writeInputItemForm($TS::TS_edmozlist_height, "text", "height");
	UI::writeInputItemForm($TS::TS_edmozlist_width, "text", "width");
	UI::writeInputItemForm($TS::TS_edmozlist_description, "text", "description");
	UI::writeItemForm("Filename", "<input type=\"file\" name=\"image\">");
	UI::writeHiddenForm("command", "add2");
	UI::writeEndForm();
}

if ($command eq "add2") {
	my $image = $cgi->param('image');
	my $height = $cgi->param('height');
	my $width = $cgi->param('width');
	my $desc = $cgi->param('description');
	my $filename = $image;
	$filename = Storage::validateFileName($filename);

	if (($image eq "") || ($height eq "") || ($width eq "") || ($desc eq "")) {
		print "Error";
		UI::writeScriptFooter();
		exit(0);
	}

	my $max;
	open(FILE, "$path_data/mozzies.counter");
	$max = <FILE>;
	close(FILE);

	if ($max eq "") {
		$max = 0;

		open(FILE, "$path_data/mozzies");
		my @content = <FILE>;
		close(FILE);

		my $content = join("", @content);
		while ($content=~/>##(.*)#/g) {
			if ($1 > $max) {
				$max = $1;
			}
		}
	}

	$max++;

	open UPLOADFILE, ">$path_images" . "moz/$filename";

	my $size = 0;
	my $buffer = "";
	my $bytesread = 0;

	while (($bytesread=read($image, $buffer, 1024)) && ($size <= 100000)) {
		print UPLOADFILE $buffer;
		$size += $bytesread;
	}

	close UPLOADFILE;

	if ($size > 100000) {
		print "Error: the size of the file is greater than the current limit: 100000 bytes.";
		unlink("$path_images" . "moz/$filename");
	} else {
		if ($size eq "0") 	{
			print "Error: empty files can not be uploaded.";
			unlink("$path_images" . "moz/$filename");
		} else {
			open(FILE, ">$path_data/mozzies.counter");
			print FILE $max;
			close(FILE);

			open(FILE, ">>$path_data/mozzies");
			print FILE ">##$max#$image#$width#$height#$desc##<\n";
			close(FILE);

			print "<p>" . $TS::TS_common_done;
		}
	}

	print "<p><a href=\"edmozlist.cgi\">" . $TS::TS_common_back . "</a>";
}

if ($command eq "delete2") {
	my $number = $cgi->param('number');
	$number=~s/[^0-9]//g;
	if (($number != 1) && ($number ne "")) {
		open(FILE, "$path_data/mozzies");
		my @content = <FILE>;
		close(FILE);
		my $content = join("", @content);
		$content=~s/>##$number#([^#]*)#([^#]*)#([^#]*)#([^#]*)##<\n//;

		open(FILE, ">$path_data/mozzies");
		print FILE $content;
		close(FILE);
		print "<p>" . $TS::TS_common_done;
	}

	print "<p><a href=\"edmozlist.cgi\">" . $TS::TS_common_back . "</a>";
}

if ($command eq "edit") {
	UI::writeStartForm();

	my ($ID, $image, $height, $width, $description);

	if ($cgi->param('full') == 1) {
		my $content = "<table width=\"100%\">";

		for (my $x = 0; $x <= $#cont; $x++) {
			$cont[$x] =~ />##([^#]*)#([^#]*)#([^#]*)#([^#]*)#([^#]*)##</;
			if (int($x / 3) * 3 == $x)  {
				$content .= "<tr>";
			}
			my $checked = "";
			my $color = "";
			if ($1 == $cgi->param('number')) {
				$checked = " checked";
				$color = " bgcolor=\"#ddeecc\"";
				$ID = $1;
				$image = $2;
				$height = $3;
				$width = $4;
				$description = $5;
			}
			$content .= "<td$color align=\"center\"><img title=\"$5\" src=\"$path_on_server/img/moz/$2\" height=\"$4\" width=\"$3\"><br><input type=\"radio\"$checked name=\"image\" value=\"$2\">$5</td>";
			if (int($x / 3) * 3 + 2 == $x)  {
				$content .= "</tr>";
			}
		}
		UI::writeItemForm($TS::TS_edmozlist_image, $content . "</table>");
	} else {
		for (my $x = 0; $x <= $#cont; $x++) {
			$cont[$x] =~ />##([^#]*)#([^#]*)#([^#]*)#([^#]*)#([^#]*)##</;
			if ($1 == $cgi->param('number')) {
				$ID = $1;
				$image = $2;
				$width = $3;
				$height = $4;
				$description = $5;
			}
		}
		my $number = $cgi->param('number');
		UI::writeItemForm($TS::TS_edmozlist_image, "<table width=\"100%\" bgcolor=\"#ddeecc\"><tr align=\"center\"><td><input type=\"hidden\" checked name=\"image\" value=\"$image\"><img height=\"$height\" width=\"$width\" src=\"$path_on_server/img/moz/$image\" title=\"$description\"><br><a href=\"edmozlist.cgi?command=edit&number=$number&full=1\">[$TS::TS_edmozlist_viewfull]</a></td></tr></table>");
	}
	UI::writeInputItemForm($TS::TS_edmozlist_height, "text", "height", $height);
	UI::writeInputItemForm($TS::TS_edmozlist_width, "text", "width", $width);
	UI::writeInputItemForm($TS::TS_edmozlist_description, "text", "description", $description);
	UI::writeHiddenForm("command", "edit2");
	UI::writeHiddenForm("number", $ID);
	UI::writeEndForm();

	print "</table>";
}

if ($command eq "edit2") {
	print "<br>$TS::TS_edmozlist_image: " . $cgi->param('image');
	print "<br>$TS::TS_edmozlist_height: " . $cgi->param('height');
	print "<br>$TS::TS_edmozlist_width: " . $cgi->param('width');
	print "<br>$TS::TS_edmozlist_description: " . $cgi->param('description');

	open(FILE, "$path_data/mozzies");
	my @content = <FILE>;
	close(FILE);

	my $number = $cgi->param('number');
	my $content = join("", @content);
	my $image = $cgi->param('image');
	my $height = $cgi->param('height');
	my $width = $cgi->param('width');
	my $desc = $cgi->param('description');
	$content=~s/>##($number)#([^#]*)#([^#]*)#([^#]*)#([^#]*)##</>##$1#$image!!!#$width#$height#$desc##</;
	my $orig = $2;
	$content=~s/#$image#/#$orig#/g;
	$content=~s/$image!!!/$image/g;

	open(FILE, ">$path_data/mozzies");
	print FILE $content;
	close(FILE);

	print "<p>" . $TS::TS_common_done;
	print "<p><a href=\"edmozlist.cgi\">" . $TS::TS_common_back . "</a>";
}

UI::writeScriptFooter();
