#!/usr/bin/perl -w
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $line = $cgi->param('line');
my $noton = $cgi->param('noton');

UI::writeHeaderCode($TS::TS_ednotice_title);
Editor::writeECode();
Editor::restrictedRoot();

if (defined $line) {
	Storage::setData('global', 'notice', $line);

	if ($noton eq 1) {
		Storage::setData('global', 'noton', '1');
	} else {
		Storage::setData('global', 'noton', '0');
	}
}

my @comments;
if (-f "$path_data/notice") {
	open(INFILE, "$path_data/notice");
	@comments = <INFILE>;
	close(INFILE);
}

my @acomments = @comments;
my $x = 0;
my $y = $#comments + 1;

while ($x ne $y) {
        $comments[$x]=~s/\n/<br>/g;
        $x++;
}

my $notond = Storage::getData('global', 'noton');
my $qchecked = ($notond eq "1") ? "checked" : "";

print <<END;
<p>
$bold $TS::TS_ednotice_current $unBold<br>
@comments
<p>
<p>
<p>
$bold $TS::TS_ednotice_title $unBold<br>
<form method="post" action="ednotice.cgi">
<textarea rows="10" name="line" cols="60">
END

foreach (@acomments) {
	print $_;
}

print <<END;
</textarea><br>
<input type="checkbox" name="noton" value="1" $qchecked> - $TS::TS_ednotice_noticeon<br>
<input type="submit" value="$TS::TS_common_submit"><br>
</form>
END

UI::writeScriptFooter();
