#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


#This is a script to edit files in a directory with.

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $editor = $cgi->param('editor');
my $file = $cgi->param('file');
my $cmd = $cgi->param('cmd');

my(@files, $path);

UI::writeHeaderCode($TS::TS_edpics_picturefileeditor);
Editor::writeECode();

if ($isMeta ne "1") {
	$editor = Editor::currentUser();
}

if ($cmd eq "remove") {
	$editor = Editor::validateEditor($editor);
	$file = Storage::validateFileName($file);
	unlink("$path_web/img/$editor/$file");
	print "$TS::TS_edpics_file \"$file\" $TS::TS_edpics_hasbeenremoved<br>";
	print "<p align=\"left\"><b><a href=\"edpics.cgi\">$TS::TS_common_back</a>";
} else {
	if ($editor eq "") {
		print <<END;
<h2>$TS::TS_edpics_picturefileeditor:</h2><br>
<form method="POST" action="edpics.cgi">
  <p align="left"><b>$TS::TS_edpics_editorchoose:</b><br>
  <input type="text" name="editor" size="20"><input type="submit" value="$TS::TS_edpics_viewfiles" name="B1"></p>
</form>
END
	} else {
		$editor = Editor::validateEditor($editor);

		opendir(DIR, "$path_web/img/$editor");
		my @files = readdir(DIR); 
		closedir(DIR); 

		chomp(@files);
		print "<h2>$TS::TS_common_editor: $editor</h2>";
		print "<h2><b><a href=\"../img/$editor/\">/img/$editor/</a></h2></b><br>";
		foreach (@files) {
			my $cL = $_;
			$cL=~s/[\n\r]$//g;
			if (($cL ne ".") && ($cL ne "..")) {
				$path = "$bold<a href=\"../img/$editor/$cL\">$cL</a>$unBold<br>[<a href=\"edpics.cgi?file=$cL&editor=$editor&cmd=remove\">$TS::TS_edpics_remove</a>] | [<a href=\"renamepics.cgi?file=$cL&editor=$editor\">$TS::TS_edpics_rename</a>]</font><br><br>\n";
				print $path;
			}
		}
	}
}

UI::writeScriptFooter();
