#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $line = $cgi->param('line');
my $email = $cgi->param('email');
my $skin = $cgi->param('skin');
my $lang = $cgi->param('lang');
my $qedit = $cgi->param('qedit');
my $cmd = $cgi->param('cmd');
my $spell = $cgi->param('spell');

my $done = 0;

my($comments, $chkqedit, $qchecked, $schecked, $emailaddr, $numskins, $i, @descriptions);
my($current, @langs, $num);

if ($line ne "") {
	$done = Storage::setData('editor', $ENV{REMOTE_USER}, "html", $line);
}

if ($cmd ne "") {
	if (!(-d "$path_data/misc")) {
		mkdir("$path_data/misc");
	}
	if ($qedit eq 1) {
		open(F, ">$path_data/misc/$ENV{REMOTE_USER}.qedit");
		print F "on";
		close(F);
		$done = 1;
	} else {
		open(F, ">$path_data/misc/$ENV{REMOTE_USER}.qedit");
		print F "off";
		close(F);
		$done = 1;
	}
}

if ($email ne "") {
	open(F, ">$path_data/misc/$ENV{REMOTE_USER}.eaddr");
	print F "$email";
	close(F);
	$done = 1;
}

if ($skin ne "") {
	$done = Storage::setData('editor', $ENV{REMOTE_USER}, "skin", $skin);
}

if ($lang ne "") {
	$done = Storage::setData('editor', $ENV{REMOTE_USER}, "lang", $lang);
}

if ($cmd ne "") {
	$done = Storage::setData('editor', $ENV{REMOTE_USER}, "spell", $spell);
}

if ($done == 1) {
	print "Status: 302 Moved\n";
	print "Location: ./\n\n";
} else {
	$comments = Storage::getData('editor', $ENV{REMOTE_USER}, 'html');

	UI::writeHeaderCode("$TS::TS_edprofile_title");
	Editor::writeECode();

	open(TEXTFILE, "$path_data/misc/$ENV{REMOTE_USER}.qedit");
	$chkqedit = <TEXTFILE>;
	close(TEXTFILE);

	if ($chkqedit eq "on") 	{
		$qchecked = "checked";
	}

	$schecked = "";

	$chkqedit = Storage::getData('editor', $ENV{REMOTE_USER}, 'spell');

	if ($chkqedit=~/1/) {
		$schecked = "checked";
	}

	open(INFILE, "$path_data/misc/$ENV{REMOTE_USER}.eaddr");
	$emailaddr = <INFILE>;
	close(INFILE);

	$skin = Storage::getData('editor', $ENV{REMOTE_USER}, 'skin');
	chomp($skin);

	print <<END;
<form method="POST" action="edprofile.cgi">
END

	if ($collectEmails) {
		print <<END;
<p>$bold$TS::TS_edprofile_email:$unBold<br>
<input type="text" name="email" value="$emailaddr" size="40">
END
	}
	
	print <<END;
<p>$bold$TS::TS_edprofile_edproinhtml $unBold<br>
<textarea rows="15" name="line" cols="60">$comments</textarea><br><br>
<input type="checkbox" name="qedit" value="1" $qchecked> $TS::TS_edprofile_qe<br>
<input type="checkbox" name="spell" value="1" $schecked> $TS::TS_edprofile_sp<br>
<br>$bold$TS::TS_edprofile_dsc:$unBold<br>
<select name="skin">
END

	for ($i = 0; $i <= $UI::numskins; $i++) {
		if ($skin eq $i) {
			print "<option value=\"$i\" selected>$UI::descriptions[$i]\n";
		} else {
			print "<option value=\"$i\">$UI::descriptions[$i]\n";
		}
	}

	print <<END;
</select>
<br><br>
$bold$TS::TS_edprofile_luiwi:$unBold<br>
<select name="lang">
END

	$current = Storage::getData('editor', $ENV{REMOTE_USER}, 'lang');
	chomp($current);
	open(LIST, "$path_code/ts/langs.txt");
	@langs = <LIST>;
	close(LIST);
	chomp(@langs);
	$num = 0;
	foreach $lang (@langs) {
		$num += 1;
		if ($current eq $num) {
			print "<option value=\"$num\" selected>$lang\n";
		} else {
			print "<option value=\"$num\">$lang\n";
		}
	}

	print <<END;
</select>
<p><input type="submit" name="cmd" value="$TS::TS_edprofile_sub">
</form>
END

	UI::writeScriptFooter();
}
