#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $edresources = $cgi->param('edresources');
my $pushed = $cgi->param('pushed');
my $edit = $cgi->param('edit');

UI::writeHeaderCode($TS::TS_edresources_title);
Editor::writeECode();
Editor::restrictedRoot();

if ($pushed ne "") {
	Storage::setData('global', 'edresources', $edresources);
}

my $edresources = Storage::getData('global', 'edresources');

print <<END;
<p>
<strong>$TS::TS_edresources_current:</strong><br>
$edresources
<p>
<p>
<p>
<b>$TS::TS_edresources_title:</b><br>
<form method="post" action="edresources.cgi">
<textarea name="edresources" rows="10" cols="60">$edresources</textarea><br>
<input type="hidden" name="pushed" value="1">
<input type="submit" value="$TS::TS_common_submit"><br>
</form>
END

UI::writeScriptFooter();
