#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $dcomments;

my $action = $cgi->param('action');
my $note = $cgi->param('note');

UI::writeHeaderCode($TS::TS_edtodo_title);
Editor::writeECode();

if ($action ne "") {
	Storage::setData('editor', $ENV{REMOTE_USER}, 'dnote', $note);
	$dcomments = $note;
	print $TS::TS_edtodo_updated;
} else {
	$dcomments = Storage::getData('editor', $ENV{REMOTE_USER}, 'dnote');

	print <<END;
<form method="post" action="edtodo.cgi">
<input type="hidden" name="action" value="save">
$bold $TS::TS_edtodo_title $unBold <br>
<textarea rows="8" name="note" cols="80">$dcomments</textarea><br>
<input type="submit" value="$TS::TS_common_submit">
</form>
END
}

UI::writeScriptFooter();
