#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $do = $cgi->param('do');
my $data = $cgi->param('data');
my $lt = localtime;

UI::writeHeaderCode("$cat - Edit Warning Log");
Editor::writeECode();
Editor::restrictedRoot();

if ($cat ne "") {
	$cat = Editor::validateEditor($cat);
}

if ($do ne "") {
	open(LDATA, ">$path_data/logs/warnlog/$cat.log");
	print LDATA "$data\n";
	close(LDATA);
}

if ($cat ne "")	{
	open(CATL, "$path_data/logs/warnlog/$cat.log");
	my @cat4 = <CATL>;
	close(CATL);
	print "@cat4";

	print <<END;
<form method="post" action="edwarn.cgi">
<textarea rows="13" name="data" cols="80">@cat4</textarea>
<br><p><input type="radio" value="$cat" checked name="cat">$cat</p>
<input type="submit" value="Update" name="do">
END
} else {
	print <<END;
<b><h1>Edit Warning Log</h1><p>Choose an editor</b><br>
<form method="get" action="edwarn.cgi">
</b>Editor:</b>
<br><input type="text" name="cat" value="$cat" size="20">
<input type="submit" value="$TS::TS_common_submit">
END
}

UI::writeScriptFooter();
