#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $newedit = $cgi->param('editor');
my $reason = $cgi->param('reason');
my $tcat = $cgi->param('tcat');
my $typeset = $cgi->param('newtype');
my $ok = "";
my $lt = localtime;
my $currenteditor = Editor::currentUser();

my $bkcat = $cat;
my $okay = "1";

if ($cat=~/>/g) {
	UI::showError("", $TS::TS_common_nocatorprivs, "", "");
}

$tcat = Editor::validateCat($tcat);
Editor::testPrivs($tcat);

if ($act ne "") {
	$cat = Editor::validateCat($cat, 2);
	Editor::validateCat($tcat . ">" . $cat, 0);

	$bkcat = $cat;
	$cat = $tcat;
	UI::editRedirect($tcat);
	$cat = $bkcat;

	UI::writeHeaderCode($TS::TS_enewcat_title);
	Editor::writeECode();

	print "<title>$cat</title>\n";
	open(EL, ">$path_sitedata/$tcat>$cat.html");
	print EL "$ok ";
	close(EL);

	open(EL4, ">>$path_sitedata/cats.lst");
	print EL4 "$tcat>$cat; ";
	close(EL4);

	open(LDATA, ">$path_sitedata/$tcat>$cat.ct");
	print LDATA "$typeset\n";
	close(LDATA);

	if (($newedit ne "") && ($isEditall eq "1")) {
		my $users = Storage::getData("global", "elist");
		if ($users=~/ $newedit /) {
			open(EL, ">>$path_data/eperm/$newedit.perm");
			print EL " $tcat>$cat; ";
			close(EL);
			print "$newedit $TS::TS_enewcat_cannowedit $tcat/$cat.<br>\n";

			open(TEXTFILE, ">>$path_sitedata/$tcat>$cat.ed");
			print TEXTFILE "$newedit\n";
			close(TEXTFILE);
			Storage::logMetaEdit($newedit,$currenteditor,'newcat',0,"$tcat>$cat ($reason)");
                  
			}
	}

	Generate::updatePublicSide($tcat . ">" . $cat);
	Generate::updatePublicSide($tcat);

	print <<END;
$TS::TS_enewcat_created<br>
<b><a href="./editcat.cgi?cat=$tcat/$cat">$TS::TS_enewcat_edit</a></b>: $tcat/$cat<br>\n
END

	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);

	#head loaded
	open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
	print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## new #!# ##!## category #!# ##!!!## $tcat>$cat - created ##!!!!## \n";
	close(TEXTFILE);
} else {
	UI::writeHeaderCode($TS::TS_enewcat_title);
	Editor::writeECode();

	#Top Cat Parse
	open(EL, "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm");
	my $dmlst= <EL>;
	close(EL);

	if ($dmlst=~/editall/g) {
		$dmlst = Storage::getData("global", "tlc.lc");
	}
	my $sep = "</option><option>";
	$dmlst=~s/; /$sep/g;

	my $tnice = UI::getNiceFormat($tcat);

	print <<END;
<font size="+2">$TS::TS_common_newcat</font>
<br>
<hr><form method="POST" action="enewcat.cgi">
<p><b>$TS::TS_common_category:</b><br>
<input type="hidden" value="$tnice" name="tcat">
$tnice/ <input type="text" name="cat" size="40">
<br><br>
END

	open(EL, "$path_data/cattype");
	my $cats = <EL>;
	close(EL);
	print "<p>$TS::TS_common_template: ";

	print Common::writeTemplateCombo($tcat, "newtype");

	print "</p>";

	if ($isEditall eq "1") {
		print <<END;
<table border="0" cellspacing="1" width="430" id="AutoNumber1" bgcolor="#A6CAF0">

<br>
 <tr>
    <td width="426">
<p>$TS::TS_enewcat_youmay</p>
<p><strong>$TS::TS_common_editor:&nbsp; &nbsp;</strong>
<input type="text" name="editor" size="20"></p>
<p><b>$TS::TS_common_reason:</b>
<input type="text" name="reason" size="40"></p>
 </td></tr></table>
END
	}

	print <<END;
<p><input type="submit" value="$TS::TS_common_create" name="action"></form>
END
}

UI::writeScriptFooter($tcat);
