#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $qcmd = $cgi->param('cmd');
my $lines = $cgi->param('lines');

if ($lines eq "") {
	$lines = 150;
}

my $rlog;

UI::writeHeaderCode("Error Log");
Editor::restrictedRoot();

if ($qcmd ne "") {
	open(TEXTFILE, ">$path_data/logs/webaccess/error.log");
	print TEXTFILE "";
	close(TEXTFILE);
	print "<br><H2><b>Error Logs<br></H2></b>\n";

	print <<END;
<form method="POST" action="errorlog.cgi">
Log cleared.
<br></form>
END
} else {
	print "<br><H2><b>Error Logs - last $lines entries<br></H2></b>\n";

	print <<END;
<form method="GET"><p>Number of lines to display: &nbsp; <input type=text name=lines size=8 value=$lines>
<input type=submit value="$TS::TS_common_submit"></p>
</form>
END

	$rlog = `tail -$lines $path_data/logs/webaccess/error.log`;

	$rlog=~s/</&lt;/g;
	$rlog=~s/>/&gt;/g;

	print "<pre>\n$rlog\n<\/pre>";
}

UI::writeScriptFooter();
