#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my($cgi) = new CGI;

my $action = $cgi->param('act');
my $to = $cgi->param('to');
my $subject = $cgi->param('sub');
my @message = $cgi->param('message');

UI::writeHeaderCode($TS::TS_feedback_title);
Editor::writeECode();

if ($action eq "send") {
	open(FROM, "$path_data/misc/$ENV{REMOTE_USER}.eaddr");
	my $fromeaddr = <FROM>;
	close(FROM);

	my @editorsts = split(" ", $to);

	foreach (@editorsts) {
		Editor::validateEditor($_);
		open(FROM, "$path_data/misc/$_.eaddr");
		my $editoremail = <FROM>;
		close(FROM);

		open(SENDMAIL, "| $path_sendmail") || die "Unable to open sendmail";
		print SENDMAIL <<END_MAIL;
From: $ENV{REMOTE_USER} <$fromeaddr>
To:  $editoremail
Subject: $HD_name - (Editor Feedback)  $subject
@message
END_MAIL
		close(SENDMAIL);
	}

	print "$TS::TS_feedback_sent";
}


if ($action eq "") {
	print <<END;
<form method="POST" action="feedback.cgi">
<input type="hidden" name="act" value="send">
$bold <h3>$TS::TS_feedback_title</h3> $unBold

$bold $TS::TS_feedback_from: $unBold $ENV{REMOTE_USER}<br><br>
END

	print<<END;
$bold $TS::TS_feedback_to: $unBold <br>
<input type="text" name="to" size="40" value="$to"><br><br>
END


	print <<END;
$bold $TS::TS_feedback_subject: $unBold<br>
<input type="text" name="sub" size="40"><br><br>

$bold $TS::TS_feedback_message: $unBold<br>
<textarea rows="8" name="message" cols="80"></textarea><br>
<input type="submit" value="$TS::TS_feedback_send">
</form>
END
}

UI::writeScriptFooter();
