#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

UI::writeHeaderCode("Grant Category");
Editor::writeECode();
Editor::restrictedMeta();

if (defined $cgi->param('action')) {
	my $username = $cgi->param('usn');
	my $reason = $cgi->param('reason');
	my $cat = $cgi->param('cat');
	my $currenteditor = Editor::currentUser();
	
	$username = Editor::validateEditor($username);
	$cat = Editor::validateCat($cat);

	Editor::catmodPriv($cat);

	# Cat Grant
	my $userf = "";
	if (open(USERS, "$path_data/eperm/$username.perm")) {
		$userf = <USERS>;
		close(USERS);
	}

	if ($reason eq "") {
		print $TS::TS_gcat_mustreason;
		UI::writeFooterCode();
		exit(0);
	}

	if ($userf=~/ $cat; /) {
		print $TS::TS_gcat_alreadycando;
	} else {
		open(EL, ">>$path_data/eperm/$username.perm");
		print EL " $cat; ";
		close(EL);
		print "$username $TS::TS_gcat_cannoweditin $cat.<br>\n";

		Generate::updatePublicSide($cat);

		open(TEXTFILE, ">>$path_sitedata/$cat.ed");
		print TEXTFILE "$username\n";
		close(TEXTFILE);
		Storage::logMetaEdit($username,$currenteditor,'grant',0,"$cat ($reason)");
	}
} else {
	my $editor = $cgi->param('editor');
	if (!defined $editor) {
		$editor = "";
	}
	
	print <<END;
<font size="5">$TS::TS_gcat_gcat</font><br>
<form method="POST" action="gcat.cgi">
  <p><b>$TS::TS_common_editor:</b><br>
  <input type="text" name="usn" value="$editor" size="20"></p>
  <p><b>$TS::TS_common_category:</b><br>
  <input type="text" name="cat" size="40"></p>
  <p><b>$TS::TS_common_reason:</b><br>
  <input type="text" name="reason" size="40"></p>
  <p><input type="submit" value="$TS::TS_common_submit" name="action"></p>
</form>
END
}

UI::writeScriptFooter();
