#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $lt = localtime;

my $cgi = new CGI;
my $act = $cgi->param('act');
my @edits;

UI::writeHeaderCode("CatEditall+ List");
Editor::restrictedRoot();

if ($act eq "") {
	print "$TS::TS_gdlist_info"; 
	print "<ul>";
	print "<li><a href=\"./gdlist.cgi?act=build\">$TS::TS_gdlist_bl</a>";
	print "</ul>";
}

if (($act eq "pre") || ($act eq "build")) {
	open(PLIST, ">$path_web/edoc/editalls.html");

	print PLIST "<h2>$HD_name - CatEditall+ List</h2>";

	print PLIST <<END;
<table cellSpacing="2" cellPadding="2" border="1">
<tbody>
<tr>
<td align="middle"><strong>editor</strong></td>
<td><b>root</b></TD>
<td><b>editall</b></TD>
<td><b>meta</b></TD>
<td align="middle"><strong>last login</strong></td></tr>
END

	opendir(DIR, "$path_data/misc");
        @edits = readdir(DIR);
        closedir(DIR);


	@edits = sort { lc($a) cmp lc($b) } @edits;
    
	#Generate Root

	my $users = Storage::getData("global", "elist");

	chomp(@edits);
	foreach (@edits) {
		my $item = $_;
		$item=~s/.eaddr//g;
		if ($users=~/ $item /) {
			my $editalllist = Storage::getData("global", "dirmod.gf");
			my $metalist = Storage::getData("global", "dirman.gf");
			my $rootlist = Storage::getData("global", "root.gf");

			my $oneditall = "";
			my $onmeta = "";
			my $onroot = "";

			my $editor = $item;

			my $onlist = 0;

			my $cat = "";

			if ($editalllist=~/ $item /g) {
				$onlist = 0;
				$oneditall =  "editall";
				open(LDATA, "$path_data/eperm/editall/$item.perm");
				$cat = <LDATA>;
				close(LDATA);
				if ($cat=~/editall/) {
					$cat = "editall";
				} else {
					$cat = "cateditall";
				}
			}

			if ($metalist=~/ $item /g) {	
				$onlist = 0;
				open(LDATA, "$path_data/eperm/meta/$item.perm");
				my $mcat = <LDATA>;
				close(LDATA);
				if ($mcat=~/meta/) {
					$onmeta = "meta";
				} else {
					$onmeta = "catmod";
				}
			}

			if ($rootlist=~/ $item /g) {
				$onlist = 1;
				$onroot = "root";
			}

			if ($onlist eq "1") {
				open(LDATA, "$path_data/logs/$editor.ll");
				my $ll = <LDATA>;
				close(LDATA);
				$cat=~s/;/<br>/g;
				print PLIST <<END;
<tr>
<td><a href="/profiles/$item.html">$item</a></td>
<td>$onroot&nbsp;</td>
<td>$cat&nbsp;</td>
<td>$onmeta&nbsp;</td>
<td>$ll</td></tr>
END
				$onmeta = "";
				$onroot = "";
				$oneditall = "";
			}
		}
	}

	#Generate Meta/Catmod

	foreach(@edits) {
		$_=~s/.eaddr//g;
		if ($users=~/ $_ /) {
			open(FILE, "$path_data/dirmod.gf");
			my $editalllist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/dirman.gf");
			my $metalist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/root.gf");
			my $rootlist = <FILE>;
			close(FILE);

			my $onmeta = "";
			my $onroot = "";
			my $oneditall = "";
			my $editor = $_;
			my $onlist = 0;
			my $cat = "";

			if ($editalllist=~/ $_ /g) {
				$onlist = 0;
				$oneditall =  "editall";
				open(LDATA, "$path_data/eperm/editall/$_.perm");
				$cat = <LDATA>;
				close(LDATA);
				if ($cat=~/editall/) {
					$cat = "editall";
				} else {
					$cat = "cateditall";
				}
			}

			if ($metalist=~/ $_ /g) {
				$onlist = 1;
				open(LDATA, "$path_data/eperm/meta/$_.perm");
				my $mcat = <LDATA>;
				close(LDATA);
				if ($mcat=~/meta/) {
					$onmeta = "meta";
				} else {
					$onmeta = "catmod";
				}
			}

			if ($rootlist=~/ $_ /g) {
				$onlist = 0;
				$onroot = "root";
			}

			if ($onlist eq "1") {
				if ($onroot eq "root") {
				} else {
					open(LDATA, "$path_data/logs/$editor.ll");
					my $ll = <LDATA>;
					close(LDATA);
					$cat=~s/;/<br>/g;
					print PLIST <<END;
<tr>
<td><a href="/profiles/$_.html">$_</a></td>
<td>$onroot&nbsp;</td>
<td>$cat&nbsp;</td>
<td>$onmeta&nbsp;</td>
<td>$ll</td></tr>
END
					$onmeta = "";
					$onroot = "";
					$oneditall = "";
				}
			}
		}
	}


	#Generate Editall/CatEditall

	foreach(@edits) {
		$_=~s/.eaddr//g;
		if ($users=~/ $_ /) {
			open(FILE, "$path_data/dirmod.gf");
			my $editalllist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/dirman.gf");
			my $metalist = <FILE>;
			close(FILE);
			open(FILE, "$path_data/root.gf");
			my $rootlist = <FILE>;
			close(FILE);

			my $onmeta = "";
			my $onroot = "";
			my $oneditall = "";
			my $editor = $_;
			my $onlist = 0;
			my $cat = "";

			if ($editalllist=~/ $_ /g) {
				$onlist = 1;
				$oneditall =  "editall";
				open(LDATA, "$path_data/eperm/editall/$_.perm");
				$cat = <LDATA>;
				close(LDATA);
				if ($cat=~/editall/) {
					$cat = "editall";
				} else {
					$cat = "cateditall";
				}
			}

			if ($metalist=~/ $_ /g) {
				$onlist = 0;
				open(LDATA, "$path_data/eperm/meta/$_.perm");
				my $mcat = <LDATA>;
				close(LDATA);
				if ($mcat=~/meta/) {
					$onmeta = "meta";
				} else {
					$onmeta = "catmod";
				}
			}

			if ($rootlist=~/ $_ /g) {
				$onlist = 0;
				$onroot = "root";
			}

			if ($onlist eq "1") {
				if (($onroot eq "root") || ($onmeta ne "")) {
				} else {
					open(LDATA, "$path_data/logs/$editor.ll");
					my $ll = <LDATA>;
					close(LDATA);
					$cat=~s/;/<br>/g;
					print PLIST <<END;
<tr>
<td><a href="/profiles/$_.html">$_</a></td>
<td>$onroot&nbsp;</td>
<td>$cat&nbsp;</td>
<td>$onmeta&nbsp;</td>
<td>$ll</td></tr>
END
					$onmeta = "";
					$onroot = "";
					$oneditall = "";
				}
			}
		}
	}


	print PLIST "</table>";

	print PLIST "<br><i>List generated $lt.</i>";

	print "<br>$TS::TS_gdlist_done";
};

UI::writeScriptFooter();
