#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

sub updateLogs {
	my($username, $lt, $who, $action, $what, $reason) = @_;

	Storage::logMetaEdit($username,$who,$action,$what,$reason);

	return 1;
}

sub doGrant {
	my($file, $username, $flag, $lt, $who, $action, $reason) = @_;

	my $users = Storage::getData("global", $file);

	if ($users=~/ $username /) {
		print "$TS::TS_grant_already $flag.<br>";
	} else {
		open(EL, ">>$path_data/$file");
		print EL "$username ";
		close(EL);

		updateLogs($username, $lt, $who, $action, $flag, $reason);
		print "$username $TS::TS_grant_hasnow $flag.<br>\n";
	}

	return 1;
}

my $cgi = new CGI;
my $username = $cgi->param('usn');
my $lt = localtime;
my $who = Editor::currentUser();

if (!defined $username) {
	$username = "";
}

UI::writeHeaderCode();
Editor::writeECode();
Editor::restrictedRoot();

if (defined $cgi->param('action')) {
	my $users = Storage::getData("global", "elist");
	my $reason = $cgi->param('reason');

	if ($users=~/ $username /) {
		if (defined $cgi->param('root')) {
			doGrant("root.gf", $username, "ROOT", $lt, $who, "grant", $reason);
		}

		if (defined $cgi->param('dirmod')) {
			doGrant("dirmod.gf", $username, "EDITALL", $lt, $who, "grant", $reason);
		}

		if (defined $cgi->param('dirman')) {
			doGrant("dirman.gf", $username, "META", $lt, $who, "grant", $reason);
		}
	} else {
		print "$TS::TS_grant_nosuchuser<br>";
	}
} else {
	print <<END;
<font size="5">$TS::TS_grant_title</font><br>
<br>
$TS::TS_grant_note
<br><br>
<form method="post" action="grant.cgi">
  <p><b>$TS::TS_common_username:</b><br>
  <input type="text" name="usn" value="$username" size="20"></p>
  <p><b>$TS::TS_common_reason:</b><br>
  <input type="text" name="reason" size="40"></p>
  <p><b>$TS::TS_grant_superprivs:</b><br>
  <p><input type="checkbox" name="root" value="ON">ROOT</p>
  <p><input type="checkbox" name="dirmod" value="ON">EDITALL</p>
  <p><input type="checkbox" name="dirman" value="ON">META</p>
  <p><input type="submit" value="$TS::TS_common_submit" name="action"></p>
</form>
END
}

UI::writeScriptFooter();
