#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Forum;
use Mailsplit;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

if (!(-d "$path_data/logs")) {
	mkdir "$path_data/logs";
}


# Writes the HTML code required to display the editor's name
#  and his email address (index.cgi only)
# Params: 0
# Returns: 1

sub writeECode2()
{
	my $user = Editor::currentUser();
	my $email = Editor::getEmail($user);
	$email = $collectEmails ? "($email)" : "";
	
	print <<END;
   <tr>
    <td align="left" colspan="3" bgcolor="$UI::dark[$UI::currentskin]">
      <big>
        <font color="$UI::subheading[$UI::currentskin]">
          $TS::TS_common_editor: &nbsp; $user $email</font></big></td>\n</tr>
END

	return 1;
}


sub writeLink {
	my($tmp) = @_;
	
	my $tmp2 = $tmp;
	$tmp2=~s/\//>/g;

	$tmp=~s/\//: /g;

	my @ttt = ("");
	if (open(TT, "$path_sitedata/$tmp2.reviewed")) {
		@ttt = <TT>;
		close(TT);
	}

	my $rd = $ttt[0];
	$rd=~s/[\n\r]//g;

	if ($rd eq "") {
		$rd = 0;
	}

	@ttt = ("");
	if (open(TT, "$path_sitedata/$tmp2.unreviewed")) {
		@ttt = <TT>;
		close(TT);
	}

	my $re = $ttt[0];
	$re=~s/[\n\r]//g;

	if ($re eq "") {
		$re = 0;
	}

	$tmp=~s/_/ /g;
	my $tmpath = $tmp2;
	$tmpath=~s/>/\//g;
	
	$re = ", <font color=\"green\">$re</font>";
	if (!$allowUnreviewed) {
		$re = "";
	}

	return "<li><a href=\"editcat.cgi?cat=$tmpath\">$tmp</a> ($rd$re)</li>";
}

sub locked {
	my($name) = @_;

	if (open(LOCK_LIST, "$path_home/profiles/$name.locked")) {
		my @list = <LOCK_LIST>;
		close(LOCK_LIST);
		for (my $i = 0; $i <= $#list; $i++) {
			my $item = $list[$i];
			$item=~s/[\n\r]//g;
			if ($item ne "") {
				print "<u>$item</u> - by $bold$name$unBold<br>";
	        	}
		}
	}
}


# Calculate Posts Sub
# Add up number of new posts in each forum.
# Pass a comma-delimited list of board IDs.
# An easy way to find a board id is to check the
# link to the board on the forum index for board=boardid

sub calculateNewPosts
{
	my $new_posts = 0;
	my $forum;
	my $cUser = Editor::currentUser();

	if ($YaBB_support == 1) {
		my @check_forums = @_;
		my $session_file = "$Forum::memberdir/$cUser.session.txt";
		my %sessions = ();

		if (-e $session_file) {
			open (INFILE, "$session_file");
			my @session_memory = <INFILE>;
			close(INFILE);
			chomp(@session_memory);

			foreach (@session_memory) {
				my ($thread, $lastpost) = split(/:/);
				$sessions{$thread} = $lastpost;
			}
		}

		foreach $forum (@check_forums) {
			my $board_file = "$Forum::boardsdir/$forum.ttl";
			open(INFILE, "$board_file");
			my $read_line = <INFILE>;
			close(INFILE);
			chomp($read_line);

			my ( $number_threads, $number_posts, @other_data ) = split(/\|/, $read_line);
			if (!exists $sessions{$forum}) {
				$sessions{$forum} = 0;
			}

			my $x = $number_posts - $sessions{$forum};
			$new_posts += $x;
		}
	}

	return $new_posts;
}


#Generate the HTML code dedicated to cateditall/editall tools

sub writeEditallSection
{
	if ($isEditall ne "1") {
		return 1;
	}

	my $titleBox = $TS::TS_index_editalltools;
	my $contentBox = <<END;
      - $TS::TS_index_categories
            <a href="catmv.cgi">$TS::TS_index_categorymove</a>,
            <a href="newcat.cgi">$TS::TS_index_categorynew</a>,
            <a href="delcat.cgi">$TS::TS_index_categorydelete</a>
END
	Editor::displayBox(6, $titleBox, $contentBox);

	return 1;
}


#Generate HTML for search box

sub GenerateSearch {
	if ($allowSearch) {
		print <<HTML_QUOTE;
<hr>
<form action="search.cgi" method="get">
  <div align="center">
    <center>
    <table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="0" wi$
      <tr>
        <td align="left" width="370"><b>$TS::TS_index_search:</b> </td>
      </tr>
      <tr>
        <td align="left" width="370">
        <p align="center"><input size="40" name="search">
        <input type="submit" value="Search"></td>
      </tr>
    </table>
    </center>
  </div>
</form>
HTML_QUOTE
	}
	
	return 1;
}


#Generate the HTML code dedicated to meta tools

sub writeMetaSection
{
	if ($isMeta eq "1") {
		my $newp = 0;
		my $newap = 0;
		my $newr = 0;

		my $titleBox = $TS::TS_index_metatools;
		my $contentBox = "";

		opendir(DIR,"$path_data/nperms");
		my @files = readdir(DIR);
		closedir(DIR);

		chomp(@files);

		foreach (@files) {
			$newp += 1;
		}

		$newp -= 2;

		if ($newp == -2) {
			$newp = 0;
		}

		opendir(DIR,"$path_data/napps");
		@files = readdir(DIR);
		closedir(DIR);

		chomp(@files);

		foreach (@files) {
   			$newap += 1;
		}

		$newap -= 2;

		if ($newap == -2) {
			$newap = 0;
		}

		opendir(DIR,"$path_data/nrins");
		@files = readdir(DIR);
		closedir(DIR);

		chomp(@files);

		foreach (@files) {
        	        $newr += 1;
		}

	        $newr -= 2;

		if ($newr == -2) {
			$newr = 0;
		}

		my $newnom = 0;
                opendir(DIR,"$path_data/eperm/cand/");
                my @noms = readdir(DIR);
                closedir(DIR);
		foreach(@noms) {
			if ($_=~/.nfo$/) {
				$newnom++;
			}
		}

		$TS::TS_logs_profilenotes = lc($TS::TS_logs_profilenotes);

		$contentBox = <<END;
        - <a href="reqedit.cgi?review=newapps">$TS::TS_index_appspending</a> ($newap)<br>
        - <a href="reqedit.cgi?review=newperms">$TS::TS_index_mreqpending</a> ($newp)<br>
        - <a href="reqedit.cgi?review=reinstate">$TS::TS_index_reinstater</a> ($newr)<br>
	- <a href="metalog.cgi">$TS::TS_index_metalog</a><br>
        - <a href="mwarnlog.cgi">$TS::TS_index_ewarnlog</a><br>
        - <a href="gemail.cgi">$TS::TS_index_lookemail</a><br>
        - <a href="edocs.cgi">$TS::TS_index_edocs</a><br>
	- <a href="iplookup.cgi">$TS::TS_index_iplog</a><br>
	- <a href="edmozlist.cgi">$TS::TS_index_edmozlist</a><br>
        - $TS::TS_index_editors
	  <a href="warn.cgi">$TS::TS_index_editorwarn</a>,
	  <a href="reactuser.cgi">$TS::TS_index_reinstate</a>,
	  <a href="rmuser.cgi">$TS::TS_index_remove</a>,
	  <a href="timeout.cgi">$TS::TS_index_timeout</a><br>
        - $TS::TS_index_categories
	  <a href="gcat.cgi">$TS::TS_index_catgrant</a>,
          <a href="rmcat.cgi">$TS::TS_index_catrevoke</a><br>
        - <a href="addtemplate.cgi">$TS::TS_index_templates</a><br>
	- $TS::TS_index_rootlogs:
	  <a href="rootlog.cgi">meta</a>,
	  <a href="pnote.cgi?mode=log">$TS::TS_logs_profilenotes</a><br>
	- <a href="abuse.cgi">$TS::TS_index_reviewabuse</a><br>
	- <a href="candidates.cgi">$TS::TS_index_promote</a> ($newnom)
END
		Editor::displayBox(5, $titleBox, $contentBox);
	}

	return 1;
}


#Generate the HTML code dedicated to root tools

sub writeRootSection
{
	if ($isRoot eq "1") {
		my $titleBox = $TS::TS_index_roottools;
		my $contentBox = <<END;
- <a href="rootindex.cgi">$TS::TS_index_roottools</a><br>
- <a href="gdlist.cgi">$TS::TS_index_gcatlist</a><br>
END
		opendir(DIR,"$path_data/feedback");
		my @files = readdir(DIR);
		closedir(DIR);

		chomp(@files);

		my $newfeed = 0;

		foreach (@files) {
	                $newfeed = $newfeed + 1;
		}

		$OpMail_totalmes = 0;

		Mailsplit::OpMail(Editor::currentUser());

		$newfeed = $newfeed - 3;
		if ($newfeed < 0) {
			$newfeed = 0;
		}

		$contentBox .= <<END;
- <a href=\"feedbackc.cgi\">$TS::TS_index_checkrmail</a> ($newfeed)<br>
- <a href=\"ednotice.cgi\">$TS::TS_index_ednotice</a><br>
- <a href=\"staffemail.cgi\">$TS::TS_index_cse</a><br>
- <a href=\"email.cgi\">$TS::TS_index_checkemail</a><br>
- <a href=\"email.cgi?act=comp\">$TS::TS_index_comp</a>
END

		if ($OpMail_totalmes eq 1) {
			$contentBox .= "($OpMail_totalmes $TS::TS_index_newm)";
		} else {
			$contentBox .= "($OpMail_totalmes $TS::TS_index_newm2)";
		}

		Editor::displayBox(7, $titleBox, $contentBox);
	}

	return 1;
}


#Generate the HTML code dedicated to editall top-level category links

sub writeEditallLinks
{
	if ($isFullEditall ne "1") {
		return 1;
	}

	print <<END;
      <table width="100%" border="0" cellspacing="0" cellpadding="4">
        <tr><td height="26">
            <hr noshade size="1">
            $bold$TS::TS_index_caneditalso:$unBold
	</td></tr>
        <tr valign="top"><td>
            <table width="100%" align="center">
              <tbody><tr><td>
END

	my $cc = Storage::getData("global", "tlc.lc");

	$cc=~s/[\n\r]//g;
	my @cc = split('; ', $cc);

	my $nr = $#cc;
	my $i = $nr / 2;

	for (my $d = "0"; $d <= $i; $d++) {
		print writeLink($cc[$d]);
	}

	my $rr = $i;
	while ($rr >= 1) {
		$rr--;
	}

	if ($rr > 0) {
		$i += 0.5;
	} else {
		$i++;
	}

	print "</td><td>";

	for (my $d = $i; $d <= $#cc; $d++) {
		print writeLink($cc[$d]);
	}

	print <<END;
           </td></tr>
              </tbody></table>
          </td></tr>
      </table>
END

	return 1;
}

UI::writeHeaderCode($TS::TS_index_eddash);

my $cUser = Editor::currentUser();

open(LLO, ">$path_data/logs/$cUser.ll");
my $lt = localtime;
print LLO "$lt";
close(LLO);

my @motd = ("");
if (open(MOTD, "$path_data/motd")) {
	@motd = <MOTD>;
	close(MOTD);
}

print <<END;
</center>
<table cellPadding="4" border="0" width="100%" align="center" border="0" cellspacing="0">
  <tbody>
END

writeECode2();

print <<END;
  <tr>
    <td align="left" width="20%" valign="top" bgcolor="$UI::lightest[$UI::currentskin]">
END

my $metaArea = "";

if (open(TT, "$path_data/eperm/meta/$cUser.perm")) {
	$metaArea = <TT>;
	close(TT);
}

if ($isRoot eq "1") {
	$metaArea = "meta";
}

$metaArea=~s/[\n\r]//g;

my @totals;
my @forumDef = split("\n", Storage::getData("global", "forums"));
if ($#forumDef < 0) {
	@forumDef = (0);
}

for (my $d = $forumDef[0] + 1; $d <= $#forumDef; $d++) {
	$forumDef[$d] =~ /^([^ ]*) (.*)$/;
	$totals[$1] += calculateNewPosts($2);
}

my $contentBox = "";

for (my $d = 1; $d <= $forumDef[0]; $d++) {
	if ($forumDef[$d] =~ /^([^ ]*) ([^ ]*) (.*)$/) {
		if (($3 eq "isEditor") ||
		    (($3 eq "isEditall") && ($isEditall eq "1")) ||
		    (($3 eq "isCatmod") && ($isMeta eq "1")) ||
		    (($3 eq "isMeta") && ($FullMeta eq "1")) ||
		    (($3 eq "isRoot") && ($isRoot eq "1"))) {
			$totals[0] += $totals[$d];
			$contentBox .= <<END;
- <a href="$Forum::boardurl/$2">$1 ($totals[$d])</a><br>
END
		}
	}
}

my $titleBox;

if ($YaBB_support == 1) {
	$titleBox = <<END;
<a href=\"$Forum::boardurl/YaBB.cgi\">
  <font color=\"$UI::subheading[$UI::currentskin]\">
    $TS::TS_index_forums ($totals[0])
  </font>
</a>
END
	Editor::displayBox(1, $titleBox, $contentBox);
}

$titleBox = $TS::TS_index_guidelines;
$contentBox = <<END;
- <a href="$path_on_server/$TS::TS_index_guidelineslink">$TS::TS_index_geditor</a><br>
END

if ($isEditall eq "1") {
	$contentBox .= "- <a href=\"$path_on_server/$TS::TS_index_editallguidelineslink\">$TS::TS_index_geditall</a><br>";
}

if ($isMeta eq "1") {
	$contentBox .= "- <a href=\"$path_on_server/$TS::TS_index_metaguidelineslink\">$TS::TS_index_gmeta</a><br>";
}

$contentBox .= "- <a href=\"$path_on_server/$TS::TS_index_opencontractlink\">$TS::TS_index_opencontract</a>";

Editor::displayBox(2, $titleBox, $contentBox);

$titleBox = $TS::TS_index_logs;

$contentBox = <<END;
 <form method="GET" action="logs.cgi">
 $bold $TS::TS_index_editorname $unBold<br><input size="18" name="name">
 <select name="what"><br>
 <option value="1">$TS::TS_index_editdetail</option>
 <option value="2">$TS::TS_index_catrequests</option>
 <option value="4" selected>$TS::TS_index_profile</option>
 <option value="8">$TS::TS_index_statistics</option>
 </select>
 <input type="submit" value="$TS::TS_index_viewlogs"> </p>
 </form>
- <a href="catmvlog.cgi">$TS::TS_index_catmvlog</a><br>
- <a href="warnlog.cgi">$TS::TS_index_warnlog</a><br>
- <a href="allcats.cgi">$TS::TS_common_allcats</a><br>
- <a href="stats.cgi">$TS::TS_index_alleds</a><br>
- $TS::TS_index_rootlogs: <a href="editrootlog.cgi">edits</a>
END

Editor::displayBox(3, $titleBox, $contentBox);

#Not supported yet.
#if ($isRoot eq "1") {
#	$titleBox = $TS::TS_index_resources . " [<a href=\"edresources.cgi\"><font color=\"$UI::subheading[$UI::currentskin]\">$TS::TS_index_edit</font></a>]";
#} else {
	$titleBox = $TS::TS_index_resources;
#}

$contentBox = <<END;
- <a href="$path_on_server/Test/">$TS::TS_index_testarea</a><br>
- <a href="$path_on_server/Test/How_To/">$TS::TS_index_howto</a><br>
- <a href="$path_on_server/Test/Help/">$TS::TS_index_help</a><br>
- <a href="$path_on_server/newsletter/">$TS::TS_index_newsletter</a>
END

Editor::displayBox(4, $titleBox, $contentBox);

print <<END;
        </td>
        <td align="left" height="106" width="50%" valign="top">
          <table width="100%" border="0" cellspacing="0" cellpadding="4">
            <tr>
              <td>
END

if (open(INFILE, "$path_data/noton")) {
	my $noton = <INFILE>;
	close(INFILE);

	if (($noton eq "1") && (open(INFILE, "$path_data/notice"))) {
		my @notice = <INFILE>;
		close(INFILE);

		my $x = -1;
		my $y = $#notice;

		while ($x ne $y) {
			$x++;
			$notice[$x]=~s/\n/<br>/g;
		}

		print <<END;
<table cellpadding="2" cellspacing="1" border="1" width="100%">
  <tbody><tr>
      <td valign="Top" bgcolor="#ff6666"><b>$TS::TS_index_notice</b><br>
      </td>
  </tr><tr>
      <td valign="Top" bgcolor="#ffcccc">@notice<br>
      </td>
    </tr></tbody>
</table><br>
END
	}
}

print <<END;
$bold$TS::TS_index_currentcats:$unBold</td></tr><tr><td>
END

# Edit where?

my $ucat = "";
if (open(EL, "$path_data/eperm/$cUser.perm")) {
	$ucat = <EL>;
	close(EL);
}

print "<ul>";

my @cCats;

if ($ucat ne "") {
	my $uct = substr($ucat, 0, 1);
	my $uct2 = "";
	my $ind = 1;
	my $subcats = 0;
	my $tmp2;

	while ($uct ne $ucat) {
		$uct = $uct . substr($ucat, $ind, 1);
		$uct2 = $uct2 . substr($ucat, $ind, 1);
		if ($uct2 eq " ") {
			$uct2 = "";
		}
		++$ind;

		if (substr($ucat, $ind, 1) eq ";") {
			$tmp2 = $uct2;
			$uct2=~s/>/\//g;

			push(@cCats, writeLink($uct2));
			$uct2 = "";
			$uct = $uct . substr($ucat, $ind, 1);
			++$ind;
	        }
	}
}

my($c, $d, $item);

@cCats = sort {
	($c) = $a=~/<li><a href=\"editcat\.cgi\?cat=.*?\">(.*?)<\/a>/;
	($d) = $b=~/<li><a href=\"editcat\.cgi\?cat=.*?\">(.*?)<\/a>/;
	$c cmp $d;
} (@cCats);

foreach $item (@cCats) {
	print $item;
}

opendir(DIR,"$path_data/nperms/");
my @edits = readdir(DIR);
closedir(DIR);

print "<br>";

foreach(@edits) {
	if (open(NOOT, "$path_data/nperms/$_")) {
		my @napps2 = <NOOT>;
		close(NOOT);

		if (($#napps2 > 0) && ($napps2[1]=~/$cUser/)) {
			$napps2[0]=~s/\>/\//g;
			print "<br>$TS::TS_index_reqpending<br><b><ul><li>$napps2[0]</li></ul></b>";
		}
	}
}

print "</ul></td></tr></table>\n";

if ($isRoot eq "1") {
	print "<p>$TS::TS_index_lockedfiles<br>";

	open(FILE, "$path_data/root.gf");
	my $roots = <FILE>;
	close(FILE);

	my @roots = split(" ", $roots);
	for (my $d = 1; $d <= $#roots; $d++) {
		if ($roots[$d] ne "") {
			locked($roots[$d]);
		}
	}

	print "$TS::TS_index_endlist [<a href=\"lockfiles.cgi\">$TS::TS_index_edit</a>]<br><br>";
}

print <<END;
<b>$TS::TS_index_todolist: </b> - <a href="edtodo.cgi">$TS::TS_index_edit</a>
END

if (open(TO_DO, "$path_home/profiles/$cUser.dnote")) {
	my @dcomments = <TO_DO>;
	close(TO_DO);
	
	my $dcom = join("<br>", @dcomments);
	print <<END;
<br>

$dcom
<p>
END
}

writeEditallLinks();

print <<END;
<hr>
<b><a href="../img/$cUser/">$TS::TS_index_mypics</a></b><hr>
<form action="upload.cgi" method="post" enctype="multipart/form-data">
$TS::TS_index_imgsdonot
<p>
<b>$TS::TS_index_uploadpic:</b>
<br><input type="file" name="photo">
<input type="submit" name="Submit" value="$TS::TS_common_upload">
</form>

END

# check for 'real' root permissions...
my($isRealRoot);

open(ROOT, "$path_data/root.gf");
my $root = <ROOT>;
close(ROOT);

my $noroot = $cgi->param('noroot');
if (!defined $noroot) {
	$noroot = "";
}

if ((($root=~/ $cUser /) || ($root=~/ ~$cUser /) || ($cUser eq "")) && ($noroot ne "1")) {
	$isRealRoot = "1";
} else {
	$isRealRoot = "0";
}

GenerateSearch();

if ($isRealRoot eq "1") {
	print <<END;
<hr>
<b>$TS::TS_index_roots</b> <a href="chprivs.cgi">$TS::TS_index_changeprivs</a><br>

END
}


print <<END;
      </td>
      <td valign="top" align="left" width="30%" bgcolor="$UI::lightest[$UI::currentskin]" height="4">
END

$titleBox = "$TS::TS_index_motd";

if ($isRoot eq "1") {
	$titleBox .= " [<a href=\"edmotd.cgi\"><font color=\"$UI::subheading[$UI::currentskin]\">$TS::TS_index_edit</font></a>]";
}

$contentBox = join("", @motd);

Editor::displayBox(8, $titleBox, $contentBox);

writeEditallSection();
writeMetaSection();
writeRootSection();

$titleBox = $TS::TS_index_editortools;

my $bi;
if ($YaBB_support == 1) {
	my @root = ();
	
	if (open(ROOT, "$Forum::memberdir/$cUser.msg")) {
		@root = <ROOT>;
		close(ROOT);
	}

	if (@root > 0) {
		$bi = "<b><i>$TS::TS_index_checkmail</i></b> (" . ++$#root . ")";
	} else {
		$bi = "$TS::TS_index_checkmail";
	}
}

$contentBox = <<END;
- <a href="feedback.cgi">$TS::TS_index_edfeedback</a><br>
- <a href="edpics.cgi">$TS::TS_index_edpics</a><br>
- <a href="edprofile.cgi">$TS::TS_index_changeprofile</a><br>
- <a href="chpass.cgi">$TS::TS_index_changepass</a><br>
END

if ($allowPolls) {
	$contentBox .= <<END;
- <a href="poll.cgi">$TS::TS_index_polls</a><br>
END
}

$contentBox .= <<END;
- <a href="dirmods.cgi">$TS::TS_index_listeditalls</a><br>
END

if ($YaBB_support == 1) {
	$contentBox .= <<END;
- $TS::TS_index_mail <a href="$Forum::boardurl/YaBB.cgi?board=;action=im">$bi</a>,
  <a href="$Forum::boardurl/YaBB.cgi?board=;action=imsend">$TS::TS_index_sendmail</a><br>
END
}

$contentBox .= <<END;
- $TS::TS_index_categories <a href="rncat.cgi">$TS::TS_index_catrequest</a>,
        <a href="rcat.cgi">$TS::TS_index_catresign</a><br>
- <a href="abuse.cgi?action=report">$TS::TS_index_reportabuse</a><br>
- <a href="resign.cgi">$TS::TS_index_acresign</a><br>
END

Editor::displayBox(9, $titleBox, $contentBox);

print <<END;
        </td>
      </tr>
      <tr bgcolor="$UI::darkest[$UI::currentskin]">
        <td align="left" colspan="3" height="2" valign="top">
          <font face="Arial, Helvetica, sans-serif" size="-2">
            <font color=$UI::lightest[$UI::currentskin]>
              Copyright &copy; $HD_name
            </font>
          </font>
        </td>
      </tr>
    </tbody>
    </table>
  </body>
</html>
END
