#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $IP = $cgi->param('IP');
my $editor = $cgi->param('editor');
my $print = $cgi->param('print');

UI::writeHeaderCode($TS::TS_iplookup_title);
Editor::writeECode();
Editor::restrictedMeta();

my $rlog;

if (($IP eq "") && ($editor eq "")) {
	print <<END;
<p><font size="5">$TS::TS_iplookup_title</font></p>
<form method="GET" action="iplookup.cgi">
  <p>$TS::TS_iplookup_ip:<br>
  <input type="text" name="IP" size="20"><input type="submit" value="$TS::TS_iplookup_lookup"></p>
</form>
<form method="GET" action="iplookup.cgi">
  <p>$TS::TS_iplookup_un:<br>
  <input type="text" name="editor" size="20"><input type="submit" value="$TS::TS_iplookup_lookup"></p>
</form>
END
}

if ($editor ne "") {
	print "<p>IP LOG ==&gt; <a href=\"iplookup.cgi?editor=$editor&print=1\">iplookup.cgi?editor=$editor&amp;print=1</a> $TS::TS_iplookup_rctd</p>";

	if ($print eq 1) {
		print "<pre>";
		$rlog = `cat $path_data/logs/webaccess/access.log | grep " $editor "`;
		$rlog=~s/\n/<br>/g;
                print $rlog;
		print "</pre>";
	}
}

if ($IP ne "") {
	print "<p>IP LOG: <a href=\"iplookup.cgi?IP=$IP&print=1\">iplookup.cgi?IP=$IP&amp;print=1</a> $TS::TS_iplookup_rctd</p>";

	if ($print eq 1) {
		print "<pre>";
		$rlog = `cat $path_data/logs/webaccess/access.log | grep "$IP -"`;
		$rlog=~s/\n/<br>/g;
                print $rlog;
		print "</pre>";
	}
}

UI::writeScriptFooter();
