#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $action = $cgi->param('action');
my $note = $cgi->param('note');

if ($action ne "") {
	print "Status: 302 Moved\n";
	print "Location: ./\n\n";
}

UI::writeHeaderCode("Staff Lock Files");
Editor::writeECode();
Editor::restrictedRoot();

my(@dcomments, $file, $dcomments);

if ($action ne "") {
	Storage::setData('editor', $ENV{REMOTE_USER}, 'locked', $note);
	
	print "List of locked files updated."
} else {
	$note = Storage::getData('editor', $ENV{REMOTE_USER}, 'locked');

	print <<END;
<form method="post" action="lockfiles.cgi">
<input type="hidden" name="action" value="save">
<b>Locked files and directories (one per line):</b><br>

<p>Note: you should lock files when you plan to make wide changes to a certain file or directory. If you plan to add a new file, there is no need to use this system. If you like to add an additional portion of code to an existing file, I suggest to write that additional code in a separate file, and when finished, download the file, modify it and reupload it within 1 minute (if possible), in order to prevent the overwritting. If you plan to work on a file for more than 5 minutes, you should use this system. Mark the file as been used here, download it, modify it and upload it back. Do not forget to eliminate files/directories from this list after finishing updating them. Thanks.</p>

<textarea name="note" rows="5" cols="70">$note</textarea><br>
<input type="submit" value="Save">
</form>
END
}

UI::writeScriptFooter();
