#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use EditorProfile;
use Logs;
use Settings;
use TS;
use UI;

sub translateActions {
	my($rlog) = @_;

	# localization of meta edits
	$rlog=~s/##!## join #!#/##!## $TS::TS_logs_join #!#/g;
	$rlog=~s/##!## accept #!#/##!## $TS::TS_logs_accept #!#/g;
	$rlog=~s/##!## decline #!#/##!## $TS::TS_logs_decline #!#/g;
	$rlog=~s/##!## grant #!#/##!## $TS::TS_logs_grant #!#/g;
	$rlog=~s/##!## remove #!#/##!## $TS::TS_logs_remove #!#/g;
	$rlog=~s/##!## revoke #!#/##!## $TS::TS_logs_revoke #!#/g;
	$rlog=~s/##!## reject #!#/##!## $TS::TS_logs_reject #!#/g;

	return $rlog;
}


my $cgi = new CGI;
my $name = $cgi->param('name');
my $what = $cgi->param('what');

my $editor = $name;
my $enamel = $name;

my (@radp, $rlog, @rlog2, $d, $ook, $action, $edit, $cat, $ncat, $time, @edits, $total);
my (@rapp, $start, $osize, $end, $endEntry, $size, @profile, $llog, $num, @rlog, @rlog3);

UI::writeHeaderCode("$TS::TS_logs_logs");

if ($name eq "") {
	print <<END;
<div align="center">
  <center>
  <p><font size="5">$TS::TS_logs_editinglogs</font></p>
  <table cellSpacing="0" cellPadding="5" bgColor="#cccccc" border="0">
    <tr>
     <form method="GET" action="logs.cgi">
      <td><b>$TS::TS_logs_editorname</b>&nbsp;<input size="40" name="name" maxsize="256">
      <select name="what">
      <option value="1">$TS::TS_logs_editdetail</option>
      <option value="2">$TS::TS_logs_catrequests</option>
      <option value="3">$TS::TS_logs_metaeditlogs</option>
      <option value="4" selected>$TS::TS_logs_profile</option>
      <option value="8">$TS::TS_logs_statistics</option>
      </select> </td>
    </tr>
  </table>
  <p><input type="submit" value="$TS::TS_logs_viewlogs"> </p>
  </form>
  </center>
</div>
END
} else {
	$name = Editor::validateEditor($name);

	Logs::loghead($name);
	EditorProfile::editorInfo($name);
	Logs::genFeedback($name);

	if ($what eq "8") {
		# @rlog = `cat $path_data/logs/rootlog/comeditlog.log | grep "##!!## $name "`;

		open(META, "$path_data/logs/rootlog/comeditlog.log");
		# @rlog2 = <META>;
		# @rlog = grep { index $_, "##!!## $name " } <META>;
		@rlog = grep { /##!!## $name / } <META>;
		close(META);
		# @rlog = grep { /##!!## $name / } @rlog2;

		$num = 0;
		chomp(@rlog);
		foreach (@rlog) {
			$num = $num + 1;
		}

		my $totaledits = $num;

		#@rlog = `cat $path_data/logs/rootlog/comeditlog.log | grep "##!!## $name " |grep "new #!# ##!## category"`;

		open(META, "$path_data/logs/rootlog/comeditlog.log");
		@rlog3 = <META>;
		close(META);
		@rlog2 = grep { /##!!## $name / } @rlog3;
		@rlog = grep { /new #!# ##!## category/ } @rlog2;

		$num = 0;
		chomp(@rlog);

		foreach (@rlog) {
			$num = $num + 1;
		}

		my $totalnewcats = $num;

		#@rlog = `cat $path_data/logs/rootlog/comeditlog.log | grep "##!!## $name " |grep "delete #!# ##!## category"`;

		open(META, "$path_data/logs/rootlog/comeditlog.log");
		@rlog3 = <META>;
		close(META);
		@rlog2 = grep { /##!!## $name / } @rlog3;
		@rlog = grep { /delete #!# ##!## category/ } @rlog2;

		$num = 0;
		chomp(@rlog);
		foreach (@rlog) {
			$num = $num + 1;
		}

		my $totaldelcats = $num;

		#@rlog = `cat $path_data/logs/rootlog/comeditlog.log | grep "##!!## $name " |grep "edit #!# ##!## section"`;

		open(META, "$path_data/logs/rootlog/comeditlog.log");
		@rlog3 = <META>;
		close(META);
		@rlog2 = grep { /##!!## $name / } @rlog3;
		@rlog = grep { /edit #!# ##!## section/ } @rlog2;

		$num = 0;
		chomp(@rlog);
		foreach (@rlog) {
			$num = $num + 1;
		}
		my $totalseccats = $num;

		#@rlog = `cat $path_data/logs/rootlog/comeditlog.log | grep "##!!## $name " |grep "edit #!# ##!## modify"`;

		open(META, "$path_data/logs/rootlog/comeditlog.log");
		@rlog3 = <META>;
		close(META);
		@rlog2 = grep { /##!!## $name / } @rlog3;
		@rlog = grep { /edit #!# ##!## modify/ } @rlog2;

		$num = 0;
		chomp(@rlog);
		foreach (@rlog) {
			$num = $num + 1;
		}
		my $totalpageedits = $num;

		print <<END;
<table border="1" cellspacing="1" width="258" id="AutoNumber1">
  <tr>
    <td width="144">$TS::TS_logs_total</td>
    <td width="114">$TS::TS_logs_edits</td>
  </tr>
  <tr>
    <td width="144">$TS::TS_logs_edits</td>
    <td width="114">$totaledits</td>
  </tr>
  <tr>
    <td width="144">$TS::TS_logs_newcats</td>
    <td width="114">$totalnewcats</td>
  </tr>
  <tr>
    <td width="144">$TS::TS_logs_delcats</td>
    <td width="114">$totaldelcats</td>
  </tr>
  <tr>
    <td width="144">$TS::TS_logs_pageedits</td>
    <td width="114">$totalpageedits</td>
  </tr>
  <tr>
    <td width="144">$TS::TS_logs_sectionedits</td>
    <td width="114">$totalseccats</td>
  </tr>
</table>
END
		if ($isMeta eq "1") {
			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name "`;

			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog = grep { /##!!## $name / } @rlog3;
			#@rlog = grep { /new #!# ##!## category/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalmetaedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name " | grep "##!## join #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## join #!#/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}

			my $totalmetanewappjoinedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name " |grep "##!## accept #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## accept #!#/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalmetaacceptedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name" |grep "##!## decline #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## decline #!#/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalmetadeclineedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name " | grep "##!## grant #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## grant #!#/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalmetagrantedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name " | grep "##!## remove #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## remove #!#/ } @rlog2;

			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalremoveedits = $num;

			#@rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $name " | grep "##!## revoke #!#"`;
			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog3 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $name / } @rlog3;
			@rlog = grep { /##!## revoke #!#/ } @rlog2;
			$num = 0;
			chomp(@rlog);
			foreach (@rlog) {
				$num = $num + 1;
			}
			my $totalrevokeedits = $num;

			print <<END;
<p>
<table border="1" cellspacing="1" width="280" id="AutoNumber1" height="144">
  <tr>
    <td width="173" height="19">$TS::TS_logs_total</td>
    <td width="174" height="19">$TS::TS_logs_edits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_metaedits</td>
    <td width="174" height="19">$totalmetaedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_newappjoins</td>
    <td width="174" height="19">$totalmetanewappjoinedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_accepted</td>
    <td width="174" height="19">$totalmetaacceptedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_declined</td>
    <td width="174" height="19">$totalmetadeclineedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_granted</td>
    <td width="174" height="19">$totalmetagrantedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_removed</td>
    <td width="174" height="19">$totalremoveedits</td>
  </tr>
  <tr>
    <td width="173" height="19">$TS::TS_logs_revoked</td>
    <td width="174" height="19">$totalrevokeedits</td>
  </tr>
</table>
END
		}
	}

	if ($what eq "4") {
		open(INFILE, "$path_home/profiles/$name.html");
		@profile = <INFILE>;
		close(INFILE);
		open(EL, "$path_data/logs/$name.ll");
		$llog = <EL>;
		close(EL);
		print "<b>$TS::TS_logs_lastlogin</b> $llog<hr>";
		print UI::safeHTML(join("", @profile));
	}

	if ($what eq "1") {
		print <<END;
<H1>$TS::TS_logs_alleditlog</H1><hr>
END
		open(META, "$path_data/logs/rootlog/comeditlog.log");
		@rlog2 = <META>;
		close(META);
		@rlog2 = grep { / $editor / } @rlog2;

		$start = $cgi->param('start');
		if ($start eq "") {
			$start = 1;
		}

		$size = $cgi->param('size');
		if ($size eq "") {
			$size = 100;
		}
		$osize = $size;

		if ($start > $#rlog2 + 1) {
			$start = $#rlog2;
		}

		if ($start + $size - 1 > $#rlog2 + 1) {
			$size = $#rlog2 + 2 - $start;
		}

		$end = $start + $size - 1;
		$total = $#rlog2 + 1;

		if ($start < 1) {
			$start = 1;
		}

		print "<p>$TS::TS_common_displaying $start $TS::TS_common_to $end... ($TS::TS_common_fromatotal $total)<br>";
		if ($start != 1) {
			print "<a href=\"logs.cgi?name=$editor&what=1&start=";
			print 1;
			print "\">[$TS::TS_common_start]</a> ";
		}
		if ($start >= $osize) {
			print "<a href=\"logs.cgi?name=$editor&what=1&start=";
			print $start - $osize;
			print "\">[$TS::TS_common_prev]</a> ";
		}
		if ($end < $#rlog2) {
			print "<a href=\"logs.cgi?name=$editor&what=1&start=";
			print $start + $osize;
			print "\">[$TS::TS_common_next]</a> ";
		}
		$endEntry = $total;
		if ($total != 0) {
			while ($endEntry - 1!= int($endEntry / $osize) * $osize) {
				$endEntry--;
			}
		} else {
			$endEntry = $start;
		}
		if ($start != $endEntry) {
			print "<a href=\"logs.cgi?name=$editor&what=1&start=";
			print $endEntry;
			print "\">[$TS::TS_common_end]</a> ";
		}
		if (!(($start == 1) && ($end == $total))) {
			print "<a href=\"logs.cgi?name=$editor&what=1&start=1&size=$total\">[$TS::TS_common_all]</a>";
		}
		print "</p>";

		print "<table><tr bgcolor=\"#eeeeee\"><td>$TS::TS_common_time</td><td>$TS::TS_common_category</td><td>$TS::TS_common_action</td><td>$TS::TS_common_object</td><td>$TS::TS_common_details</td></tr>";

		$start--;
		$end--;

		for ($d = $start; $d <= $end; $d++) {
			$rlog = $rlog2[$d];
			if ($rlog=~/##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# {1,}##!## (.*?) {1,}#!# ##!!!## (.*?) (.*?) ##!!!!##/) {
				$editor = $1;
				$time = $2;
				$action = $3;
				$what = $4;
				$cat = $5;
				$edit = $6;

				if ($cat eq "Uploaded") {
					$cat = "img/$editor/$edit";
				}
	
				#Workaround for previous buggy logging
				if ($cat=~/^'(.*)'$/) {
					$cat = $1;
				}

				$ncat = UI::getNiceFormat($cat);
				$cat=~s/>/\//g;
				$edit =~s/ - //g;
				$edit =~s/- //g;
				$edit =~s/unreviewed//g;
				if ($edit=~/^[0-9]*$/) {
					$edit = "<a href=\"viewedit.cgi?num=$edit\">[$TS::TS_common_view]</a>";
				} else {
					$edit=~s/>/\//g;
					$edit=~s/_/ /g;
				}

				print "<tr bgcolor=\"#f8f8f8\"><td>$time</td><td><a href=\"/$cat\">$ncat</a></td><td>$action</td><td>$what</td><td>$edit</td></tr>";
			}
		}

		print "</table>";
	}

	if ($what eq "2") {
		print <<END;
<H1>$TS::TS_logs_reqlog</H1><hr>
<table border="1" id="AutoNumber1" cellpadding="2">
  <tr>
    <td>$TS::TS_logs_date</td>
    <td>$TS::TS_logs_who</td>
    <td>$TS::TS_logs_action</td>
    <td>$TS::TS_logs_comments</td>
  </tr>
END

		#$rlog = `cat $path_data/logs/rootlog/areqeditlog.log | grep "##!!## $editor "`;

		open(META, "$path_data/logs/rootlog/areqeditlog.log");
		@rlog2 = <META>;
		close(META);
		@rlog2 = grep { /##!!## $editor / } @rlog2;
		for ($d = 0; $d <= $#rlog2; $d++) {
			$rlog = "$rlog $rlog2[$d]";
			#print $rlog2[$d];
		}

		$rlog = translateActions($rlog);

	        $rlog=~s/\>/\//g;
		$rlog=~s/ ##!!## $editor/ /g; #<td bgcolor="#CCCCCC"> /g;
		$rlog=~s/ \#!\#/ <\/td> /g;
		$rlog=~s/ \#\#!\#\#/ <td> /g;
		$rlog=~s/ \#\#!!!\#\# / <td> /g;
		$rlog=~s/ \#\#!!!!\#\# / <\/td><\/tr> /g;

		opendir(DIR, "$path_data/misc/");
		@edits = readdir(DIR);
		closedir(DIR);

		chomp(@edits);
		foreach (@edits) {
			if ($_=~/.eaddr/) {
				$_=~s/.eaddr//g;

				if ($isMeta ne "1") {
					$rlog=~s/ $TS::TS_logs_hidden - $_ / - /g;
				}

				$ook = "<a href=\"./profile.cgi?editor=$_\">$_</a>";
				$rlog=~s/ $_ / $ook /g;
			}
		}

		opendir(DIR, "$path_sitedata/");
		@edits = readdir(DIR);
		closedir(DIR);

		chomp(@edits);
		foreach (@edits) {
			if ($_=~/.html/) {
				$_=~s/.html//g;
				$_=~s/\>/\//g;
				$ook = " <a href=\"./editcat.cgi?cat=$_\">$_</a> ";
				$rlog=~s/ $_ /$ook/g;
			}
		}

		print $rlog;
		print "</table>";
	}

	if ($what eq "3") {
		if ($isMeta eq "1") {
			print <<END;
<H1>$TS::TS_logs_metaeditorlog</H1><hr>
<table border="1" id="AutoNumber1" cellpadding="2">

  <tr>
    <td bgcolor="#CCCCCC">$TS::TS_logs_meta</td>
    <td>$TS::TS_logs_date</td>
    <td>$TS::TS_logs_editor</td>
    <td>$TS::TS_logs_action</td>
    <td>$TS::TS_logs_comments</td>
  </tr>
END

			#$rlog = `cat $path_data/logs/rootlog/ametalog.log | grep "##!!## $editor "`;

			open(META, "$path_data/logs/rootlog/ametalog.log");
			@rlog2 = <META>;
			close(META);
			@rlog2 = grep { /##!!## $editor / } @rlog2;
			for ($d = 0; $d <= $#rlog2; $d++) {
				$rlog = "$rlog $rlog2[$d]";
			}

			$rlog = translateActions($rlog);

			$rlog=~s/#\#!!#\#/ <tr><td bgcolor="#CCCCCC"> /g;
		        $rlog=~s/ \#!\#/ <\/td> /g;
		        $rlog=~s/ ##!## / <td> /g;
		        $rlog=~s/\#\#!!!\#\# / <td> /g;
		        $rlog=~s/ ##!!!!\##/ <\/td><\/tr> /g;

			print $rlog;
			print "</table>";
		}
	}

	if ($what eq "6") {
		if ($isMeta eq "1") {
			open(DCATS, "$path_data/napps/$name.req");
			@rapp = <DCATS>;
			close(DCATS);

			$rapp[0]=~s/\n//g;
			$rapp[1]=~s/\n//g;
			$rapp[2]=~s/\n//g;
			$rapp[3]=~s/\n//g;
			$rapp[4]=~s/\n//g;
			$rapp[5]=~s/\n//g;

			print <<END;

<H1>$TS::TS_logs_editorapplication</H1><table border="1" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber1" bgcolor="#111111">
  <tr>
    <td width="100%"><font size="5" color="#FFFFFF">$TS::TS_logs_editorapplication</font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#CCCCCC"><font face="Courier" size="5">$TS::TS_logs_editorname: $rapp[1]</font><tr>
    <td width="100%" bgcolor="#CCCCCC"><font face="Courier">$TS::TS_logs_category 
    <a href="editcat.cgi?cat=$rapp[0]">$rapp[0]</a></font><tr>
    <td width="100%" bgcolor="#CCCCCC"><font face="Courier">$TS::TS_logs_email $rapp[2]</font><tr>
    <td width="100%" bgcolor="#CCCCCC"><font face="Courier">$TS::TS_logs_ipaddress
    <a href="iplookup.cgi?IP=$rapp[4]">$rapp[4]</a></font><tr>
    <td width="100%" bgcolor="#CCCCCC"><font face="Courier">$TS::TS_logs_reason<br>
    $rapp[5]$rapp[5]$rapp[7]$rapp[8]$rapp[9]$rapp[10]$rapp[11]$rapp[12]$rapp[12]$rapp[14]$rapp[15]
    $rapp[16]$rapp[17]$rapp[18]$rapp[19]$rapp[20]$rapp[21]$rapp[22]$rapp[23]$rapp[24]$rapp[25]
    $rapp[26]$rapp[27]$rapp[28]$rapp[29]$rapp[30]$rapp[31]$rapp[32]$rapp[33]$rapp[34]$rapp[35]</font>

END
		}
	} else {
		print "";
	}
}

UI::writeScriptFooter();
