#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;
use DBI;

use lib '.';
use Include;
use Editor;
use Settings;
use SQL;
use TS;
use UI;

my $cgi = new CGI;
my $query = $cgi->param('query');

UI::writeHeaderCode();
Editor::restrictedMeta();

print "<H2>$TS::TS_logsearch_title</H2>";

UI::writeStartForm();
UI::writeInputItemForm($TS::TS_common_content, "text", "query");
UI::writeEndForm();

if ($query eq "") {
	print $TS::TS_logsearch_empty;
	UI::writeScriptFooter();
	exit(0);
} else {
	print $TS::TS_logsearch_searching . " $query...<br>";
}

my $dbh = DBI->connect ("DBI:mysql:$sqldbname:$sqlserver", $sqlusername, $sqlpassword);
if (!$dbh) {
         print "Error connecting to database: $DBI::errstr\n";
}


my $sth = $dbh->prepare("select * from edits where curcont LIKE '%$query%'") || die print "Darn, there is an error. Error: $DBI::errstr";
$sth->execute || die print "Darn, there is an error. Error: $DBI::errstr";

while (my @array = $sth->fetchrow_array) {
	my ($cat, $edit, $editor, $date, $null, $content, $ip) = @array;

	$cat=~s/\>/\//g;
	print <<END;
<table border="0">
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_common_editor</strong></td>
    <td><a href="profile.cgi?editor=$editor">$editor</a></td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_common_category</strong></td>
    <td><a href="http://$HD_domain$path_on_server/$cat">$cat</a></td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>IP</strong></td>
    <td>$ip</td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_logs_date</strong></td>
    <td>$date</td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_logs_viewedit</strong></td>
    <td><a href="viewedit.cgi?num=$edit">$edit</a></td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_common_content</strong></td>
    <td>$content</td>
  </tr>
</table>
<br>
END
}
 
$dbh->disconnect();

UI::writeScriptFooter();
