#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $ename = $cgi->param('name');
my $list = $cgi->param('list');
my $editor = $ename;

UI::writeHeaderCode("$ename - $TS::TS_metalog_title");
Editor::restrictedMeta();

if ($ename eq "") {
	print <<END;
<font size="+2">$TS::TS_metalog_title</font>
<br>
<hr><form method="get" action="metalog.cgi">
<p><b>$TS::TS_common_editor:</b>
<br><input type="text" name="name" size="20">
<p><input type="submit" value="Ok">
<br></form>
END
} else {
	$ename = Editor::validateEditor($ename);
	
	#Request Log
	print <<END;
<H1>Meta Editor Log</H1><hr>
END
  
	print <<END;
<table border="1" id="AutoNumber1" cellpadding="2">
  <tr>
    <td bgcolor="#CCCCCC">meta</td>
    <td>date</td>
    <td>editor</td>
    <td>action</td>
    <td>comments</td>
  </tr>
END

	open(META, "$path_data/logs/rootlog/ametalog.log");
	my @rlog2 = <META>;
	close(META);
	@rlog2 = grep { /##!!## $editor / } @rlog2;
	my $rlog;
	for (my $d = 0; $d <= $#rlog2; $d++) {
		$rlog = "$rlog $rlog2[$d]";
	}
        
	$rlog=~s/#\#!!#\#/ <tr><td bgcolor="#CCCCCC"> /g;
        $rlog=~s/ \#!\#/ <\/td> /g;
        $rlog=~s/ ##!## / <td> /g;
        $rlog=~s/\#\#!!!\#\# / <td> /g;
        $rlog=~s/ ##!!!!\##/ <\/td><\/tr> /g;

	opendir(DIR, "$path_data/misc/");
	my @edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/\.eaddr/) {
			$_=~s/.eaddr//g;
			my $ook = "<a href=\"./profile.cgi?editor=$_\">$_</a>";
			$rlog=~s/ $_ / $ook /g;
		}
	}

	opendir(DIR, "$path_sitedata/");
	my @edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/\.html/) {
			$_=~s/.html//g;
			my $gcat = $_;
			$gcat=~s/\>/\//g;
			my $ook = " <a href=\"./editcat.cgi?cat=$gcat\">$gcat</a> ";                                
			$rlog=~s/ $_ /$ook/g;
		}
	}

	opendir(DIR, "$path_data/rjnapps");
	my @edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/\.req/) {
			$_=~s/.req//g;
			my $rjapp = " [<a href=\"reqlog.cgi?app=$_&req=1\">$_</a>] ";
			$rlog=~s/- $_ -/ - $rjapp /g;
			$rlog=~s/-$_-/ - $rjapp /g;
		}
	}

	print $rlog;
	print "</table>";
}

UI::writeScriptFooter();
