#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $action = $cgi->param('action');
my $cat = $cgi->param('cat');
my $linkcat = $cgi->param('linkcat');
my $linktitle = $cgi->param('linktitle');
my $linkall = $cgi->param('linkall');
my $linktemplate = $cgi->param('template');

$cat = Editor::testPrivs($cat);

if ($action eq "submit") {
	$cat = Editor::validateCat($cat);
	$linkcat = Editor::validateCat($linkcat);
	if (($linktitle=~/\<|\>|:|\/|\\|\"/) || ($linktitle eq "")) {
		UI::writeHeaderCode("$TS::TS_mksectionlink_createnewlink");
		Editor::writeECode();
		print "$TS::TS_mksectionlink_notvalidtitle\n";
		UI::writeScriptFooter($cat);
		exit(0);
	}

	open(LINKS, "$path_sitedata/$cat.scl");
	my @content = <LINKS>;
	close(LINKS);

	for (my $er = 0; $er <= $#content; $er++) {
		if ($content[$er] =~/^$linktitle:.*/) {
			UI::writeHeaderCode($TS::TS_mksectionlink_createnewlink);
			Editor::writeECode();
			print "A similar section link has been already found in this category.\n";
			UI::writeScriptFooter($cat);
			exit(0);
		}
	}

	UI::editRedirect();

	UI::writeHeaderCode("$TS::TS_mksectionlink_createnewlink");
	Editor::writeECode();

	$linktitle=~s/ /_/g;
	if ($linkall ne "on") {
		$linkall = "";
	}
	if ($linktemplate ne "on") {
		$linktemplate = "";
	}

	open(LINKS, ">>$path_sitedata/$cat.scl");
	print LINKS "$linktitle:$linkcat:$linkall:$linktemplate\n";
	close(LINKS);
	open(LINKSTO, ">>$path_sitedata/$linkcat.seclinksto");
	print LINKSTO "$cat:$linktitle\n";
	close(LINKSTO);
	
	open(EL, "$path_data/pginfo/tble");
	my $table = <EL>;
	close(EL);

	Storage::logEdit("add", "sectionlink", $cat, "$linktitle\n$linkcat");
	Generate::updatePublicSide($cat);

	print "$TS::TS_mksectionlink_linkcreated\n";
} else {
	UI::writeHeaderCode("$TS::TS_mksectionlink_createnewlink");
	Editor::writeECode();

	UI::writeScriptHeader($cat, $TS::TS_mksectionlink_createnewlink);

	print "<p>$TS::TS_mksectionlink_usetocreate</p>";

	UI::writeStartForm($cat, "mksectionlink.cgi");
	UI::writeHiddenForm("action", "submit");
	UI::writeInputItemForm("<strong>$TS::TS_mksectionlink_categorytolink<br> <small>$TS::TS_mksectionlink_catexample</small></strong>", "text", "linkcat");
	UI::writeInputItemForm("<strong>$TS::TS_mksectionlink_titleoflink</strong>", "text", "linktitle");
	UI::writeCheckboxForm("linkall", "on", $TS::TS_mksectionlink_alloccurrence);
	UI::writeCheckboxForm("template", "on", $TS::TS_mksectionlink_template);
	UI::writeEndForm("");
	print "<p>$TS::TS_mksectionlink_brackets</p>";
}

UI::writeScriptFooter($cat);
