#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $action = $cgi->param('action');
my $cat = $cgi->param('cat');
my $linkcat = $cgi->param('linkcat');
my $linktitle = $cgi->param('linktitle');
my $sort = $cgi->param('sort');

$cat = Editor::testPrivs($cat);

if ($action eq "submit") {
	$cat = Editor::validateCat($cat);
	$linkcat = Editor::validateCat($linkcat);
	if (($linktitle=~/\<|\>|:|\/|\\|\"/) || ($linktitle eq "")) {
		UI::writeHeaderCode("$TS::TS_mksymlink_createnewlink");
		Editor::writeECode();
		print "$TS::TS_mksymlink_notvalidtitle\n";
		UI::writeScriptFooter($cat);
		exit(0);
	}

	open(LINKS, "$path_sitedata/$cat.symlinks");
	my @content = <LINKS>;
	close(LINKS);

	for (my $er = 0; $er <= $#content; $er++) {
		if ($content[$er] =~/^$linktitle:.*/) {
			UI::writeHeaderCode("$TS::TS_mksymlink_createnewlink");
			Editor::writeECode();
			print "$TS::TS_mksymlink_similarlink\n";
			UI::writeScriptFooter($cat);
			exit();
		}
	}

	UI::editRedirect();
	UI::writeHeaderCode("$TS::TS_mksymlink_createnewlink");
	Editor::writeECode();

	$linktitle=~s/ /_/g;
	open(LINKS, ">>$path_sitedata/$cat.symlinks");
	print LINKS "$linktitle:$linkcat\n";
	close(LINKS);
	open(LINKSTO, ">>$path_sitedata/$linkcat.symlinksto");
	print LINKSTO "$cat:$linktitle\n";
	close(LINKSTO);
	$linktitle=~s/_/ /g;
	open(SORT, ">>$path_sitedata/$cat.pricat");
	print SORT "$linktitle$sort;\n";
	close(SORT);

	open(EL, "$path_data/pginfo/tble");
	my $table = <EL>;
	close(EL);

	Storage::logEdit("add", "symlink", $cat, "$linktitle\n$linkcat");
	Generate::updatePublicSide($cat);

	print "$TS::TS_mksymlink_linkcreated\n";
} else {
	UI::writeHeaderCode("$TS::TS_mksymlink_createnewlink");
	Editor::writeECode();
	UI::writeScriptHeader($cat, $TS::TS_mksymlink_createnewlink);

	print "<p>$TS::TS_mksymlink_usetocreate</p>";

	UI::writeStartForm($cat, "mksymlink.cgi");
	UI::writeHiddenForm("action", "submit");
	UI::writeInputItemForm("<strong>$TS::TS_mksymlink_categorytolink<br> <small>$TS::TS_mksymlink_catexample</small></strong>", "text", "linkcat");
	UI::writeInputItemForm("<strong>$TS::TS_mksymlink_titleoflink</strong>", "text", "linktitle");
	UI::writeItemForm("<strong>$TS::TS_mksymlink_sortpri</strong>", "<input type=\"radio\" name=\"sort\" value=\"2\">$TS::TS_mksymlink_highest <input type=\"radio\" name=\"sort\" value=\"1\">$TS::TS_mksymlink_medium <input type=\"radio\" name=\"sort\" value=\"0\" checked>$TS::TS_mksymlink_bottom");
	UI::writeEndForm("");
}

UI::writeScriptFooter($cat);
