#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $newedit = $cgi->param('editor');
my $reason = $cgi->param('reason');
my $tcat = $cgi->param('tcat');
my $ok = "";
my $lt = localtime;
my $currenteditor = Editor::currentUser();

UI::writeHeaderCode("$TS::TS_newcat_createnewcat");
Editor::writeECode();
Editor::restrictedEditall();

if ($act ne "") {
	$tcat = Editor::validateCat($tcat);
	$cat = Editor::validateCat($cat, 2);
	my $fpath = $tcat . ">" . $cat;
	Editor::validateCat($fpath, 0);
	my $parent = $fpath . " ";
	$parent=~s/(.*)>[^>\s]+\s/$1/g;
	Editor::validateCat($parent);

	open(EL, ">$path_sitedata/$tcat>$cat.html");
	print EL "$ok ";
	close(EL);
	open(EL4, ">>$path_sitedata/cats.lst");
	print EL4 "$tcat>$cat; ";
	close(EL4);
	
	if ($newedit ne "") {
		my $users = Storage::getData("global", "elist");
		if ($users=~/ $newedit /) {
			open(EL, ">>$path_data/eperm/$newedit.perm");
			print EL " $tcat>$cat; ";
			close(EL);

			Generate::updatePublicSide($tcat . ">" . $cat);

			print "$newedit $TS::TS_newcat_editorcannoweditincat $tcat>$cat.<br>\n";

                        open(TEXTFILE, ">>$path_sitedata/$tcat>$cat.ed");
                        print TEXTFILE "$newedit\n";
                        close(TEXTFILE);

			Storage::logMetaEdit($newedit,$currenteditor,'newcat',0,"$tcat>$cat ($reason)");

			#fix

			open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
			print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## new #!# ##!## category #!# ##!!!## $tcat>$cat created ##!!!!## \n";
			close(TEXTFILE);
		}
	}

	print "$TS::TS_newcat_catcreated <br>";

	open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
	print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## new #!# ##!## category #!# ##!!!## $tcat>$cat created. ##!!!!## \n";
	close(TEXTFILE);
} else {
	open(EL, "$path_data/eperm/editall/$ENV{REMOTE_USER}.perm");
	my $dmlst = <EL>;
	close(EL);
	if ($dmlst=~/editall/g) {
		$dmlst = Storage::getData("global", "tlc.lc");
	}
	my $sep = "</option><option>";
	$dmlst=~s/; /$sep/g;

	print <<END;
<font size="+1">New Category</font>
<br>
<form method="POST" action="newcat.cgi">
<p><b>$TS::TS_newcat_category</b><br>
<select name="tcat">
<option>
$dmlst
</select><b>/</b>
<input type="text" name="cat" size="40">
<br>
<table border="0" cellspacing="1" width="430" id="AutoNumber1" bgcolor="#A6CAF0">

<br>
 <tr>
    <td width="426">
<p>$TS::TS_newcat_youmayappoint</p>
<p><b>Editor:&nbsp; &nbsp;</b>
<input type="text" name="editor" size="20"></p>
<p><b>Reason:</b>
<input type="text" name="reason" size="40"></p>
 </td></tr></table>

<p><input type="submit" value="$TS::TS_newcat_create" name="action"></form>
END
}

UI::writeScriptFooter();
