#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

UI::writeHeaderCode($TS::TS_newpoll_title);
Editor::restrictedMeta();

if (defined $cgi->param('submit')) {
	my $tit = $cgi->param('title');
	my $des = $cgi->param('desc');

	if (($tit eq "") || ($des eq "")) {
		print "$TS::TS_newpoll_missing";
	} elsif ($isMeta ne "1") {
		print "$TS::TS_newpoll_noprivs";
	} else {
		my $newp = 0;
		if (open(TIT, "$path_data/polls/new")) {
			$newp = <TIT>;
			close(TIT);
		}

		if ($newp eq "") {
			$newp = 0;
		}
		
		if ($newp=~/^([0-9]+)$/) {
			$newp = $1;
		} else {
			die "Insecure format for the polls counter.";
		}

		my $ne = $newp;
		$newp++;
		
		if (!-d "$path_data/polls") {
			mkdir("$path_data/polls");
		}

		open(TIT, ">$path_data/polls/new");
		print TIT $newp;
		close(TIT);

		open(TIT, ">>$path_data/polls/opened");
		print TIT " $ne;";
		close(TIT);

		open(TIT, ">$path_data/polls/$ne.poll");
		open(REZ, ">$path_data/polls/$ne.rez");
		my $x = $cgi->param('title');
		print TIT $x . "\n";
		$x = $cgi->param('desc');
		print TIT $x . "\n";

		for (my $d = "1"; $d <= "50"; $d++) {
			chomp($d);
			$x = $cgi->param("choice" . $d);
			print TIT $x . "\n";
			print REZ "0\n";
		}
		print TIT "---\n";
		close(TIT);
		close(REZ);

		print $TS::TS_newpoll_created;
	}
} else {
	print <<END;
<form action="newpoll.cgi" method="post">
<input type="hidden" name="action" value="new">
<input type="hidden" name="poll" value="new">
<center><table width="90%"><tr><td>
  <b>$TS::TS_newpoll_newpoll:</b><br>
$TS::TS_newpoll_info<p>
</td></tr></table></center>
<center><table bgcolor="#cccccc" border=0 width="80%">
	<tr><td><table cellspacing="5" cellpadding="5" border="0" width="100%">
<tr><td valign="top"><b>$TS::TS_common_title:</b></td><td><input type="text" name="title" size="60"></td></tr>
<tr><td valign="top"><b>$TS::TS_common_description:</b></td><td><textarea name="desc" rows="3" cols="60"></textarea></td></tr>
END

	for (my $d = 1; $d < 51; $d++) {
		print "<tr><td valign=\"top\"><b>$TS::TS_newpoll_choice $d:</b></td><td><input type=\"text\" name=\"choice$d\" size=\"60\"></td></tr>";
	}

	print <<END;
</table></td></tr></table></center>
  <center>
    <input type="submit" name="submit" value="$TS::TS_newpoll_create">
  </center>
</form>
END
}

print "<p><a href=\"poll.cgi\">$TS::TS_newpoll_backindex</a></p>";

UI::writeScriptFooter();
