#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use CGI;
use strict;

use lib '.';
use Include;
use Editor;
use EditorProfile;
use Logs;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $name = $cgi->param('name');
my $what = $cgi->param('what');

UI::writeHeaderCode("Logs");

if ($name eq "") {
	print <<END;
<div align="center">
  <center>
  <p><font size="5">Editing Logs</font></p>
  <table cellSpacing="0" cellPadding="5" bgColor="#cccccc" border="0">
    <tr>
     <form method="GET" action="oldlogs.cgi">
      <td><b>Editor Name</b>&nbsp;<input size="40" name="name" maxsize="256">
      <select name="what">
      <option value="1">Edit Detail</option>
      <option value="2">Category Requests</option>
      <option value="3">Meta Editing Logs</option>
      <option value="4" selected>Profile</option>
      </select> </td>
    </tr>
  </table>
  <p><input type="submit" value="Submit Query"> </p>
  </form>
  </center>
</div>
END
} else {
	my $editor = $name;
	my $enamel = $name;

	$name = Editor::validateEditor($name);

	Logs::loghead();
	EditorProfile::editorInfo($name);

	if ($what eq "4") {
		open(INFILE, "$path_home/profiles/$name.html");
		my @profile = <INFILE>;
		close(INFILE);
		open(EL, "$path_data/logs/$name.ll");
		my $llog = <EL>;
		close(EL);
		print "<b>Last login:</b> $llog<hr>";
		print "@profile";
	}

	if ($what eq "1") {
		print <<END;
	<H1>All Edit Log</H1><hr>
	<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="600"><tr><td width="600">
END
		open(INFILE, "$path_data/logs/allog/$name.log");
		my @rlog = <INFILE>;
		close(INFILE);
		print "@rlog";
		print "</table> <br>";
	}

	if ($what eq "2") {
		print <<END;
	<H1>Request Log / Misc</H1><hr>
	<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="600"><tr><td width="600">
END
		open(INFILE, "$path_data/logs/trlog/$name.log");
		my @rlog = <INFILE>;
		close(INFILE);
		print "@rlog";
		print "</table> <br>";
	}

	if (($what eq "3") && ($isMeta eq "1")) {
		print <<END;
	<H1>Meta Editor Log</H1><hr>
	<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="600" <tr><td width="600">
END
		open(INFILE, "$path_data/logs/trlog/$name.mlog");
		my @rlog = <INFILE>;
		close(INFILE);
		print "@rlog";
		print "</table> <br>";
	}
}

UI::writeFooterCode();
