#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Logs;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $lt = localtime;
my %cn;


sub logNote {
	my($editor, $who, $type, $info) = @_;
	open(LOG, ">>$path_data/logs/rootlog/pnotes.log");
	print LOG " ##!!## $editor #!# ##!## $who #!# ##!## $type #!# ##!## $info ##!!!!## ##!t!## $lt ##!te!## \n";
	close(LOG);
	return 1;
}


sub formForNewNote {
	my ($editor) = @_;
	print <<END;
<div align="center">
  <center>
  <table border="1" cellspacing="8" style="border-collapse: collapse" bordercolor="#cccccc" width="80%" id="AutoNumber1" bgcolor="#cccccc">
    <tr>
      <td width="100%" align="center"><font size="4">$TS::TS_pnote_title</font></td>
    </tr>
    <tr>
      <td width="100%" align="center">
      <p align="left">$TS::TS_pnote_to: $editor</p>
      <p align="left">$TS::TS_pnote_from: $ENV{REMOTE_USER}</p>
      <form method="post" action="pnote.cgi">
        <p align="left"><b>$TS::TS_pnote_color:&nbsp;
        <input type="radio" name="color" value="green" checked><font color="#008000">$TS::TS_pnote_goodediting</font>
        <input type="radio" name="color" value="yellow"><font color="#ffff00">$TS::TS_pnote_poorediting</font>
        <input type="radio" name="color" value="red"   ><font color="#ff0000">$TS::TS_pnote_pabuse</font>
        <input type="radio" name="color" value="purple"><font color="#cc66cc">$TS::TS_pnote_oc</font>
        </b></p>
        <p align="left">$TS::TS_pnote_ntitle:<br>
        <input type="text" name="title" size="30"></p>
	$TS::TS_pnote_noteurl
        <p align="left">$TS::TS_pnote_note: <br>
        <input type="hidden" name="editor" value="$editor">
        <input type="hidden" name="act" value="post">
        <textarea rows="4" name="note" cols="39"></textarea></p>
        <p align="left"><input type="submit" value="$TS::TS_common_submit"></p>
      </form>
      </td>
    </tr>
  </table>
  </center>
</div>
END
	return 1;
}


my $editor = $cgi->param('editor');
my $color = $cgi->param('color');
my $title = $cgi->param('title');
my $note = $cgi->param('note');
my $num = $cgi->param('num');
my $act = $cgi->param('act');
my $meta = $cgi->param('meta');
my $what = $cgi->param('what');
my $note2 = $cgi->param('note2');
my $mode = $cgi->param('mode');
my $last = $cgi->param('last');

UI::writeHeaderCode($TS::TS_pnote_title);
Editor::writeECode();
Editor::restrictedMeta();

if ($mode ne "log") {
	$editor = Editor::validateEditor($editor);
}


if ($note eq "") {
	if ($mode eq "log") {
		if ($what eq "master") {
			if ($last eq "") {
				$last = 5;
			}

			print "<H3>$TS::TS_pnote_mased - $TS::TS_pnote_title ($TS::TS_pnote_last $last)</H3>";

			$last = $last -1;

		        UI::writeStartForm("", "pnote.cgi");
			UI::writeHiddenForm("mode", "log");
			UI::writeHiddenForm("what", "master");
		        UI::writeInputItemForm($TS::TS_pnote_last, "text", "last");
		        UI::writeEndForm();

			print <<END;
        <table><tr bgcolor="#eeeeee"><td>$TS::TS_common_time</td><td>$TS::TS_pnote_meta</td><td>
  $TS::TS_common_action</td><td>$TS::TS_common_editor</td><td>$TS::TS_pnote_note</td></tr>
END

                        open(TEXTFILE, "$path_data/logs/rootlog/pnotes.log");
                        our @rlog = <TEXTFILE>;
                        close(TEXTFILE);

                        for (my $d = $#rlog-$last; $d <= $#rlog; $d++) {
                                if ($rlog[$d]=~/ ##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) ##!!!!## ##!t!## (.*?) ##!te!##/) {
                                        $cn{'meta'} = $1;
                                        $cn{'editor'} = $2;
                                        $cn{'action'} = $3;
                                        $cn{'note'} = $4;
                                        $cn{'date'} = $5;

                                        print "<tr bgcolor=\"#eeeeee\"><td>";
                                        print "$cn{'date'}</td><td><a href=\"profile.cgi?editor=$cn{'meta'}\">$cn{'meta'}</a></td><td>";
                                        print "$cn{'action'}</td><td><a href=\"profile.cgi?editor=$cn{'editor'}\">$cn{'editor'}</a></td><td>";
                                        Logs::genDispNote($cn{'note'});
                                        print "</td></tr>";

                                }
                        }
                        print "</table>";
		}

		if ($what eq "") {
			print "<H3>$TS::TS_pnote_logt</H3>";
			print "<ul><li><a href=\"./pnote.cgi?mode=log&what=master\">$TS::TS_pnote_mased</a></li></ul>";

			print "<br><H4>$TS::TS_pnote_search:</H4>";
			UI::writeStartForm("", "pnote.cgi");
			UI::writeHiddenForm("mode", "log");
			UI::writeHiddenForm("what", "search");
			UI::writeInputItemForm($TS::TS_pnote_meta, "text", "meta", "");
			UI::writeInputItemForm($TS::TS_common_editor, "text", "editor", "");
			UI::writeEndForm();
		}

		if ($what eq "search") {

			print <<END;
	<table><tr bgcolor="#eeeeee"><td>$TS::TS_common_time</td><td>$TS::TS_pnote_meta</td><td>
  $TS::TS_common_action</td><td>$TS::TS_common_editor</td><td>$TS::TS_pnote_note</td></tr>
END
			if ($meta ne "") {
	                	open(TEXTFILE, "$path_data/logs/rootlog/pnotes.log");
        	        	our @rlog = grep { /##!!## $meta / } <TEXTFILE>;
                		close(TEXTFILE);
				for (my $d = 0; $d <= $#rlog; $d++) {
					if ($rlog[$d]=~/ ##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) ##!!!!## ##!t!## (.*?) ##!te!##/) {
						$cn{'meta'} = $1;
						$cn{'editor'} = $2;
						$cn{'action'} = $3;
						$cn{'note'} = $4;
						$cn{'date'} = $5;

						print "<tr bgcolor=\"#eeeeee\"><td>";
						print "$cn{'date'}</td><td>$cn{'meta'}</td><td>";
  						print "$cn{'action'}</td><td>$cn{'editor'}</td><td>";
						Logs::genDispNote($cn{'note'});
						print "</td></tr>";
					}
				}				
				print "</table>";
			}


	                if ($editor ne "") {
	                        open(TEXTFILE, "$path_data/logs/rootlog/pnotes.log");
        	                our @rlog = grep { / ##!## $editor / } <TEXTFILE>;
                	        close(TEXTFILE);
                        	for (my $d = 0; $d <= $#rlog; $d++) {
	                                if ($rlog[$d]=~/ ##!!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) #!# ##!## (.*?) ##!!!!## ##!t!## (.*?) ##!te!##/) {
	                                        $cn{'meta'} = $1;
        	                                $cn{'editor'} = $2;
                	                        $cn{'action'} = $3;
                        	                $cn{'note'} = $4;
                                	        $cn{'date'} = $5;

	                                        print "<tr bgcolor=\"#eeeeee\"><td>";
        	                                print "$cn{'date'}</td><td>$cn{'meta'}</td><td>";
                	                        print "$cn{'action'}</td><td>$cn{'editor'}</td><td>";
                        	                Logs::genDispNote($cn{'note'});
                                	        print "</td></tr>";
                        	        }
                	        }
        	                print "</table>";
	                }
		}

		UI::writeScriptFooter();
		exit(0);
	}

	if ($editor ne "") {
		formForNewNote($editor);
	}
} else {
	if ($act eq "mod") {
                open(TEXTFILE, "$path_data/logs/pnotes/$editor.note");
                my @file = <TEXTFILE>;
                close(TEXTFILE);
                my @notedat = split(/\|/, $file[$note]);
                if (($notedat[0] ne $ENV{REMOTE_USER}) && ($isRoot ne 1)) {
                        print $TS::TS_pnote_remerror;
                        UI::writeScriptFooter();
                        exit();
		} else {
			print <<END;
<div align="center">
  <center>
  <table border="1" cellspacing="8" style="border-collapse: collapse" bordercolor="#CCCCCC" width="80%" id="AutoNumber1" bgcolor="#CCCCCC">
    <tr>
      <td width="100%" align="center"><font size="4">$TS::TS_pnote_editnote</font><br><br>$TS::TS_pnote_current :
END
	Logs::genDispNote($file[$note]);
print <<END;
</td>
    </tr>
    <tr>
      <td width="100%" align="center">
      <p align="left">$TS::TS_pnote_to : $editor</p>
      <p align="left">$TS::TS_pnote_from : $notedat[0]</p>
      <p align="left">$TS::TS_pnote_date : $notedat[2]</p>
      <form method="POST" action="pnote.cgi">
        <p align="left">$TS::TS_pnote_color:&nbsp;
END
			my ($gchecked, $ychecked, $rchecked, $pchecked);

			if ($notedat[1] eq "green") { $gchecked = "checked" };
			if ($notedat[1] eq "yellow") { $ychecked = "checked" };
			if ($notedat[1] eq "red") { $rchecked = "checked" };
			if ($notedat[1] eq "purple") { $pchecked = "checked" };

			$notedat[4]=~s/<br>/\n/g;

			print <<END;
        <b>
        <input type="radio" name="color" value="green"  $gchecked><font color="#008000">$TS::TS_pnote_goodediting</font>
        <input type="radio" name="color" value="yellow" $ychecked><font color="#ffff00">$TS::TS_pnote_poorediting</font>&nbsp;
        <input type="radio" name="color" value="red"    $rchecked><font color="#ff0000">$TS::TS_pnote_pabuse</font>
        <input type="radio" name="color" value="purple" $pchecked><font color="#cc66cc">$TS::TS_pnote_oc</font>
        </b></p>
        <p align="left">$TS::TS_pnote_ntitle :<br>
        <input type="text" name="title" value="$notedat[3]" size="30"></p>
        <p align="left">$TS::TS_pnote_note : <br>
        <input type="hidden" name="editor" value="$editor">
        <input type="hidden" name="act" value="update">
        <input type="hidden" name="note2" value="$note">
        <textarea rows="4" name="note" cols="39">$notedat[4]</textarea></p>
        <p align="left"><input type="submit" value="$TS::TS_common_submit"></p>
      </form>
      </td>
    </tr>
  </table>
  </center>
</div>
END
		}
	}

	if ($act eq "post") {
		$title=~s/\n//g;
		$title=~s/\|/-/g;
		$note=~s/\n/<br>/g;
		$note=~s/\|/-/g;
		if (!(-d "$path_data/logs")) {
			mkdir("$path_data/logs");
		}
		if (!(-d "$path_data/logs/pnotes")) {
			mkdir("$path_data/logs/pnotes");
		}
		open(TEXTFILE, ">>$path_data/logs/pnotes/$editor.note");
		print TEXTFILE "\n$ENV{REMOTE_USER}|$color|$lt|$title|$note";
		close(TEXTFILE);
		logNote($ENV{REMOTE_USER}, $editor, "post", "$ENV{REMOTE_USER}|$color|$lt|$title|$note");
		print "$TS::TS_pnote_noteposted";
	}

        if ($act eq "del") {
                open(TEXTFILE, "$path_data/logs/pnotes/$editor.note");
                my @file = <TEXTFILE>;
                close(TEXTFILE);
		my @notedat = split(/\|/, $file[$note]);
		if (($notedat[0] ne $ENV{REMOTE_USER}) && ($isRoot ne 1)) {
			print $TS::TS_pnote_remerror;
			UI::writeScriptFooter();
			exit(0);
		} else {
			if ($what ne 1) {
				print "$TS::TS_pnote_deletesure<br><br>";
				Logs::genDispNote($file[$note]);
				print <<END;
<form method="POST" action="pnote.cgi">
  <input type="hidden" value="$editor" name="editor">
  <input type="hidden" value="$note" name="note">
  <input type="hidden" value="del" name="act">
  <input type="hidden" value="1" name="what">
  <p><input type="submit" value="$TS::TS_pnote_del"></p>
</form>
END
			}

			if ($what eq 1) {
				logNote($ENV{REMOTE_USER}, $editor, "delete", "$file[$note]");
				$file[$note] = "";
				open(TEXTFILE, ">$path_data/logs/pnotes/$editor.note");
				print TEXTFILE @file;
				close(TEXTFILE);
				print $TS::TS_pnote_noteremoved;
			}
		}
	}

        if ($act eq "update") {
                open(TEXTFILE, "$path_data/logs/pnotes/$editor.note");
                our @file = <TEXTFILE>;
                close(TEXTFILE);
                our @notedat = split(/\|/, $file[$note2]);
                if (($notedat[0] ne $ENV{REMOTE_USER}) && ($isRoot ne 1)) {
                        print $TS::TS_pnote_remerror;
                        UI::writeScriptFooter();
                        exit(0);
                } else {
	                $title=~s/\n//g;
        	        $title=~s/\|/-/g;
                	$note=~s/\n/<br>/g;
                	$note=~s/\|/-/g;
			$notedat[2]=~s/\n/<br>/g;
			$notedat[2]=~s/\|/-/g;
			$notedat[0]=~s/\n/<br>/g;
			$notedat[0]=~s/\|/-/g;

                        $file[$note2] = "$notedat[0]|$color|$notedat[2]|$title|$note";
                        open(TEXTFILE, ">$path_data/logs/pnotes/$editor.note");
                        print TEXTFILE @file;
                        close(TEXTFILE);
			logNote($ENV{REMOTE_USER}, $editor, "modify", $file[$note2]);
                        print $TS::TS_pnote_edited;
                }

        }
}

print "<p>$bold<a href=\"./logs.cgi?name=$editor&what=4\">$TS::TS_common_back</a>$unBold</p>";

UI::writeScriptFooter();
