#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $id = $cgi->param('id');
my $sel = $cgi->param('select');
my $act = $cgi->param('close');
my $reopen = $cgi->param('reopen');

my($nonex, $hasVoted, $votes, @rez, $line, $opt, $x);

UI::writeHeaderCode($TS::TS_poll_title);

if (!(-d "$path_data/polls")) {
        mkdir "$path_data/polls";
}

if ((defined $reopen) && ($isMeta eq "1")) {
	open(POLLS, ">>$path_data/polls/opened");
	print POLLS " $id;";
	close(POLLS);
}

my $opoll = 0;
if (open(POLLS, "$path_data/polls/opened")) {
	$opoll = <POLLS>;
	close(POLLS);
}

if ((defined $id) && ($id ne "") && ($id !~ /^([0-9]+)$/)) {
	die "Data validation failed for id value.";
} else {
	$id = $1;
}

if (($isMeta eq "1") && (defined $act) && ($act ne "")) {
	# Close the poll with the ID stored in $act

	open(POLLS, "$path_data/polls/opened");
	my $poll = <POLLS>;
	close(POLLS);

	$poll =~ s/ $act;//;

	open(POLLS, ">$path_data/polls/opened");
	print POLLS $poll;
	close(POLLS);

	print $TS::TS_poll_closed;
}

if (!defined $id) {
	# Display the general list with polls

	print "<p>$TS::TS_poll_copened<ul>";

	my $poll = "";
	if (open(POLLS, "$path_data/polls/opened")) {
		$poll = <POLLS>;
		close(POLLS);
	}

	my $noPolls = "0";

	while ($poll =~ /([0-9]+);/g) {
		if (open(TIT, "$path_data/polls/$1.poll")) {
			my @poll = <TIT>;
			close(TIT);
			print "<li><a href=\"poll.cgi?id=$1\">$poll[0]</a>";
			if ($isMeta eq "1") {
				print " - <a href=\"poll.cgi?close=$1\">[$TS::TS_poll_close]</a>";
			}
			print "<br>";
			$noPolls++;
		}
	}

	if ($noPolls eq "0") {
		print $TS::TS_poll_nopolls;
	}

	print "</ul></p>";

	if ($isMeta eq "1") {
		print "<p><a href=\"newpoll.cgi\">$TS::TS_poll_createnew</a></p>";
	}
} else {
	# Display poll number #id

	open(TIT, "$path_data/polls/$id.poll");
	my @it = <TIT>;
	close(TIT);

	if ($it[0] eq "") {
		print $TS::TS_poll_notfound;
		$nonex = "1";
	} else {
		open(VOTES, "$path_data/polls/$id.votes");
		$votes = <VOTES>;
		close(VOTES);

		$hasVoted = ($votes =~ /$ENV{REMOTE_USER};/);

		if (defined $sel) {
			if ($hasVoted eq "1") {
				print $TS::TS_poll_alreadyvoted;
			} else {
				if ($opoll=~/ $id;/) {
					print $TS::TS_poll_voterecorded;

					$sel--;

					open(REZ, "$path_data/polls/$id.rez");
					@rez = <REZ>;
					close(REZ);

					$rez[$sel]++;
					$rez[$sel] = $rez[$sel] . "\n";

					open(REZ, ">$path_data/polls/$id.rez");
					print REZ @rez;
					close(REZ);

					open(VOTES, ">>$path_data/polls/$id.votes");
					print VOTES "$ENV{REMOTE_USER};";
					close(VOTES);
				} else {
					print $TS::TS_poll_closed;
				}
			}
		}

		open(TIT, "$path_data/polls/$id.poll");
		@it = <TIT>;
		close(TIT);

		open(REZ, "$path_data/polls/$id.rez");
		@rez = <REZ>;
		close(REZ);

		open(VOTES, "$path_data/polls/$id.votes");
		$votes = <VOTES>;
		close(VOTES);

		$hasVoted = ($votes =~ /$ENV{REMOTE_USER};/);

		print "<p><div align=\"center\"><strong><big>$it[0]</big></strong></div></p>";
		print "<p>$it[1]</p>";
		$line = "2";
		$opt = "";
		while ($opt ne "---") {
			$opt = $it[$line];
			chomp($opt);
			$line++;
			if (($opt ne "---") && ($opt ne "")) {
				print "$opt - $rez[$line - 3] vote(s)";
				if ($hasVoted eq "") {
					$x = $line - 2;

					if ($opoll=~/ $id;/) {
						print " - <a href=\"poll.cgi?id=$id&select=$x\">$TS::TS_poll_vote</a>";
					}
				}
				print "<br>";
			}
		}
	}

	print "<p><a href=\"poll.cgi\">$TS::TS_poll_backtoindex</a></p>";

	if ($opoll!~/ $id;/) {
		if (($nonex ne "1") && ($isMeta eq 1)) {
			print " - <a href=\"poll.cgi?id=$id&reopen=1\">$TS::TS_poll_reopen</a>";
		}
	}
}

print "<p></p>";

UI::writeScriptFooter();
