#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');
my $ad = "";
my $deleted = 0;

$cat = Editor::testPrivs($cat);

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_powereditsection_title);
Editor::writeECode();

open(USERS, "$path_sitedata/$cat.sections");
my $ids = <USERS>;
close(USERS);

UI::writeScriptHeader($cat, $TS::TS_powereditsection_title,
	$TS::TS_powereditsection_editno);

if ($submit eq "") {
	print "<form method = post>";
}

for (my $idtable = 1; $idtable <= $ids; $idtable++) {
	my $idreal = $idtable - $deleted;
	open(TT, "$path_sitedata/$cat.$ad" . "sct$idreal");
	my @rt = <TT>;
	close(TT);
	my $okay = 1;
	if ($rt[0]=~/2.0/) {
		if (($rt[2] eq "\n") || ($rt[2] eq ""))	{
			$okay = 0;
		}
	} else {
		if (($rt[0] eq "\n") || ($rt[0] eq "")) {
			$okay = 0;
		}
	}

	if ($okay == 1) {
		print ("<p>");

		if ($submit ne "") {
			my $name = $cgi->param($idtable . "name");
			my $val = $cgi->param($idtable . "val");
			my $type = $cgi->param($idtable . "type");
			my $omit = $cgi->param($idtable . "omit");

			$type=~s/\n//g;
			$type=~s/\r//g;
	
			if ($omit eq "yes") {
				open(TABLE, "$path_sitedata/$cat.$ad" . "sct$idreal");
				my @cntl = <TABLE>;
				close(TABLE);
				my $cntl = join("", @cntl);

				Common::deleteSection($cat, $ad, $idreal);
				my $place = "reviewed";
				if ($ad eq "u") {
					Storage::logEdit("delete", "section", "$cat - unreviewed", $cntl);
					$place = "unreviewed";
				} else {
					Storage::logEdit("delete", "section", $cat, $cntl);
				}

				Common::updateCounter($cat, $place, -1);
				$deleted++;
			} else {
				open(TEMPL, "$path_data/template/$type");
				my @tmpl = <TEMPL>;
				close(TEMPL);

				my $cntl = "2.0\n";
				$cntl .= $type . "\n";
				$cntl .= $name . "\n";

				for (my $i = "1"; $i <= ($#tmpl / 2); $i++) {
					my $y = "$idtable" . "p" . $i;
					my $x = $cgi->param($y);
					chomp($x);
					$cntl = $cntl . "$x\n";
				}

				$cntl = $cntl . $val;
	
				if (!(Common::isSectionEmpty(split("\n", $cntl)))) {
					open(TABLE, ">$path_sitedata/$cat.$ad" . "sct$idreal");
					print TABLE $cntl;
					close(TABLE);
	
					if ($ad eq "u") {
						Storage::logEdit("edit", "section", "$cat - unreviewed", $cntl);
					} else {
						Storage::logEdit("edit", "section", $cat, $cntl);
					}
				} else {
					print "$TS::TS_powereditsection_errorsect";
					UI::writeScriptFooter();
					exit(0);
				}
			}

			Generate::updatePublicSide($cat);

			print "$idtable - $TS::TS_common_changesdone";
		} else {
			print "<table width=\"100%\"><tr><td bgcolor=\"green\"><font color=\"white\"><strong>$TS::TS_powereditsection_title - $TS::TS_common_section $idtable</strong></font></td></tr></table>";
			open(TABLE, "$path_sitedata/$cat.sct$idtable");
			my @cont = <TABLE>;
			close(TABLE);

			my($type, $name, $val);

			if ($cont[0]=~/2.0/) {
				$type = $cont[1];
				$name = $cont[2];
			} else {
				$type = "default";
				$name = $cont[0];
				$val = "";
				for (my $i = "1"; $i <= $#cont; $i++)
				{
					$val = $val . $cont[$i];
				}
			}

			$type=~s/\n//g;
			$type=~s/\r//g;

			open(TEMPL, "$path_data/template/$type");
			my @tmpl = <TEMPL>;
			close(TEMPL);

			my $ncat = $cat;
			$ncat=~s/>/\//g;
			$ncat=~s/_/ /g;

			print ("<input type=\"hidden\" name=\"idtable\" value=\"$idtable\">");

			$name=~s/\"/&quot;/g;

			print ("<table><tr><td>$TS::TS_common_type:</td><td>$type</td></tr><tr><td>$TS::TS_common_title:</td><td><input size=\"70\" name=\"$idtable" . "name\" type=\"text\" value=\"$name\"></td></tr>");

			if ($cont[0]=~/2.0/) {
				my $j = "0";
				for (my $i = "1"; $i <= $#tmpl; $i = $i + 2) {
					$j = $j + 1;
					chomp($tmpl[$i]);
					$tmpl[$i]=~s/.$//g;
					my $xx = $tmpl[$i];
					$xx=~s/<.>//g;
					$xx=~s/<\/.>//g;
					$xx=~s/<br>//g;
					$xx=~s/#name//g;
					my $k = $j + 2;
					print "<tr><td>$xx:</td><td><input name=\"$idtable". "p$j\" type=\"text\" size=\"70\" value=\"$cont[$k]\"></td></tr>";
				}
				$val = "";
				for (my $t = $j + 3; $t <= $#cont; $t++) {
					$val = $val . $cont[$t];
				}
			}

			print ("<tr><td>$TS::TS_common_content:</td><td><textarea name=\"$idtable" . "val\" rows=10 cols=70>$val</textarea></td></tr>");
			print ("<tr><td>$TS::TS_common_action:</td><td><input type=\"radio\" name=\"$idtable" . "omit\" value=\"no\" checked>$TS::TS_common_update &nbsp; <input type=\"radio\" name=\"$idtable" . "omit\" value=\"yes\">$TS::TS_common_delete</td></tr>");
			print ("</table>");
			print ("<input type=\"hidden\" name=\"$idtable" . "type\" value=\"$type\">");
		}
		print ("</p>");
	}
}

if ($submit eq "") {
	print "<input type=\"submit\" name=\"submit\" value=\"$TS::TS_common_submit\"><input type=\"hidden\" value=\"$cat\" name=\"cat\"></form>";
}

UI::writeScriptFooter($cat);
