#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $submit = $cgi->param('submit');

$cat = Editor::validateCat($cat);

if ($submit ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode("$TS::TS_pricat_catsortpriority");
Editor::writeECode();

$cat = Editor::testPrivs($cat);

my $nicecat = $cat;
$nicecat=~s/>/\//g;
$nicecat=~s/_/ /g;

open(DCATS, "$path_sitedata/cats.lst");
my $ucat = <DCATS>;
close(DCATS);

my @subcat_list = ();

my($uct2, $backt, $uct, $line, $linktitle, $linkcat, $tempvar);
my($linktitledisp, $subcats, $c, $d, $totaledits, $edits, $tempx);
my($name, $logdata, $table, @pricat, $pricat, @pos);

while ($ucat=~/ $cat>(.[^;>]*);/g) {
	$uct2 = $1;
	$backt = $1;
	$uct = $cat;
	$uct=~s/>/\//g;
	$uct2=~s/_/ /g;
	$uct2=~s/>/: /g;
	push(@subcat_list, "<a href=\"editcat.cgi?cat=$uct/$backt\">$uct2</a><br>");
}

open(LINKS, "$path_sitedata/$cat.symlinks");
while (<LINKS>) {
	$line = $_;
	chomp($line);
	($linktitle, $linkcat) = split(/:/, $line);
	$linktitledisp = $linktitle;
	$linktitledisp=~s/_/ /g;
	$tempvar = $linkcat;
	$tempvar=~s/>/\//g;
	push(@subcat_list, "<a href=\"editcat.cgi?cat=$tempvar\">$linktitledisp</a>\@<br>");
}

@subcat_list = sort
{
	($c) = $a=~/<a href=\".*?\">(.*?)<\/a>/;
	($d) = $b=~/<a href=\".*?\">(.*?)<\/a>/;
	$c cmp $d;
} (@subcat_list);

$subcats = $#subcat_list;

if ($subcats <= 0) {
	print $TS::TS_pricat_needtwosubcats;
	UI::writeScriptFooter($cat);
	exit(0);
}

if ($submit ne "") {
	$totaledits = $edits + 1;

	open(LINKS, ">$path_sitedata/$cat.pricat");
	for (my $i = "0"; $i <= $subcats; $i++) {
		$tempx = $subcat_list[$i];

		if ($tempx=~/<a href=\".*?\">(.*?)<\/a>/) {
			$name = $1;
		}

		my $rpar = $name;
		$rpar=~s/ /_/g;
		print LINKS "$name" . $cgi->param($rpar) . ";\n";
		$logdata = "$logdata $name";
	}
	close(LINKS);

	Storage::logEdit("edit", "pricat", $cat, $logdata);
	print "<p>$TS::TS_pricat_changessaved</p>";

	UI::writeScriptFooter($cat);
	exit(0);
}

print "<p>$TS::TS_pricat_thistool</p>";

UI::writeStartForm($cat, "pricat.cgi");

print <<END;
<p align="center">
  <table width="80%" align="center">
    <tr align="center" bgcolor="#f0f0f0">
      <td colspan="4">$TS::TS_pricat_sortprifor <strong>$nicecat</strong></td>
    </tr>
    <tr align="center" bgcolor="#f0f0f0">
      <td align="left">$TS::TS_pricat_subcategory</td>
      <td>$TS::TS_pricat_highest</td>
      <td>$TS::TS_pricat_medium</td>
      <td>$TS::TS_pricat_bottom</td>
    </tr>
END

open(LINKS, "$path_sitedata/$cat.pricat");
@pricat = <LINKS>;
close(LINKS);

$pricat = join("", @pricat);
$pricat=~s/ /_/g;
$pricat = " " . $pricat;

for (my $i = "0"; $i <= $subcats; $i++) {
	$pos["0"] = "";
	$pos["1"] = "";
	$pos["2"] = "";
	$tempx = $subcat_list[$i];

	if ($tempx=~/<a href=\".*?\">(.*?)<\/a>/) {
		$name = $1;
	}

	$name=~s/ /_/g;

	if ($pricat=~/\s$name(.);/) {
		$pos[$1] = " checked";
	} else {
		$pos["0"] = " checked";
	}

	print <<END;
  <tr align="center">
    <td align="left" bgcolor="#eff8f0">$subcat_list[$i]</td>
    <td><input type="radio" name="$name" value="2"$pos[2]></td>
    <td><input type="radio" name="$name" value="1"$pos[1]></td>
    <td><input type="radio" name="$name" value="0"$pos[0]></td>
  </tr>
END
}

print "</table></p>";

UI::writeEndForm();

UI::writeScriptFooter($cat);
