#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use CGI;
use strict;

use lib '.';
use Include;
use Editor;
use EditorProfile;
use Logs;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $ename = $cgi->param('editor');
my $list = $cgi->param('list');
my $enamel = $ename;

UI::writeHeaderCode("$ename - $TS::TS_profile_editorinfo");

if ($ename eq "") {
	print <<END;
<font size="+2">$TS::TS_profile_lookupeditor</font>
<br>
<hr><form method="get" action="profile.cgi">
<p><b>$TS::TS_profile_username</b>
<br><input type="text" name="editor" size="20">
<p><input type="submit" value="$TS::TS_profile_ok">
<br></form>
END
} else {
	$ename = Editor::validateEditor($ename);
	Logs::loghead($ename);
	EditorProfile::editorInfo($ename);
	Logs::genFeedback($ename);

	my $profile = Storage::getData('editor', $ename, 'html');
	
	print "$TS::TS_profile_profile<br>";
	print UI::safeHTML($profile);
}

UI::writeScriptFooter();
