#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


#Code for react login of users.

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $editor = $cgi->param('editor');
my $username = $cgi->param('usn');
my $act = $cgi->param('action');
my $reason = $cgi->param('reason');
my $currenteditor = Editor::currentUser();

my($users, $lou2, $lt);

UI::writeHeaderCode($TS::TS_reactuser_title);
Editor::writeECode();
Editor::restrictedMod();

if ($act eq "$TS::TS_reactuser_react") {
	$users = Storage::getData("global", "elist");
	if ($users=~/ $username /) {
		print $TS::TS_reactuser_error1;
	} else {
		$users = Storage::getData("global", "inlist");
		if ($users=~/ $username /) {
			open(EL, ">>$path_data/elist");
			print EL "$username ";
			close(EL);

			open(EL, "$path_data/inlist");
			$lou2 = <EL>;
			$lou2=~s/ $username / /g;
			close(EL);
			open(EL2, ">$path_data/inlist");
			print EL2 "$lou2";
			close(EL2);

			Storage::logMetaEdit($username,$currenteditor,'reinstate',0,$reason);

			print $TS::TS_reactuser_done;
		} else {
			print $TS::TS_reactuser_error2;
		}
	}
} else {
	print <<END;
<font size=+2>$TS::TS_reactuser_title</font><br>
<hr><form method="POST" action="reactuser.cgi">
<p><b>$TS::TS_common_editor:</b>
<br><input type="text" name="usn" value="$editor" size="20">
<p><b>$TS::TS_reactuser_reason:</b>
<br><input type="text" name="reason" size="38">
<p><input type="submit" value="$TS::TS_reactuser_react" name="action">
<br></form>
END
}

UI::writeScriptFooter();
