#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $submit = $cgi->param('submit');
my $cat = $cgi->param('cat');

$cat = Editor::testPrivs($cat);

my(@cats, $target, @secondcats);

if (defined $submit) {
	my($val) = $cgi->param('val');
	
	$val=~s/</&lt;/g;
	@cats = split(/\n/, $val);
	foreach $target (@cats) {
		$target=~s/[\n\r]//g;
		$target = Editor::validateCat($target);
		push(@secondcats, $target);
	}
	$val = join("\n", @secondcats);

	Storage::setData('category', $cat, 'rel', $val);
	Storage::logEdit("edit", "related", $cat, $val);
	Generate::updatePublicSide($cat);

	UI::editRedirect();
	UI::writeHeaderCode($TS::TS_related_title);
	Editor::writeECode();
	print "<p>$TS::TS_related_saved</p>";
} else {
	my $val = Storage::getData('category', $cat, 'rel');

	$val=~s/>/\//g;

	UI::writeHeaderCode($TS::TS_related_title);
	Editor::writeECode();

	UI::writeScriptHeader($cat, $TS::TS_related_title, $TS::TS_related_info);

	UI::writeStartForm($cat);
	UI::writeItemForm("$TS::TS_related_related", "<textarea name=\"val\" rows=\"10\" cols=\"70\">$val</textarea>");
	UI::writeEndForm();
}

UI::writeScriptFooter($cat);
