#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

UI::writeHeaderCode();
Editor::writeECode();
Editor::restrictedMeta();

my $cgi = new CGI;

my $oldfile = $cgi->param('ofile');
my $newfile = $cgi->param('file');

$oldfile = Storage::validateFileName($oldfile);
$newfile = Storage::validateFileName($newfile);

my($t1, $t2);

if ($newfile eq "") {
	print <<END;
<form method="POST" action="rename.cgi">
  <input type="hidden" value="$oldfile" name="ofile">
  <p><font size="4">Rename File:</font></p>
  <p>File:&nbsp;$oldfile&nbsp;&nbsp; ------&gt;&nbsp;&nbsp;&nbsp;
  <input type="text" name="file" size="20">&nbsp;&nbsp;
  <input type="submit" value="Submit"></p>
</form>
END
} else {
	$t1 = "$path_web/docs/$oldfile";
	$t2 = "$path_web/docs/$newfile";

	move($t1, $t2);
	print "File \"$oldfile\" renamed to \"$newfile\".";
	print "<p><b><a href=\"./edocs.cgi\">$TS::TS_common_back</a></b>";
}

UI::writeScriptFooter();
