#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my($cgi) = new CGI;

UI::writeHeaderCode("$TS::TS_renamepics_title");
Editor::writeECode();

my $oldfile = $cgi->param('file');
$oldfile = Storage::validateFileName($oldfile);

my $newfile = $cgi->param('nfile');
$newfile = Storage::validateFileName($newfile);

my $editor = $cgi->param('editor');
$editor = Editor::validateEditor($editor);

if ($isMeta ne "1") {
	$editor = Editor::currentUser();
}

if ($newfile eq "") {
	print <<END;
<form method="POST" action="renamepics.cgi">
  <input type="hidden" value="$oldfile" name="file">
  <input type="hidden" value="$editor" name="editor">
  <p><font size="4">$TS::TS_renamepics_renfile</font></p>
  <p>$TS::TS_renamepics_file&nbsp;$oldfile&nbsp;&nbsp; ------&gt;&nbsp;&nbsp;&nbsp;
  <input type="text" name="nfile" size="20">&nbsp;&nbsp;
  <input type="submit" value="$TS::TS_common_submit"></p>
</form>
END
} else {
	if (!(($newfile=~/.jpg$/) || ($newfile=~/.gif$/) || ($newfile=~/.png$/) || ($newfile=~/.bmp$/))) 	{
		print "Error: the new file name does not have a valid extention.";
	} else {
		my $t1 = "$path_web/img/$editor/$oldfile";
		my $t2 = "$path_web/img/$editor/$newfile";

		move($t1, $t2);
		print "$TS::TS_renamepics_file \"$oldfile\" $TS::TS_renamepics_renamedto \"$newfile\".";
		print "<p>$bold<a href=\"./edpics.cgi\">$TS::TS_common_back</a>$unBold";
	}
}

UI::writeScriptFooter();
