#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Logs;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $app = $cgi->param('app');
my $num = $cgi->param('num');
my $req = $cgi->param('req');

my(@files, @cat, @request, $x, @rapp);

UI::writeHeaderCode("Open Site - Logs");
Editor::restrictedMeta();

if (($app eq "") && ($num eq "")) {
	print <<END;
  <form method="GET" action="reqlog.cgi">
  <p><font size="4">$TS::TS_common_editor:</font><br>
  <input type="text" name="app" size="20"><input type="submit" value="Submit"></p>
</form>
END
	UI::writeScriptFooter();
	exit();
}

if (($app ne "") && ($num eq "")) {
	if ($req eq "1") {
		$num = "orig";
	} else {
		Editor::validateEditor($app);
		print "<H2>$TS::TS_common_editor: $app</H2>";
		print "<ol>";

		opendir(DIR, "$path_data/oldperm");
		my @files = readdir(DIR); 
		closedir(DIR); 

		chomp(@files);
		foreach (@files) {
			if ($_=~/$app/g) {
				open(EL, "$path_data/oldperm/$_");
				@cat= <EL>;
				close(EL);
				$_=~s/.req//g;
				print "<li><a href=\"reqlog.cgi?num=$_&app=$app\">$cat[0]</a></li>";
			}
		}

		print "</ol><br><br>";

		Logs::GenReqNoteLog($app);

		UI::writeScriptFooter();
		exit();
	}
}

if ($num ne "orig") {
	Editor::validateEditor($app);
	open(INFILE, "$path_data/oldperm/$num.req");
	@request = <INFILE>;
	close(INFILE);

	print <<END;
<table border="1" cellspacing="1" width="648" id="AutoNumber1">
  <tr>
    <td width="146">Category</td>
    <td width="489">$request[0]</td>
  </tr>
  <tr>
    <td width="146">Editor</td>
    <td width="489">$request[1]</td>
  </tr>
  <tr>
    <td width="146">Reason</td>
    <td width="489">
END

	$x = 1;

	while ($x ne $#request)	{
        	$x = $x + 1;
	        print "$request[$x] <br>\n"
	}

	print <<END;
 </td>
  </tr>
</table>

END
	UI::writeScriptFooter();
	exit();
}

if ($num eq "orig") {
	if ($req eq "1") {
		$app=~s/\.//g;
		$app=~s/\///g;
		open(DCATS, "$path_data/rjnapps/$app.req");
		@rapp = <DCATS>;
		close(DCATS);
	}

	if ($req ne "1") {
		Editor::validateEditor($app);
		open(DCATS, "$path_data/rnapps/$app.req");
		@rapp = <DCATS>;
		close(DCATS);
	}

	$rapp[0]=~s/\n//g;
	$rapp[1]=~s/\n//g;
	$rapp[2]=~s/\n//g;
	$rapp[3]=~s/\n//g;
	$rapp[4]=~s/\n//g;
	$rapp[5]=~s/\n//g;

	print <<END;

<H1>Editor Application</H1><table border="1" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="100%" id="AutoNumber1" bgcolor="#111111">
  <tr>
    <td width="100%"><font size="5" color="#FFFFFF">Editor Application</font></td>
  </tr>
  <tr>
    <td width="100%" bgcolor="#CCCCCC">Editor 
    Name: $rapp[1]<tr>
    <td width="100%" bgcolor="#CCCCCC">Category: 
    <a href="editcat.cgi?cat=$rapp[0]">$rapp[0]</a><tr>
    <td width="100%" bgcolor="#CCCCCC">E-Mail: $rapp[2]<tr>
    <td width="100%" bgcolor="#CCCCCC">IP:
    <a href="iplookup.cgi?IP=$rapp[4]">$rapp[4]</a><tr>
    <td width="100%" bgcolor="#CCCCCC">Reason:<br>
END

	$x = 4;

	while ($x ne $#rapp) {
	        $x = $x + 1;
        	print "$rapp[$x] <br>\n"
	}

	print "</table>";

	print "<hr>";
	print "<pre>RAW:\n\n@rapp</pre>";

	UI::writeScriptFooter();
	exit(0);
}
