#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $sure = $cgi->param('sure');
my $act = $cgi->param('action');
my $reason = $cgi->param('reason');
my $lt = localtime;
my $rmeta = $cgi->param('rmeta');
my $reditall = $cgi->param('reditall');
my $rroot = $cgi->param('rroot');
my $rall = $cgi->param('rall');
my $currenteditor = Editor::currentUser();

UI::writeHeaderCode($TS::TS_resign_title);
Editor::writeECode();

#Get cats
my $ccats = "";
if (open(TEXTFILE, "$path_data/eperm/$currenteditor.perm")) {
	$ccats = <TEXTFILE>;
	close(TEXTFILE);
}

my($lou, $lou2);

if (defined $sure) {
	# If we require to self-remove all categories before self-removing
	# from the project, we should check this and display $TS::TS_resign_e1 for error.
	if ($reason eq "") {
		print $TS::TS_resign_e2;
		UI::writeFooterCode();
		exit();
	}

	if (($reditall eq 1) && ($isEditall eq 1)) {
		open(EL, "$path_data/dirmod.gf");
		$lou2 = <EL>;
		$lou2=~s/ $ENV{REMOTE_USER} / /g;
		close(EL2);
		open(EL2, ">$path_data/dirmod.gf");
		print EL2 "$lou2";
		close(EL2);

		Storage::logMetaEdit($currenteditor, $currenteditor, 'revoke', 'EDITALL', $reason);
	}
        
	if (($rmeta eq 1) && ($isMeta eq 1)) {
		open(EL, "$path_data/dirman.gf");
		$lou2 = <EL>;
		$lou2=~s/ $ENV{REMOTE_USER} / /g;
		close(EL2);
		open(EL2, ">$path_data/dirman.gf");
		print EL2 "$lou2";
		close(EL2);

		Storage::logMetaEdit($currenteditor, $currenteditor, 'revoke', 'META', $reason);
	}

	if (($rroot eq 1) && ($isRoot eq 1)) {
		open(EL, "$path_data/root.gf");
		$lou2 = <EL>;
		$lou2=~s/ $ENV{REMOTE_USER} / /g;
		close(EL2);
		open(EL2, ">$path_data/root.gf");
		print EL2 "$lou2";
		close(EL2);

		Storage::logMetaEdit($currenteditor, $currenteditor, 'revoke', 'ROOT',$reason);
	}

	if ($rall eq 1) {
		$lou = Storage::getData("global", "elist");
		$lou=~s/ $ENV{REMOTE_USER} / /g;
		Storage::setData("global", "elist", $lou);

		open(EL2, ">>$path_data/inlist");
		print EL2 "$ENV{REMOTE_USER} ";
		close(EL2);
	
		Storage::logMetaEdit($currenteditor, $currenteditor, 'removed', 0, $reason);
	}

	print $TS::TS_resign_allgone;
	UI::writeFooterCode();
} else {
	UI::writeScriptHeader("", $TS::TS_resign_title, $TS::TS_resign_info);

	print <<END;
<hr><form method="POST" action="resign.cgi">
<input type="hidden" name="sure" value="1">
<input type="checkbox" name="rall" value="1"> - $TS::TS_resign_account<br>\n
END

	if ($isEditall eq 1) {
		print <<END;
<input type="checkbox" name="reditall" value="1"> - Editall<br>\n
END
	}

	if ($isMeta eq 1) {
		print <<END;
<input type="checkbox" name="rmeta" value="1"> - Meta<br>\n
END
	}

	if ($isRoot eq 1) {
		print <<END;
<input type="checkbox" name="rroot" value="1"> - Root<br>\n
END
	}

	print <<END;
<hr width="100%">
<p><b>$TS::TS_resign_reason:</b><br>
<input type="text" name="reason" size="37"><p><hr>
<p><input value="$TS::TS_common_submit" type="Submit"></p></form>
END

	UI::writeScriptFooter();
}
