#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $do = $cgi->param('do');
my $typeset = $cgi->param('newtype');

my $chainsaw = $cgi->param('chainsaw');

$cat = Editor::validateCat($cat);
if ($chainsaw) {
	UI::writeHeaderCode($TS::TS_review_super);
} else {
	UI::writeHeaderCode($TS::TS_review_title);
}

Editor::writeECode();

my $ncat = UI::getNiceFormat($cat);
my $pcat = $cat;
$pcat=~s/>/\//g;

if ($chainsaw) {
	print "<h4>$TS::TS_review_super</h4>";
} else {
	print "<h4>$TS::TS_review_title</h4>";
	print "<p>$TS::TS_review_info</p>";
	print "<p><a href=\"review.cgi?cat=$cat&chainsaw=1\">$TS::TS_review_super</a> - $TS::TS_review_superinfo</p>";
}

print "<h4>$TS::TS_common_category: $ncat</h4>";

my $users = 0;
if (open(USERS, "$path_sitedata/$cat.usections")) {
	$users = <USERS>;
	close(USERS);
}

my $x = 0;
my(@r);

if (($users eq "") || ($users eq "0")) {
	print "<p>No unreviewed found.</p>";
} else {
	for (my $d = 1; $d <= $users; $d++) {
		print "<a href=\"editsection.cgi?cat=$pcat&idtable=$d&unreviewed=1\">Item $d</a><br>";
	}
}

if ($chainsaw) {
	my ($tt, $cats, $catInd);
	open(EL, "$path_sitedata/cats.lst");
	$cats = <EL>;
	close(EL);
	$cats=~s/\s\s/ /g;
	$cats=~s/\//>/g;
	$cats=~s/\\/>/g;
	my(@cats) = split("; ", $cats);
	@cats = sort(@cats);
	my($spattern) = $cat . ">";
	foreach $catInd (@cats) {
		if ($catInd=~/^$spattern/) {
			my $tt = 0;
			if (open(USECTIONS, "$path_sitedata/$catInd.usections")) {
				$tt = <USECTIONS>;
				close(USECTIONS);
			}
			next if ( $tt < 1 );
			my $catn = UI::getNiceFormat($catInd);
			print "<p>$TS::TS_common_category: $catn</p>";
			for (my $dd = 1; $dd <= $tt; $dd++) {
				print "<a href=\"editsection.cgi?cat=$catInd&idtable=$dd&unreviewed=1\">Item $dd</a><br>";
			}
		}
	}
}

print "<br><br>";

UI::writeScriptFooter($cat);
