#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $username = $cgi->param('usn');
my $reason = $cgi->param('reason');
my $root = $cgi->param('root');
my $dirmod = $cgi->param('dirmod');
my $dirman = $cgi->param('dirman');
my $currenteditor = Editor::currentUser();
my $lt = localtime;

my($lou, $lou2);

UI::writeHeaderCode($TS::TS_revoke_title);
Editor::writeECode();
Editor::restrictedRoot();

if (!defined $username) {
	$username = "";
}

if (defined $cgi->param('action')) {
	if (defined $root) {
		open(EL, "$path_data/root.gf");
		$lou = <EL>;
		$lou=~s/ $username / /g;
		close(EL);
		open(EL, ">$path_data/root.gf");
		print EL "$lou";
		close(EL);
		print "$TS::TS_revoke_revroot<br>\n";

		Storage::logMetaEdit($username, $currenteditor, 'revoke', 'ROOT', $reason);
	}

	#Meta
	if (defined $dirman) {
		open(EL, "$path_data/dirman.gf");
		$lou2 = <EL>;
		$lou2=~s/ $username / /g;
		close(EL2);
		open(EL2, ">$path_data/dirman.gf");
		print EL2 "$lou2";
		close(EL2);
		print "$TS::TS_revoke_revmeta<br>\n";#

		Storage::logMetaEdit($username, $currenteditor, 'revoke', 'META', $reason);
	}

	if (defined $dirmod) {
		open(EL, "$path_data/dirmod.gf");
		$lou2 = <EL>;
		$lou2=~s/ $username / /g;
		close(EL2);
		open(EL2, ">$path_data/dirmod.gf");
		print EL2 "$lou2";
		close(EL2);
		print "$TS::TS_revoke_reveditall<br>\n";#

		Storage::logMetaEdit($username, $currenteditor, 'revoke', 'EDITALL', $reason);
	}
} else {
	print <<END;
<p><font size="5">$TS::TS_revoke_title</font></p>
$TS::TS_revoke_note
<br><br>
<form method="POST" action="revoke.cgi">
  <p><b>$TS::TS_common_username:</b><br>
  <input type="text" name="usn" value="$username" size="20"></p>
  <p><b>$TS::TS_common_reason:</b><br>
  <input type="text" name="reason" size="40"></p>
  <p><b>$TS::TS_revoke_suppriv:</b><br>
  <p><input type="checkbox" name="root" value="ON">ROOT</p>
  <p><input type="checkbox" name="dirmod" value="ON">EDITALL</p>
  <p><input type="checkbox" name="dirman" value="ON">META</p>
  <p><input type="submit" value="$TS::TS_common_submit" name="action"></p>
</form>
END
}

UI::writeScriptFooter();
