#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $reason = $cgi->param('reason');
my $ename = $cgi->param('name');
my $revoke = $cgi->param('revoke');
my $lt = localtime;
my $currenteditor = Editor::currentUser();

UI::writeHeaderCode($TS::TS_rmcat_title);
Editor::writeECode();
Editor::restrictedMeta();

my(@lou, $lou);

if ($ename eq "") {
	print <<END;
<form method="POST" action="rmcat.cgi">
  <p><font size="5">$TS::TS_rmcat_title</font></p>
  <p><b>$TS::TS_common_editor: </b><br>
  <input type="text" name="name" size="20"><br><input type="submit" value="$TS::TS_common_submit" name="B1"></p>
</form>
END
}

if ($act eq $TS::TS_common_submit) {
	$ename = Editor::validateEditor($ename);
	Editor::catmodPriv($cat);

	foreach $cat ($cat) {
		$cat = Editor::validateCat($cat, 2);
		open(EL, "$path_data/eperm/$ename.perm");
		$lou = <EL>;
		$lou=~s/ $cat; / /g;
		close(EL);
		open(EL, ">$path_data/eperm/$ename.perm");
		print EL "$lou";
		close(EL);

		open(EL, "$path_sitedata/$cat.ed");
		@lou = <EL>;
		close(EL);
		open(EL, ">$path_sitedata/$cat.ed");
		for (my $id = 0; $id < 50; $id++) {
			$lou[$id] =~s/$ename//g;
			if ($lou[$id] ne "\n") {
				print EL "$lou[$id]";
			}
		}
		close(EL);

		Generate::updatePublicSide($cat);

		print "$TS::TS_rmcat_youremoved $ename $TS::TS_rmcat_from $cat.<br>\n";

		Storage::logMetaEdit($ename,$currenteditor,'remove',0,"$cat ($reason)",$revoke);
	}
} else {
	if ($ename ne "") {
		print <<END;
<font size="+2">$TS::TS_rmcat_explain</font>
<br>
$TS::TS_rmcat_oneperturn
<hr><form method="POST" action="rmcat.cgi">
END
		open(EL, "$path_data/eperm/$ename.perm");
		my $ucat= <EL>;
		close(EL);
		open(EL, "$path_data/pginfo/tble");
		my $table= <EL>;
		close(EL);
		print "<ul>";
		my $uct = " ";
		my $uct2 = "";
		my $ind = 1;
		my $subcats = 0;

		while ($uct ne $ucat) {
			$uct = $uct . substr($ucat, $ind, 1);
			$uct2 = $uct2 . substr($ucat, $ind, 1);
			if ($uct2 eq " ") {
				$uct2 = "";
			}
			++$ind;
			if (substr($ucat, $ind, 1) eq ";") {
				print "<p><input type=\"checkbox\" name=\"cat\" value=\"$uct2\">$uct2</p>";
				$uct2 = "";
				$uct = $uct . substr($ucat, $ind, 1);
				++$ind;
			}
		}
		print "</ul>";
		print "<hr width=\"100%\">\n";

		print <<END;
<p><font size="3"><input type="hidden" value="$ename" name="name"><input type="checkbox" name="revoke" value="1"> $TS::TS_rmcat_hide</font></p>
<br>$TS::TS_common_reason:<br>
<input type="text" name="reason" size="60"><br>
<p><input type="submit" value="$TS::TS_common_submit" name="action">
<br></form>
END
	}  
}

UI::writeScriptFooter();
