#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $newfile = $cgi->param('file');
$newfile = Storage::validateFileName($newfile);

UI::writeHeaderCode("Remove Page");
Editor::writeECode();
Editor::restrictedMeta();

if ($newfile eq "") {
	print <<END;
<form method="POST" action="rmpage.cgi">
  <p align="left"><b>Remove File:<br>
  <input type="text" name="file" size="20"><br>
  <input type="submit" value="Delete"></b></p>
</form>
END
} else {
	unlink("$path_web/docs/$newfile");
	print "File \"$newfile\" deleted.<p><b><a href=\"./edocs.cgi\">$TS::TS_common_back</a></b>";
}

UI::writeScriptFooter();
