#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my($cgi) = new CGI;

my $cat  = $cgi->param('cat');
my $rwhy  = $cgi->param('rwhy');
my $raff  = $cgi->param('raff');
my $scont  = $cgi->param('scont');
my $dirman  = $cgi->param('dirman');
my $act = $cgi->param('action');
my $lt = localtime;

my(@files, $userf, $edits, $totaledits, $nicecat, @box, $currentskin);

$currentskin = $Common::currentskin;

if (!(-d "$path_data/nperms")) {
        mkdir "$path_data/nperms";
}

if ($cat ne "") {
	$cat = Editor::validateCat($cat);
}

UI::writeHeaderCode("$TS::TS_rncat_title");
Editor::writeECode();

opendir(DIR, "$path_data/nperms");
my @files = readdir(DIR);
closedir(DIR);

chomp(@files);
foreach (@files) {
	if($_ =~ /$ENV{REMOTE_USER}.req/) {
		print $TS::TS_rncat_tomany;
		UI::writeScriptFooter();
		exit(0);
	}
}

$rwhy=~s/\\n//g;
$raff=~s/\\n//g;
$scont=~s/\\n//g;
$rwhy=~s/\\r//g;
$raff=~s/\\r//g;
$scont=~s/\\r//g;

if ($act ne "") {
	if (($rwhy eq "") || ($raff eq "") || ($scont eq "")) {
		print $TS::TS_rncat_incomplete;
		UI::writeScriptFooter();
		exit(0);
	}

	if (!(-d "$path_data/eperm")) {
        	mkdir "$path_data/eperm";
	}


	open(USERS, "$path_data/eperm/$ENV{REMOTE_USER}.perm");
	$userf = <USERS>;
	close(USERS);
	if ($userf=~/ $cat; /) {
		print "$TS::TS_rncat_alreadyhave <br>";
	} else {
		$cat=~s/\n//g;

		$lt = localtime;

	        $totaledits = Storage::logGetID();

		open(TEXTFILE, ">$path_data/nperms/$totaledits.req");
		print TEXTFILE "$cat\n";
		print TEXTFILE "$ENV{REMOTE_USER}\n";
		print TEXTFILE "\n";
		print TEXTFILE "\n";
		print TEXTFILE "$lt\n";
		print TEXTFILE "$rwhy\n";
		print TEXTFILE "$raff\n";
		print TEXTFILE "$scont\n";
		close(TEXTFILE);

		print "$TS::TS_rncat_applied <br>";
	}
} else {
	$nicecat = $cat;
	$nicecat=~s/_/ /g;
	$nicecat=~s/>/\//g;
	print <<END;
 <div align="center">
   <center>
   <table id="AutoNumber1" style="BORDER-COLLAPSE: collapse" borderColor="#111111" cellSpacing="20" width="443" bgColor="$Common::box[$currentskin]" border="0">
     <tr>
       <td width="439">
       <p align="center"><font size="5">$TS::TS_rncat_title</font></p>
       <form method="POST" action="rncat.cgi">
   <p><b>$TS::TS_common_category:</b><br>
   <input size="40" name="cat" value="$nicecat"></p>
   <p>$TS::TS_rncat_quest1:<br>
   <textarea rows="9" name="rwhy" cols="50"></textarea>
   <p>$TS::TS_rncat_affiliations:<br>
   <textarea rows="9" name="raff" cols="50"></textarea>
   <p>$TS::TS_rncat_sample_content:<br>
   <textarea rows="9" name="scont" cols="50"></textarea>
   <p><input type="submit" value="$TS::TS_rncat_button1" name="action"></p>
       </form>
       </td>
     </tr>
   </table>
   </center>
 </div>

END
}

UI::writeScriptFooter();
