#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $last = $cgi->param('last');

my($qcmd, $rlog, @edits, $ook, $catt, $rjapp);

UI::writeHeaderCode($TS::TS_rootlog_title);
Editor::restrictedMeta();

if ($qcmd ne "") {
	print "<br><H2><b>Root Edit Log<br></H2></b>\n";
 
	print <<END;
<form method="POST" action="rootlog.cgi">
Log cleared.<br></form>
END
} else {
	if ($last eq "") {
	        $last = 20;
	}

	print "<br><h2><b>$TS::TS_rootlog_title ($TS::TS_rootlog_last $last)<br></h2></b>\n";

	UI::writeStartForm("", "rootlog.cgi");
	UI::writeInputItemForm($TS::TS_rootlog_last, "text", "last");
	UI::writeEndForm();

	print <<END;
<table border="1" id="AutoNumber1" cellpadding="2">
  <tr>
    <td bgcolor="#CCCCCC">meta</td>
    <td>date</td>
    <td>editor</td>
    <td>action</td>
    <td>comments</td>
  </tr>
END

	my @rlog;
	open(INFILE, "$path_data/logs/rootlog/ametalog.log");
	while (<INFILE>) {
		push @rlog, $_;
		if ($#rlog == $last) {
			shift @rlog;
		}
	}
	close(INFILE);
	
	$rlog = join("", @rlog);

        $rlog=~s/#\#!!#\#/ <tr><td bgcolor="#CCCCCC"> /g;
        $rlog=~s/ \#!\#/ <\/td> /g;
        $rlog=~s/ ##!## / <td> /g;
        $rlog=~s/\#\#!!!\#\# / <td> /g;
        $rlog=~s/##!!!!\##/ <\/td><\/tr> /g;

	opendir(DIR, "$path_data/misc/");
	my @edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/.eaddr/) {
			$_=~s/.eaddr//g;
			$ook = " <a href=\"profile.cgi?editor=$_\">$_</a> ";
			$rlog=~s/ $_ /$ook/g;
		}
	}

	opendir(DIR, "$path_sitedata");
	@edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/.html/) {
			$_=~s/.html//g;
			$catt = $_;
			$catt=~s/\>/\//g;
			$ook = " <a href=\"editcat.cgi?cat=$catt\">$catt</a> ";
			$rlog=~s/ $_ /$ook/g;
		}
	}

	opendir(DIR, "$path_data/rjnapps");
	@edits = readdir(DIR);
	closedir(DIR);

	chomp(@edits);
	foreach (@edits) {
		if ($_=~/.req/) {
			$_=~s/.req//g;
			$rjapp = " [<a href=\"reqlog.cgi?app=$_&req=1\">$_</a>] ";
			$rlog=~s/ - $_ - / - $rjapp /g;
			$rlog=~s/-$_-/ - $rjapp /g;
		}
	}

	print $rlog;
	print "</table>";

	print "<br></form>";
}

UI::writeFooterCode();
