#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $act = $cgi->param('action');
my $ok = "ok";

my $lt = localtime;

UI::writeHeaderCode("New Category");
Editor::writeECode();
Editor::restrictedRoot();

if (!(-d $path_sitedata)) {
	mkdir($path_sitedata);
}

if (!(-f "$path_sitedata/cats.lst")) {
	open(FILE, ">$path_sitedata/cats.lst");
	print FILE " ";
	close(FILE);
}

open(USERS, "$path_sitedata/cats.lst");
my $users = <USERS>;
close(USERS);

if ($users=~/ $cat; /) {
	print "This category has already been created.";
} else {
	if ($cat=~/ /g) {
		print <<HTML_QUOTE;
Please do not use " " (spaces) in the name. <br>
<b><a href="../">Editor's Home</a></b><br>\n
HTML_QUOTE
	} else {
		if ($act eq "Create") {
			open(EL, ">$path_sitedata/$cat.html");
			print EL "$ok ";
			close(EL);
			open(EL4, ">>$path_sitedata/cats.lst");
			print EL4 "$cat; ";
			close(EL4);
			print <<HTML_QUOTE;
The category has been created. <br>
HTML_QUOTE

			#log code
			open(EL, "$path_data/pginfo/tble");
			my $table= <EL>;
			close(EL);

			print TEXTFILE "<i>$lt</i><br>Category: '$cat' created!<br>Created by: $ENV{REMOTE_USER}; $table\n";
			close(TEXTFILE);
			open(TEXTFILE, ">>$path_data/logs/rootlog/rlog.log");
			print TEXTFILE "<i>$lt</i><br>Category: '$cat' created!<br>Created by: $ENV{REMOTE_USER}; $table\n";
			close(TEXTFILE);
		} else {
			print <<HTML_QUOTE;
<font size="+2">New Category</font>
<br>
<hr><form method="post" action="rootnewcat.cgi">
<p><b>Category:</b><br>
<i>Ex: home</i>
<br><input type="text" name="cat" size="40">
<p><input type="submit" value="Create" name="action">
<br></form>
HTML_QUOTE
		}
	}
}

UI::writeScriptFooter();
