#!/usr/bin/perl 
#************************************************************************ 
# 
# The contents of this fi 
# The contents of this file are subject to the Mozilla Public License 
# Version 1.1 (the "License"); you may not use this file except in 
# compliance with the License. You may obtain a copy of the License at 
# http://www.mozilla.org/MPL/ 
# 
# Software distributed under the License is distributed on an "AS IS" 
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
# License for the specific language governing rights and limitations 
# under the License. 
# 
# 
# The Original Code is Open-site. 
# 
# The Initial Developer of the Original Code is Open-site.org Website. 
# 
# Portions created by Open-site.org are Copyright (C) 2002. 
# All Rights Reserved. 
# 
#************************************************************************ 
 

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use UI;

my $cgi = new CGI;
my $search = $cgi->param('search');
my $start = $cgi->param('start');

if ($start eq "") { $start = 0 };

#if ($search=~/./)
#{ 
#	#Temp fix, hence no string.
#	print $TS::TS_search_error1;
#	die;
#};

sub LovNav {
	my($start,$end,$dump,$last) = @_;
	my $pstart = $start + 1;
	my $pdump = $dump + 1;
	print <<END;
<p><font size=\"3\">$TS::TS_search_viewing: ($pstart - $end $TS::TS_search_of $pdump)<br>
$bold
[<a href="./search.cgi?search=$search&start=$end">$TS::TS_search_next 20</a>]
[<a href="./search.cgi?search=$search&start=$last">$TS::TS_search_last 20</a>]
</font>
$unBold</p>
END
	return 1;
}

UI::writeHeaderCode($TS::TS_search_title);
Editor::writeECode();

# print HTML header

if ($search eq "") {
	GenerateSearch();
	UI::writeScriptFooter();
	exit();
}

if (length($search) < 3) { 
	print $TS::TS_search_error2;
	GenerateSearch();
	UI::writeScriptFooter();
	exit();
}

open(SDUMP, "$path_data/search.fdb");
my @sdump = <SDUMP>;
close(SDUMP);
my @rdump = grep { /$search/i } @sdump;

#Rid of HTML
foreach (@rdump) {$_=~s/\<(.*?)\>//g};

my $end = $start + 20;
my $last = $start - 20;

print "<p> $bold <font size=\"5\">$TS::TS_search_sresults</font> $unBold </p>";
print "<p><font size=\"4\">$TS::TS_search_searchingfor &quot;$search&quot;...</font></p>";

GenerateSearch();
print "<hr>";

LovNav($start, $end, $#rdump, $last);

my $x = $start;


while ($x ne $end) {

if ($rdump[$x] ne "") {
my @hitcat = split(/:/, $rdump[$x]);
$hitcat[1]=~s/\>/\//g;
my $hitcontent = $rdump[$x];
#$hitcontent=~s/$hitcat[1]//g;
$hitcontent=~s/CAT:(.*?)://g;

#Block results
my @safer = split(/\//, $hitcat[1]);
my $skip = 0;

if ($skip ne 1) { 
	print <<END;
<table border="0">
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_common_category</strong></td>
    <td><strong><a href="http://$HD_domain$path_on_server/$hitcat[1]">$hitcat[1]</a></strong></td>
  </tr>
 <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_search_options</strong></td>
    <td><strong><a href="http://$HD_domain$path_on_server/editors/editcat.cgi?cat=$hitcat[1]">$TS::TS_search_editcat</a></strong></td>
 </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>$TS::TS_search_content</strong></td>
    <td>$hitcontent</td>
  </tr>
</table>
<br>
END
}
}

$x++;

}

LovNav($start,$end,$#rdump,$last);

print "<hr>";
print $sdump[0];
print "<br>" x 3;

sub GenerateSearch {
	print <<HTML_QUOTE;
<form action="search.cgi" method="get">
  <div align="center">
    <center>
    <table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="0" width="372" bgColor="#bbbbbb" border="0">
      <tr>
        <td align="left" width="370"><b>$TS::TS_search_title:</b> </td>
      </tr>
      <tr>
        <td align="left" width="370">
        <p align="center"><input size="40" name="search">
        <input type="submit" value="Search"></td>
      </tr>
    </table>
    </center>
  </div>
</form>
HTML_QUOTE
	return 1;
}

GenerateSearch();

UI::writeScriptFooter();
