#!/usr/bin/perl 
#************************************************************************ 
# 
# The contents of this fi 
# The contents of this file are subject to the Mozilla Public License 
# Version 1.1 (the "License"); you may not use this file except in 
# compliance with the License. You may obtain a copy of the License at 
# http://www.mozilla.org/MPL/ 
# 
# Software distributed under the License is distributed on an "AS IS" 
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
# License for the specific language governing rights and limitations 
# under the License. 
# 
# 
# The Original Code is Open-site. 
# 
# The Initial Developer of the Original Code is Open-site.org Website. 
# 
# Portions created by Open-site.org are Copyright (C) 2002. 
# All Rights Reserved. 
# 
#************************************************************************ 
 

use strict; 
use CGI; 

use lib '.';
use Include; 
use Editor;
use Settings; 
use TS;
use UI;
 
UI::writeHeaderCode($TS::TS_searchgen_title); 
Editor::writeECode(); 
 
my $cgi = new CGI; 
my $cmd = $cgi->param('cmd'); 
my $verify = $cgi->param('verify');
my $what = $cgi->param('what');
 
Editor::restrictedRoot();

print "<H2>$TS::TS_searchgen_title</H2>";

sub status {
	my ($name) = @_;

	open(FLOW, "$path_code/bin/$name.flow");
	my $flow = <FLOW>;
	close(FLOW);
	my @flow = split(/\|/, $flow);
	$flow[1]=~s/\n//g;

	print "<p>Status for the <strong>$name</strong> module: ";

	if ($flow[0] eq $flow[1]) {
		print '<span style="color: rgb(51, 204, 0);">';
		print $TS::TS_searchgen_completed;
		print '</span>';
	} else {
		my $div = $flow[0]/$flow[1]*100;
		print "$flow[0] \/ $flow[1] ($div\%)";

		my $perc = int($div * 10) / 10;
		my $width = int($div);
		my $width2 = 100 - $width;
		if (!($perc =~/\./)) {
			$perc .= ".0";
		}
		$perc .= "&nbsp;%";

		print <<END;
  <table width="100" cellspacing="0">
    <tr>
END
		if ($width > 0) {
			print <<END;
      <td width="$width%" bgcolor="#33ff44">&nbsp;</td>
END
		}
		if ($width2 > 0) {
			print <<END;
      <td width="$width2%" bgcolor="#ffaaaa">&nbsp;</td>
END
		}
		print <<END;
    </tr>
  </table>
END
	}

	if ((-f "$path_code/bin/$name.start") && (-f "$path_code/bin/$name.stop")) {
		open(FIL, "$path_code/bin/$name.start");
		my $sec1 = <FIL>;
		close(FIL);
		open(FIL, "$path_code/bin/$name.stop");
		my $sec2 = <FIL>;
		close(FIL);
		my $dif = $sec2 - $sec1;
		if ($dif >= 0) {
			print "<br>Last run took $dif seconds.";
		}
	}

	print "<br>" x 2;

	if ($flow[0] eq $flow[1]) {
		if (((!($cmd)) && ($verify eq "")) || ($what ne $name)) {
			print "<a href=\"./searchgen.cgi?what=$name&cmd=start\">$TS::TS_searchgen_start</a>";
		}
		if (($cmd) && ($verify eq "") && ($what eq $name)) {
			print $TS::TS_searchgen_startq . " ";
			print "<a href=\"./searchgen.cgi?what=$name&cmd=start&verify=1\">[$TS::TS_searchgen_startr1]</a> ";
			print "<a href=\"./searchgen.cgi\">[$TS::TS_searchgen_startr2]</a>";
		}
		if (($cmd) && ($verify) && ($what eq $name)) {
			if ($name eq "search") {
				system("nohup $path_code/bin/searchbuild.pl&");
			} elsif ($name eq "rdf") {
				system("nohup $path_web/editors/makerdf.cgi&");
			}
			print $TS::TS_searchgen_startd;
		}
	}
}

status("search");
status("rdf");

UI::writeScriptFooter();
