#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $qcmd = $cgi->param('cmd');
my $editor = $cgi->param('editor');
my $search = $cgi->param('search');
my $lines = $cgi->param('lines');
my $logfull = $cgi->param('logfull');

if ($lines eq "") {
	$lines = 150;
}

UI::writeHeaderCode("Server Logs");
Editor::writeECode();
Editor::restrictedRoot();

if ($qcmd eq "Clear") {
	open(TEXTFILE, ">$path_data/logs/webaccess/access.log");
	print TEXTFILE "";
	close(TEXTFILE);
	print "<br><h2><b>Access Logs<br></H2></b>\n";

	#Request Log
	print <<HTML_QUOTE;
<form method="POST" action="serverlogs.cgi">
Log cleared.
<br></form>
HTML_QUOTE
} else {
	print "<br><H2><b>Access Logs - last $lines entries<br></H2></b>\n";

	my $ch = "";
	if ($logfull ne "") {
		$ch = " checked";
	}

	print <<END;
<form method="GET"><p>Number of lines to display: &nbsp;
<input type="text" name="lines" size="8" value="$lines"></p>
<p>Restrict to a specific editor: &nbsp;
<input type="text" name="editor" size="8" value="$editor">
<input type="submit" value="$TS::TS_common_submit"></p>
<p><input type="checkbox" name="logfull"$ch>Display the full log</p>
</form>
END
	my $rlog;

	if (($editor eq "") && ($search eq "")) {
		$rlog = `tail -$lines $path_data/logs/webaccess/access.log`;
	} else {
		if ($editor ne "") {
			$rlog = `cat $path_data/logs/webaccess/access.log | grep " - $editor " | tail -$lines`;
		} else {
			if ($search ne "") {
				$rlog = `cat $path_data/logs/webaccess/access.log | grep "$search" | tail -$lines`;
			}
		}
	}

	$rlog=~s/GET ([^ ]*) /GET <a href="$1">$1<\/a> /g;
	$rlog=~s/ ([^ ]{2,}) \[/ <a href="\/editors\/profile.cgi?editor=$1">$1<\/a> \[/g;
	my $ulist = "";
	my @blist;
	while ($rlog=~/"(http:\/\/.*?)"/g) {
		my $url = $1;
		if (!($url=~/http:\/\/open-site.org/)) {
			$ulist = $ulist . "<a href=\"$url\">$url</a>\n";
		}
	}

	my $counter = 0;
	my %blist;
	while ($rlog=~/\((.*?); (.*?); (.*?)[\);]/g) {
		$counter++;
		$blist{$2} = $blist{$2} + 1;
		$blist{$3} = $blist{$3} + 1;
	}

	$rlog=~s/"(http:\/\/.*?)"/"<a href="$1">$1<\/a>"/g;
	$rlog=~s/([0-9]*\.[0-9]*\.[0-9]*\.[0-9]*) /<a href="http:\/\/www\.ripe\.net\/perl\/whois\?searchtext=$1">$1<\/a> /g;

	print "The list of referrers within the results:<br><pre>$ulist</pre>\n";

	print "<p>Browser Status:<ul><li>$lines total lines.</li><li>$counter parsed succesfully - (x; y; z) format.</li>";
	print "<li> $blist{'MSIE 5.0'} - MSIE 5.0</li>";
	print "<li> $blist{'MSIE 5.01'} - MSIE 5.01</li>";
	print "<li> $blist{'MSIE 5.14'} - MSIE 5.14</li>";
	print "<li> $blist{'MSIE 5.5'} - MSIE 5.5</li>";
	print "<li> $blist{'MSIE 6.0'} - MSIE 6.0</li>";
	print "</ul></p>";

	print "<p>OS Status:<ul><li>$lines total lines.</li><li>$counter parsed succesfully - (x; y; z) format.</li>";
	print "<li> $blist{'Windows 95'} - Windows 95</li>";
	print "<li> $blist{'Windows 98'} - Windows 98</li>";
	print "<li> $blist{'Windows NT 5.0'} - Windows NT 5.0</li>";
	print "<li> $blist{'Windows NT 5.1'} - Windows NT 5.1</li>";
	print "<li> $blist{'Mac_PowerPC'} - Mac_PowerPC</li>";
	print "</ul></p>";

	if ($logfull ne "") {
		print "<pre>\n$rlog\n<\/pre>\n";
	}
}

UI::writeScriptFooter();
