#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $message = $cgi->param('message');
my $editor = $cgi->param('editor');
my $act = $cgi->param('action');

UI::writeHeaderCode("Send Mail to Editors");
Editor::restrictedRoot();

if ($act ne "") {
	my $users = Storage::getData("global", "elist");
	if ($users=~/ $editor /) {
		open(EL, "$path_data/pginfo/tble");
		my $table= <EL>;
		close(EL);

		my $lt = localtime;
		open(TEXTFILE, ">>$path_data/misc/mail/$editor.mail");
		print TEXTFILE "<b>EDITOR - STAFF MAIL!:</b><br>From: Open Site Staff<br><i>$lt</i><br>Message:<br>$message $table\n";
		close(TEXTFILE);

		print "Your message has been sent.<br>";
		print <<HTML_QUOTE;
<b><a href="./">$TS::TS_common_back</a></b><br>\n
HTML_QUOTE
	} else {
		print "Please spell the name of the editor you wish to mail correctly.";
	}
} else {
	print <<HTML_QUOTE;
<font size="5">Mail Editors</font><br>
<form method="POST" action="smail.cgi">
<p><b>From: Open Site Staff</b><br>
<p><b>To Editor:</b><br>
<input type="text" name="editor" size="20"></p>
<p><b>Message:</b><br>
<textarea rows="10" name="message" cols="60"></textarea><br>
<p><input type="submit" value="Send" name="action"></p>
HTML_QUOTE
}

UI::writeFooterCode();
