#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;
use File::Copy;

use lib '.';
use Include;
use Editor;
use Mailsplit;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $act = $cgi->param('act');
my $id = $cgi->param('id');
my $message = $cgi->param('message');
my $to = $cgi->param('to');
my $subject = $cgi->param('subj');
my $lt = localtime;

my(@data, @allmail, @mail);

UI::writeHeaderCode($TS::TS_staffemail_title);
Editor::restrictedRoot();

if ($act eq "") {
	Mailsplit::OpMail("staff", 1, 1);
}

if ($act eq "snd") {
	open(SENDMAIL, "| $path_sendmail") || die "Unable to open sendmail";
	print SENDMAIL <<END_MAIL;
From: staff\@$HD_domain
To: $to
Subject: $subject
$message
END_MAIL
	close(SENDMAIL);

	print "$TS::TS_staffemail_sent<br><br>";
}

if ($act eq "comp") {
	print <<END;
<H2>$TS::TS_staffemail_comp</H2>
<form action="staffemail.cgi" method="post">
<strong>$TS::TS_staffemail_from:</strong> staff\@$HD_domain<br><br><strong>$TS::TS_staffemail_to:</strong><br>
<input size="40" name="to">
<br>
<strong>$TS::TS_staffemail_subject:</strong><br>
<input size="40" name="subj">
<br><br>
<strong>$TS::TS_staffemail_message:</strong>
<br>
<textarea rows="8" name="message" cols="80"></textarea><br><br>
<input type="hidden" name="act" value="snd">
<input type="submit" value="$TS::TS_staffemail_send">
END
}

if ($act eq "rm") {
	if ($id=~/staff/) {
		@data = split(/-/, $id);
		move("$path_data/mail/$data[0]-$data[1]-staff", "$path_data/mail/delete/$id");
		print "$TS::TS_staffemail_mesmv<br>";
	} else {
		print "$TS::TS_staffemail_delm<br>";
	}
}

if ($act eq "") {
	print "<H2>$TS::TS_staffemail_title</H2><H4>$TS::TS_staffemail_misc</H4>";

	opendir(DIR,"$path_data/mail/");
	@allmail = readdir(DIR);
	closedir(DIR);

	my $OpMail_totalmesleft = 0;

	foreach(@allmail) {
		if ($_=~/staff/) {
			$OpMail_totalmesleft++;
		}
	}

	print "$TS::TS_staffemail_mess $OpMail_totalmesleft $TS::TS_staffemail_mess2";

	foreach(@allmail) {
		if ($_=~/staff/) {
			open(MAIL, "$path_data/mail/$_");
			@mail = <MAIL>;
			close(MAIL);

			print <<END;
<p><table cellpadding="2" cellspacing="2" border="1">
  <tbody>
    <tr>
      <td valign="Top">$TS::TS_staffemail_mid
      </td>
      <td valign="Top">$_<br>
      </td>
    </tr>
    <tr>
      <td valign="Top">$TS::TS_staffemail_mesd
      </td>
      <td valign="Top"><pre> @mail</pre><br>
      </td>
    </tr>
    <tr>
      <td valigh="Top"></td>
      <td valigh="Top"><form method="get" action="staffemail.cgi">
        <input type="hidden" name="id" value="$_">
	<input type="hidden" name="act" value="rm">
        <input type="submit" value="$TS::TS_staffemail_delete"><br>
        </form>
    </td>
   </tr>
</table></p>

END

		}
	}
}

if ($act ne "comp") {
	print "<p><a href=\"./staffemail.cgi?act=comp\">$TS::TS_staffemail_comp</a></p>";
}

if ($act ne "") {
	print "<p><a href=\"./staffemail.cgi\">$TS::TS_staffemail_eindex</a></p>";
}

UI::writeScriptFooter();
