#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use CGI;
use strict;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;
my $notActive = $cgi->param('notActive');
my $notInactive = $cgi->param('notInactive');
my $restricted = $cgi->param('restricted');
my $showEmail = $cgi->param('showEmail');
my $sort = $cgi->param('sort');
my $showStatus = $cgi->param('showStatus');
my $showLastLogin = $cgi->param('showLastLogin');
my $showJoined = $cgi->param('showJoined');
my $showCats = $cgi->param('showCats');
my $showNoEdits = $cgi->param('showNoEdits');

if (!defined $restricted) {
	$restricted = "";
}

my $eds = Storage::getData("global", "elist");
my $ed2 = Storage::getData("global", "inlist");

$eds=~s/active://;

my($list);

UI::writeHeaderCode($TS::TS_stats_title);

print "<h2>$TS::TS_stats_title</h2>";

if ((!defined $sort) || ($sort eq "")) {
	$sort = 1;
}

if ($isMeta ne "1") {
	$showEmail = undef;
	if ($sort == 4) {
		$sort = 1;
	}
}



# Compares two dates.
# Params: 2
# Param 1: the first date.
# Param 2: the second date.
# Returns:
#  -  -1 : the first date is more old compared to the 2nd date.
#  -   0 : the first date and the 2nd date are the same.
#  -   1 : the first date is more recent compared to the 2nd date.

sub dateCmp
{
	my($a, $b) = @_;

	if (!defined $a) {
		return -1;
	}
	if ($a eq "") {
		return -1;
	}
	if (!defined $b) {
		return 1;
	}
	if ($b eq "") {
		return 1;
	}

	$a=~s/  / /g;
	$b=~s/  / /g;

	my @date1 = split(/ /, $a);
	my @date2 = split(/ /, $b);

	my $month1 = $date1[1];
	my $day1 = $date1[2];
	my $year1 = $date1[4];
	my $mon1 = Common::getMonth($month1);
	my $hms1 = $date1[3];
	$hms1=~/^([^:]*):([^:]*):([^:]*)$/;
	my $h1 = $1;
	my $m1 = $2;
	my $s1 = $3;

	my $month2 = $date2[1];
	my $day2 = $date2[2];
	my $year2 = $date2[4];
	my $mon2 = Common::getMonth($month2);
	my $hms2 = $date2[3];
	$hms2=~/^([^:]*):([^:]*):([^:]*)$/;
	my $h2 = $1;
	my $m2 = $2;
	my $s2 = $3;

	if ($year1 < $year2) {
		return -1;
	}

	if ($year1 > $year2) {
		return 1;
	}

	if ($mon1 < $mon2) {
		return -1;
	}

	if ($mon1 > $mon2) {
		return 1;
	}

	if ($day1 < $day2) {
		return -1;
	}

	if ($day1 > $day2) {
		return 1;
	}

	if ($h1 < $h2) {
		return -1;
	}

	if ($h1 > $h2) {
		return 1;
	}

	if ($m1 < $m2) {
		return -1;
	}

	if ($m1 > $m2) {
		return 1;
	}

	if ($s1 < $s2) {
		return -1;
	}

	if ($s1 > $s2) {
		return 1;
	}

	return 0;
}

sub getFrm {
	my($var) = @_;
	if ((defined $var) && ($var ne "")) {
		return " checked";
	}

	return "";
}

sub getFrm2 {
	my($var, $value) = @_;
	if ($var == $value) {
		return " checked";
	}

	return "";
}

sub comp {
	my($a, $b) = @_;
	if ($a < $b) {
		return 1;
	}

	if ($a > $b) {
		return -1;
	}

	return 0;
}

my $frmNotActive = getFrm($notActive);
my $frmNotInactive = getFrm($notInactive);
my $frmShowLastLogin = getFrm($showLastLogin);
my $frmShowStatus = getFrm($showStatus);
my $frmShowEmail = getFrm($showEmail);
my $frmShowJoined = getFrm($showJoined);
my $frmShowCats = getFrm($showCats);
my $frmShowNoEdits = getFrm($showNoEdits);

my $frmSort1 = getFrm2($sort, 1);
my $frmSort2 = getFrm2($sort, 2);
my $frmSort3 = getFrm2($sort, 3);
my $frmSort4 = getFrm2($sort, 4);
my $frmSort5 = getFrm2($sort, 5);

print <<END;
<form method="get">
<table align="center" bgcolor="#f0f0f0"><tr><td>
<p>
$TS::TS_stats_restrict: <input type="text" name="restricted" size="30" value="$restricted">
<p>
<input type="checkbox" name="notActive"$frmNotActive>$TS::TS_stats_ignoreactive<br>
<input type="checkbox" name="notInactive"$frmNotInactive>$TS::TS_stats_ignoreinactive<br>
<input type="checkbox" name="showLastLogin"$frmShowLastLogin>$TS::TS_stats_showlogin<br>
<input type="checkbox" name="showStatus"$frmShowStatus>$TS::TS_stats_showstatus<br>
<input type="checkbox" name="showJoined"$frmShowJoined>$TS::TS_stats_showjoined<br>
<input type="checkbox" name="showCats"$frmShowCats>$TS::TS_stats_showcats<br>
<input type="checkbox" name="showNoEdits"$frmShowNoEdits>$TS::TS_stats_shownoedits<br>
END

if ($isMeta eq "1") {
	print <<END;
<input type="checkbox" name="showEmail"$frmShowEmail>$TS::TS_stats_showemail<br>
END
}

print <<END;
<table><tr><td rowspan="2">$TS::TS_stats_sortby:</td><td><input type="radio" name="sort" value="1"$frmSort1>$TS::TS_stats_login
<input type="radio" name="sort" value="2"$frmSort2>$TS::TS_stats_joined</td></tr>
<tr><td>
<input type="radio" name="sort" value="3"$frmSort3>$TS::TS_stats_lastlogin
END

if ($isMeta eq "1") {
	print <<END;
<input type="radio" name="sort" value="4"$frmSort4>$TS::TS_stats_email
END
}

print <<END;
<input type="radio" name="sort" value="5"$frmSort5>$TS::TS_stats_noedits
</td></tr></table>
<p><center><input type="submit" name="submit" value="$TS::TS_common_submit">
</td></tr></table>
</form><p>
END

my $showFull = 0;
my $cols = 1;

if (defined $showLastLogin) {
	$cols++;
}
if (defined $showStatus) {
	$cols++;
}
if (defined $showEmail) {
	$cols++;
}
if (defined $showJoined) {
	$cols++;
}
if (defined $showNoEdits) {
	$cols++;
}

if ($cols > 1) {
	$showFull = 1;
}

if (defined $notActive) {
	$notInactive = "";
	print $TS::TS_stats_displayinactive;
	$list = $ed2;
}

if (defined $notInactive) {
	$notActive = "";
	print $TS::TS_stats_displayactive;
	$list = $eds;
}

if ((!defined $notInactive) && (!defined $notActive)) {
	print $TS::TS_stats_displayall;
	$list = $ed2 . $eds;
	$list=~s/ {2,}/ /g;
}

$list=~s/^ {1,}//;
$list=~s/ {1,}$//;

my @editors = split(" " , $list);
my %cats;

$restricted=~s/\//>/g;
for (my $d = 0; $d <= $#editors; $d++) {
	my $ed = $editors[$d];
	if (open(EL, "$path_data/eperm/$ed.perm")) {
		my $ucat = <EL>;
		close(EL);
		if ($ucat=~/$restricted/) {
			$cats{$ed} = $ucat;
		} else {
			$editors[$d] = "";
		}
	} else {
		$editors[$d] = "";
	}
}

$list = join(" ", @editors);
$list=~s/ {2,}/ /g;
@editors = split(" ", $list);

my $displayNumber = $#editors + 1;

print "<p>$displayNumber $TS::TS_stats_edfound.</p>";

if ($showFull) {
	my $tab = "";
	$tab = "<table width=\"100%\">";

	$tab .= "<tr bgcolor=\"#dddddd\"><th>$TS::TS_stats_username</th>";

	if (defined $showEmail) {
		$tab .= "<th>$TS::TS_stats_email</th>";
	}

	if (defined $showStatus) {
		$tab .= "<th>$TS::TS_stats_status</th>";
	}

	if (defined $showLastLogin) {
		$tab .= "<th>$TS::TS_stats_lastlogin</th>";
	}

	if (defined $showJoined) {
		$tab .= "<th>$TS::TS_stats_joined</th>";
	}

	if (defined $showNoEdits) {
		$tab .= "<th>$TS::TS_stats_noedits</th>";
	}

	$tab .= "</tr>";

	my %email;
	my %joined;
	my %llogin;
	my %noEdits;

	open(META, "$path_data/logs/rootlog/areqeditlog.log");
	my @rlog2 = <META>;
	close(META);
	@rlog2 = grep { /##!## join #!#/ } @rlog2;

	for (my $d = 0; $d <= $#editors; $d++) {
		my $ed = $editors[$d];

		$email{$ed} = Editor::getEmail($ed);

		if (open(FIL, "$path_data/logs/$ed.ll")) {
			$llogin{$ed} = <FIL>;
			close(FIL);
		} else {
			$llogin{$ed} = "";
		}

		my @rlog3 = grep { /##!!## $ed / } @rlog2;
		if ($#rlog3 >= 0) {
			$rlog3[0]=~/ ##!!## [^#]* #!# ##!## ([^#]*) #!# ##!## /;
			$joined{$ed} = $1;
		} else {
			$joined{$ed} = "";
		}

		$noEdits{$ed} = 0;
	}

	open(META, "$path_data/logs/rootlog/comeditlog.log");
	my @mlog = <META>;
	close(META);

	for (my $e = 0; $e <= $#mlog; $e++) {
		$mlog[$e]=~/^ ##!!## ([^#]*) #/;
		my $ed = $1;
		if (!defined $noEdits{$ed}) {
			$noEdits{$ed} = 0;
		}
		$noEdits{$ed}++;
	}

	if ($sort == 1) {
		@editors = sort @editors;
	}

	if ($sort == 2) {
		# sort by date - joined
		@editors = sort {
			dateCmp($joined{$a}, $joined{$b});
		} (@editors);
	}

	if ($sort == 3) {
		# sort by date - llogin
		@editors = sort {
			dateCmp($llogin{$a}, $llogin{$b});
		} (@editors);
	}

	if ($sort == 4) {
		# sort by email
		@editors = sort {
			$email{$a} cmp $email{$b};
		} (@editors);
	}

	if ($sort == 5) {
		# sort by noEdits
		@editors = sort {
			comp($noEdits{$a}, $noEdits{$b});
		} (@editors);
	}

	for (my $d = 0; $d <= $#editors; $d++) {
		my $ed = $editors[$d];
		$tab .=  "<tr bgcolor=\"#eeeeee\">";
		$tab .=  "<td><a href=\"profile.cgi?editor=$ed\">$ed</a></td>";
		if (defined $showEmail) {
			$tab .= "<td>" . $email{$ed} . "</td>";
		}
		if (defined $showStatus) {
			if ($eds=~/$ed/) {
				$tab .= "<td>$TS::TS_stats_active</td>";
			} else {
				$tab .= "<td>$TS::TS_stats_inactive</td>";
			}
		}
		if (defined $showLastLogin) {
			$tab .= "<td>" . $llogin{$ed} . "</td>";
		}
		if (defined $showJoined) {
			$tab .= "<td>" . $joined{$ed} . "</td>";
		}
		if (defined $showNoEdits) {
			$tab .= "<td>" . $noEdits{$ed} . "</td>";
		}
		$tab .=  "</tr>";
		if (defined $showCats) {
			$tab .= "<tr bgcolor=\"#f0f0f0\"><td colspan=\"$cols\"><ul>";
			my $r = $cats{$ed};
			$r=~s/ {2,}/ /g;
			$r=~s/ $//;
			$r=~s/^ //;
			my @r = split(" ", $r);
			for (my $e = 0; $e <= $#r; $e++) {
				$r[$e]=~s/;//g;
				$r[$e]=~s/>/\//g;
				$r[$e] = "<a href=\"$path_on_server/$r[$e]\">$r[$e]</a>";
				$tab .= "<li>$r[$e]<br>";
			}
			$tab .= "</ul></td></tr>";
		}
	}

	$tab .= "</table>";

	print $tab;
}

UI::writeScriptFooter();
