#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use Storage;
use TS;
use UI;

my $cgi = new CGI;

my $cat = $cgi->param('cat');
my $act = $cgi->param('act');
my $data = $cgi->param('data');

$cat = Editor::validateCat($cat);

my(@charter, $charter, $ncat, $dc);

UI::writeHeaderCode("$TS::TS_subguide_title");
Editor::writeECode();

open(TEMPD, "$path_sitedata/$cat.subguide");
@charter = <TEMPD>;
close(TEMPD);
$charter = join("", @charter);

$ncat = $cat;
$ncat=~s/>/\//g;

if ($act eq "") {
	print <<END;
<p><font size="5">$TS::TS_subguide_catcharter</font>\n
END

	print <<END;
[<a href="subguide.cgi?cat=$cat&act=edit">$TS::TS_subguide_edit</a>]\n
END

	$dc = $charter;
	$dc =~ s/\n/<br>/g;

	print <<END;
</p>
<table border="1" cellspacing="1" width="100%" id="AutoNumber1">
  <tr>
    <td width="100%">
    <p align="left">$ncat</td>
  </tr>
  <tr>
    <td width="100%">$dc</td>
  </tr>
</table>
END
}

if ($act eq "edit")
{
	$cat = Editor::testPrivs($cat);
	print <<END;
<p><font size="5">$TS::TS_subguide_catcharter</font></p>
<table border="1" cellspacing="1" width="100%" id="AutoNumber1">
  <tr>
    <td width="100%">
    <p align="left">$ncat</td>
  </tr>
  <tr>
    <td width="100%">
    <form method="POST" action="subguide.cgi">
      <p align="center"><br>
      <textarea rows="14" name="data" cols="62">$charter</textarea></p>
      <input type="hidden" value="$cat" name="cat">
      <p align="center"><input type="submit" value="$TS::TS_subguide_update" name="act"></p>
    </form>
    </td>
  </tr>
</table>
END
}

if ($act eq "$TS::TS_subguide_update") {
	$cat = Editor::testPrivs($cat);
	open(LDATA2, ">$path_sitedata/$cat.subguide");
	print LDATA2 "$data";
	close(LDATA2);

	Generate::updatePublicSide($cat);
	Storage::logEdit("edit", "subguide", $cat, $data);

	print "$TS::TS_subguide_charterupdated";
}

UI::writeScriptFooter($cat);
