#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Generate;
use Settings;
use TS;
use UI;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $do = $cgi->param('do');
my $typeset = $cgi->param('newtype');

my $lt = localtime;
my $logdata;

$cat = Editor::testPrivs($cat);

if ($do ne "") {
	UI::editRedirect();
}

UI::writeHeaderCode($TS::TS_template_title);
Editor::writeECode();

open(CAT, "$path_sitedata/$cat.html");
my @cat2 = <CAT>;
close(CAT);

open(ED, "$path_sitedata/$cat.ed");
my @edi = <ED>;
close(ED);

open(CT, "$path_sitedata/$cat.ct");
my $typ = <CT>;
close(CT);

if (($typ eq "") || ($typ eq "\n")) {
	$typ = "default";
}

open(TEMPL, "$path_data/template/$typ");
my @tmpl = <TEMPL>;
close(TEMPL);

if ($do ne "") {
	open(EL, "$path_data/pginfo/tble");
	my $table= <EL>;
	close(EL);

	open(EL, "$path_home/edits/edit1");
	my $edits= <EL>;
	close(EL);

	my $totaledits = $edits + 1;

	open(LDATA2, ">$path_home/edits/edit1");
	print LDATA2 "$totaledits";
	close(LDATA2);

	open(LDATA, ">$path_sitedata/$cat.tem");
	print LDATA "$tmpl[0]";
	for (my $i = "1"; $i <= $#tmpl; $i++) {
		my $y = "p" . $i;
		my $x = $cgi->param($y);
		chomp($x);
		$logdata = "$logdata\n$x";
		print LDATA "$x\n";
	}
	close(LDATA);
	Storage::logEdit("edit", "template", $cat, $logdata);
	
	Generate::updatePublicSide($cat);
}

open(CONT, "$path_sitedata/$cat.tem");
my @tem = <CONT>;
close(CONT);

if ($typ eq "") {
	$typ = "default";
}

UI::writeScriptHeader($cat, $TS::TS_template_title, $TS::TS_template_info);
print "<h4>$TS::TS_template_current: $typ [<a href=\"cattype.cgi?cat=$cat\">$TS::TS_common_change</a>]</h4>";

if ($tmpl[0] eq "") {
	print $TS::TS_template_nodata;
} else {
	UI::writeStartForm($cat, "template.cgi");
	my $j = "0";
	for (my $i = "1"; $i <= $#tmpl; $i = $i + 2) {
         	$j = $j + 1;
       	 	chomp($tmpl[$i]);
		my $xx = $tmpl[$i];
         	$xx=~s/<.>//g;
       	 	$xx=~s/<\/.>//g;
       		$xx=~s/<br>//g;
         	$xx=~s/#name//g;
		$xx=~s/\n//g;
		$xx=~s/\r//g;
		$tem[$j]=~s/\"/&quot;/g;
		UI::writeInputItemForm($xx, "text", "p$j", $tem[$j]);
	}
	UI::writeEndForm("do");
}

UI::writeScriptFooter($cat);
