#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use Storage;
use TS;
use UI;

my $TO_noLogin = 1;

my $cgi = new CGI;

my $ename = $cgi->param('name');

my $title = $TS::TS_timeout_title;

my $users = Storage::getData("global", "elist");

my(@edits, @date2, $tday, $tyear, $tmon, $tday2, $tyear2, $tmonth2);

my $lt = localtime;
$lt=~s/  / /g;
my @date = split(/ /, $lt);

my $month = $date[1];
my $today = $date[2];
my $toyear = $date[4];

my $tomon = Common::getMonth($month);

UI::writeHeaderCode($title);
Editor::restrictedMod();
Editor::writeECode();

open(META, "$path_data/logs/rootlog/areqeditlog.log");
my @rlog2 = <META>;
close(META);
@rlog2 = grep { /##!## join #!#/ } @rlog2;

print "<H2>$title</H2>";
print "$TS::TS_timeout_rbh<br><br>";

my $lt = localtime;

print "$TS::TS_timeout_today: $toyear-$tomon-$today ($lt).<br>";
print "$TS::TS_timeout_tsft: $TO_month $TS::TS_timeout_months / $TO_noLogin $TS::TS_timeout_months";

opendir(DIR,"$path_data/misc");
@edits = readdir(DIR);
closedir(DIR);

@edits = sort { lc($a) cmp lc($b) } @edits;

print <<END;
<hr>
<table cellSpacing="2" cellPadding="2" border="1">
<tbody>
<tr>
<td align="middle"><strong>$TS::TS_common_editor</strong></td>
<td align="middle">$bold$TS::TS_timeout_ll$unBold</td>
<td align="middle">$bold$TS::TS_timeout_action$unBold</td>
</tr>
END

foreach (@edits) {
	if ($_=~/.eaddr/) {
		$_=~s/.eaddr//;
		my $ed = $_;

		my $lld = "";
		if (open(LLD, "$path_data/logs/$ed.ll")) {
			$lld = <LLD>;
			close(LLD);
		}

		my $expire = $TO_month;
		my $message = $lld;

		if ($lld eq "") {
			$expire = $TO_noLogin;
			$message = "<i>$TS::TS_timeout_neverli</i>";

			my @rlog3 = grep { /##!!## $ed / } @rlog2;
			if ($rlog3[0]=~/ ##!!## [^#]* #!# ##!## ([^#]*) #!# ##!## /) {
				$lld = $1;
			}
		}

		if ($lld ne "") {
			$lld=~s/  / /g;

			@date2 = split(/ /, $lld);

			$month = $date2[1];
			$tday = $date2[2];
			$tyear = $date2[4];

			$tmon = Common::getMonth($month);

			$tday2 = $today - $tday;
			$tmonth2 = $tomon - $tmon;
			$tyear2 = $toyear - $tyear;

			if ($tday2 < 0) {
				$tday2 += 30;
				$tmonth2--;
			}

			if ($tmonth2 < 0) {
				$tmonth2 += 12;
				$tyear2--;
			}

			if ($tmonth2 >= $expire) {
				if ($users=~/ $ed /) {
					print <<END;
<tr>
<td align="middle"><a href=\"./profile.cgi?editor=$ed\">$ed</a></td>
<td align="middle">$message</TD>
<td align="middle"><a href="./toeditor.cgi?editor=$ed">$TS::TS_timeout_to</a></TD>
</tr>
END
				}
			}
		}
	}
}

print "</table>";

UI::writeScriptFooter();
