#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use Storage;
use TS;
use UI;


my $cgi = new CGI;
my $filename = $cgi->param("photo");
my $lt = localtime;
my $xxx = $filename;
$filename =~ s/.*[\/\\](.*)/$1/;
my $cuser = Editor::currentUser();

UI::writeHeaderCode("Upload File");
Editor::writeECode();

$cuser = Editor::validateEditor($cuser);
$filename = Storage::validateFileName($filename);

if (! -d "$path_images" . $cuser) {
	mkdir $path_images . $cuser;
}

if (!(($filename=~/.jpg$/) || ($filename=~/.gif$/) || 
      ($filename=~/.png$/) || ($filename=~/.bmp$/) ||
      ($filename=~/.PNG$/) || ($filename=~/.BMP$/) ||
      ($filename=~/.JPG$/) || ($filename=~/.GIF$/))) {
	print "Error: the file you want to upload does not have a valid extention.";
	UI::writeFooterCode();
	exit(0);
}

open UPLOADFILE, ">$path_images$cuser/$filename";

my $size = 0;
my $buffer = "";
my $bytesread = 0;

while (($bytesread=read($xxx, $buffer, 1024)) && ($size <= 100000)) {
	print UPLOADFILE $buffer;
	$size += $bytesread;
}

close UPLOADFILE;

if ($size > 100000) {
	print "Error: the size of the file is greater than the current limit: 100000 bytes.";
	unlink("$path_images$cuser/$filename");
} else {
	if ($size eq "0") 	{
		print "Error: empty files can not be uploaded.";
		unlink("$path_images$cuser/$filename");
	} else {
		open(EL, "$path_data/pginfo/tble");
		my $table= <EL>;
		close(EL);

		open(TEXTFILE, ">>$path_data/logs/rootlog/comeditlog.log");
		print TEXTFILE " ##!!## $ENV{REMOTE_USER} #!# ##!## $lt #!# ##!## edit #!# ##!## modify #!# ##!!!## Uploaded $filename ##!!!!## \n";
		close(TEXTFILE);

 		print <<END;
<p>Upload complete. Size: $size bytes.</p>
<p>URL: <a href="/img/$cuser/$filename">http://open-site.org/img/$cuser/$filename</a></p>
END
	}
}

UI::writeScriptFooter();
