#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use SQL;
use TS;
use UI;

my $cgi = new CGI;

UI::writeHeaderCode("$TS::TS_viewedit_editlog");
Editor::writeECode();

my $edit = $cgi->param('num');
my (@dat, $ncat, $x, $display, $cont);

if ($edit ne "") {
	if ($sqluse eq 0) {
		open(EL, "$path_home/edits/$edit.log");
		@dat = <EL>;
		close(EL);
	}

	if ($sqluse eq 1) {
		SQL::SQLConnect();
		my $sql = qq{ SELECT editor FROM edits where edit = $edit };
		SQL::SQLRead($sql, 'editor');
		$dat[0] = $SQL::RSQL[0];

                my $sql = qq{ SELECT IP FROM edits where edit = $edit };
                SQL::SQLRead($sql, 'IP');
                $dat[1] = $SQL::RSQL[0];

                my $sql = qq{ SELECT time FROM edits where edit = $edit };
                SQL::SQLRead($sql, 'TIME');
                $dat[2] = $SQL::RSQL[0];

                my $sql = qq{ SELECT cat FROM edits where edit = $edit };
                SQL::SQLRead($sql, 'CAT');
                $dat[3] = $SQL::RSQL[0];

                my $sql = qq{ SELECT curcont FROM edits where edit = $edit };
                SQL::SQLRead($sql, 'CONT');
                $cont = $SQL::RSQL[0];

		SQL::SQLDisconnect();
	}

		UI::writeScriptHeader($dat[3], $TS::TS_viewedit_editlog, $TS::TS_viewedit_edit);

		$ncat = UI::getNiceFormat($dat[3]);

	print <<END;

<table border="0" cellspacing="1" width="648" id="AutoNumber1">
  <tr>
    <td width="147" bgcolor="#eeeeee">$TS::TS_viewedit_editor</td>
    <td bgcolor="#f8f8f8"><a href=\"$path_on_server/editors/profile.cgi?editor=$dat[0]\">$dat[0]</a></td>
  </tr>
END

if ($isMeta eq 1) {
print <<END;
  <tr>
    <td bgcolor="#eeeeee">$TS::TS_viewedit_IP</td>
    <td bgcolor="#f8f8f8">$dat[1]</td>
</tr>
END
}

print <<END;
  <tr>
    <td bgcolor="#eeeeee">$TS::TS_viewedit_time</td>
    <td bgcolor="#f8f8f8">$dat[2]</td>
  </tr>
  <tr>
    <td bgcolor="#eeeeee">$TS::TS_common_category:</td>
    <td bgcolor="#f8f8f8">$ncat</td>
  </tr>
  <tr>
    <td bgcolor="#eeeeee">$TS::TS_common_content:</td>
    <td bgcolor="#f8f8f8">
END
	$x = 4;

	$display = $dat[$x];

	#Fix strange bug due to old buggy logging
	$display=~s/<br><\/td><\/tr><tr><td width=\"600\">//g;

	print $display;

	if ($sqluse eq 0) {	
		while ($x ne $#dat) {
			$x = $x + 1;
			$display = $dat[$x];

			#Fix strange bug due to old buggy logging
			$display=~s/<br><\/td><\/tr><tr><td width=\"600\">//g;

			print "<hr>\n$display";
		}
	} else {
		$cont=~s/\n/<hr>/g;
		print $cont;
	}

	print "</td></tr></table>";

	UI::writeScriptFooter($dat[3]);
} else {
	UI::writeScriptHeader("", $TS::TS_viewedit_editlog);

	print <<END;
<form method="GET" action="viewedit.cgi">
  <p>$bold $TS::TS_viewedit_editnumber $unBold<br>
  <input type="text" name="num" size="20"><br>
  <input type="submit" value="$TS::TS_common_submit"></p>
</form>
END
	UI::writeScriptFooter();
}
