#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $editor = $cgi->param('editor');
my $username = $cgi->param('usn');
my $reason = $cgi->param('reason');
my $act = $cgi->param('action');
my $lt = localtime;

UI::writeHeaderCode("$TS::TS_warn_title");
Editor::writeECode();
Editor::restrictedMeta();

if (defined $act) {
	$username = Editor::validateEditor($username);

	my $table = "";

	if (open(EL, "$path_data/pginfo/tble")) {
		$table = <EL>;
		close(EL);
	}

	if (!(-d "$path_data/logs")) {
		mkdir("$path_data/logs");
	}
	if (!(-d "$path_data/logs/warnlog")) {
		mkdir("$path_data/logs/warnlog");
	}
	if (!(-d "$path_data/logs/rootlog")) {
		mkdir("$path_data/logs/rootlog");
	}
	
	open(TEXTFILE, ">>$path_data/logs/warnlog/$username.log");
	print TEXTFILE "<i>$lt</i><br>WARNING:<br>By: $ENV{REMOTE_USER};<br>- Warning: <br>$reason $table\n";
	close(TEXTFILE);

	open(TEXTFILE, ">$path_data/logs/warnlog/$username.sw");
	print TEXTFILE "1";
	close(TEXTFILE);

	open(TEXTFILE, ">>$path_data/logs/rootlog/rlog.log");
	print TEXTFILE "<i>$lt</i><br>WARNING:<br>By: $ENV{REMOTE_USER};<br>To: $username<br>- Warning: <br>$reason $table\n";
	close(TEXTFILE);
	#end log code

	print "$TS::TS_warn_warnd<br>";
} else {
	print <<END;
<font size="5">$TS::TS_warn_title</font><br>
<form method="POST" action="warn.cgi">
  <p>$bold$TS::TS_common_editor:$unBold<br>
  <input type="text" name="usn" value="$editor" size="20"></p>
  <p>$bold$TS::TS_warn_warn:$unBold</b><br>
  <textarea rows="13" name="reason" cols="60"></textarea></p>
  <p><input type="submit" value="$TS::TS_common_submit" name="action"></p>
</form>
END
}

UI::writeScriptFooter();
