#!/usr/bin/perl -wT
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Common;
use Editor;
use Settings;
use TS;
use UI;

my $cgi = new CGI;

my $ename = $cgi->param('name');
my $list = $cgi->param('list');
my $action = $cgi->param('cmd');

if (!defined $ename) {
	$ename = "";
}

my $lt = localtime;

if (defined $action) {
	my $user = Editor::currentUser();
	
	if (!(-d "$path_data/logs")) {
		mkdir("$path_data/logs");
	}
	if (!(-d "$path_data/logs/warnlog")) {
		mkdir("$path_data/logs/warnlog");
	}
	if (!(-d "$path_data/logs/rootlog")) {
		mkdir("$path_data/logs/rootlog");
	}

	open(TEXTFILE, ">$path_data/logs/warnlog/$user.sw");
	print TEXTFILE "";
	close(TEXTFILE);

	my $table;

	if (open(EL, "$path_data/pginfo/tble")) {
		$table = <EL>;
		close(EL);
	}

	open(TEXTFILE, ">>$path_data/logs/warnlog/$user.log");
	print TEXTFILE "<i>$lt</i><br>WARNING:<br>Accepted By: $ENV{REMOTE_USER}$table\n";
	close(TEXTFILE);
	open(TEXTFILE, ">>$path_data/logs/rootlog/rlog.log");
	print TEXTFILE "<i>$lt</i><br>WARNING:<br>Accepted By: $ENV{REMOTE_USER}$table\n";
	close(TEXTFILE);
}

UI::writeHeaderCode("$ename - Warning Log");
Editor::writeECode();

if (defined $action) {
	print "Warning accepted.";
} else {
	print <<END;
<h1>Warning Log</h1>
<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" width="600" bgcolor="#FFA0A0"><tr><td width="600">
END
	my @rlog = ();
	if (open(INFILE, "$path_data/logs/warnlog/$ENV{REMOTE_USER}.log")) {
		@rlog = <INFILE>;
		close(INFILE);
	}
	print "@rlog";
	print "</table> <br>";
}

UI::writeScriptFooter();
