#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Editor;
use PTS;
use Settings;
use Storage;
use UI;

my $cgi = new CGI;
my $action = $cgi->param('act');
my $to = $cgi->param('to');
my $fromname = $cgi->param('fromname');
my $fromeaddr = $cgi->param('fromeaddr');
my $subject = $cgi->param('sub');
my @message = $cgi->param('message');

PTS::writeHeader("Feedback an Editor");

if ($action eq "send") {
	if ($fromname eq "") {
		print "Please enter your name.";
		die;
	}

	if ($fromeaddr eq "") {
	        print "Please enter your email address.";
	        die;
	}

	my $users = Storage::getData("global", "elist");

	if ($users!~/ $to /g) {
		print "This editor does not exist.";
		die;
	}

	my $editoremail = Editor::getEmail($to);
	 
	open(SENDMAIL, "| $path_sendmail") || die "Unable to open sendmail";
	print SENDMAIL <<END_MAIL;
From: $fromname <$fromeaddr>
To: $editoremail
Subject: $HD_name - (Outside Feedback)  $subject
@message
END_MAIL
	close(SENDMAIL);

	print "Feedback Sent.";
}

if ($action eq "") {
	print <<END;
<form method="POST" action="outedfeed.cgi">
<input type="hidden" name="act" value="send">
$bold <h3><br>Send Feedback to an Editor</h3> $unBold

$bold Your Name: $unBold <br>
<input type="text" name="fromname" size="40" value=""><br><br>

$bold Your E-Mail: $unBold <br>
<input type="text" name="fromeaddr" size="40" value=""><br><br>
END

	if ($to eq "") {
		print <<END

$bold To Editor: $unBold <br>
<input type="text" name="to" size="40" value="$to"><br><br>

END
	} else {
		print <<END

$bold To Editor: $to$unBold 
<input type="hidden" name="to" value="$to"><br><br>

END
	}

	print <<END;
$bold Subject: $unBold<br>
<input type="text" name="sub" size="40"><br><br>

$bold Message: $unBold<br>
<textarea rows="8" name="message" cols="80"></textarea><br>
<input type="submit" value="Send">
</form>

END
}

UI::writeFooterCode();
