#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use Include;
use Settings;
use Storage;
use PTS;

my $cgi = new CGI;
my $editor = $cgi->param('editor');
my $email = $cgi->param('email');
my $reason = $cgi->param('reason');
my $lt = localtime;

if (!(-d "$path_data/nrins")) {
        mkdir("$path_data/nrins");
}

$editor = lc($editor);

PTS::writeHeader("Request Reinstatement");

open(FOOT, "$path_data/pginfo/footer.html");
my @foot = <FOOT>;
close(FOOT);

if ($editor ne "") {
	if ($editor eq "") {
		print "Please enter your editor name.";
		print "@foot\n";
		die;
	}

	if ($reason eq "") {
		print "Please provide a reason in your application.";
		print "@foot\n";
		die;
	}

	my $users = Storage::getData("global", "elist");

	if ($users=~/ $editor /) {
		print "You are already an active editor.";
		print "@foot\n";
		die;
	}

	open(USERS, "$path_data/inlist");
	my $users = <USERS>;
	close(USERS);
	if ($users=~/ $editor /) {
	} else {
		print "No such editor account.";
		print "@foot\n";
		die;
	}

	if ($email eq "") {
		print "Please enter your email.";
                print "@foot\n";
                die;
	}

	my $ip = $ENV{REMOTE_ADDR};


	$email=~s/\n//g;
	$editor=~s/\n//g;
	$reason=~s/\n//g;;

	my $lt = localtime;

        open(EL, "$path_home/edits/edit1");
	my $edits = <EL>;
        close(EL);

	my $totaledits = $edits + 1;
	open(LDATA2, ">$path_home/edits/edit1");
	print LDATA2 "$totaledits";
	close(LDATA2);

        open(TEXTFILE, ">$path_data/nrins/$totaledits.req");
	print TEXTFILE "$editor\n";
	print TEXTFILE "$email\n";
	print TEXTFILE "$ip\n";
	print TEXTFILE "$lt\n";
	print TEXTFILE "$reason\n";
	close(TEXTFILE);
	#end log code

	print "Your request for reinstatement has been submitted.<br>";
	print "You will be emailed if you are reinstated.<br>";
	print "<strong><a href=\"./\">$PTS::TS_common_back</a></strong><br>\n";
	print "<br>@foot";

	die;
} else {
	print <<END;
<form method="POST" action="reinstate.cgi">
<p>This form allows ex-editors who had accounts that  either expired or 
were removed due to abuse to request reinstatement into the project.</p>
<div align="center">
  <center>
  <table cellSpacing="3" cellPadding="3" width="90%" bgColor="#CCCCCC" border="0" style="border-collapse: collapse" bordercolor="#111111">
    <tr>
      <td width="25%"><b>Editor Name:</b></td>
      <td width="35%"><input name="editor" size="20"></td>
    </tr>
    <tr>
      <td><b>E-mail:<br>
      </b><font size="2">(E-mail address used while you were at active) <br> (Mail will be sent there.)</font></td>
      <td><input value name="email" size="20"></td>
    </tr>
    <tr>
      <td width="25%"><b>Why you want to be reinstated as editor?</b></td>
      <td width="35%"><textarea name="reason" rows="6" cols="40"></textarea></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
  </table>
  </center>
</div>
<center>
<p><input type="submit" value="Request Reinstatement"></p>
</center>
</form>
END
	print "<p>@foot\n";
}
