#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************


use strict;
use CGI;

use lib '.';
use Include;
use Settings;
use UI;

my $cgi = new CGI;
my $search = $cgi->param('search');
my $start = $cgi->param('start');

if ($start eq "") { $start = 0 };

#if ($search=~/./)
#{ 
#	#Temp fix, hence no string.
#	print "Error: You may not search for \".\".";
#	die;
#}

sub LovNav {
	my($start,$end,$dump,$last) = @_;
	my $pstart = $start + 1;
	my $pdump = $dump + 1;
	if ($end > $pdump) {
		$end = $pdump;
	}
	print <<END;
<p><font size=\"3\">Viewing: ($pstart - $end of $pdump)<br>
$bold
[<a href="./search.cgi?search=$search&start=$end">Next 20</a>]
[<a href="./search.cgi?search=$search&start=$last">Last 20</a>]
</font>
$unBold</p>
END
	return 1;
}

#print header;
print "Content-Type: text/html; charset=utf-8\n\n";

# print HTML header
open(HTMLHEAD, "/export/home/data/pginfo/head.html");
print <HTMLHEAD>;
close(HTMLHEAD);
# print HTML footer
open(HTMLFOOT, "/export/home/data/pginfo/footer.html");
my @footer =  <HTMLFOOT>;
close(HTMLFOOT);


if (length($search) < 3) { 
	print "You must search for more than two letters.";
	print @footer;
	exit(0);
}

open(SDUMP, "$path_data/search.fdb");
my @sdump = <SDUMP>;
close(SDUMP);
my @rdump = grep { /$search/i } @sdump;

#Rid of HTML
foreach (@rdump) {$_=~s/\<(.*?)\>//g};

my $end = $start + 20;

my $last = $start - 20;

print "<p> $bold <font size=\"5\">Search Results</font> $unBold </p>";
print "<p><font size=\"4\">Searching for &quot;$search&quot;...</font></p>";

if ($#rdump < 1) {
	print "No results have been found for this search term.";
} else {
	LovNav($start, $end, $#rdump, $last);

	my $x = $start;

	while ($x ne $end) {
		if ($rdump[$x] ne "") {
			my @hitcat = split(/:/, $rdump[$x]);
			$hitcat[1]=~s/\>/\//g;
			my $hitcontent = $rdump[$x];
			#$hitcontent=~s/$hitcat[1]//g;
			$hitcontent=~s/CAT:(.*?)://g;

			#Block results
			my @safer = split(/\//, $hitcat[1]);
			my $skip = 0;
			if ($safer[0] eq "Test") { $skip = 1 };
			if ($safer[0] eq "Bookmarks") { $skip = 1 };

			if ($skip ne 1) { 
				print <<END;
<table border="0">
  <tr bgColor="#e0e0e0">
    <td><strong>Category</strong></td>
    <td><strong><a href="http://$HD_domain$path_on_server/$hitcat[1]">$hitcat[1]</a></strong></td>
  </tr>
  <tr bgColor="#e0e0e0">
    <td><strong>Content</strong></td>
    <td>$hitcontent</td>
  </tr>
</table>
<br>
END
			}
		}
		$x++;
	}
	LovNav($start, $end, $#rdump, $last);
}

print $sdump[0];
print "<br>" x 3;

print <<HTML_QUOTE;

<form action="/search.cgi" method="get">
  <div align="center">
    <center>
    <table style="BORDER-COLLAPSE: collapse" cellSpacing="0" cellPadding="0" width="372" bgColor="#bbbbbb" border="0">
      <tr>
        <td align="left" width="370"><b>Search:</b> </td>
      </tr>
      <tr>
        <td align="left" width="370">
        <p align="center"><input size="40" name="search">
        <input type="submit" value="Search"></td>
      </tr>
    </table>
    </center>
  </div>
</form>
@footer
HTML_QUOTE
