#!/usr/bin/perl
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
#
# The Original Code is Open-site.
#
# The Initial Developer of the Original Code is Open-site.org Website.
#
# Portions created by Open-site.org are Copyright (C) 2002.
# All Rights Reserved.
#
#************************************************************************

use strict;
use CGI;
use Include;
use Settings;
use PTS;

my $cgi = new CGI;
my $cat = $cgi->param('cat');
my $depthmax = $cgi->param('depthmax');
my $depthmin = $cgi->param('depthmin');
my $lt = localtime;

if ($depthmax eq "") {
	$depthmax = 0;
}

if ($depthmax > 0) {
	$depthmax = 0;
}

if ($depthmin eq "") {
	$depthmin = 0;
}

PTS::writeHeader("$PTS::TS_add_title");
print "<p>";

$cat=~s/\//>/g;
$cat=~s/ /_/g;
$cat=~s/\\//g;
$cat=~s/\.\.//g;
$cat=~s#>$##;

open(DCATS, "$path_sitedata/cats.lst");
my $ucat = <DCATS>;
close(DCATS);

open(FOOT, "$path_data/pginfo/footer.html");
my @foot = <FOOT>;
close(FOOT);

if (!($ucat=~/ $cat; /)) {
	print "<p>$PTS::TS_sectionchart_validcat</p>\n";
	print "@foot\n";
	die;
}

my $ncat = $cat;
$ncat=~s/>/: /g;

my ($HC, $ct, $ct2, $ind, $blr);

$HC = "<a href=\"$path_on_server/\">Top</a>";
while ($ct ne $cat) {
	$ct = $ct . substr($cat, $ind, 1);
	$ct2 = $ct2 . substr($cat, $ind, 1);
	++$ind;
	$ct2=~s/_/ /g;

	if (substr($cat, $ind, 1) eq ">") {
		$blr = $ct;
		$blr=~s/>/\//g;
		$HC = $HC . ": <a href=\"$path_on_server/$blr/\">$ct2</a>";
		$ct2 = "";
		$ct = $ct . substr($cat, $ind, 1);
		++$ind;
	}
}

$blr = $ct;
$blr=~s/>/\//g;
$HC = $HC . ": <a href=\"$path_on_server/$blr/\">$ct2</a></strong>";

print "<h3>$HC - $PTS::TS_sectionchart_title</h3>";

my (@entries, @parents, %h_fullPath, %list);

while ($ucat=~/ $cat>([^;]*);/g) {
	my $rel = $1;
	my $newcat = $cat.">$rel";

	my $dep = 0;
	while ($rel=~/>/g) {
		$dep++;
	}

	if (($dep <= $depthmax) && ($dep >= $depthmin)) {
		my $last = $newcat;
		$last=~s/^.*>([^>]*)$/$1/;
		open(TEMPD, "$path_sitedata/$newcat.sections");
		my $tb = <TEMPD>;
		close(TEMPD);

		my $hits = 0;
		for (my $i = 1; $i <= $tb; $i++) {
			open(TEMPD, "$path_sitedata/$newcat.sct$i");
			my @tb = <TEMPD>;
			close(TEMPD);
			$tb[2]=~s/\n//g;
			$tb[2]=~s/\r//g;
			$tb[2]=~s/^[ ]*//;
			$tb[2]=~s/[ ]*$//;
			if ($tb[2] ne "") {
				$hits++;
				push(@entries, $tb[2]);
				if (!($list{$tb[2]})) {
					$list{$tb[2]} = ();
				}
				push(@{$list{$tb[2]}}, $last);
			}
		}

		my $ucat2 = $ucat;
		while ($ucat2=~/ $newcat>([^;>]*);/g) {
			$hits++;
			my $loc = $1;
			push(@entries, $loc);
			if (!($list{$loc})) {
				$list{$loc} = ();
			}
			push(@{$list{$loc}}, $last);
		}

		if ($hits > 0) {
			push(@parents, $last);
			$h_fullPath{$last} = $newcat;
		}
	}
}

if (($#parents < 1) || ($#entries < 1)) {
	print $PTS::TS_sectionchart_notenough;
	$cat=~s/>/\//g;
	$ncat=~s/\: /\//g;
	print "<p><a href=\"$path_on_server/$cat/\">Back to $ncat</a></p>";

	my $foot = join("", @foot);

	print $foot;
	exit(0);
}

@entries = sort @entries;
@parents = sort @parents;

my @links;

for (my $d = 0; $d <= $#parents; $d++) {
	my $path = $h_fullPath{$parents[$d]};
	$path=~s/>/\//g;
	my $display = $parents[$d];
	$display=~s/_/ /g;
	push(@links, "<a href=\"$path_on_server/$path/\">$display</a>");
}

print <<END;
<table border="1">
<tr>
<td>&nbsp;</td>
END

for (my $d = 0; $d <= $#links; $d++) {
	print "<td>$links[$d]</td>"
}

print "</tr>";

for (my $d = 0; $d <= $#entries; $d++) {
	if ($d < $#entries) {
		my $string = $entries[$d + 1];
		my $entr = $entries[$d];
		if (($entr=~/$string/i) && ($string=~/$entr/i)) {
			if (!($entries[$d] eq $string)) {
				my @temp = @{$list{$entries[$d]}};
				for (my $y = 0; $y <= $#temp; $y++) {
					push(@{$list{$entries[$d + 1]}}, $temp[$y]);
				}
			}
			next;
		}
	}
	@{$list{$entries[$d]}} = sort @{$list{$entries[$d]}};
	my $counter = 0;
	my $disp = $entries[$d];
	$disp=~s/_/ /g;
	print "<tr><td>$disp</td>";
	for (my $e = 0; $e <= $#links; $e++) {
		if (${$list{$entries[$d]}}[$counter] eq $parents[$e]) {
			$counter++;
			print "<td bgcolor=\"#bbaaee\">&nbsp;</td>";
		} else {
			print "<td>&nbsp;</td>";
		}
	}

	print "</tr>";
}

print "</table>";

$cat=~s/>/\//g;
$ncat=~s/\: /\//g;
print "<p><a href=\"$path_on_server/$cat/\">$PTS::TS_sectionchart_backto $ncat</a></p>";

print join("", @foot);
